# =================================================================================================
#<profile4xi profile = "12" />
#<program4xi program = "image2d4xi.py">
#<abstract4xi abstract = "2D image management"/>
#<refer4xi reference = "2D images"/>
#<verify4xi verification = "10" target = "image2d4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4moduletesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API                
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Image2D4Xi',                         # ACK 5.31  p76 
            
            'copy2image4xi',                      # ACK 5.3.3 p88
            'copy2imagetobuffer4xi',              # ACK 5.3.4 p90
            'copy2buffertoimage4xi',              # ACK 5.3.4 p92
            'create2image4xi',                    # ACK 5.31  p76           

            'get2imageinfo4xi',                   # ACK 5.3.6 p97        
            'get2supportedimageformats4xi',       # ACK 5.3.2 p82 
                              
            'manoeuvre2copyimage4xi',             # ACK 
            'manoeuvre2copyimagetobuffer4xi',     # ACK     
            'manoeuvre2copybuffertoimage4xi',     # ACK 
            'manoeuvre2mapimage4xi',              # ACK                                       
            'manoeuvre2readimage4xi',             # ACK  
            'manoeuvre2writeimage4xi',            # ACK       
            
            'map2image4xi',                       # ACK 5.3.5 p94 
            
            'read2image4xi',                      # ACK 5.3.3 p84 
            'retain2image4xi',                    # ACK 5.4.1 p99
            'release2image4xi',                   # ACK 5.4.1 p99

            'set2imagecallback4xi',               # ACK
            'set2image4xi',                       # ACK          

            'trace2image4xi',                     # ACK 
                                    
            'wait2image4xi',                      # ACK 
            'write2image4xi'                      # ACK 5.3.3 p84                 
          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi


# -------------------------------------------------------------------------------------------------
# Image modules of devices                           
# -------------------------------------------------------------------------------------------------
from apu2image4xi import APU2Image4Xi                                                             
from bpu2image4xi import BPU2Image4Xi
from cpu2image4xi import CPU2Image4Xi
from dpu2image4xi import DPU2Image4Xi
from epu2image4xi import EPU2Image4Xi
from fpu2image4xi import FPU2Image4Xi
from gpu2image4xi import GPU2Image4Xi
from hpu2image4xi import HPU2Image4Xi
from ipu2image4xi import IPU2Image4Xi
from jpu2image4xi import JPU2Image4Xi
from kpu2image4xi import KPU2Image4Xi
from lpu2image4xi import LPU2Image4Xi
from mpu2image4xi import MPU2Image4Xi
from npu2image4xi import NPU2Image4Xi
from opu2image4xi import OPU2Image4Xi
from ppu2image4xi import PPU2Image4Xi
from qpu2image4xi import QPU2Image4Xi
from rpu2image4xi import RPU2Image4Xi
from spu2image4xi import SPU2Image4Xi
from tpu2image4xi import TPU2Image4Xi
from upu2image4xi import UPU2Image4Xi
from vpu2image4xi import VPU2Image4Xi
from xpu2image4xi import XPU2Image4Xi
from wpu2image4xi import WPU2Image4Xi
from ypu2image4xi import YPU2Image4Xi
from zpu2image4xi import ZPU2Image4Xi

from apu2image4xi import copy2image4apu                                                            
from bpu2image4xi import copy2image4bpu
from cpu2image4xi import copy2image4cpu
from dpu2image4xi import copy2image4dpu
from epu2image4xi import copy2image4epu
from fpu2image4xi import copy2image4fpu
from gpu2image4xi import copy2image4gpu
from hpu2image4xi import copy2image4hpu
from ipu2image4xi import copy2image4ipu
from jpu2image4xi import copy2image4jpu
from kpu2image4xi import copy2image4kpu
from lpu2image4xi import copy2image4lpu
from mpu2image4xi import copy2image4mpu
from npu2image4xi import copy2image4npu
from opu2image4xi import copy2image4opu
from ppu2image4xi import copy2image4ppu
from qpu2image4xi import copy2image4qpu
from rpu2image4xi import copy2image4rpu
from spu2image4xi import copy2image4spu
from tpu2image4xi import copy2image4tpu
from upu2image4xi import copy2image4upu
from vpu2image4xi import copy2image4vpu
from xpu2image4xi import copy2image4xpu
from wpu2image4xi import copy2image4wpu
from ypu2image4xi import copy2image4ypu
from zpu2image4xi import copy2image4zpu

from apu2image4xi import copy2imagetobuffer4apu                                                            
from bpu2image4xi import copy2imagetobuffer4bpu
from cpu2image4xi import copy2imagetobuffer4cpu
from dpu2image4xi import copy2imagetobuffer4dpu
from epu2image4xi import copy2imagetobuffer4epu
from fpu2image4xi import copy2imagetobuffer4fpu
from gpu2image4xi import copy2imagetobuffer4gpu
from hpu2image4xi import copy2imagetobuffer4hpu
from ipu2image4xi import copy2imagetobuffer4ipu
from jpu2image4xi import copy2imagetobuffer4jpu
from kpu2image4xi import copy2imagetobuffer4kpu
from lpu2image4xi import copy2imagetobuffer4lpu
from mpu2image4xi import copy2imagetobuffer4mpu
from npu2image4xi import copy2imagetobuffer4npu
from opu2image4xi import copy2imagetobuffer4opu
from ppu2image4xi import copy2imagetobuffer4ppu
from qpu2image4xi import copy2imagetobuffer4qpu
from rpu2image4xi import copy2imagetobuffer4rpu
from spu2image4xi import copy2imagetobuffer4spu
from tpu2image4xi import copy2imagetobuffer4tpu
from upu2image4xi import copy2imagetobuffer4upu
from vpu2image4xi import copy2imagetobuffer4vpu
from xpu2image4xi import copy2imagetobuffer4xpu
from wpu2image4xi import copy2imagetobuffer4wpu
from ypu2image4xi import copy2imagetobuffer4ypu
from zpu2image4xi import copy2imagetobuffer4zpu

from apu2image4xi import copy2buffertoimage4apu                                                            
from bpu2image4xi import copy2buffertoimage4bpu
from cpu2image4xi import copy2buffertoimage4cpu
from dpu2image4xi import copy2buffertoimage4dpu
from epu2image4xi import copy2buffertoimage4epu
from fpu2image4xi import copy2buffertoimage4fpu
from gpu2image4xi import copy2buffertoimage4gpu
from hpu2image4xi import copy2buffertoimage4hpu
from ipu2image4xi import copy2buffertoimage4ipu
from jpu2image4xi import copy2buffertoimage4jpu
from kpu2image4xi import copy2buffertoimage4kpu
from lpu2image4xi import copy2buffertoimage4lpu
from mpu2image4xi import copy2buffertoimage4mpu
from npu2image4xi import copy2buffertoimage4npu
from opu2image4xi import copy2buffertoimage4opu
from ppu2image4xi import copy2buffertoimage4ppu
from qpu2image4xi import copy2buffertoimage4qpu
from rpu2image4xi import copy2buffertoimage4rpu
from spu2image4xi import copy2buffertoimage4spu
from tpu2image4xi import copy2buffertoimage4tpu
from upu2image4xi import copy2buffertoimage4upu
from vpu2image4xi import copy2buffertoimage4vpu
from xpu2image4xi import copy2buffertoimage4xpu
from wpu2image4xi import copy2buffertoimage4wpu
from ypu2image4xi import copy2buffertoimage4ypu
from zpu2image4xi import copy2buffertoimage4zpu

from apu2image4xi import create2image4apu                                                            
from bpu2image4xi import create2image4bpu
from cpu2image4xi import create2image4cpu
from dpu2image4xi import create2image4dpu
from epu2image4xi import create2image4epu
from fpu2image4xi import create2image4fpu
from gpu2image4xi import create2image4gpu
from hpu2image4xi import create2image4hpu
from ipu2image4xi import create2image4ipu
from jpu2image4xi import create2image4jpu
from kpu2image4xi import create2image4kpu
from lpu2image4xi import create2image4lpu
from mpu2image4xi import create2image4mpu
from npu2image4xi import create2image4npu
from opu2image4xi import create2image4opu
from ppu2image4xi import create2image4ppu
from qpu2image4xi import create2image4qpu
from rpu2image4xi import create2image4rpu
from spu2image4xi import create2image4spu
from tpu2image4xi import create2image4tpu
from upu2image4xi import create2image4upu
from vpu2image4xi import create2image4vpu
from xpu2image4xi import create2image4xpu
from wpu2image4xi import create2image4wpu
from ypu2image4xi import create2image4ypu
from zpu2image4xi import create2image4zpu

from apu2image4xi import create2image4apu                                                            
from bpu2image4xi import create2image4bpu
from cpu2image4xi import create2image4cpu
from dpu2image4xi import create2image4dpu
from epu2image4xi import create2image4epu
from fpu2image4xi import create2image4fpu
from gpu2image4xi import create2image4gpu
from hpu2image4xi import create2image4hpu
from ipu2image4xi import create2image4ipu
from jpu2image4xi import create2image4jpu
from kpu2image4xi import create2image4kpu
from lpu2image4xi import create2image4lpu
from mpu2image4xi import create2image4mpu
from npu2image4xi import create2image4npu
from opu2image4xi import create2image4opu
from ppu2image4xi import create2image4ppu
from qpu2image4xi import create2image4qpu
from rpu2image4xi import create2image4rpu
from spu2image4xi import create2image4spu
from tpu2image4xi import create2image4tpu
from upu2image4xi import create2image4upu
from vpu2image4xi import create2image4vpu
from xpu2image4xi import create2image4xpu
from wpu2image4xi import create2image4wpu
from ypu2image4xi import create2image4ypu
from zpu2image4xi import create2image4zpu

from apu2image4xi import get2imageinfo4apu                                                            
from bpu2image4xi import get2imageinfo4bpu
from cpu2image4xi import get2imageinfo4cpu
from dpu2image4xi import get2imageinfo4dpu
from epu2image4xi import get2imageinfo4epu
from fpu2image4xi import get2imageinfo4fpu
from gpu2image4xi import get2imageinfo4gpu
from hpu2image4xi import get2imageinfo4hpu
from ipu2image4xi import get2imageinfo4ipu
from jpu2image4xi import get2imageinfo4jpu
from kpu2image4xi import get2imageinfo4kpu
from lpu2image4xi import get2imageinfo4lpu
from mpu2image4xi import get2imageinfo4mpu
from npu2image4xi import get2imageinfo4npu
from opu2image4xi import get2imageinfo4opu
from ppu2image4xi import get2imageinfo4ppu
from qpu2image4xi import get2imageinfo4qpu
from rpu2image4xi import get2imageinfo4rpu
from spu2image4xi import get2imageinfo4spu
from tpu2image4xi import get2imageinfo4tpu
from upu2image4xi import get2imageinfo4upu
from vpu2image4xi import get2imageinfo4vpu
from xpu2image4xi import get2imageinfo4xpu
from wpu2image4xi import get2imageinfo4wpu
from ypu2image4xi import get2imageinfo4ypu
from zpu2image4xi import get2imageinfo4zpu

from apu2image4xi import get2supportedimageformats4apu                                                            
from bpu2image4xi import get2supportedimageformats4bpu
from cpu2image4xi import get2supportedimageformats4cpu
from dpu2image4xi import get2supportedimageformats4dpu
from epu2image4xi import get2supportedimageformats4epu
from fpu2image4xi import get2supportedimageformats4fpu
from gpu2image4xi import get2supportedimageformats4gpu
from hpu2image4xi import get2supportedimageformats4hpu
from ipu2image4xi import get2supportedimageformats4ipu
from jpu2image4xi import get2supportedimageformats4jpu
from kpu2image4xi import get2supportedimageformats4kpu
from lpu2image4xi import get2supportedimageformats4lpu
from mpu2image4xi import get2supportedimageformats4mpu
from npu2image4xi import get2supportedimageformats4npu
from opu2image4xi import get2supportedimageformats4opu
from ppu2image4xi import get2supportedimageformats4ppu
from qpu2image4xi import get2supportedimageformats4qpu
from rpu2image4xi import get2supportedimageformats4rpu
from spu2image4xi import get2supportedimageformats4spu
from tpu2image4xi import get2supportedimageformats4tpu
from upu2image4xi import get2supportedimageformats4upu
from vpu2image4xi import get2supportedimageformats4vpu
from xpu2image4xi import get2supportedimageformats4xpu
from wpu2image4xi import get2supportedimageformats4wpu
from ypu2image4xi import get2supportedimageformats4ypu
from zpu2image4xi import get2supportedimageformats4zpu

from apu2image4xi import manoeuvre2copyimage4apu                                                            
from bpu2image4xi import manoeuvre2copyimage4bpu
from cpu2image4xi import manoeuvre2copyimage4cpu
from dpu2image4xi import manoeuvre2copyimage4dpu
from epu2image4xi import manoeuvre2copyimage4epu
from fpu2image4xi import manoeuvre2copyimage4fpu
from gpu2image4xi import manoeuvre2copyimage4gpu
from hpu2image4xi import manoeuvre2copyimage4hpu
from ipu2image4xi import manoeuvre2copyimage4ipu
from jpu2image4xi import manoeuvre2copyimage4jpu
from kpu2image4xi import manoeuvre2copyimage4kpu
from lpu2image4xi import manoeuvre2copyimage4lpu
from mpu2image4xi import manoeuvre2copyimage4mpu
from npu2image4xi import manoeuvre2copyimage4npu
from opu2image4xi import manoeuvre2copyimage4opu
from ppu2image4xi import manoeuvre2copyimage4ppu
from qpu2image4xi import manoeuvre2copyimage4qpu
from rpu2image4xi import manoeuvre2copyimage4rpu
from spu2image4xi import manoeuvre2copyimage4spu
from tpu2image4xi import manoeuvre2copyimage4tpu
from upu2image4xi import manoeuvre2copyimage4upu
from vpu2image4xi import manoeuvre2copyimage4vpu
from xpu2image4xi import manoeuvre2copyimage4xpu
from wpu2image4xi import manoeuvre2copyimage4wpu
from ypu2image4xi import manoeuvre2copyimage4ypu
from zpu2image4xi import manoeuvre2copyimage4zpu

from apu2image4xi import manoeuvre2copyimagetobuffer4apu                                                            
from bpu2image4xi import manoeuvre2copyimagetobuffer4bpu
from cpu2image4xi import manoeuvre2copyimagetobuffer4cpu
from dpu2image4xi import manoeuvre2copyimagetobuffer4dpu
from epu2image4xi import manoeuvre2copyimagetobuffer4epu
from fpu2image4xi import manoeuvre2copyimagetobuffer4fpu
from gpu2image4xi import manoeuvre2copyimagetobuffer4gpu
from hpu2image4xi import manoeuvre2copyimagetobuffer4hpu
from ipu2image4xi import manoeuvre2copyimagetobuffer4ipu
from jpu2image4xi import manoeuvre2copyimagetobuffer4jpu
from kpu2image4xi import manoeuvre2copyimagetobuffer4kpu
from lpu2image4xi import manoeuvre2copyimagetobuffer4lpu
from mpu2image4xi import manoeuvre2copyimagetobuffer4mpu
from npu2image4xi import manoeuvre2copyimagetobuffer4npu
from opu2image4xi import manoeuvre2copyimagetobuffer4opu
from ppu2image4xi import manoeuvre2copyimagetobuffer4ppu
from qpu2image4xi import manoeuvre2copyimagetobuffer4qpu
from rpu2image4xi import manoeuvre2copyimagetobuffer4rpu
from spu2image4xi import manoeuvre2copyimagetobuffer4spu
from tpu2image4xi import manoeuvre2copyimagetobuffer4tpu
from upu2image4xi import manoeuvre2copyimagetobuffer4upu
from vpu2image4xi import manoeuvre2copyimagetobuffer4vpu
from xpu2image4xi import manoeuvre2copyimagetobuffer4xpu
from wpu2image4xi import manoeuvre2copyimagetobuffer4wpu
from ypu2image4xi import manoeuvre2copyimagetobuffer4ypu
from zpu2image4xi import manoeuvre2copyimagetobuffer4zpu

from apu2image4xi import manoeuvre2copybuffertoimage4apu                                                            
from bpu2image4xi import manoeuvre2copybuffertoimage4bpu
from cpu2image4xi import manoeuvre2copybuffertoimage4cpu
from dpu2image4xi import manoeuvre2copybuffertoimage4dpu
from epu2image4xi import manoeuvre2copybuffertoimage4epu
from fpu2image4xi import manoeuvre2copybuffertoimage4fpu
from gpu2image4xi import manoeuvre2copybuffertoimage4gpu
from hpu2image4xi import manoeuvre2copybuffertoimage4hpu
from ipu2image4xi import manoeuvre2copybuffertoimage4ipu
from jpu2image4xi import manoeuvre2copybuffertoimage4jpu
from kpu2image4xi import manoeuvre2copybuffertoimage4kpu
from lpu2image4xi import manoeuvre2copybuffertoimage4lpu
from mpu2image4xi import manoeuvre2copybuffertoimage4mpu
from npu2image4xi import manoeuvre2copybuffertoimage4npu
from opu2image4xi import manoeuvre2copybuffertoimage4opu
from ppu2image4xi import manoeuvre2copybuffertoimage4ppu
from qpu2image4xi import manoeuvre2copybuffertoimage4qpu
from rpu2image4xi import manoeuvre2copybuffertoimage4rpu
from spu2image4xi import manoeuvre2copybuffertoimage4spu
from tpu2image4xi import manoeuvre2copybuffertoimage4tpu
from upu2image4xi import manoeuvre2copybuffertoimage4upu
from vpu2image4xi import manoeuvre2copybuffertoimage4vpu
from xpu2image4xi import manoeuvre2copybuffertoimage4xpu
from wpu2image4xi import manoeuvre2copybuffertoimage4wpu
from ypu2image4xi import manoeuvre2copybuffertoimage4ypu
from zpu2image4xi import manoeuvre2copybuffertoimage4zpu

from apu2image4xi import manoeuvre2mapimage4apu                                                            
from bpu2image4xi import manoeuvre2mapimage4bpu
from cpu2image4xi import manoeuvre2mapimage4cpu
from dpu2image4xi import manoeuvre2mapimage4dpu
from epu2image4xi import manoeuvre2mapimage4epu
from fpu2image4xi import manoeuvre2mapimage4fpu
from gpu2image4xi import manoeuvre2mapimage4gpu
from hpu2image4xi import manoeuvre2mapimage4hpu
from ipu2image4xi import manoeuvre2mapimage4ipu
from jpu2image4xi import manoeuvre2mapimage4jpu
from kpu2image4xi import manoeuvre2mapimage4kpu
from lpu2image4xi import manoeuvre2mapimage4lpu
from mpu2image4xi import manoeuvre2mapimage4mpu
from npu2image4xi import manoeuvre2mapimage4npu
from opu2image4xi import manoeuvre2mapimage4opu
from ppu2image4xi import manoeuvre2mapimage4ppu
from qpu2image4xi import manoeuvre2mapimage4qpu
from rpu2image4xi import manoeuvre2mapimage4rpu
from spu2image4xi import manoeuvre2mapimage4spu
from tpu2image4xi import manoeuvre2mapimage4tpu
from upu2image4xi import manoeuvre2mapimage4upu
from vpu2image4xi import manoeuvre2mapimage4vpu
from xpu2image4xi import manoeuvre2mapimage4xpu
from wpu2image4xi import manoeuvre2mapimage4wpu
from ypu2image4xi import manoeuvre2mapimage4ypu
from zpu2image4xi import manoeuvre2mapimage4zpu

from apu2image4xi import manoeuvre2readimage4apu                                                            
from bpu2image4xi import manoeuvre2readimage4bpu
from cpu2image4xi import manoeuvre2readimage4cpu
from dpu2image4xi import manoeuvre2readimage4dpu
from epu2image4xi import manoeuvre2readimage4epu
from fpu2image4xi import manoeuvre2readimage4fpu
from gpu2image4xi import manoeuvre2readimage4gpu
from hpu2image4xi import manoeuvre2readimage4hpu
from ipu2image4xi import manoeuvre2readimage4ipu
from jpu2image4xi import manoeuvre2readimage4jpu
from kpu2image4xi import manoeuvre2readimage4kpu
from lpu2image4xi import manoeuvre2readimage4lpu
from mpu2image4xi import manoeuvre2readimage4mpu
from npu2image4xi import manoeuvre2readimage4npu
from opu2image4xi import manoeuvre2readimage4opu
from ppu2image4xi import manoeuvre2readimage4ppu
from qpu2image4xi import manoeuvre2readimage4qpu
from rpu2image4xi import manoeuvre2readimage4rpu
from spu2image4xi import manoeuvre2readimage4spu
from tpu2image4xi import manoeuvre2readimage4tpu
from upu2image4xi import manoeuvre2readimage4upu
from vpu2image4xi import manoeuvre2readimage4vpu
from xpu2image4xi import manoeuvre2readimage4xpu
from wpu2image4xi import manoeuvre2readimage4wpu
from ypu2image4xi import manoeuvre2readimage4ypu
from zpu2image4xi import manoeuvre2readimage4zpu

from apu2image4xi import manoeuvre2writeimage4apu                                                            
from bpu2image4xi import manoeuvre2writeimage4bpu
from cpu2image4xi import manoeuvre2writeimage4cpu
from dpu2image4xi import manoeuvre2writeimage4dpu
from epu2image4xi import manoeuvre2writeimage4epu
from fpu2image4xi import manoeuvre2writeimage4fpu
from gpu2image4xi import manoeuvre2writeimage4gpu
from hpu2image4xi import manoeuvre2writeimage4hpu
from ipu2image4xi import manoeuvre2writeimage4ipu
from jpu2image4xi import manoeuvre2writeimage4jpu
from kpu2image4xi import manoeuvre2writeimage4kpu
from lpu2image4xi import manoeuvre2writeimage4lpu
from mpu2image4xi import manoeuvre2writeimage4mpu
from npu2image4xi import manoeuvre2writeimage4npu
from opu2image4xi import manoeuvre2writeimage4opu
from ppu2image4xi import manoeuvre2writeimage4ppu
from qpu2image4xi import manoeuvre2writeimage4qpu
from rpu2image4xi import manoeuvre2writeimage4rpu
from spu2image4xi import manoeuvre2writeimage4spu
from tpu2image4xi import manoeuvre2writeimage4tpu
from upu2image4xi import manoeuvre2writeimage4upu
from vpu2image4xi import manoeuvre2writeimage4vpu
from xpu2image4xi import manoeuvre2writeimage4xpu
from wpu2image4xi import manoeuvre2writeimage4wpu
from ypu2image4xi import manoeuvre2writeimage4ypu
from zpu2image4xi import manoeuvre2writeimage4zpu

from apu2image4xi import map2image4apu                                                            
from bpu2image4xi import map2image4bpu
from cpu2image4xi import map2image4cpu
from dpu2image4xi import map2image4dpu
from epu2image4xi import map2image4epu
from fpu2image4xi import map2image4fpu
from gpu2image4xi import map2image4gpu
from hpu2image4xi import map2image4hpu
from ipu2image4xi import map2image4ipu
from jpu2image4xi import map2image4jpu
from kpu2image4xi import map2image4kpu
from lpu2image4xi import map2image4lpu
from mpu2image4xi import map2image4mpu
from npu2image4xi import map2image4npu
from opu2image4xi import map2image4opu
from ppu2image4xi import map2image4ppu
from qpu2image4xi import map2image4qpu
from rpu2image4xi import map2image4rpu
from spu2image4xi import map2image4spu
from tpu2image4xi import map2image4tpu
from upu2image4xi import map2image4upu
from vpu2image4xi import map2image4vpu
from xpu2image4xi import map2image4xpu
from wpu2image4xi import map2image4wpu
from ypu2image4xi import map2image4ypu
from zpu2image4xi import map2image4zpu

from apu2image4xi import read2image4apu                                                            
from bpu2image4xi import read2image4bpu
from cpu2image4xi import read2image4cpu
from dpu2image4xi import read2image4dpu
from epu2image4xi import read2image4epu
from fpu2image4xi import read2image4fpu
from gpu2image4xi import read2image4gpu
from hpu2image4xi import read2image4hpu
from ipu2image4xi import read2image4ipu
from jpu2image4xi import read2image4jpu
from kpu2image4xi import read2image4kpu
from lpu2image4xi import read2image4lpu
from mpu2image4xi import read2image4mpu
from npu2image4xi import read2image4npu
from opu2image4xi import read2image4opu
from ppu2image4xi import read2image4ppu
from qpu2image4xi import read2image4qpu
from rpu2image4xi import read2image4rpu
from spu2image4xi import read2image4spu
from tpu2image4xi import read2image4tpu
from upu2image4xi import read2image4upu
from vpu2image4xi import read2image4vpu
from xpu2image4xi import read2image4xpu
from wpu2image4xi import read2image4wpu
from ypu2image4xi import read2image4ypu
from zpu2image4xi import read2image4zpu

from apu2image4xi import retain2image4apu                                                            
from bpu2image4xi import retain2image4bpu
from cpu2image4xi import retain2image4cpu
from dpu2image4xi import retain2image4dpu
from epu2image4xi import retain2image4epu
from fpu2image4xi import retain2image4fpu
from gpu2image4xi import retain2image4gpu
from hpu2image4xi import retain2image4hpu
from ipu2image4xi import retain2image4ipu
from jpu2image4xi import retain2image4jpu
from kpu2image4xi import retain2image4kpu
from lpu2image4xi import retain2image4lpu
from mpu2image4xi import retain2image4mpu
from npu2image4xi import retain2image4npu
from opu2image4xi import retain2image4opu
from ppu2image4xi import retain2image4ppu
from qpu2image4xi import retain2image4qpu
from rpu2image4xi import retain2image4rpu
from spu2image4xi import retain2image4spu
from tpu2image4xi import retain2image4tpu
from upu2image4xi import retain2image4upu
from vpu2image4xi import retain2image4vpu
from xpu2image4xi import retain2image4xpu
from wpu2image4xi import retain2image4wpu
from ypu2image4xi import retain2image4ypu
from zpu2image4xi import retain2image4zpu

from apu2image4xi import release2image4apu                                                            
from bpu2image4xi import release2image4bpu
from cpu2image4xi import release2image4cpu
from dpu2image4xi import release2image4dpu
from epu2image4xi import release2image4epu
from fpu2image4xi import release2image4fpu
from gpu2image4xi import release2image4gpu
from hpu2image4xi import release2image4hpu
from ipu2image4xi import release2image4ipu
from jpu2image4xi import release2image4jpu
from kpu2image4xi import release2image4kpu
from lpu2image4xi import release2image4lpu
from mpu2image4xi import release2image4mpu
from npu2image4xi import release2image4npu
from opu2image4xi import release2image4opu
from ppu2image4xi import release2image4ppu
from qpu2image4xi import release2image4qpu
from rpu2image4xi import release2image4rpu
from spu2image4xi import release2image4spu
from tpu2image4xi import release2image4tpu
from upu2image4xi import release2image4upu
from vpu2image4xi import release2image4vpu
from xpu2image4xi import release2image4xpu
from wpu2image4xi import release2image4wpu
from ypu2image4xi import release2image4ypu
from zpu2image4xi import release2image4zpu

from apu2image4xi import set2imagecallback4apu                                                            
from bpu2image4xi import set2imagecallback4bpu
from cpu2image4xi import set2imagecallback4cpu
from dpu2image4xi import set2imagecallback4dpu
from epu2image4xi import set2imagecallback4epu
from fpu2image4xi import set2imagecallback4fpu
from gpu2image4xi import set2imagecallback4gpu
from hpu2image4xi import set2imagecallback4hpu
from ipu2image4xi import set2imagecallback4ipu
from jpu2image4xi import set2imagecallback4jpu
from kpu2image4xi import set2imagecallback4kpu
from lpu2image4xi import set2imagecallback4lpu
from mpu2image4xi import set2imagecallback4mpu
from npu2image4xi import set2imagecallback4npu
from opu2image4xi import set2imagecallback4opu
from ppu2image4xi import set2imagecallback4ppu
from qpu2image4xi import set2imagecallback4qpu
from rpu2image4xi import set2imagecallback4rpu
from spu2image4xi import set2imagecallback4spu
from tpu2image4xi import set2imagecallback4tpu
from upu2image4xi import set2imagecallback4upu
from vpu2image4xi import set2imagecallback4vpu
from xpu2image4xi import set2imagecallback4xpu
from wpu2image4xi import set2imagecallback4wpu
from ypu2image4xi import set2imagecallback4ypu
from zpu2image4xi import set2imagecallback4zpu

from apu2image4xi import set2image4apu                                                            
from bpu2image4xi import set2image4bpu
from cpu2image4xi import set2image4cpu
from dpu2image4xi import set2image4dpu
from epu2image4xi import set2image4epu
from fpu2image4xi import set2image4fpu
from gpu2image4xi import set2image4gpu
from hpu2image4xi import set2image4hpu
from ipu2image4xi import set2image4ipu
from jpu2image4xi import set2image4jpu
from kpu2image4xi import set2image4kpu
from lpu2image4xi import set2image4lpu
from mpu2image4xi import set2image4mpu
from npu2image4xi import set2image4npu
from opu2image4xi import set2image4opu
from ppu2image4xi import set2image4ppu
from qpu2image4xi import set2image4qpu
from rpu2image4xi import set2image4rpu
from spu2image4xi import set2image4spu
from tpu2image4xi import set2image4tpu
from upu2image4xi import set2image4upu
from vpu2image4xi import set2image4vpu
from xpu2image4xi import set2image4xpu
from wpu2image4xi import set2image4wpu
from ypu2image4xi import set2image4ypu
from zpu2image4xi import set2image4zpu

from apu2image4xi import trace2image4apu                                                            
from bpu2image4xi import trace2image4bpu
from cpu2image4xi import trace2image4cpu
from dpu2image4xi import trace2image4dpu
from epu2image4xi import trace2image4epu
from fpu2image4xi import trace2image4fpu
from gpu2image4xi import trace2image4gpu
from hpu2image4xi import trace2image4hpu
from ipu2image4xi import trace2image4ipu
from jpu2image4xi import trace2image4jpu
from kpu2image4xi import trace2image4kpu
from lpu2image4xi import trace2image4lpu
from mpu2image4xi import trace2image4mpu
from npu2image4xi import trace2image4npu
from opu2image4xi import trace2image4opu
from ppu2image4xi import trace2image4ppu
from qpu2image4xi import trace2image4qpu
from rpu2image4xi import trace2image4rpu
from spu2image4xi import trace2image4spu
from tpu2image4xi import trace2image4tpu
from upu2image4xi import trace2image4upu
from vpu2image4xi import trace2image4vpu
from xpu2image4xi import trace2image4xpu
from wpu2image4xi import trace2image4wpu
from ypu2image4xi import trace2image4ypu
from zpu2image4xi import trace2image4zpu

from apu2image4xi import wait2image4apu                                                            
from bpu2image4xi import wait2image4bpu
from cpu2image4xi import wait2image4cpu
from dpu2image4xi import wait2image4dpu
from epu2image4xi import wait2image4epu
from fpu2image4xi import wait2image4fpu
from gpu2image4xi import wait2image4gpu
from hpu2image4xi import wait2image4hpu
from ipu2image4xi import wait2image4ipu
from jpu2image4xi import wait2image4jpu
from kpu2image4xi import wait2image4kpu
from lpu2image4xi import wait2image4lpu
from mpu2image4xi import wait2image4mpu
from npu2image4xi import wait2image4npu
from opu2image4xi import wait2image4opu
from ppu2image4xi import wait2image4ppu
from qpu2image4xi import wait2image4qpu
from rpu2image4xi import wait2image4rpu
from spu2image4xi import wait2image4spu
from tpu2image4xi import wait2image4tpu
from upu2image4xi import wait2image4upu
from vpu2image4xi import wait2image4vpu
from xpu2image4xi import wait2image4xpu
from wpu2image4xi import wait2image4wpu
from ypu2image4xi import wait2image4ypu
from zpu2image4xi import wait2image4zpu

from apu2image4xi import write2image4apu                                                            
from bpu2image4xi import write2image4bpu
from cpu2image4xi import write2image4cpu
from dpu2image4xi import write2image4dpu
from epu2image4xi import write2image4epu
from fpu2image4xi import write2image4fpu
from gpu2image4xi import write2image4gpu
from hpu2image4xi import write2image4hpu
from ipu2image4xi import write2image4ipu
from jpu2image4xi import write2image4jpu
from kpu2image4xi import write2image4kpu
from lpu2image4xi import write2image4lpu
from mpu2image4xi import write2image4mpu
from npu2image4xi import write2image4npu
from opu2image4xi import write2image4opu
from ppu2image4xi import write2image4ppu
from qpu2image4xi import write2image4qpu
from rpu2image4xi import write2image4rpu
from spu2image4xi import write2image4spu
from tpu2image4xi import write2image4tpu
from upu2image4xi import write2image4upu
from vpu2image4xi import write2image4vpu
from xpu2image4xi import write2image4xpu
from wpu2image4xi import write2image4wpu
from ypu2image4xi import write2image4ypu
from zpu2image4xi import write2image4zpu

# -------------------------------------------------------------------------------------------------
# Buffer module                           
# -------------------------------------------------------------------------------------------------
from buffer4xi import Buffer4Xi
from buffer4xi import create2buffer4xi
from buffer4xi import create2subbuffer4xi
from buffer4xi import get2bufferinfo4xi
from buffer4xi import release2buffer4xi
from buffer4xi import retain2buffer4xi
from buffer4xi import set2buffer4xi


# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from commandqueue4xi import CommandQueue4Xi
from commandqueue4xi import create2commandqueue4xi 
from commandqueue4xi import flush2commandqueue4xi
from commandqueue4xi import finish2commandqueue4xi
from commandqueue4xi import get2commandqueueinfo4xi
from commandqueue4xi import release2commandqueue4xi
from commandqueue4xi import retain2commandqueue4xi
from commandqueue4xi import set2commandqueue4xi


# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from context4xi import Context4Xi 
from context4xi import create2context4xi
from context4xi import get2context4xi
from context4xi import release2context4xi
from context4xi import retain2context4xi
from context4xi import set2context4xi


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from device4xi import Device4Xi
from device4xi import init2device4xi 
from device4xi import set2device4xi
from device4xi import get2device4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from event4xi import Event4Xi


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global image2d4xi                                                      # 2D-IMAGES

global image2dtrace4xi                                                 # TRACE

global image2dbuffer4xi                                                # BUFFER FOR 2D-IMAGES
global info2image4xi                                                   # IMAGE INFORMATION

global platform2xi                                                     # PLATFORM
global device2xi                                                       # DEVICE
global context2xi                                                      # CONTEXT

global mission2read                                                    # MISSION TO READ
global mission2copy                                                    # MISSION TO COPY 
global mission2copyimagetobuffer                                       # MISSION TO COPYIMAGETOBUFFER     
global mission2copybuffertoimage                                       # MISSION TO COPYBUFFERTOIMAGE  
global mission2map                                                     # MISSION TO MAP                                       
global mission2write                                                   # MISSION TO WRITE  

global control2readimage4xi                                            # COMMAND AND CONTROL TO READ 2D IMAGES  
global state2read4xi                                                   # STATE FOR COMMAND AND CONTROL
global max2readstate4xi                                                # MAX FOR STATE
global ack2readinfo4xi                                                 # ACK FOR IMAGE INFO
global message2readget4xi                                              # QUEUE GET
global message2readput4xi                                              # QUEUE PUT
global message2readreceive4xi                                          # PIPE RECEIVE
global message2readsend4xi                                             # PIPE SEND

global control2writeimage4xi                                           # COMMAND AND CONTROL TO WRITE 2D IMAGES 
global state2write4xi                                                  # STATE FOR COMMAND AND CONTROL
global max2writestate4xi                                               # MAX FOR STATE
global ack2writeinfo4xi                                                # ACK FOR IMAGE INFO
global message2writeget4xi                                             # QUEUE GET
global message2writeput4xi                                             # QUEUE PUT
global message2writereceive4xi                                         # PIPE RECEIVE
global message2writesend4xi                                            # PIPE SEND

global control2copy4xi                                                 # COMMAND AND CONTROL TO COPY 2D IMAGES 
global state2copy4xi                                                   # STATE FOR COMMAND AND CONTROL
global max2copystate4xi                                                # MAX FOR STATE
global ack2copyinfo4xi                                                 # ACK FOR IMAGE INFO
global message2copyget4xi                                              # QUEUE GET
global message2copyput4xi                                              # QUEUE PUT
global message2copyreceive4xi                                          # PIPE RECEIVE
global message2copysend4xi                                             # PIPE SEND

global control2copytobuffer4xi                                         # COMMAND AND CONTROL TO COPY 2D IMAGES TO BUFFER WITH XI 
global state2copyimagetobuffer4xi                                      # STATE FOR COMMAND AND CONTROL
global max2copyimagetobufferstate4xi                                   # MAX FOR STATE
global ack2copyimagetobufferinfo4xi                                    # ACK FOR IMAGE INFO
global message2copyimagetobufferget4xi                                 # QUEUE GET
global message2copyimagetobufferput4xi                                 # QUEUE PUT
global message2copyimagetobufferreceive4xi                             # PIPE RECEIVE
global message2copyimagetobuffersend4xi                                # PIPE SEND

global control2copybuffertoimage4xi                                    # COMMAND AND CONTROL TO COPY BUFFER TO 2D IMAGE WITH XI 
global state2copybuffertoimage4xi                                      # STATE FOR COMMAND AND CONTROL
global max2copybuffertoimagestate4xi                                   # MAX FOR STATE
global ack2copybuffertoimageinfo4xi                                    # ACK FOR IMAGE INFO
global message2copybuffertoimageget4xi                                 # QUEUE GET
global message2copybuffertoimageput4xi                                 # QUEUE PUT
global message2copybuffertoimagereceive4xi                             # PIPE RECEIVE
global message2copybuffertoimagesend4xi                                # PIPE SEND                      

global control2mapimage4xi                                             # COMMAND AND CONTROL TO READ  2D IMAGES  
global state2map4xi                                                    # STATE FOR COMMAND AND CONTROL
global max2mapstate4xi                                                 # MAX FOR STATE
global ack2mapinfo4xi                                                  # ACK FOR IMAGE INFO
global message2mapget4xi                                               # QUEUE GET
global message2mapput4xi                                               # QUEUE PUT
global message2mapreceive4xi                                           # PIPE RECEIVE
global message2mapsend4xi                                              # PIPE SEND

          
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
image2d4xi = {}                                                      # 2D-IMAGES
image2dtrace4xi = {}                                                 # TRACE
image2dbuffer4xi = {}                                                # BUFFER FOR 2D-IMAGES
info2image4xi = {}                                                   # IMAGE INFORMATION

platform2xi = {}                                                     # PLATFORM
device2xi   = {}                                                     # DEVICE
context2xi  = {}                                                     # CONTEXT

mission2read = "NACK"                                                # MISSION TO READ

control2readimage4xi = {}                                            # COMMAND AND CONTROL TO READ 2D IMAGES  

state2read4xi = {}                                                   # STATE FOR COMMAND AND CONTROL
    
max2readstate4xi = {}                                                # MAX FOR STATE
ack2readinfo4xi = {}                                                 # ACK FOR IMAGE INFO
message2readget4xi = {}                                              # QUEUE GET
message2readput4xi = {}                                              # QUEUE PUT
message2readreceive4xi = {}                                          # PIPE RECEIVE
message2readsend4xi = {}                                             # PIPE SEND

control2writeimage4xi = {}                                           # COMMAND AND CONTROL TO WRITE 2D IMAGES 
state2write4xi = {}                                                  # STATE FOR COMMAND AND CONTROL
max2writestate4xi = {}                                               # MAX FOR STATE
ack2writeinfo4xi = {}                                                # ACK FOR IMAGE INFO
message2writeget4xi = {}                                             # QUEUE GET
message2writeput4xi = {}                                             # QUEUE PUT
message2writereceive4xi = {}                                         # PIPE RECEIVE
message2writesend4xi = {}                                            # PIPE SEND

control2copy4xi = {}                                                 # COMMAND AND CONTROL TO COPY 2D IMAGES 
state2copy4xi = {}                                                   # STATE FOR COMMAND AND CONTROL
max2copystate4xi = {}                                                # MAX FOR STATE
ack2copyinfo4xi = {}                                                 # ACK FOR IMAGE INFO
message2copyget4xi = {}                                              # QUEUE GET
message2copyput4xi = {}                                              # QUEUE PUT
message2copyreceive4xi = {}                                          # PIPE RECEIVE
message2copysend4xi = {}                                             # PIPE SEND

control2copytobuffer4xi = {}                                         # COMMAND AND CONTROL TO COPY 2D IMAGES TO BUFFER WITH XI 
state2copyimagetobuffer4xi = {}                                      # STATE FOR COMMAND AND CONTROL
max2copyimagetobufferstate4xi = {}                                   # MAX FOR STATE
ack2copyimagetobufferinfo4xi = {}                                    # ACK FOR IMAGE INFO
message2copyimagetobufferget4xi = {}                                 # QUEUE GET
message2copyimagetobufferput4xi = {}                                 # QUEUE PUT
message2copyimagetobufferreceive4xi = {}                             # PIPE RECEIVE
message2copyimagetobuffersend4xi = {}                                # PIPE SEND

control2copybuffertoimage4xi = {}                                    # COMMAND AND CONTROL TO COPY BUFFER TO 2D IMAGE WITH XI 
state2copybuffertoimage4xi = {}                                      # STATE FOR COMMAND AND CONTROL
max2copybuffertoimagestate4xi = {}                                   # MAX FOR STATE
ack2copybuffertoimageinfo4xi = {}                                    # ACK FOR IMAGE INFO
message2copybuffertoimageget4xi = {}                                 # QUEUE GET
message2copybuffertoimageput4xi = {}                                 # QUEUE PUT
message2copybuffertoimagereceive4xi = {}                             # PIPE RECEIVE
message2copybuffertoimagesend4xi = {}                                # PIPE SEND                      

control2mapimage4xi = {}                                             # COMMAND AND CONTROL TO READ  2D IMAGES  
state2map4xi = {}                                                    # STATE FOR COMMAND AND CONTROL
max2mapstate4xi = {}                                                 # MAX FOR STATE
ack2mapinfo4xi = {}                                                  # ACK FOR IMAGE INFO
message2mapget4xi = {}                                               # QUEUE GET
message2mapput4xi = {}                                               # QUEUE PUT
message2mapreceive4xi = {}                                           # PIPE RECEIVE
message2mapsend4xi = {}                                              # PIPE SEND
#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2image4xi" usage = "  
#
#   print('(Step 15A/25) OF IMAGE2D4XI5TEST - TRYING TO TRACE XI: ', time4xi()) 
#   try:                               
#       task4trace2image  = {}
#       for key2pu in keys2pu:
#           task4trace2image[key2pu]  = {}
#       response4trace2image = trace2image4xi(task4trace2image)  
#       key2response = response4trace2image.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4trace2image[key2response] )
#           # APU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4apu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2image4apu', 'METHOD': 'trace2image4apu'}
#           # GPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4gpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2image4gpu', 'METHOD': 'trace2image4gpu'}
#           # XPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4xpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2image4xpu', 'METHOD': 'trace2image4xpu'}
#           # ZPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4zpu-failed {}; time: 04:43:16 10/31/11 Pacific Daylight Time}', 'CLASS': 'trace2image4zpu', 'METHOD': 'trace2image4zpu'}                                                                                                  
#   except:
#       print('(Step 15Z1/25) OF IMAGE2D4XI5TEST *** FAILED TO TRACE XI: ', time4xi()) 
#
#">

# -------------------------------------------------------------------------------------------------   
def trace2image4xi(task4trace2xi=None):  

    '''
    creates callback to image2d4xi
    '''

    global image2dtrace4xi
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    debug = True
    
    class2print = "trace2image4xi" 
    method2print = "trace2image4xi"

    message2print = "{(Step 1A/33) started" + "; trace2image4xi-started: " + str(trace2image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # <function trace2image4xi at 0x0000000003AF0348> 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2xi-to-trace2image4xi: " + str(task4trace2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # None 

    code2ack  = ' '
    code2nack = ' '    
    
    image2dtrace4xi = {}                                                                                             # INITIALIZES TO EMPTY DICTIONARY
      
      
    if task4trace2xi is None:
        keys2task = None    
    else:
        try:
            keys2task = task4trace2xi.keys()
        except:
            keys2task = None   
    if debug is True:
       print("{(Step 1C/33) of trace2image4xi - keys2task: ", sorted(keys2task))
               

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        if 'APU' in keys2task:
            message2print = "{(Step A/33) passing" + "; task-passing-to-trace2image4apu: " + str(task4trace2xi['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            
            image2dtrace4xi ['APU']  = trace2image4apu()                                                      
             
            message2print = "{(Step A1/33) set" + "; apu-image-trace-set-by-trace2image4apu to: " + str(image2dtrace4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step A2/33) of trace2image4xi - set trace4xi of APU image to: ", image2dtrace4xi ['APU'])
            
            code2ack  = code2ack + 'A1-'
        else:
            pass    
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-trace2image4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        if 'BPU' in keys2task:
            message2print = "{(Step B/33) passing" + "; task-passing-to-trace2image4bpu: " + str(task4trace2xi['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['BPU']  = trace2image4bpu()                                                      # 
         
            message2print = "{(Step B1/33) set" + "; bpu-image-trace-set-by-trace2image4bpu to: " + str(image2dtrace4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'B1-'
        else:
            pass    
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-trace2image4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        if 'CPU' in keys2task:
            message2print = "{(Step C/33) passing" + "; task-passing-to-trace2image4cpu: " + str(task4trace2xi['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['CPU']  = trace2image4cpu()                                                      # 
         
            message2print = "{(Step C1/33) set" + "; cpu-image-trace-set-by-trace2image4cpu to: " + str(image2dtrace4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'C1-'
        else:
            pass    
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-trace2image4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        if 'DPU' in keys2task:
            message2print = "{(Step D/33) passing" + "; task-passing-to-trace2image4dpu: " + str(task4trace2xi['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['DPU']  = trace2image4dpu()                                                      # 
         
            message2print = "{(Step D1/33) set" + "; dpu-image-trace-set-by-trace2image4dpu to: " + str(image2dtrace4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'D1-'
        else:
            pass    
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-trace2image4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        if 'EPU' in keys2task:
            message2print = "{(Step E/33) passing" + "; task-passing-to-trace2image4epu: " + str(task4trace2xi['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['EPU']  = trace2image4epu()                                                      # 
         
            message2print = "{(Step E1/33) set" + "; epu-image-trace-set-by-trace2image4epu to: " + str(image2dtrace4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'E1-'
        else:
            pass    
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-trace2image4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        if 'FPU' in keys2task:
            message2print = "{(Step F/33) passing" + "; task-passing-to-trace2image4fpu: " + str(task4trace2xi['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['FPU']  = trace2image4fpu()                                                      # 
         
            message2print = "{(Step F1/33) set" + "; fpu-image-trace-set-by-trace2image4fpu to: " + str(image2dtrace4xi ['PU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'F1-'
        else:
            pass    
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-trace2image4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        if 'GPU' in keys2task:
            message2print = "{(Step G/33) passing" + "; task-passing-to-trace2image4gpu: " + str(task4trace2xi['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['GPU']  = trace2image4gpu()                                                      # 
         
            message2print = "{(Step G1/33) set" + "; gpu-image-trace-set-by-trace2image4gpu to: " + str(image2dtrace4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'G1-'
        else:
            pass    
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-trace2image4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        if 'HPU' in keys2task:
            message2print = "{(Step H/33) passing" + "; task-passing-to-trace2image4hpu: " + str(task4trace2xi['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['HPU']  = trace2image4hpu()                                                      # 
         
            message2print = "{(Step H1/33) set" + "; hpu-image-trace-set-by-trace2image4hpu to: " + str(image2dtrace4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'H1-'
        else:
            pass    
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-trace2image4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        if 'IPU' in keys2task:
            message2print = "{(Step I/33) passing" + "; task-passing-to-trace2image4ipu: " + str(task4trace2xi['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['IPU']  = trace2image4ipu()                                                      # 
         
            message2print = "{(Step I1/33) set" + "; ipu-image-trace-set-by-trace2image4ipu to: " + str(image2dtrace4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'I1-'
        else:
            pass    
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-trace2image4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        if 'JPU' in keys2task:
            message2print = "{(Step J/33) passing" + "; task-passing-to-trace2image4jpu: " + str(task4trace2xi['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['JPU']  = trace2image4jpu()                                                      # 
         
            message2print = "{(Step J1/33) set" + "; jpu-image-trace-set-by-trace2image4jpu to: " + str(image2dtrace4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'J1-'
        else:
            pass    
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-trace2image4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        if 'KPU' in keys2task:
            message2print = "{(Step K/33) passing" + "; task-passing-to-trace2image4kpu: " + str(task4trace2xi['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['KPU']  = trace2image4kpu()                                                      # 
         
            message2print = "{(Step K1/33) set" + "; kpu-image-trace-set-by-trace2image4kpu to: " + str(image2dtrace4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'K1-'
        else:
            pass    
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-trace2image4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        if 'LPU' in keys2task:
            message2print = "{(Step L/33) passing" + "; task-passing-to-trace2image4lpu: " + str(task4trace2xi['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['LPU']  = trace2image4lpu()                                                      # 
         
            message2print = "{(Step L1/33) set" + "; lpu-image-trace-set-by-trace2image4lpu to: " + str(image2dtrace4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + '1-'
        else:
            pass    
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-trace2image4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        if 'MPU' in keys2task:
            message2print = "{(Step M/33) passing" + "; task-passing-to-trace2image4mpu: " + str(task4trace2xi['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['MPU']  = trace2image4mpu()                                                      # 
         
            message2print = "{(Step M1/33) set" + "; mpu-image-trace-set-by-trace2image4mpu to: " + str(image2dtrace4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'M1-'
        else:
            pass    
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-trace2image4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        if 'NPU' in keys2task:
            message2print = "{(Step N/33) passing" + "; task-passing-to-trace2image4npu: " + str(task4trace2xi['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['NPU']  = trace2image4npu()                                                      # 
         
            message2print = "{(Step N1/33) set" + "; npu-image-trace-set-by-trace2image4npu to: " + str(image2dtrace4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'N1-'
        else:
            pass    
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-trace2image4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        if 'OPU' in keys2task:
            message2print = "{(Step O/33) passing" + "; task-passing-to-trace2image4opu: " + str(task4trace2xi['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['OPU']  = trace2image4opu()                                                      # 
         
            message2print = "{(Step O1/33) set" + "; opu-image-trace-set-by-trace2image4opu to: " + str(image2dtrace4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'O1-'
        else:
            pass    
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-trace2image4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        if 'PPU' in keys2task:
            message2print = "{(Step P/33) passing" + "; task-passing-to-trace2image4ppu: " + str(task4trace2xi['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['PPU']  = trace2image4ppu()                                                      # 
         
            message2print = "{(Step P1/33) set" + "; ppu-image-trace-set-by-trace2image4ppu to: " + str(image2dtrace4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'P1-'
        else:
            pass    
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-trace2image4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        if 'QPU' in keys2task:
            message2print = "{(Step Q/33) passing" + "; task-passing-to-trace2image4qpu: " + str(task4trace2xi['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['QPU']  = trace2image4qpu()                                                      # 
         
            message2print = "{(Step Q1/33) set" + "; qpu-image-trace-set-by-trace2image4qpu to: " + str(image2dtrace4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Q1-'
        else:
            pass    
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-trace2image4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        if 'RPU' in keys2task:
            message2print = "{(Step R/33) passing" + "; task-passing-to-trace2image4rpu: " + str(task4trace2xi['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['RPU']  = trace2image4rpu()                                                      # 
         
            message2print = "{(Step R1/33) set" + "; rpu-image-trace-set-by-trace2image4rpu to: " + str(image2dtrace4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'R1-'
        else:
            pass    
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-trace2image4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        if 'SPU' in keys2task:
            message2print = "{(Step S/33) passing" + "; task-passing-to-trace2image4spu: " + str(task4trace2xi['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['SPU']  = trace2image4spu()                                                      # 
         
            message2print = "{(Step S1/33) set" + "; spu-image-trace-set-by-trace2image4spu to: " + str(image2dtrace4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'S1-'
        else:
            pass    
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-trace2image4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        if 'TPU' in keys2task:
            message2print = "{(Step T/33) passing" + "; task-passing-to-trace2image4tpu: " + str(task4trace2xi['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['TPU']  = trace2image4tpu()                                                      # 
         
            message2print = "{(Step T1/33) set" + "; tpu-image-trace-set-by-trace2image4tpu to: " + str(image2dtrace4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'T1-'
        else:
            pass    
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-trace2image4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        if 'UPU' in keys2task:
            message2print = "{(Step U/33) passing" + "; task-passing-to-trace2image4upu: " + str(task4trace2xi['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['UPU']  = trace2image4upu()                                                      # 
         
            message2print = "{(Step U1/33) set" + "; upu-image-trace-set-by-trace2image4upu to: " + str(image2dtrace4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'U1-'
        else:
            pass    
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-trace2image4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        if 'VPU' in keys2task:
            message2print = "{(Step V/33) passing" + "; task-passing-to-trace2image4vpu: " + str(task4trace2xi['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['VPU']  = trace2image4vpu()                                                      # 
         
            message2print = "{(Step V1/33) set" + "; vpu-image-trace-set-by-trace2image4vpu to: " + str(image2dtrace4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'V1-'
        else:
            pass    
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-trace2image4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        if 'WPU' in keys2task:
            message2print = "{(Step W/33) passing" + "; task-passing-to-trace2image4wpu: " + str(task4trace2xi['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['WPU']  = trace2image4wpu()                                                      # 
         
            message2print = "{(Step W1/33) set" + "; wpu-image-trace-set-by-trace2image4wpu to: " + str(image2dtrace4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'W1-'
        else:
            pass    
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-trace2image4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        if 'XPU' in keys2task:
            message2print = "{(Step X/33) passing" + "; task-passing-to-trace2image4xpu: " + str(task4trace2xi['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['XPU']  = trace2image4xpu()                                                      # 
         
            message2print = "{(Step X1/33) set" + "; xpu-image-trace-set-by-trace2image4xpu to: " + str(image2dtrace4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step X2/33) of trace2image4xi - set trace4xi of XPU image to: ", image2dtrace4xi ['XPU'])
            code2ack  = code2ack + 'X1-'
        else:
            pass    
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-trace2image4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        if 'YPU' in keys2task:
            message2print = "{(Step Y/33) passing" + "; task-passing-to-trace2image4ypu: " + str(task4trace2xi['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['YPU']  = trace2image4ypu()                                                      # 
         
            message2print = "{(Step Y1/33) set" + "; ypu-image-trace-set-by-trace2image4ypu to: " + str(image2dtrace4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Y1-'
        else:
            pass    
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-trace2image4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        if 'ZPU' in keys2task:
            message2print = "{(Step Z/33) passing" + "; task-passing-to-trace2image4zpu: " + str(task4trace2xi['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2dtrace4xi ['ZPU']  = trace2image4zpu()                                                      # 
         
            message2print = "{(Step Z1/33) set" + "; zpu-image-trace-set-by-trace2image4zpu to: " + str(image2dtrace4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step Z2/33) of trace2image4xi - set trace4xi of ZPU image to: ", image2dtrace4xi ['ZPU'])
            code2ack  = code2ack + 'Z1-'
        else:
            pass    
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-trace2image4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of trace2image4xi image2dtrace4xi - RETURNING : ", image2dtrace4xi)
    
    message2print = "{(Step 33/33) returning" + "; image2dtrace4xi-returning-by-trace2image4xi: " + str(image2dtrace4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    return image2dtrace4xi


#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2imagecallback4xi" usage = " 
#
#   print('(Step 14B/700) OF IMAGE2D4XI5TEST - TRYING TO SET 2D IMAGE CALLBACK OF XI DEVICE ', time4xi())     
#   try:                               
#       task4callback2image  = {}
#       for key2pu in keys2pu:
#           task4callback2image[key2pu]  = {}
#       response4setcallback2image = set2imagecallback4xi(task4callback2image) 
#       key2response = response4setcallback2image.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4setcallback2image[key2response])
#           # APU  :  <function trace2image4apu at 0x00000000043F1C48>
#           # ...
#           # ZPU  :  <function trace2image4zpu at 0x00000000058610C8>
#                                                                                                     
#   except:
#       print('(Step 14Z2/700) OF IMAGE2D4XI5TEST *** FAILED TO SET 2D IMAGE CALLBACK OF XI DEVICE ', time4xi())
#
#">

# ------------------------------------------------------------------------------------------------- 
 
def set2imagecallback4xi(task4set2imagecallback=None):

    '''
    registers callback function to image2d4xi
    '''
    global image2d4xi
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    
    class2print = "set2imagecallback4xi"
    method2print = "set2imagecallback4xi"

    message2print = "{(Step 1A/33) started" + "; set2imagecallback4xi-started: " + str(set2imagecallback4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2imagecallback4xi at 0x0000000003A62848> 
    
    message2print = "{(Step 1B/33) passed" + "; task4imageset2xi-to-set2imagecallback4xi: " + str(task4set2imagecallback) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
            
    code2ack  = ' '
    code2nack = ' '
    if image2d4xi is None:
        image2d4xi = create2image2d4xi()                                                                            
                                
        message2print = "{(Step 1C/33) set" + "; image2d4xi-set-by-set2imagecallback4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
    
        
    if task4set2imagecallback is None:
        keys2task = None    
    else:
        try:
            keys2task = task4set2imagecallback.keys()
        except:
            keys2task = None   
    if debug is True:
       print("{(Step 1C/33) of set2imagecallback4xi - keys2task: ", sorted(keys2task))
               

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        if 'APU' in keys2task:
            message2print = "{(Step A/33) passing" + "; task-passing-to-set2imagecallback4apu: " + str(task4set2imagecallback['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            
            image2d4xi ['APU'] ['CALLBACK'] = set2imagecallback4apu()                                                      # 
             
            message2print = "{(Step A1/33) set" + "; apu-image-set-by-set2imagecallback4apu to: " + str(image2d4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step A2/33) of set2imagecallback4xi - set callback4xi of APU image to: ", image2d4xi ['APU'] ['CALLBACK'])
            
            code2ack  = code2ack + 'A1-'
        else:
            pass    
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set2imagecallback4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        if 'BPU' in keys2task:
            message2print = "{(Step B/33) passing" + "; task-passing-to-set2imagecallback4bpu: " + str(task4set2imagecallback['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['BPU'] ['CALLBACK'] = set2imagecallback4bpu()                                                      # 
         
            message2print = "{(Step B1/33) set" + "; bpu-image-set-by-set2imagecallback4bpu to: " + str(image2d4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'B1-'
        else:
            pass    
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set2imagecallback4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        if 'CPU' in keys2task:
            message2print = "{(Step C/33) passing" + "; task-passing-to-set2imagecallback4cpu: " + str(task4set2imagecallback['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['CPU'] ['CALLBACK'] = set2imagecallback4cpu()                                                      # 
         
            message2print = "{(Step C1/33) set" + "; cpu-image-set-by-set2imagecallback4cpu to: " + str(image2d4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'C1-'
        else:
            pass    
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set2imagecallback4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        if 'DPU' in keys2task:
            message2print = "{(Step D/33) passing" + "; task-passing-to-set2imagecallback4dpu: " + str(task4set2imagecallback['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['DPU'] ['CALLBACK'] = set2imagecallback4dpu()                                                      # 
         
            message2print = "{(Step D1/33) set" + "; dpu-image-set-by-set2imagecallback4dpu to: " + str(image2d4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'D1-'
        else:
            pass    
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set2imagecallback4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        if 'EPU' in keys2task:
            message2print = "{(Step E/33) passing" + "; task-passing-to-set2imagecallback4epu: " + str(task4set2imagecallback['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['EPU'] ['CALLBACK'] = set2imagecallback4epu()                                                      # 
         
            message2print = "{(Step E1/33) set" + "; epu-image-set-by-set2imagecallback4epu to: " + str(image2d4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'E1-'
        else:
            pass    
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set2imagecallback4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        if 'FPU' in keys2task:
            message2print = "{(Step F/33) passing" + "; task-passing-to-set2imagecallback4fpu: " + str(task4set2imagecallback['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['FPU'] ['CALLBACK'] = set2imagecallback4fpu()                                                      # 
         
            message2print = "{(Step F1/33) set" + "; fpu-image-set-by-set2imagecallback4fpu to: " + str(image2d4xi ['PU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'F1-'
        else:
            pass    
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set2imagecallback4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        if 'GPU' in keys2task:
            message2print = "{(Step G/33) passing" + "; task-passing-to-set2imagecallback4gpu: " + str(task4set2imagecallback['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['GPU'] ['CALLBACK'] = set2imagecallback4gpu()                                                      # 
         
            message2print = "{(Step G1/33) set" + "; gpu-image-set-by-set2imagecallback4gpu to: " + str(image2d4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'G1-'
        else:
            pass    
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set2imagecallback4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        if 'HPU' in keys2task:
            message2print = "{(Step H/33) passing" + "; task-passing-to-set2imagecallback4hpu: " + str(task4set2imagecallback['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['HPU'] ['CALLBACK'] = set2imagecallback4hpu()                                                      # 
         
            message2print = "{(Step H1/33) set" + "; hpu-image-set-by-set2imagecallback4hpu to: " + str(image2d4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'H1-'
        else:
            pass    
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set2imagecallback4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        if 'IPU' in keys2task:
            message2print = "{(Step I/33) passing" + "; task-passing-to-set2imagecallback4ipu: " + str(task4set2imagecallback['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['IPU'] ['CALLBACK'] = set2imagecallback4ipu()                                                      # 
         
            message2print = "{(Step I1/33) set" + "; ipu-image-set-by-set2imagecallback4ipu to: " + str(image2d4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'I1-'
        else:
            pass    
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set2imagecallback4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        if 'JPU' in keys2task:
            message2print = "{(Step J/33) passing" + "; task-passing-to-set2imagecallback4jpu: " + str(task4set2imagecallback['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['JPU'] ['CALLBACK'] = set2imagecallback4jpu()                                                      # 
         
            message2print = "{(Step J1/33) set" + "; jpu-image-set-by-set2imagecallback4jpu to: " + str(image2d4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'J1-'
        else:
            pass    
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set2imagecallback4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        if 'KPU' in keys2task:
            message2print = "{(Step K/33) passing" + "; task-passing-to-set2imagecallback4kpu: " + str(task4set2imagecallback['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['KPU'] ['CALLBACK'] = set2imagecallback4kpu()                                                      # 
         
            message2print = "{(Step K1/33) set" + "; kpu-image-set-by-set2imagecallback4kpu to: " + str(image2d4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'K1-'
        else:
            pass    
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set2imagecallback4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        if 'LPU' in keys2task:
            message2print = "{(Step L/33) passing" + "; task-passing-to-set2imagecallback4lpu: " + str(task4set2imagecallback['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['LPU'] ['CALLBACK'] = set2imagecallback4lpu()                                                      # 
         
            message2print = "{(Step L1/33) set" + "; lpu-image-set-by-set2imagecallback4lpu to: " + str(image2d4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + '1-'
        else:
            pass    
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set2imagecallback4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        if 'MPU' in keys2task:
            message2print = "{(Step M/33) passing" + "; task-passing-to-set2imagecallback4mpu: " + str(task4set2imagecallback['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['MPU'] ['CALLBACK'] = set2imagecallback4mpu()                                                      # 
         
            message2print = "{(Step M1/33) set" + "; mpu-image-set-by-set2imagecallback4mpu to: " + str(image2d4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'M1-'
        else:
            pass    
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set2imagecallback4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        if 'NPU' in keys2task:
            message2print = "{(Step N/33) passing" + "; task-passing-to-set2imagecallback4npu: " + str(task4set2imagecallback['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['NPU'] ['CALLBACK'] = set2imagecallback4npu()                                                      # 
         
            message2print = "{(Step N1/33) set" + "; npu-image-set-by-set2imagecallback4npu to: " + str(image2d4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'N1-'
        else:
            pass    
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set2imagecallback4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        if 'OPU' in keys2task:
            message2print = "{(Step O/33) passing" + "; task-passing-to-set2imagecallback4opu: " + str(task4set2imagecallback['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['OPU'] ['CALLBACK'] = set2imagecallback4opu()                                                      # 
         
            message2print = "{(Step O1/33) set" + "; opu-image-set-by-set2imagecallback4opu to: " + str(image2d4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'O1-'
        else:
            pass    
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set2imagecallback4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        if 'PPU' in keys2task:
            message2print = "{(Step P/33) passing" + "; task-passing-to-set2imagecallback4ppu: " + str(task4set2imagecallback['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['PPU'] ['CALLBACK'] = set2imagecallback4ppu()                                                      # 
         
            message2print = "{(Step P1/33) set" + "; ppu-image-set-by-set2imagecallback4ppu to: " + str(image2d4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'P1-'
        else:
            pass    
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set2imagecallback4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        if 'QPU' in keys2task:
            message2print = "{(Step Q/33) passing" + "; task-passing-to-set2imagecallback4qpu: " + str(task4set2imagecallback['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['QPU'] ['CALLBACK'] = set2imagecallback4qpu()                                                      # 
         
            message2print = "{(Step Q1/33) set" + "; qpu-image-set-by-set2imagecallback4qpu to: " + str(image2d4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Q1-'
        else:
            pass    
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set2imagecallback4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        if 'RPU' in keys2task:
            message2print = "{(Step R/33) passing" + "; task-passing-to-set2imagecallback4rpu: " + str(task4set2imagecallback['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['RPU'] ['CALLBACK'] = set2imagecallback4rpu()                                                      # 
         
            message2print = "{(Step R1/33) set" + "; rpu-image-set-by-set2imagecallback4rpu to: " + str(image2d4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'R1-'
        else:
            pass    
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set2imagecallback4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        if 'SPU' in keys2task:
            message2print = "{(Step S/33) passing" + "; task-passing-to-set2imagecallback4spu: " + str(task4set2imagecallback['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['SPU'] ['CALLBACK'] = set2imagecallback4spu()                                                      # 
         
            message2print = "{(Step S1/33) set" + "; spu-image-set-by-set2imagecallback4spu to: " + str(image2d4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'S1-'
        else:
            pass    
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set2imagecallback4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        if 'TPU' in keys2task:
            message2print = "{(Step T/33) passing" + "; task-passing-to-set2imagecallback4tpu: " + str(task4set2imagecallback['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['TPU'] ['CALLBACK'] = set2imagecallback4tpu()                                                      # 
         
            message2print = "{(Step T1/33) set" + "; tpu-image-set-by-set2imagecallback4tpu to: " + str(image2d4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'T1-'
        else:
            pass    
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set2imagecallback4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        if 'UPU' in keys2task:
            message2print = "{(Step U/33) passing" + "; task-passing-to-set2imagecallback4upu: " + str(task4set2imagecallback['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['UPU'] ['CALLBACK'] = set2imagecallback4upu()                                                      # 
         
            message2print = "{(Step U1/33) set" + "; upu-image-set-by-set2imagecallback4upu to: " + str(image2d4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'U1-'
        else:
            pass    
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set2imagecallback4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        if 'VPU' in keys2task:
            message2print = "{(Step V/33) passing" + "; task-passing-to-set2imagecallback4vpu: " + str(task4set2imagecallback['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['VPU'] ['CALLBACK'] = set2imagecallback4vpu()                                                      # 
         
            message2print = "{(Step V1/33) set" + "; vpu-image-set-by-set2imagecallback4vpu to: " + str(image2d4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'V1-'
        else:
            pass    
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set2imagecallback4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        if 'WPU' in keys2task:
            message2print = "{(Step W/33) passing" + "; task-passing-to-set2imagecallback4wpu: " + str(task4set2imagecallback['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['WPU'] ['CALLBACK'] = set2imagecallback4wpu()                                                      # 
         
            message2print = "{(Step W1/33) set" + "; wpu-image-set-by-set2imagecallback4wpu to: " + str(image2d4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'W1-'
        else:
            pass    
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set2imagecallback4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        if 'XPU' in keys2task:
            message2print = "{(Step X/33) passing" + "; task-passing-to-set2imagecallback4xpu: " + str(task4set2imagecallback['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['XPU'] ['CALLBACK'] = set2imagecallback4xpu()                                                      # 
         
            message2print = "{(Step X1/33) set" + "; xpu-image-set-by-set2imagecallback4xpu to: " + str(image2d4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step X2/33) of set2imagecallback4xi - set callback4xi of XPU image to: ", image2d4xi ['XPU'] ['CALLBACK'])
            code2ack  = code2ack + 'X1-'
        else:
            pass    
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set2imagecallback4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        if 'YPU' in keys2task:
            message2print = "{(Step Y/33) passing" + "; task-passing-to-set2imagecallback4ypu: " + str(task4set2imagecallback['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['YPU'] ['CALLBACK'] = set2imagecallback4ypu()                                                      # 
         
            message2print = "{(Step Y1/33) set" + "; ypu-image-set-by-set2imagecallback4ypu to: " + str(image2d4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Y1-'
        else:
            pass    
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set2imagecallback4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        if 'ZPU' in keys2task:
            message2print = "{(Step Z/33) passing" + "; task-passing-to-set2imagecallback4zpu: " + str(task4set2imagecallback['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['ZPU'] ['CALLBACK'] = set2imagecallback4zpu()                                                      # 
         
            message2print = "{(Step Z1/33) set" + "; zpu-image-set-by-set2imagecallback4zpu to: " + str(image2d4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step Z2/33) of set2imagecallback4xi - set callback4xi of ZPU image to: ", image2d4xi ['ZPU'] ['CALLBACK'])
            code2ack  = code2ack + 'Z1-'
        else:
            pass    
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set2imagecallback4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of set2imagecallback4xi - RETURNING IMAGE2D4XI: ", image2d4xi)
    
    message2print = "{(Step 33/33) returning" + "; image2d4xi-returning-by-set2imagecallback4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    return image2d4xi
         
#</function4xi> 

 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2image4xi" usage = "
#1     
#   print('=' *33)          
#   print('(Step 2A/700) OF IMAGE2D4XI5TEST - TRYING TO CREATE 2D IMAGE4XI ', time4xi())      
#   print('=' *33)        
#   # 
#   try:
#       response4create2Dimage = create2image4xi()                                                                 
#       print('(Step 2B/700) OF IMAGE2D4XI5TEST - CREATED 2D IMAGE4XI ', time4xi())
#       keys2response = response4create2Dimage.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4create2Dimage[key2response])
#           # 
#   except:
#       print('(Step 2Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO CREATE 2D IMAGE4XI *** ', time4xi())
#2
#   print('(Step 123A/700) OF IMAGE2D4XI5TEST - TRYING TO CREATE 2D IMAGE for XI ', time4xi()) 
#   # 
#   try:
#       xi2xi = Image2D4Xi()                            
#       response4create2Dimage = xi2xi.create2image()                                  
#       keys2response = response4create2Dimage.keys()
#       print('(Step 122B/700) OF IMAGE2D4XI5TEST - CREATED 2D IMAGE ', time4xi())  
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4create2Dimage[key2response])
#           # 
#   except:
#       print('(Step 123Z/700) OF IMAGE2D4XI5TEST *** FAILED TO CREATE 2D IMAGE for XI ', time4xi())    
#">

# -------------------------------------------------------------------------------------------------   
def create2image4xi(task4imagecreate2xi=None):

    '''
    creates 2D image for device xi
    '''
    global platform2xi
    global device2xi
    global context2xi 
    global image2d4xi
    global info2image4xi                                                                                              
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
        
    class2print = "create2image4xi" 
    method2print = "create2image4xi"

    message2print = "{(Step 1A/70) started" + "; create2image4xi-started: " + str(create2image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2image4xi at 0x00000000038D97C8> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4imagecreate2xi-to-create2image4xi: " + str(task4imagecreate2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # None 

    code2ack  = ' '
    code2nack = ' '    
    
    ack2all = False             
    if task4imagecreate2xi is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - SYSTEM CREATES ALL
        # -----------------------------------------------------------------------------------------    
        ack2all = True                                                                                                
        code2ack  = code2ack + '1C-'
    else:
        # -----------------------------------------------------------------------------------------
        # SOME PARAMETERS GIVEN BY CALLER FOR INITIALIZATION - IMAGE2D4XI NEEDS INITIALIZATION
        # -----------------------------------------------------------------------------------------        
        try:
            if image2d4xi is None:                                                                                       
                image2d4xi = {} 
                code2ack  = code2ack + '1D-'
        except:
            image2d4xi = {} 
            code2ack  = code2ack + '1D-'
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/33)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4imagecreate2xi-try-by-create2image4xi: " + str(task4imagecreate2xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # None 
    
    if ack2all is True:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) - ALL DEVICES - EACH WITH THE CONTEXT OR THEIR OWN (GIVEN BY THE CALLED ONE) 
            # ----------------------------------------------------------------------------------------- 
            image2d4xi = {} 
            image2d4xi['APU'] = create2image4apu()                                                                        
            image2d4xi['BPU'] = create2image4bpu()   
            image2d4xi['CPU'] = create2image4cpu()   
            image2d4xi['DPU'] = create2image4dpu()   
            image2d4xi['EPU'] = create2image4epu()   
            image2d4xi['FPU'] = create2image4fpu()   
            image2d4xi['GPU'] = create2image4gpu()   
            image2d4xi['HPU'] = create2image4hpu()   
            image2d4xi['IPU'] = create2image4ipu()   
            image2d4xi['JPU'] = create2image4jpu()   
            image2d4xi['KPU'] = create2image4kpu()   
            image2d4xi['LPU'] = create2image4lpu()   
            image2d4xi['MPU'] = create2image4mpu()   
            image2d4xi['NPU'] = create2image4npu()   
            image2d4xi['OPU'] = create2image4opu()   
            image2d4xi['PPU'] = create2image4ppu()   
            image2d4xi['QPU'] = create2image4qpu()   
            image2d4xi['RPU'] = create2image4rpu()   
            image2d4xi['SPU'] = create2image4spu()   
            image2d4xi['TPU'] = create2image4tpu()   
            image2d4xi['UPU'] = create2image4upu()   
            image2d4xi['VPU'] = create2image4vpu()   
            image2d4xi['XPU'] = create2image4xpu()   
            image2d4xi['WPU'] = create2image4wpu()   
            image2d4xi['YPU'] = create2image4ypu()   
            image2d4xi['ZPU'] = create2image4zpu()   
            
            message2print = "{(Step 3A/33) initialized" + "; image2d4xi-initialized-by-create2image4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                                                      
            # 
            
            code2ack  = code2ack + '3A-'
        except:
            message2print = "{(Step 3Z1/33) yielded" + "; image2d4xi-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                               #   
            code2nack  = code2nack + '3Z1-'
    else:    
    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step A/33) - APU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['APU'] = create2image4apu(task4imagecreate2xi['APU'])
            
            message2print = "{(Step A/33) initialized" + "; apu-initialized-by-create2image4xi to: " + str(image2d4xi['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'A-'
        except: 
            message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'AZ1-'          
        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step B/33) - BPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['BPU'] = create2image4bpu(task4imagecreate2xi['BPU'])
            
            message2print = "{(Step B/33) initialized" + "; bpu-initialized-by-create2image4xi to: " + str(image2d4xi['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'B-'
        except: 
            message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'BZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step C/33) - CPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['CPU'] = create2image4cpu(task4imagecreate2xi['CPU'])
            
            message2print = "{(Step C/33) initialized" + "; cpu-initialized-by-create2image4xi to: " + str(image2d4xi['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'C-'
        except: 
            message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'CZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step D/33) - DPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['DPU'] = create2image4dpu(task4imagecreate2xi['DPU'])
            
            message2print = "{(Step D/33) initialized" + "; dpu-initialized-by-create2image4xi to: " + str(image2d4xi['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'D-'
        except: 
            message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'DZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step E/33) - EPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['EPU'] = create2image4epu(task4imagecreate2xi['EPU'])
            
            message2print = "{(Step E/33) initialized" + "; epu-initialized-by-create2image4xi to: " + str(image2d4xi['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'E-'
        except: 
            message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'EZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step F/33) - FPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['FPU'] = create2image4fpu(task4imagecreate2xi['FPU'])
            
            message2print = "{(Step F/33) initialized" + "; fpu-initialized-by-create2image4xi to: " + str(image2d4xi['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'F-'
        except: 
            message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'FZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step G/33) - GPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['GPU'] = create2image4gpu(task4imagecreate2xi['GPU'])
            
            message2print = "{(Step G/33) initialized" + "; gpu-initialized-by-create2image4xi to: " + str(image2d4xi['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'G-'
        except: 
            message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'GZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step H/33) - HPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['HPU'] = create2image4hpu(task4imagecreate2xi['HPU'])
            
            message2print = "{(Step H/33) initialized" + "; hpu-initialized-by-create2image4xi to: " + str(image2d4xi['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'H-'
        except: 
            message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'HZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step I/33) - IPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['IPU'] = create2image4ipu(task4imagecreate2xi['IPU'])
            
            message2print = "{(Step I/33) initialized" + "; ipu-initialized-by-create2image4xi to: " + str(image2d4xi['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'I-'
        except: 
            message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'IZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step J/33) - JPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['JPU'] = create2image4jpu(task4imagecreate2xi['JPU'])
            
            message2print = "{(Step J/33) initialized" + "; jpu-initialized-by-create2image4xi to: " + str(image2d4xi['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'J-'
        except: 
            message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'JZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step K/33) - KPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['KPU'] = create2image4kpu(task4imagecreate2xi['KPU'])
            
            message2print = "{(Step K/33) initialized" + "; kpu-initialized-by-create2image4xi to: " + str(image2d4xi['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'K-'
        except: 
            message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'KZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step L/33) - LPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['LPU'] = create2image4lpu(task4imagecreate2xi['LPU'])
            
            message2print = "{(Step L/33) initialized" + "; lpu-initialized-by-create2image4xi to: " + str(image2d4xi['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'L-'
        except: 
            message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'LZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step M/33) - MPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['MPU'] = create2image4mpu(task4imagecreate2xi['MPU'])
            
            message2print = "{(Step M/33) initialized" + "; mpu-initialized-by-create2image4xi to: " + str(image2d4xi['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'M-'
        except: 
            message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'MZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step N/33) - NPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['NPU'] = create2image4npu(task4imagecreate2xi['NPU'])
            
            message2print = "{(Step N/33) initialized" + "; npu-initialized-by-create2image4xi to: " + str(image2d4xi['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'N-'
        except: 
            message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'NZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step O/33) - OPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['OPU'] = create2image4opu(task4imagecreate2xi['OPU'])
            
            message2print = "{(Step O/33) initialized" + "; opu-initialized-by-create2image4xi to: " + str(image2d4xi['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'O-'
        except: 
            message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'OZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step P/33) - PPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['PPU'] = create2image4ppu(task4imagecreate2xi['PPU'])
            
            message2print = "{(Step P/33) initialized" + "; ppu-initialized-by-create2image4xi to: " + str(image2d4xi['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'P-'
        except: 
            message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'PZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Q/33) - QPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['QPU'] = create2image4qpu(task4imagecreate2xi['QPU'])
            
            message2print = "{(Step Q/33) initialized" + "; qpu-initialized-by-create2image4xi to: " + str(image2d4xi['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Q-'
        except: 
            message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'QZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step R/33) - RPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['RPU'] = create2image4rpu(task4imagecreate2xi['RPU'])
            
            message2print = "{(Step R/33) initialized" + "; rpu-initialized-by-create2image4xi to: " + str(image2d4xi['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'R-'
        except: 
            message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'RZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step S/33) - SPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['SPU'] = create2image4spu(task4imagecreate2xi['SPU'])
            
            message2print = "{(Step S/33) initialized" + "; spu-initialized-by-create2image4xi to: " + str(image2d4xi['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'S-'
        except: 
            message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'SZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step T/33) - TPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['TPU'] = create2image4tpu(task4imagecreate2xi['TPU'])
            
            message2print = "{(Step T/33) initialized" + "; tpu-initialized-by-create2image4xi to: " + str(image2d4xi['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'T-'
        except: 
            message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'TZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step U/33) - UPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['UPU'] = create2image4upu(task4imagecreate2xi['UPU'])
            
            message2print = "{(Step U/33) initialized" + "; upu-initialized-by-create2image4xi to: " + str(image2d4xi['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'U-'
        except: 
            message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'UZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step V/33) - VPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['VPU'] = create2image4vpu(task4imagecreate2xi['VPU'])
            
            message2print = "{(Step V/33) initialized" + "; vpu-initialized-by-create2image4xi to: " + str(image2d4xi['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'V-'
        except: 
            message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'VZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step W/33) - WPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['WPU'] = create2image4wpu(task4imagecreate2xi['WPU'])
            
            message2print = "{(Step W/33) initialized" + "; wpu-initialized-by-create2image4xi to: " + str(image2d4xi['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'W-'
        except: 
            message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'WZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step X/33) - XPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['XPU'] = create2image4xpu(task4imagecreate2xi['XPU'])
            
            message2print = "{(Step X/33) initialized" + "; xpu-initialized-by-create2image4xi to: " + str(image2d4xi['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'X-'
        except: 
            message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'XZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Y/33) - YPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['YPU'] = create2image4ypu(task4imagecreate2xi['YPU'])
            
            message2print = "{(Step Y/33) initialized" + "; ypu-initialized-by-create2image4xi to: " + str(image2d4xi['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Y-'
        except: 
            message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'YZ1-'     
                    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step Z/33) - ZPU
            # -----------------------------------------------------------------------------------------               
            image2d4xi['ZPU'] = create2image4zpu(task4imagecreate2xi['ZPU'])
            
            message2print = "{(Step Z/33) initialized" + "; zpu-initialized-by-create2image4xi to: " + str(image2d4xi['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + 'Z-'
        except: 
            message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + 'ZZ1-'                 

            
          
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of create2image4xi - RETURNING IMAGE2D4XI: ", image2d4xi)
            
    message2print = "{(Step 33/33) returning" + "; image2d4xi-returning-by-create2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 

    return image2d4xi
            
#</function4xi>  


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2image4xi" usage = "
#
#   # ---------------------------------------------------------------------------------------------
#   # (10) FINALLY SET 2D IMAGE AFTER HAVING PROVIDED VALUES FOR REQUIRED PROCESSING UNITS                            
#   # ---------------------------------------------------------------------------------------------          
#   response4set2Dimage = {} 
#   print('(Step 10A/700) OF IMAGE2D4XI5TEST - TRYING TO SET 2D IMAGE4XI ', time4xi())   
#   try:                               
#       response4set2Dimage = set2image4xi(task4set2image)                                                                                                         
#                                                                                     
#       print('(Step 10B/700) OF IMAGE2D4XI5TEST - SET 2D IMAGE4XI ', time4xi())
#       keys2response = response4set2Dimage.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4set2Dimage[key2response])
#           # APU  :  {'CODE2ERROR': 0, ... 'ROWPITCH': 800, ...
#           # ....
#           # ZPU  :  {'CODE2ERROR': 0, ... 'ROWPITCH': 800, ...
#   except:
#       print('(Step 10Z/700) OF IMAGE2D4XI5TEST *** FAILED TO SET 2D IMAGE4XI *** ', time4xi())  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2image4xi(task4imageset2xi=None):

    '''
    sets 2D images for xi device
    '''
    global platform2xi
    global device2xi
    global context2xi    
    global image2d4xi
    global info2image4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    
    class2print = "set2image4xi"
    method2print = "set2image4xi"

    message2print = "{(Step 1A/33) started" + "; set2image4xi-started: " + str(set2image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2image4xi at 0x0000000003A62848> 
    
    message2print = "{(Step 1B/33) passed" + "; task4imageset2xi-to-set2image4xi: " + str(task4imageset2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
            
    code2ack  = ' '
    code2nack = ' '
    if image2d4xi is None:
        image2d4xi = create2image2d4xi()                                                                            
                                
        message2print = "{(Step 1C/33) set" + "; image2d4xi-set-by-set2image4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
        

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step A/33) passing" + "; task-passing-to-set2image4apu: " + str(task4set2image['APU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['APU'] = set2image4apu(task4set2image['APU'])                                                      # 
         
        message2print = "{(Step A1/33) set" + "; apu-image-set-by-set2image4apu to: " + str(image2d4xi ['APU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'A1-'
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-set2image4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step B/33) passing" + "; task-passing-to-set2image4bpu: " + str(task4set2image['BPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['BPU'] = set2image4bpu(task4set2image['BPU'])                                                      # 
         
        message2print = "{(Step B1/33) set" + "; bpu-image-set-by-set2image4bpu to: " + str(image2d4xi ['BPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'B1-'
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-set2image4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step C/33) passing" + "; task-passing-to-set2image4cpu: " + str(task4set2image['CPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['CPU'] = set2image4cpu(task4set2image['CPU'])                                                      # 
         
        message2print = "{(Step C1/33) set" + "; cpu-image-set-by-set2image4cpu to: " + str(image2d4xi ['CPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'C1-'
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-set2image4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step D/33) passing" + "; task-passing-to-set2image4dpu: " + str(task4set2image['DPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['DPU'] = set2image4dpu(task4set2image['DPU'])                                                      # 
         
        message2print = "{(Step D1/33) set" + "; dpu-image-set-by-set2image4dpu to: " + str(image2d4xi ['DPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'D1-'
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-set2image4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step E/33) passing" + "; task-passing-to-set2image4epu: " + str(task4set2image['EPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['EPU'] = set2image4epu(task4set2image['EPU'])                                                      # 
         
        message2print = "{(Step E1/33) set" + "; epu-image-set-by-set2image4epu to: " + str(image2d4xi ['EPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'E1-'
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-set2image4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step F/33) passing" + "; task-passing-to-set2image4fpu: " + str(task4set2image['FPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['FPU'] = set2image4fpu(task4set2image['FPU'])                                                      # 
         
        message2print = "{(Step F1/33) set" + "; fpu-image-set-by-set2image4fpu to: " + str(image2d4xi ['PU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'F1-'
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-set2image4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step G/33) passing" + "; task-passing-to-set2image4gpu: " + str(task4set2image['GPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['GPU'] = set2image4gpu(task4set2image['GPU'])                                                      # 
         
        message2print = "{(Step G1/33) set" + "; gpu-image-set-by-set2image4gpu to: " + str(image2d4xi ['GPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'G1-'
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-set2image4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step H/33) passing" + "; task-passing-to-set2image4hpu: " + str(task4set2image['HPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['HPU'] = set2image4hpu(task4set2image['HPU'])                                                      # 
         
        message2print = "{(Step H1/33) set" + "; hpu-image-set-by-set2image4hpu to: " + str(image2d4xi ['HPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'H1-'
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-set2image4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step I/33) passing" + "; task-passing-to-set2image4ipu: " + str(task4set2image['IPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['IPU'] = set2image4ipu(task4set2image['IPU'])                                                      # 
         
        message2print = "{(Step I1/33) set" + "; ipu-image-set-by-set2image4ipu to: " + str(image2d4xi ['IPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'I1-'
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-set2image4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step J/33) passing" + "; task-passing-to-set2image4jpu: " + str(task4set2image['JPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['JPU'] = set2image4jpu(task4set2image['JPU'])                                                      # 
         
        message2print = "{(Step J1/33) set" + "; jpu-image-set-by-set2image4jpu to: " + str(image2d4xi ['JPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'J1-'
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-set2image4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step K/33) passing" + "; task-passing-to-set2image4kpu: " + str(task4set2image['KPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['KPU'] = set2image4kpu(task4set2image['KPU'])                                                      # 
         
        message2print = "{(Step K1/33) set" + "; kpu-image-set-by-set2image4kpu to: " + str(image2d4xi ['KPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'K1-'
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-set2image4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step L/33) passing" + "; task-passing-to-set2image4lpu: " + str(task4set2image['LPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['LPU'] = set2image4lpu(task4set2image['LPU'])                                                      # 
         
        message2print = "{(Step L1/33) set" + "; lpu-image-set-by-set2image4lpu to: " + str(image2d4xi ['LPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + '1-'
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-set2image4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step M/33) passing" + "; task-passing-to-set2image4mpu: " + str(task4set2image['MPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['MPU'] = set2image4mpu(task4set2image['MPU'])                                                      # 
         
        message2print = "{(Step M1/33) set" + "; mpu-image-set-by-set2image4mpu to: " + str(image2d4xi ['MPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'M1-'
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-set2image4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step N/33) passing" + "; task-passing-to-set2image4npu: " + str(task4set2image['NPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['NPU'] = set2image4npu(task4set2image['NPU'])                                                      # 
         
        message2print = "{(Step N1/33) set" + "; npu-image-set-by-set2image4npu to: " + str(image2d4xi ['NPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'N1-'
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-set2image4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step O/33) passing" + "; task-passing-to-set2image4opu: " + str(task4set2image['OPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['OPU'] = set2image4opu(task4set2image['OPU'])                                                      # 
         
        message2print = "{(Step O1/33) set" + "; opu-image-set-by-set2image4opu to: " + str(image2d4xi ['OPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'O1-'
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-set2image4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step P/33) passing" + "; task-passing-to-set2image4ppu: " + str(task4set2image['PPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['PPU'] = set2image4ppu(task4set2image['PPU'])                                                      # 
         
        message2print = "{(Step P1/33) set" + "; ppu-image-set-by-set2image4ppu to: " + str(image2d4xi ['PPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'P1-'
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-set2image4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Q/33) passing" + "; task-passing-to-set2image4qpu: " + str(task4set2image['QPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['QPU'] = set2image4qpu(task4set2image['QPU'])                                                      # 
         
        message2print = "{(Step Q1/33) set" + "; qpu-image-set-by-set2image4qpu to: " + str(image2d4xi ['QPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Q1-'
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-set2image4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step R/33) passing" + "; task-passing-to-set2image4rpu: " + str(task4set2image['RPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['RPU'] = set2image4rpu(task4set2image['RPU'])                                                      # 
         
        message2print = "{(Step R1/33) set" + "; rpu-image-set-by-set2image4rpu to: " + str(image2d4xi ['RPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'R1-'
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-set2image4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step S/33) passing" + "; task-passing-to-set2image4spu: " + str(task4set2image['SPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['SPU'] = set2image4spu(task4set2image['SPU'])                                                      # 
         
        message2print = "{(Step S1/33) set" + "; spu-image-set-by-set2image4spu to: " + str(image2d4xi ['SPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'S1-'
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-set2image4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step T/33) passing" + "; task-passing-to-set2image4tpu: " + str(task4set2image['TPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['TPU'] = set2image4tpu(task4set2image['TPU'])                                                      # 
         
        message2print = "{(Step T1/33) set" + "; tpu-image-set-by-set2image4tpu to: " + str(image2d4xi ['TPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'T1-'
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-set2image4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step U/33) passing" + "; task-passing-to-set2image4upu: " + str(task4set2image['UPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['UPU'] = set2image4upu(task4set2image['UPU'])                                                      # 
         
        message2print = "{(Step U1/33) set" + "; upu-image-set-by-set2image4upu to: " + str(image2d4xi ['UPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'U1-'
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-set2image4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step V/33) passing" + "; task-passing-to-set2image4vpu: " + str(task4set2image['VPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['VPU'] = set2image4vpu(task4set2image['VPU'])                                                      # 
         
        message2print = "{(Step V1/33) set" + "; vpu-image-set-by-set2image4vpu to: " + str(image2d4xi ['VPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'V1-'
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-set2image4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step W/33) passing" + "; task-passing-to-set2image4wpu: " + str(task4set2image['WPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['WPU'] = set2image4wpu(task4set2image['WPU'])                                                      # 
         
        message2print = "{(Step W1/33) set" + "; wpu-image-set-by-set2image4wpu to: " + str(image2d4xi ['WPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'W1-'
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-set2image4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step X/33) passing" + "; task-passing-to-set2image4xpu: " + str(task4set2image['XPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['XPU'] = set2image4xpu(task4set2image['XPU'])                                                      # 
         
        message2print = "{(Step X1/33) set" + "; xpu-image-set-by-set2image4xpu to: " + str(image2d4xi ['XPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'X1-'
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-set2image4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Y/33) passing" + "; task-passing-to-set2image4ypu: " + str(task4set2image['YPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['YPU'] = set2image4ypu(task4set2image['YPU'])                                                      # 
         
        message2print = "{(Step Y1/33) set" + "; ypu-image-set-by-set2image4ypu to: " + str(image2d4xi ['YPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Y1-'
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-set2image4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        message2print = "{(Step Z/33) passing" + "; task-passing-to-set2image4zpu: " + str(task4set2image['ZPU'])  + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                         
        # 
        
        image2d4xi ['ZPU'] = set2image4zpu(task4set2image['ZPU'])                                                      # 
         
        message2print = "{(Step Z1/33) set" + "; zpu-image-set-by-set2image4zpu to: " + str(image2d4xi ['ZPU'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        code2ack  = code2ack + 'Z1-'
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-set2image4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print('(Step 33/33) of set2image4xi - RETURNING IMAGE2D4XI:  ', image2d4xi) 
    
    message2print = "{(Step 33/33) returning" + "; image2d4xi-returning-by-set2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    
    return image2d4xi
           
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "copy2image4xi" usage = "
#                                                                                                              
#   # ---------------------------------------------------------------------------------------------
#   # PHASE I: COPY FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND              
#   # ---------------------------------------------------------------------------------------------    
#   print('=' *33)          
#   print('(Step 40A/700) OF IMAGE2D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY2IMAGE4XI ', time4xi())        
#   print('=' *33)      
#   #                         
#   respon4copy2image      = {} 
#   task4copy2image        = {}                                                                                    
#   queue4copy          = {} 
#   channel4copy2publish = {} 
#   channel4copy2consume = {} 
#   try: 
#       task4copy2image = {} 
#       for key2pu in keys2pu:
#           if KB2CC [key2pu] == 'ACK':
#               task4copy2image [key2pu]  = {}
#                                               
#       response4copy2image = copy2image4xi(task4copy2image)
#       
#       print('(Step 40B/700) OF IMAGE2D4XI5TEST - GOT RESPONSE4COPY2IMAGE ', response4copy2image)
#       # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005EE6898>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6848>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6844>}, 
#       #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005EE6D68>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6880>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6876>},
#       #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005EE6550>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6816>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6812>}}
#     except:
#       print('(Step 40Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY2IMAGE4XI ', time4xi())
#                
#   print('(Step 40C/700) OF IMAGE2D4XI5TEST - TRYING TO SET QUEUE AND CHANNELS FOR COPY ', time4xi())               
#   try: 
#       queue4copy          = {}
#       channel4copy2publish = {} 
#       channel4copy2consume = {}
#       for key2pu in keys2pu:
#           if KB2CC [key2pu] == 'ACK':   
#               queue4copy [key2pu] = response4copy2image [key2pu] ['QUEUE']
#               print(key2pu, ' SET QUEUE TO : ', queue4copy [key2pu])
#               # ZPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006047240>; GPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006047160>; APU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006047128>
#               
#               channel4copy2publish [key2pu] = response4copy2image [key2pu] ['PUBLISHERCHANNEL']
#               print(key2pu, ' SET CHANNEL TO PUBLISH4XI TO : ', channel4copy2publish [key2pu])
#               # ZPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 6880>; GPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 6848>; APU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 6816>
#                       
#               channel4copy2consume [key2pu] = response4copy2image [key2pu]['CONSUMERCHANNEL']
#               print(key2pu, ' SET CHANNEL TO CONSUME4XI TO : ', channel4copy2consume [key2pu])
#               # ZPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 6876>; GPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 6844>; APU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 6812>
#                       
#   except:
#       print('(Step 40Z2/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR COPY ', time4xi()) 
#
#">

# -------------------------------------------------------------------------------------------------   
def copy2image4xi(task4copyimage2xi=None):

    '''
    copies 2D images for XI
    '''
    global platform2xi
    global device2xi
    global context2xi    
    global image2d4xi                                                     # 2D-IMAGES
    global info2image4xi  
    global control2copy4xi                                           # COMMAND AND CONTROL FOR 2D IMAGE FOR XIS 
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class2print = "copy2image4xi"
    method2print = "copy2image4xi"

    message2print = "{(Step 1A/33) started" + "; copy2image4xi-started: " + str(copy2image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function copy2image4xi at 0x00000000039595C8> 
    
    message2print = "{(Step 1B/33) passed" + "; task4copyimage2xi-to-copy2image4xi: " + str(task4copyimage2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
            
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # CREATE 2D IMAGE FOR XI IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if image2d4xi is None:
            image2d4xi = create2image4xi()                                                                              # INITIALIZE IMAGE FOR XI 
            message2print = "{(Step 1C/70) created" + "; image2d4xi-created-by-copy2image4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2image4xi-skipped-by-copy2image4xi: " + str(copy2image4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # skipped                                 
    except:
        try:
            image2d4xi = create2image4xi()
            message2print = "{(Step 1E/70) set" + "; image2d4xi-set-by-copy2image4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            image2d4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; image2d4xi-yielded-by-copy2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
    
    # -----------------------------------------------------------------------------------------
    #           
    # ----------------------------------------------------------------------------------------- 
    control2copy4xi = {}
    try:         
        keys2taskcopyimage = task4copyimage2xi.keys()
        if debug is True:
            print('(Step 1/33) of copy2image4xi - keys2taskcopyimage:  ', keys2taskcopyimage) 
            # dict_keys(['GPU', 'ZPU', 'APU'])
        if 'APU' in keys2taskcopyimage:
            try:
                control2copy4xi['APU'] = copy2image4apu(task4copyimage2xi['APU'])
                message2print = "{(Step 1C1/33) got" + "; apuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1A/33) of copy2image4xi - control2copy4xi:  ', control2copy4xi['APU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000006047128>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6816>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6812>}

            except:
                pass     
        if 'BPU' in keys2taskcopyimage:
            try:
                control2copy4xi['BPU'] = copy2image4bpu(task4copyimage2xi['BPU'])
                message2print = "{(Step 1C1/33) got" + "; bpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass     
            
        if 'CPU' in keys2taskcopyimage:
            try:
                control2copy4xi['CPU'] = copy2image4cpu(task4copyimage2xi['CPU'])
                message2print = "{(Step 1C1/33) got" + "; cpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass     
            
        if 'DPU' in keys2taskcopyimage:
            try:
                control2copy4xi['DPU'] = copy2image4dpu(task4copyimage2xi['DPU'])
                message2print = "{(Step 1C1/33) got" + "; dpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'EPU' in keys2taskcopyimage:
            try:
                control2copy4xi['EPU'] = copy2image4epu(task4copyimage2xi['EPU'])
                message2print = "{(Step 1C1/33) got" + "; epuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'FPU' in keys2taskcopyimage:
            try:
                control2copy4xi['FPU'] = copy2image4fpu(task4copyimage2xi['FPU'])
                message2print = "{(Step 1C1/33) got" + "; fpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'GPU' in keys2taskcopyimage:
            try:
                control2copy4xi['GPU'] = copy2image4gpu(task4copyimage2xi['GPU'])
                message2print = "{(Step 1C1/33) got" + "; gpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'HPU' in keys2taskcopyimage:
            try:
                control2copy4xi['HPU'] = copy2image4hpu(task4copyimage2xi['HPU'])
                message2print = "{(Step 1C1/33) got" + "; hpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #             
            except:
                pass
        if 'IPU' in keys2taskcopyimage:    
            try:
                control2copy4xi['IPU'] = copy2image4ipu(task4copyimage2xi['IPU'])
                message2print = "{(Step 1C1/33) got" + "; ipuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'JPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['JPU'] = copy2image4jpu(task4copyimage2xi['JPU'])
                message2print = "{(Step 1C1/33) got" + "; jpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'KPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['KPU'] = copy2image4kpu(task4copyimage2xi['KPU'])
                message2print = "{(Step 1C1/33) got" + "; kpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'LPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['LPU'] = copy2image4lpu(task4copyimage2xi['LPU'])
                message2print = "{(Step 1C1/33) got" + "; lpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'MPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['MPU'] = copy2image4mpu(task4copyimage2xi['MPU'])
                message2print = "{(Step 1C1/33) got" + "; mpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'NPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['NPU'] = copy2image4npu(task4copyimage2xi['NPU'])
                message2print = "{(Step 1C1/33) got" + "; npuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'OPU' in keys2taskcopyimage:                    
            try:
                control2copy4xi['OPU'] = copy2image4opu(task4copyimage2xi['OPU'])
                message2print = "{(Step 1C1/33) got" + "; opuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'PPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['PPU'] = copy2image4ppu(task4copyimage2xi['PPU'])
                message2print = "{(Step 1C1/33) got" + "; ppuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'QPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['QPU'] = copy2image4qpu(task4copyimage2xi['QPU'])
                message2print = "{(Step 1C1/33) got" + "; qpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'RPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['RPU'] = copy2image4rpu(task4copyimage2xi['RPU'])
                message2print = "{(Step 1C1/33) got" + "; rpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'SPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['SPU'] = copy2image4spu(task4copyimage2xi['SPU'])
                message2print = "{(Step 1C1/33) got" + "; spuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'TPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['TPU'] = copy2image4tpu(task4copyimage2xi['TPU'])
                message2print = "{(Step 1C1/33) got" + "; tpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'UPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['UPU'] = copy2image4upu(task4copyimage2xi['UPU'])
                message2print = "{(Step 1C1/33) got" + "; upuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'VPU' in keys2taskcopyimage:                    
            try:
                control2copy4xi['VPU'] = copy2image4vpu(task4copyimage2xi['VPU'])
                message2print = "{(Step 1C1/33) got" + "; vpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'WPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['WPU'] = copy2image4wpu(task4copyimage2xi['WPU'])
                message2print = "{(Step 1C1/33) got" + "; wpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'XPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['XPU'] = copy2image4xpu(task4copyimage2xi['XPU'])
                message2print = "{(Step 1C1/33) got" + "; xpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'YPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['YPU'] = copy2image4ypu(task4copyimage2xi['YPU'])
                message2print = "{(Step 1C1/33) got" + "; ypuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'ZPU' in keys2taskcopyimage:                     
            try:
                control2copy4xi['ZPU'] = copy2image4zpu(task4copyimage2xi['ZPU'])
                message2print = "{(Step 1C1/33) got" + "; zpuimage-control-got-by-get2imageinfo: " + str(control2copy4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
               
    except:
        message2print = "{(Step 1Z/70) yielded" + "; control2copy4xi-yielded-by-copy2image4xi: " + str(control2copy4xi) + "; time: " + time4xi() + "}"                
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '1Z-'     
        
    # ---------------------------------------------------------------------------------------------
    # RETURN CONTROL AND COMMAND DICTIONARY
    # ---------------------------------------------------------------------------------------------          
    message2print = "{(Step 70A/70) set" + "; code2ack-set-by-copy2image4xi: " + str(code2ack) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                             
    # 
     
    message2print = "{(Step 70B/70) set" + "; code2nack-set-by-copy2image4xi: " + str(code2nack) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    #   
        
    message2print = "{(Step 70C/70) returning" + "; control2copy4xi-returning-by-copy2image4xi: " + str(control2copy4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    if debug is True:
        print('(Step 33/33) of control2copy4xi - RETURNING CONTROL2COPYIMAGE4XI:  ', control2copy4xi) 
        # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000006047160>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6848>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6844>}, 
        #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000006047240>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6880>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6876>}, 
        #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000006047128>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6816>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6812>}}
        
    return control2copy4xi
                    
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "copy2imagetobuffer4xi" usage = "
#                                                                                                              
#   # ---------------------------------------------------------------------------------------------
#   # PHASE I: COPY2IMAGETOBUFFER4XI FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND              
#   # ---------------------------------------------------------------------------------------------    
#   print('=' *33)          
#   print('(Step 60A/700) OF IMAGE2D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY2IMAGETOBUFFER4XI ', time4xi())        
#   print('=' *33)      
#   #                         
#   response4copy2imagetobuffer      = {} 
#   task4copy2imagetobuffer        = {}                                                                                    
#   queue4copyimagetobuffer          = {} 
#   channel4copyimagetobuffer2publish = {} 
#   channel4copyimagetobuffer2consume = {} 
#   try:
#       task4copy2imagetobuffer = {} 
#       for key2pu in keys2pu:
#           if KB2CC [key2pu] == 'ACK':
#               task4copy2imagetobuffer [key2pu]  = {}
#                                               
#       response4copy2imagetobuffer = copy2imagetobuffer4xi(task4copy2imagetobuffer)
#       
#       print('(Step 60B/700) OF IMAGE2D4XI5TEST - GOT RESPONSE4COPY2IMAGETOBUFFER4XI2IMAGE ', response4copy2imagetobuffer)
#       # 
#   except:
#       print('(Step 60Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY2IMAGETOBUFFER4XI ', time4xi())
#                
#   print('(Step 60C/700) OF IMAGE2D4XI5TEST - TRYING TO SET QUEUE AND CHANNELS FOR COPY2IMAGETOBUFFER4XI ', time4xi())               
#   try: 
#       queue4copyimagetobuffer          = {}
#       channel4copyimagetobuffer2publish = {} 
#       channel4copyimagetobuffer2consume = {}
#       for key2pu in keys2pu:
#           if KB2CC [key2pu] == 'ACK':   
#               queue4copyimagetobuffer [key2pu] = response4copy2imagetobuffer [key2pu] ['QUEUE']
#               print(key2pu, ' SET QUEUE TO : ', queue4copyimagetobuffer [key2pu])
#               # 
#               
#               channel4copyimagetobuffer2publish [key2pu] = response4copy2imagetobuffer [key2pu] ['PUBLISHERCHANNEL']
#               print(key2pu, ' SET CHANNEL TO PUBLISH4XI TO : ', channel4copyimagetobuffer2publish [key2pu])
#               # 
#                       
#               channel4copyimagetobuffer2consume [key2pu] = response4copy2imagetobuffer [key2pu]['CONSUMERCHANNEL']
#               print(key2pu, ' SET CHANNEL TO CONSUME4XI TO : ', channel4copyimagetobuffer2consume [key2pu])
#               # 
#                       
#   except:
#       print('(Step 60Z2/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR COPY2IMAGETOBUFFER4XI ', time4xi()) 
#">

# -------------------------------------------------------------------------------------------------   
def copy2imagetobuffer4xi(task4copyimagetobuffer2xi=None):

    '''
    copies 2D images to buffer for XI
    '''
    global platform2xi
    global device2xi
    global context2xi    
    global image2d4xi                                                                                               # 2D-IMAGES
    global info2image4xi  
    global image2dbuffer4xi                                                                                         # BUFFER FOR XI
    
    global control2copytobuffer4xi                                                                             # COMMAND AND CONTROL FOR 2D IMAGE FOR XIS 
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class2print = "copy2imagetobuffer4xi"
    method2print = "copy2imagetobuffer4xi"

    message2print = "{(Step 1A/33) started" + "; copy2imagetobuffer4xi-started: " + str(copy2imagetobuffer4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function copy2imagetobuffer4xi at 0x00000000039595C8> 
    
    message2print = "{(Step 1B/33) passed" + "; task4copyimagetobuffer2xi-to-copy2imagetobuffer4xi: " + str(task4copyimagetobuffer2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
            
    code2ack  = ' '
    code2nack = ' '
    
    if task4copyimagetobuffer2xi is None:
        task4copyimagetobuffer2xi = {}
    
    # -----------------------------------------------------------------------------------------
    # CREATE 2D IMAGE FOR XI IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if image2d4xi is None:
            image2d4xi = create2image4xi()                                                                              # INITIALIZE IMAGE FOR XI 
            message2print = "{(Step 1C/70) created" + "; image2d4xi-created-by-copy2imagetobuffer4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2image4xi-skipped-by-copy2imagetobuffer4xi: " + str(copy2imagetobuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # skipped                                 
    except:
        try:
            image2d4xi = create2image4xi()
            message2print = "{(Step 1E/70) set" + "; image2d4xi-set-by-copy2imagetobuffer4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            image2d4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; image2d4xi-yielded-by-copy2imagetobuffer4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
    
    # -----------------------------------------------------------------------------------------
    #           
    # ----------------------------------------------------------------------------------------- 
    control2copytobuffer4xi = {}
    try:         
        keys2taskcopyimagetobuffer = task4copyimagetobuffer2xi.keys()
        if debug is True:
            print('(Step 1/33) of copy2imagetobuffer4xi - keys2taskcopyimagetobuffer:  ', keys2taskcopyimagetobuffer) 
          
        if 'APU' in keys2taskcopyimagetobuffer:
            try:
                control2copytobuffer4xi['APU'] = copy2imagetobuffer4apu(task4copyimagetobuffer2xi['APU'])
                message2print = "{(Step 1C1/33) got" + "; apuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1A/33) of copy2imagetobuffer4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi) 
                    # {'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005EB71D0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6956>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6952>}}

            except:
                pass     
        if 'BPU' in keys2taskcopyimagetobuffer:
            try:
                control2copytobuffer4xi['BPU'] = copy2imagetobuffer4bpu(task4copyimagetobuffer2xi['BPU'])
                message2print = "{(Step 1C1/33) got" + "; bpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass     
            
        if 'CPU' in keys2taskcopyimagetobuffer:
            try:
                control2copytobuffer4xi['CPU'] = copy2imagetobuffer4cpu(task4copyimagetobuffer2xi['CPU'])
                message2print = "{(Step 1C1/33) got" + "; cpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass     
            
        if 'DPU' in keys2taskcopyimagetobuffer:
            try:
                control2copytobuffer4xi['DPU'] = copy2imagetobuffer4dpu(task4copyimagetobuffer2xi['DPU'])
                message2print = "{(Step 1C1/33) got" + "; dpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'EPU' in keys2taskcopyimagetobuffer:
            try:
                control2copytobuffer4xi['EPU'] = copy2imagetobuffer4epu(task4copyimagetobuffer2xi['EPU'])
                message2print = "{(Step 1C1/33) got" + "; epuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'FPU' in keys2taskcopyimagetobuffer:
            try:
                control2copytobuffer4xi['FPU'] = copy2imagetobuffer4fpu(task4copyimagetobuffer2xi['FPU'])
                message2print = "{(Step 1C1/33) got" + "; fpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'GPU' in keys2taskcopyimagetobuffer:
            try:
                control2copytobuffer4xi['GPU'] = copy2imagetobuffer4gpu(task4copyimagetobuffer2xi['GPU'])
                message2print = "{(Step 1C1/33) got" + "; gpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'HPU' in keys2taskcopyimagetobuffer:
            try:
                control2copytobuffer4xi['HPU'] = copy2imagetobuffer4hpu(task4copyimagetobuffer2xi['HPU'])
                message2print = "{(Step 1C1/33) got" + "; hpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #             
            except:
                pass
        if 'IPU' in keys2taskcopyimagetobuffer:    
            try:
                control2copytobuffer4xi['IPU'] = copy2imagetobuffer4ipu(task4copyimagetobuffer2xi['IPU'])
                message2print = "{(Step 1C1/33) got" + "; ipuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'JPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['JPU'] = copy2imagetobuffer4jpu(task4copyimagetobuffer2xi['JPU'])
                message2print = "{(Step 1C1/33) got" + "; jpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'KPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['KPU'] = copy2imagetobuffer4kpu(task4copyimagetobuffer2xi['KPU'])
                message2print = "{(Step 1C1/33) got" + "; kpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'LPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['LPU'] = copy2imagetobuffer4lpu(task4copyimagetobuffer2xi['LPU'])
                message2print = "{(Step 1C1/33) got" + "; lpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'MPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['MPU'] = copy2imagetobuffer4mpu(task4copyimagetobuffer2xi['MPU'])
                message2print = "{(Step 1C1/33) got" + "; mpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'NPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['NPU'] = copy2imagetobuffer4npu(task4copyimagetobuffer2xi['NPU'])
                message2print = "{(Step 1C1/33) got" + "; npuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'OPU' in keys2taskcopyimagetobuffer:                    
            try:
                control2copytobuffer4xi['OPU'] = copy2imagetobuffer4opu(task4copyimagetobuffer2xi['OPU'])
                message2print = "{(Step 1C1/33) got" + "; opuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'PPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['PPU'] = copy2imagetobuffer4ppu(task4copyimagetobuffer2xi['PPU'])
                message2print = "{(Step 1C1/33) got" + "; ppuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'QPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['QPU'] = copy2imagetobuffer4qpu(task4copyimagetobuffer2xi['QPU'])
                message2print = "{(Step 1C1/33) got" + "; qpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'RPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['RPU'] = copy2imagetobuffer4rpu(task4copyimagetobuffer2xi['RPU'])
                message2print = "{(Step 1C1/33) got" + "; rpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'SPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['SPU'] = copy2imagetobuffer4spu(task4copyimagetobuffer2xi['SPU'])
                message2print = "{(Step 1C1/33) got" + "; spuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'TPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['TPU'] = copy2imagetobuffer4tpu(task4copyimagetobuffer2xi['TPU'])
                message2print = "{(Step 1C1/33) got" + "; tpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'UPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['UPU'] = copy2imagetobuffer4upu(task4copyimagetobuffer2xi['UPU'])
                message2print = "{(Step 1C1/33) got" + "; upuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'VPU' in keys2taskcopyimagetobuffer:                    
            try:
                control2copytobuffer4xi['VPU'] = copy2imagetobuffer4vpu(task4copyimagetobuffer2xi['VPU'])
                message2print = "{(Step 1C1/33) got" + "; vpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'WPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['WPU'] = copy2imagetobuffer4wpu(task4copyimagetobuffer2xi['WPU'])
                message2print = "{(Step 1C1/33) got" + "; wpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'XPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['XPU'] = copy2imagetobuffer4xpu(task4copyimagetobuffer2xi['XPU'])
                message2print = "{(Step 1C1/33) got" + "; xpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'YPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['YPU'] = copy2imagetobuffer4ypu(task4copyimagetobuffer2xi['YPU'])
                message2print = "{(Step 1C1/33) got" + "; ypuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'ZPU' in keys2taskcopyimagetobuffer:                     
            try:
                control2copytobuffer4xi['ZPU'] = copy2imagetobuffer4zpu(task4copyimagetobuffer2xi['ZPU'])
                message2print = "{(Step 1C1/33) got" + "; zpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
               
    except:
        message2print = "{(Step 1Z/70) yielded" + "; control2copytobuffer4xi-yielded-by-copy2imagetobuffer4xi: " + str(control2copytobuffer4xi) + "; time: " + time4xi() + "}"                
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '1Z-'     
        
    # ---------------------------------------------------------------------------------------------
    # RETURN CONTROL AND COMMAND DICTIONARY
    # ---------------------------------------------------------------------------------------------          
    message2print = "{(Step 70A/70) set" + "; code2ack-set-by-copy2imagetobuffer4xi: " + str(code2ack) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                             
    # 
     
    message2print = "{(Step 70B/70) set" + "; code2nack-set-by-copy2imagetobuffer4xi: " + str(code2nack) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    #   
        
    message2print = "{(Step 70C/70) returning" + "; control2copytobuffer4xi-returning-by-copy2imagetobuffer4xi: " + str(control2copytobuffer4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    if debug is True:
        print('(Step 33/33) of copy2imagetobuffer4xi - RETURNING CONTROL2COPYIMAGETOBUFFER4XI:  ', control2copytobuffer4xi) 
            
    return control2copytobuffer4xi
        
                    
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "copy2buffertoimage4xi" usage = "
#                                                                                                              
#   # ---------------------------------------------------------------------------------------------
#   # PHASE I: COPY2BUFFERTOIMAGE4XI FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND              
#   # ---------------------------------------------------------------------------------------------    
#   print('=' *33)          
#   print('(Step 80A/700) OF IMAGE2D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY2BUFFERTOIMAGE4XI ', time4xi())        
#   print('=' *33)      
#   #                         
#   response4copy2buffertoimage      = {} 
#   task4copy2buffertoimage        = {}                                                                                    
#   queue4copybuffertoimage          = {} 
#   channel4copybuffertoimage2publish = {} 
#   channel4copybuffertoimage2consume = {} 
#   try:
#       task4copy2buffertoimage = {} 
#       for key2pu in keys2pu:
#           if KB2CC [key2pu] == 'ACK':
#               task4copy2buffertoimage [key2pu]  = {}
#                                               
#       response4copy2buffertoimage = copy2buffertoimage4xi(task4copy2buffertoimage)
#       
#       print('(Step 80B/700) OF IMAGE2D4XI5TEST - GOT RESPONSE4COPY2BUFFERTOIMAGE4XI2IMAGE ', response4copy2buffertoimage)
#       # 
#   except:
#       print('(Step 80Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY2BUFFERTOIMAGE4XI ', time4xi())
#                
#   print('(Step 80C/700) OF IMAGE2D4XI5TEST - TRYING TO SET QUEUE AND CHANNELS FOR COPY2BUFFERTOIMAGE4XI ', time4xi())               
#   try: 
#       queue4copybuffertoimage          = {}
#       channel4copybuffertoimage2publish = {} 
#       channel4copybuffertoimage2consume = {}
#       for key2pu in keys2pu:
#           if KB2CC [key2pu] == 'ACK':   
#               queue4copybuffertoimage [key2pu] = response4copy2buffertoimage [key2pu] ['QUEUE']
#               print(key2pu, ' SET QUEUE TO : ', queue4copybuffertoimage [key2pu])
#                channel4copybuffertoimage2publish [key2pu] = response4copy2buffertoimage [key2pu] ['PUBLISHERCHANNEL']
#               print(key2pu, ' SET CHANNEL TO PUBLISH4XI TO : ', channel4copybuffertoimage2publish [key2pu])
#    
#               channel4copybuffertoimage2consume [key2pu] = response4copy2buffertoimage [key2pu]['CONSUMERCHANNEL']
#               print(key2pu, ' SET CHANNEL TO CONSUME4XI TO : ', channel4copybuffertoimage2consume [key2pu])
#               # 
#               # ZPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000005FC4F98>
#               # ZPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7160>
#               # ZPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7156>
#               # GPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000005FC4AC8>
#               # GPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7128>
#               # GPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7124>
#               # APU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000005FC4A58>
#               # APU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7096>
#               # APU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7092> 
#                       
#   except:
#       print('(Step 80Z2/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR COPY2BUFFERTOIMAGE4XI ', time4xi())   
#
#">

# -------------------------------------------------------------------------------------------------   
def copy2buffertoimage4xi(task4copybuffertoimage2xi=None):
    
    '''
    copies buffer to 2D image for XI
    '''
    global platform2xi
    global device2xi
    global context2xi    
    global image2d4xi                                                                                               # 2D-IMAGES
    global info2image4xi  
    global image2dbuffer4xi                                                                                         # BUFFER FOR XI
    
                                                                                
    global control2copybuffertoimage4xi                                                                             # COMMAND AND CONTROL TO COPY BUFFER TO 2D IMAGE WITH XI 
    global state2copybuffertoimage4xi                                                                               # STATE FOR COMMAND AND CONTROL
    global max2copybuffertoimagestate4xi                                                                            # MAX FOR STATE
    global ack2copybuffertoimageinfo4xi                                                                             # ACK FOR IMAGE INFO
    global message2copybuffertoimageget4xi                                                                          # QUEUE GET
    global message2copybuffertoimageput4xi                                                                          # QUEUE PUT
    global message2copybuffertoimagereceive4xi                                                                      # PIPE RECEIVE
    global message2copybuffertoimagesend4xi                                                                         # PIPE SEND   
      
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS JATKA          
    # -----------------------------------------------------------------------------------------          
    debug = True
    class2print = "copy2buffertoimage4xi"
    method2print = "copy2buffertoimage4xi"

    message2print = "{(Step 1A/33) started" + "; copy2buffertoimage4xi-started: " + str(copy2buffertoimage4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              #  
    # <function copy2buffertoimage4xi at 0x00000000039595C8> 
    
    message2print = "{(Step 1B/33) passed" + "; task4copybuffertoimage2xi-to-copy2buffertoimage4xi: " + str(task4copybuffertoimage2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    if debug is True:
        print("(Step 1B/33) of copy2buffertoimage4xi - PASSED TASK4COPYBUFFERTOIMAGE2XX: ", task4copybuffertoimage2xi)
        # {'GPU': {}, 'ZPU': {}, 'APU': {}}    
    code2ack  = ' '
    code2nack = ' '
    
    if task4copybuffertoimage2xi is None:
        task4copybuffertoimage2xi = {}
    
    # -----------------------------------------------------------------------------------------
    # CREATE 2D IMAGE FOR XI IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if image2d4xi is None:
            image2d4xi = create2image4xi()                                                                          # INITIALIZE IMAGE FOR XI 
            message2print = "{(Step 1C/70) created" + "; image2d4xi-created-by-copy2buffertoimage4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2image4xi-skipped-by-copy2buffertoimage4xi: " + str(copy2buffertoimage4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # skipped                                 
    except:
        try:
            image2d4xi = create2image4xi()
            message2print = "{(Step 1E/70) set" + "; image2d4xi-set-by-copy2buffertoimage4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            image2d4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; image2d4xi-yielded-by-copy2buffertoimage4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
    
    # -----------------------------------------------------------------------------------------
    #           
    # ----------------------------------------------------------------------------------------- 
    control2copytobuffer4xi = {}
    try:         
        keys2taskcopybuffertoimage = task4copybuffertoimage2xi.keys()
        if debug is True:
            print('(Step 1/33) of copy2buffertoimage4xi - KEYS2TASKCOPYBUFFERTOIMAGE:  ', keys2taskcopybuffertoimage) 
            # dict_keys(['GPU', 'ZPU', 'APU'])
            
        if 'APU' in keys2taskcopybuffertoimage:
            try:
                control2copytobuffer4xi['APU'] = copy2buffertoimage4apu()
                message2print = "{(Step 1C1/33) got" + "; apuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1A/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['APU']) 
                    # {'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005F414E0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7096>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7092>}}

            except:
                pass     
        if 'BPU' in keys2taskcopybuffertoimage:
            try:
                control2copytobuffer4xi['BPU'] = copy2buffertoimage4bpu()
                message2print = "{(Step 1C1/33) got" + "; bpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1B/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['BPU']) 
                    # 
            except:
                pass     
            
        if 'CPU' in keys2taskcopybuffertoimage:
            try:
                control2copytobuffer4xi['CPU'] = copy2buffertoimage4cpu()
                message2print = "{(Step 1C1/33) got" + "; cpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1C/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['CPU']) 
                    # 
            except:
                pass     
            
        if 'DPU' in keys2taskcopybuffertoimage:
            try:
                control2copytobuffer4xi['DPU'] = copy2buffertoimage4dpu()
                message2print = "{(Step 1C1/33) got" + "; dpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
                if debug is True:
                    print('(Step 1D/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['DPU']) 
                    # 
            except:
                pass               
        if 'EPU' in keys2taskcopybuffertoimage:
            try:
                control2copytobuffer4xi['EPU'] = copy2buffertoimage4epu()
                message2print = "{(Step 1C1/33) got" + "; epuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
                if debug is True:
                    print('(Step 1E/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['EPU']) 
                    # 
            except:
                pass               
        if 'FPU' in keys2taskcopybuffertoimage:
            try:
                control2copytobuffer4xi['FPU'] = copy2buffertoimage4fpu()
                message2print = "{(Step 1C1/33) got" + "; fpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
                if debug is True:
                    print('(Step 1F/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['FPU']) 
                    # 
            except:
                pass               
        if 'GPU' in keys2taskcopybuffertoimage:
            try:
                control2copytobuffer4xi['GPU'] = copy2buffertoimage4gpu()
                message2print = "{(Step 1C1/33) got" + "; gpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
                if debug is True:
                    print('(Step 1G/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['GPU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005FC4AC8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7128>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7124>}

            except:
                pass               
        if 'HPU' in keys2taskcopybuffertoimage:
            try:
                control2copytobuffer4xi['HPU'] = copy2buffertoimage4hpu()
                message2print = "{(Step 1C1/33) got" + "; hpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #             
                if debug is True:
                    print('(Step 1H/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['HPU']) 
                    # 
            except:
                pass
        if 'IPU' in keys2taskcopybuffertoimage:    
            try:
                control2copytobuffer4xi['IPU'] = copy2buffertoimage4ipu()
                message2print = "{(Step 1C1/33) got" + "; ipuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1I/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['IPU']) 
                    # 
            except:
                pass
        if 'JPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['JPU'] = copy2buffertoimage4jpu()
                message2print = "{(Step 1C1/33) got" + "; jpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1J/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['JPU']) 
                    # 
            except:
                pass
        if 'KPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['KPU'] = copy2buffertoimage4kpu()
                message2print = "{(Step 1C1/33) got" + "; kpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1K/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['KPU']) 
                    # 
            except:
                pass
        if 'LPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['LPU'] = copy2buffertoimage4lpu()
                message2print = "{(Step 1C1/33) got" + "; lpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1L/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['LPU']) 
                    # 
            except:
                pass
        if 'MPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['MPU'] = copy2buffertoimage4mpu()
                message2print = "{(Step 1C1/33) got" + "; mpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1M/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['MPU']) 
                    # 
            except:
                pass
        if 'NPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['NPU'] = copy2buffertoimage4npu()
                message2print = "{(Step 1C1/33) got" + "; npuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1N/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['NPU']) 
                    # 
            except:
                pass
        if 'OPU' in keys2taskcopybuffertoimage:                    
            try:
                control2copytobuffer4xi['OPU'] = copy2buffertoimage4opu()
                message2print = "{(Step 1C1/33) got" + "; opuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1O/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['OPU']) 
                    # 
            except:
                pass
        if 'PPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['PPU'] = copy2buffertoimage4ppu()
                message2print = "{(Step 1C1/33) got" + "; ppuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1P/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['PPU']) 
                    # 
            except:
                pass
        if 'QPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['QPU'] = copy2buffertoimage4qpu()
                message2print = "{(Step 1C1/33) got" + "; qpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1Q/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['QPU']) 
                    # 
            except:
                pass
        if 'RPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['RPU'] = copy2buffertoimage4rpu()
                message2print = "{(Step 1C1/33) got" + "; rpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1R/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['RPU']) 
                    # 
            except:
                pass
        if 'SPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['SPU'] = copy2buffertoimage4spu()
                message2print = "{(Step 1C1/33) got" + "; spuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1S/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['SPU']) 
                    # 
            except:
                pass
        if 'TPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['TPU'] = copy2buffertoimage4tpu()
                message2print = "{(Step 1C1/33) got" + "; tpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1T/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['TPU']) 
                    # 
            except:
                pass
        if 'UPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['UPU'] = copy2buffertoimage4upu()
                message2print = "{(Step 1C1/33) got" + "; upuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1U/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['UPU']) 
                    # 
            except:
                pass
        if 'VPU' in keys2taskcopybuffertoimage:                    
            try:
                control2copytobuffer4xi['VPU'] = copy2buffertoimage4vpu()
                message2print = "{(Step 1C1/33) got" + "; vpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1V/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['VPU']) 
                    # 
            except:
                pass
        if 'WPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['WPU'] = copy2buffertoimage4wpu()
                message2print = "{(Step 1C1/33) got" + "; wpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1W/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['WPU']) 
                    # 
            except:
                pass
        if 'XPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['XPU'] = copy2buffertoimage4xpu()
                message2print = "{(Step 1C1/33) got" + "; xpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1X/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['XPU']) 
                    # 
            except:
                pass
        if 'YPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['YPU'] = copy2buffertoimage4ypu()
                message2print = "{(Step 1C1/33) got" + "; ypuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1Y/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['YPU']) 
                    # 
            except:
                pass
        if 'ZPU' in keys2taskcopybuffertoimage:                     
            try:
                control2copytobuffer4xi['ZPU'] = copy2buffertoimage4zpu()
                message2print = "{(Step 1C1/33) got" + "; zpuimage-control-got-by-get2imageinfo: " + str(control2copytobuffer4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1Z/33) of copy2buffertoimage4xi - control2copytobuffer4xi:  ', control2copytobuffer4xi ['ZPU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005FC4F98>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7160>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7156>}

            except:
                pass
               
    except:
        message2print = "{(Step 1Z/70) yielded" + "; control2copytobuffer4xi-yielded-by-copy2buffertoimage4xi: " + str(control2copytobuffer4xi) + "; time: " + time4xi() + "}"                
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '1Z-'     
        print("(Step 1Z/70) of control2copytobuffer4xi *** FAILED BY-COPY2BUFFERTOIMAGE4XI: ", control2copytobuffer4xi)
        
            
    # ---------------------------------------------------------------------------------------------
    # RETURN CONTROL AND COMMAND DICTIONARY
    # ---------------------------------------------------------------------------------------------          
    if debug is True:
        print("(Step 70A/70) of control2copytobuffer4xi - TRYING RETURN DEBUG WITH CONTROL2COPYTOBUFFER4XI: ", control2copytobuffer4xi)
    try: 
        message2print = "{(Step 70B/70) set" + "; code2ack-set-by-copy2buffertoimage4xi: " + str(code2ack) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                             
        # 
     
        message2print = "{(Step 70C/70) set" + "; code2nack-set-by-copy2buffertoimage4xi: " + str(code2nack) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                             
        #   
            
        message2print = "{(Step 70D/70) returning" + "; control2copytobuffer4xi-returning-by-copy2buffertoimage4xi: " + str(control2copytobuffer4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                             
        # 
        if debug is True:
            print('(Step 33/33) of copy2buffertoimage4xi - RETURNING CONTROL2COPYBUFFERTOIMAGE4XI:  ', control2copytobuffer4xi)
            # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005FC4AC8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7128>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7124>}, 
            #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005FC4F98>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7160>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7156>}, 
            #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005FC4A58>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7096>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7092>}}
 
    except:
        print("(Step 70Z/70) of control2copytobuffer4xi *** FAILED TO DEBUG RETURN *** ", time4xi())
                    
    return control2copytobuffer4xi
        
                    
                    
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "read2image4xi" usage = "
#                                                                                                              
#   # ---------------------------------------------------------------------------------------------
#   # PHASE I: READ FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND - STATE 0                  
#   # ---------------------------------------------------------------------------------------------    
#   print('(Step 16C/700) OF IMAGE2D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH READ2IMAGE4XI ', time4xi())        
#   try: 
#       task4read2image = {} 
#       for key2pu in keys2pu:
#           if KB2CC [key2pu] == 'ACK':
#               task4read2image[key2pu]  = {}    # PROCESSING UNIT SELECTED
#           else:
#               pass                             # SKIPPED PROCESSING UNIT
#           
#       
#       response4read2image = read2image4xi(task4read2image)
#       
#       keys2readresponse = response4read2image.keys()
#       for key2readresponse in sorted(keys2readresponse):
#           kb2detail = response4read2image[key2readresponse]
#           keys2detail = kb2detail.keys()
#           for key2detail in keys2detail: 
#               print(key2readresponse, key2detail, kb2detail[key2detail])
#               #1:
#               # {'DPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFD390>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5840>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5836>},
#               #  'EPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFD4A8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5872>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5868>}, 
#               #  'BPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DF99E8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5776>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5772>},
#               #  'CPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DF9898>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5808>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5804>},
#               #  'VPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E019E8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6420>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6416>},
#               #  'RPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E014A8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6292>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6288>},
#               #  'WPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01B38>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6452>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6448>},
#               #  'SPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E015F8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6324>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6320>},
#               #  'PPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01208>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6228>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6224>},
#               #  'QPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01358>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6260>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6256>},
#               #  'KPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFDB38>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6064>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6060>},
#               #  'YPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01DD8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6516>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6512>},
#               #  'LPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFDC88>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6096>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6092>},
#               #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01F28>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6548>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6544>}, 
#               #  'HPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFD7F0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5968>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5964>},
#               #  'FPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFD5C0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5904>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5900>}, 
#               #  'TPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01748>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6356>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6352>},
#               #  'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFD6D8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5936>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5932>}, 
#               #  'UPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01898>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6388>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6384>}, 
#               #  'XPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E01C88>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6484>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6480>},
#               #  'OPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFDEF0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6196>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6192>},
#               #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DF9860>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 5744>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5740>},
#               #  'MPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFDDD8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6128>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6124>},
#               #  'IPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFD908>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6000>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 5996>},
#               #  'NPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFDF28>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6164>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6160>},
#               #  'JPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DFDA20>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6032>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6028>}}
#               #2 
#               #APU QUEUE <queue4xi.Queue4Xi object at 0x0000000005E87C18>
#               #APU PUBLISHERCHANNEL <read-write PipeConnection, handle 6552>
#               #APU CONSUMERCHANNEL <read-write PipeConnection, handle 6548>
#   except:
#       print('(Step 16Z4/700) OF IMAGE2D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH READ2IMAGE4XI ', time4xi())
#       
 
# -------------------------------------------------------------------------------------------------   
def read2image4xi(task4readimage2xi=None):

    '''
    reads 2D images for XI
    '''
    global platform2xi
    global device2xi
    global context2xi
    global image2d4xi                                                     # 2D-IMAGES 
    global info2image4xi 
    global control2readimage4xi                                           # COMMAND AND CONTROL FOR 2D IMAGE FOR XIS 
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class2print = "read2image4xi"
    method2print = "read2image4xi"

    message2print = "{(Step 1A/33) started" + "; read2image4xi-started: " + str(read2image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function read2image4xi at 0x00000000039595C8> 
    
    message2print = "{(Step 1B/33) passed" + "; task4readimage2xi-to-read2image4xi: " + str(task4readimage2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
     
    if task4readimage2xi is None:
        task4readimage2xi = {}
               
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # CREATE 2D IMAGE FOR XI IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if image2d4xi is None:
            image2d4xi = create2image4xi()                                                                              # INITIALIZE IMAGE FOR XI 
            message2print = "{(Step 1C/70) created" + "; image2d4xi-created-by-read2image4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2image4xi-skipped-by-read2image4xi: " + str(read2image4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # skipped                                 
    except:
        try:
            image2d4xi = create2image4xi()
            message2print = "{(Step 1E/70) set" + "; image2d4xi-set-by-read2image4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            image2d4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; image2d4xi-yielded-by-read2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
    
    # -----------------------------------------------------------------------------------------
    #           
    # ----------------------------------------------------------------------------------------- 
    control2readimage4xi = {}
    try:         
        keys2taskreadimage = task4readimage2xi.keys()
        if debug is True:
            print('(Step 1/33) of read2image4xi - keys2taskreadimage:  ', keys2taskreadimage) 
          
        if 'APU' in keys2taskreadimage:
            try:
                control2readimage4xi['APU'] = read2image4apu(task4readimage2xi['APU'])
                message2print = "{(Step 1C1/33) got" + "; apuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1A/33) of read2image4xi - control2readimage4xi:  ', control2readimage4xi['APU']) 
                
            except:
                pass     
        if 'BPU' in keys2taskreadimage:
            try:
                control2readimage4xi['BPU'] = read2image4bpu(task4readimage2xi['BPU'])
                message2print = "{(Step 1C1/33) got" + "; bpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass     
            
        if 'CPU' in keys2taskreadimage:
            try:
                control2readimage4xi['CPU'] = read2image4cpu(task4readimage2xi['CPU'])
                message2print = "{(Step 1C1/33) got" + "; cpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass     
            
        if 'DPU' in keys2taskreadimage:
            try:
                control2readimage4xi['DPU'] = read2image4dpu(task4readimage2xi['DPU'])
                message2print = "{(Step 1C1/33) got" + "; dpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'EPU' in keys2taskreadimage:
            try:
                control2readimage4xi['EPU'] = read2image4epu(task4readimage2xi['EPU'])
                message2print = "{(Step 1C1/33) got" + "; epuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'FPU' in keys2taskreadimage:
            try:
                control2readimage4xi['FPU'] = read2image4fpu(task4readimage2xi['FPU'])
                message2print = "{(Step 1C1/33) got" + "; fpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'GPU' in keys2taskreadimage:
            try:
                control2readimage4xi['GPU'] = read2image4gpu(task4readimage2xi['GPU'])
                message2print = "{(Step 1C1/33) got" + "; gpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'HPU' in keys2taskreadimage:
            try:
                control2readimage4xi['HPU'] = read2image4hpu(task4readimage2xi['HPU'])
                message2print = "{(Step 1C1/33) got" + "; hpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #             
            except:
                pass
        if 'IPU' in keys2taskreadimage:    
            try:
                control2readimage4xi['IPU'] = read2image4ipu(task4readimage2xi['IPU'])
                message2print = "{(Step 1C1/33) got" + "; ipuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'JPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['JPU'] = read2image4jpu(task4readimage2xi['JPU'])
                message2print = "{(Step 1C1/33) got" + "; jpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'KPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['KPU'] = read2image4kpu(task4readimage2xi['KPU'])
                message2print = "{(Step 1C1/33) got" + "; kpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'LPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['LPU'] = read2image4lpu(task4readimage2xi['LPU'])
                message2print = "{(Step 1C1/33) got" + "; lpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'MPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['MPU'] = read2image4mpu(task4readimage2xi['MPU'])
                message2print = "{(Step 1C1/33) got" + "; mpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'NPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['NPU'] = read2image4npu(task4readimage2xi['NPU'])
                message2print = "{(Step 1C1/33) got" + "; npuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'OPU' in keys2taskreadimage:                    
            try:
                control2readimage4xi['OPU'] = read2image4opu(task4readimage2xi['OPU'])
                message2print = "{(Step 1C1/33) got" + "; opuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'PPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['PPU'] = read2image4ppu(task4readimage2xi['PPU'])
                message2print = "{(Step 1C1/33) got" + "; ppuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'QPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['QPU'] = read2image4qpu(task4readimage2xi['QPU'])
                message2print = "{(Step 1C1/33) got" + "; qpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'RPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['RPU'] = read2image4rpu(task4readimage2xi['RPU'])
                message2print = "{(Step 1C1/33) got" + "; rpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'SPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['SPU'] = read2image4spu(task4readimage2xi['SPU'])
                message2print = "{(Step 1C1/33) got" + "; spuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'TPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['TPU'] = read2image4tpu(task4readimage2xi['TPU'])
                message2print = "{(Step 1C1/33) got" + "; tpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'UPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['UPU'] = read2image4upu(task4readimage2xi['UPU'])
                message2print = "{(Step 1C1/33) got" + "; upuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'VPU' in keys2taskreadimage:                    
            try:
                control2readimage4xi['VPU'] = read2image4vpu(task4readimage2xi['VPU'])
                message2print = "{(Step 1C1/33) got" + "; vpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'WPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['WPU'] = read2image4wpu(task4readimage2xi['WPU'])
                message2print = "{(Step 1C1/33) got" + "; wpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'XPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['XPU'] = read2image4xpu(task4readimage2xi['XPU'])
                message2print = "{(Step 1C1/33) got" + "; xpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'YPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['YPU'] = read2image4ypu(task4readimage2xi['YPU'])
                message2print = "{(Step 1C1/33) got" + "; ypuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'ZPU' in keys2taskreadimage:                     
            try:
                control2readimage4xi['ZPU'] = read2image4zpu(task4readimage2xi['ZPU'])
                message2print = "{(Step 1C1/33) got" + "; zpuimage-control-got-by-get2imageinfo: " + str(control2readimage4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
               
    except:
        message2print = "{(Step 1Z/70) yielded" + "; control2readimage4xi-yielded-by-read2image4xi: " + str(control2readimage4xi) + "; time: " + time4xi() + "}"                
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '1Z-'     
        
    # ---------------------------------------------------------------------------------------------
    # RETURN CONTROL AND COMMAND DICTIONARY
    # ---------------------------------------------------------------------------------------------          
    message2print = "{(Step 70A/70) set" + "; code2ack-set-by-read2image4xi: " + str(code2ack) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                             
    # 
     
    message2print = "{(Step 70B/70) set" + "; code2nack-set-by-read2image4xi: " + str(code2nack) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    #   
        
    message2print = "{(Step 70C/70) returning" + "; control2readimage4xi-returning-by-read2image4xi: " + str(control2readimage4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    if debug is True:
        print('(Step 33/33) of read2image4xi - RETURNING CONTROL2READIMAGE4XI:  ', control2readimage4xi) 
        
    return control2readimage4xi
                    
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "map2image4xi" usage = "
#                                                                                                              
#   # ---------------------------------------------------------------------------------------------
#   # PHASE I: MAP FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND              
#   # ---------------------------------------------------------------------------------------------    
#   print('=' *33)          
#   print('(Step 92A/700) OF IMAGE2D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH MAP2IMAGE4XI ', time4xi())        
#   print('=' *33)      
#   #                         
#   response4map2image      = {} 
#   task4map2image        = {}                                                                                    
#   queue4map          = {} 
#   channel4map2publish = {} 
#   channel4map2consume = {} 
#   try:
#       task4map2image = {} 
#       for key2pu in keys2pu:
#           if KB2CC [key2pu] == 'ACK':
#               task4map2image [key2pu]  = {}
#                                               
#       response4map2image = map2image4xi(task4map2image)
#       
#       print('(Step 92B/700) OF IMAGE2D4XI5TEST - GOT RESPONSE4MAP2IMAGE ', response4map2image)
#       # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E678D0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7228>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7224>}, 
#       #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E6E128>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7260>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7256>}, 
#       #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E67F28>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7196>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7192>}}
#       print('(Step 9CB/700) OF IMAGE2D4XI5TEST - CONTINUES AFTER GETTING RESPONSE4MAP2IMAGE ', time4xi())   
#   except:
#       print('(Step 92Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH MAP2IMAGE4XI ', time4xi())
#                
#   print('(Step 92C/700) OF IMAGE2D4XI5TEST - TRYING TO INITIALIZE QUEUE FOR MAP ', time4xi())               
#   try: 
#       queue4map          = {}
#   except:
#       print('(Step 92Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO INITIALIZE QUEUES FOR MAP ', time4xi()) 
#   try:            
#       channel4map2publish = {}
#   except:
#       print('(Step 92Z2/700) OF IMAGE2D4XI5TEST *** FAILED TO INITIALIZE PUBLISHING CHANNELS FOR MAP ', time4xi()) 
#    try:    
#       channel4map2consume = {}
#   except:    
#       print('(Step 92Z5/700) OF IMAGE2D4XI5TEST *** FAILED TO INITIALIZE CONSUMING CHANNELS FOR MAP ', time4xi())
#   try:         
#       for key2pu in keys2pu:
#           try:
#               if KB2CC [key2pu] == 'ACK':
#                   try:   
#                       queue4map [key2pu] = response4map2image [key2pu] ['QUEUE']
#                       print(key2pu, ' SET QUEUE TO : ', queue4map [key2pu])
#                       # ZPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006046588>
#                       # GPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006046400>
#                       # APU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006046390>
#                   except:
#                       print('(Step 92Z6/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi()) 
#                   try:    
#                       channel4map2publish [key2pu] = response4map2image [key2pu] ['PUBLISHERCHANNEL']
#                       print(key2pu, ' SET CHANNEL TO PUBLISH4XI TO : ', channel4map2publish [key2pu])
#                       # ZPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7256>
#                       # GPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7224>
#                       # APU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7192>
#                                          
#                   except:
#                       print('(Step 92Z7/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi()) 
#                   try:            
#                       channel4map2consume [key2pu] = response4map2image [key2pu]['CONSUMERCHANNEL']
#                       print(key2pu, ' SET CHANNEL TO CONSUME4XI TO : ', channel4map2consume [key2pu])
#                       # ZPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7252>
#                       # GPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7220>
#                       # APU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7188>
#                   except:
#                       print('(Step 92Z8/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi())     
#           except:
#               print('(Step 92Z9/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi())             
#   except:
#       print('(Step 92Z10/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi()) 
#                                           
#">

# -------------------------------------------------------------------------------------------------   
def map2image4xi(task4mapimage2xi=None):
    # 
    '''
    maps 2D images for XI
    '''

    global image2d4xi                                                                                              # 2D-IMAGES
    global control2mapimage4xi                                                                                     # COMMAND AND CONTROL FOR 2D IMAGE FOR XIS 
 
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class2print = "map2image4xi"
    method2print = "map2image4xi"

    message2print = "{(Step 1A/33) started" + "; map2image4xi-started: " + str(map2image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    message2print = "{(Step 1B/33) passed" + "; task4mapimage2xi-to-map2image4xi: " + str(task4mapimage2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    
    if task4mapimage2xi is None:
        task4mapimage2xi = {}
            
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # CREATE 2D IMAGE4XI IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if image2d4xi is None:
            image2d4xi = create2image4xi()                                                                              # INITIALIZE IMAGE FOR XI 
            message2print = "{(Step 1C/70) created" + "; image2d4xi-created-by-map2image4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2image4xi-skipped-by-map2image4xi: " + str(map2image4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                
    except:
        try:
            image2d4xi = create2image4xi()
            message2print = "{(Step 1E/70) set" + "; image2d4xi-set-by-map2image4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            image2d4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; image2d4xi-yielded-by-map2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
    
    
    # -----------------------------------------------------------------------------------------
    #           
    # ----------------------------------------------------------------------------------------- 
    control2mapimage4xi = {}
    try:         
        keys2taskmapimage = task4mapimage2xi.keys()
        if debug is True:
            print('(Step 1/33) of map2image4xi - keys2taskmapimage:  ', keys2taskmapimage) 
            # dict_keys(['GPU', 'ZPU', 'APU']
            
        if 'APU' in keys2taskmapimage:
            try:
                control2mapimage4xi['APU'] = map2image4apu()
                message2print = "{(Step 1C1/33) got" + "; apuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1A/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['APU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x00000000060E2588>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7192>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7188>}


            except:
                pass     
        if 'BPU' in keys2taskmapimage:
            try:
                control2mapimage4xi['BPU'] = map2image4bpu()
                message2print = "{(Step 1C1/33) got" + "; bpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1B/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['BPU']) 
                    # 
            except:
                pass     
            
        if 'CPU' in keys2taskmapimage:
            try:
                control2mapimage4xi['CPU'] = map2image4cpu()
                message2print = "{(Step 1C1/33) got" + "; cpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1C/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['CPU']) 
                    # 
            except:
                pass     
            
        if 'DPU' in keys2taskmapimage:
            try:
                control2mapimage4xi['DPU'] = map2image4dpu()
                message2print = "{(Step 1C1/33) got" + "; dpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
                if debug is True:
                    print('(Step 1D/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['DPU']) 
                    # 
            except:
                pass               
        if 'EPU' in keys2taskmapimage:
            try:
                control2mapimage4xi['EPU'] = map2image4epu()
                message2print = "{(Step 1C1/33) got" + "; epuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
                if debug is True:
                    print('(Step 1E/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['EPU']) 
                    # 
            except:
                pass               
        if 'FPU' in keys2taskmapimage:
            try:
                control2mapimage4xi['FPU'] = map2image4fpu()
                message2print = "{(Step 1C1/33) got" + "; fpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
                if debug is True:
                    print('(Step 1F/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['FPU']) 
                    # 
            except:
                pass               
        if 'GPU' in keys2taskmapimage:
            try:
                control2mapimage4xi['GPU'] = map2image4gpu()
                message2print = "{(Step 1C1/33) got" + "; gpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
                if debug is True:
                    print('(Step 1G/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['GPU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x00000000060E25F8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7224>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7220>}

            except:
                pass               
        if 'HPU' in keys2taskmapimage:
            try:
                control2mapimage4xi['HPU'] = map2image4hpu()
                message2print = "{(Step 1C1/33) got" + "; hpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #             
                if debug is True:
                    print('(Step 1H/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['HPU']) 
                    # 
            except:
                pass
        if 'IPU' in keys2taskmapimage:    
            try:
                control2mapimage4xi['IPU'] = map2image4ipu()
                message2print = "{(Step 1C1/33) got" + "; ipuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1I/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['IPU']) 
                    # 
            except:
                pass
        if 'JPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['JPU'] = map2image4jpu()
                message2print = "{(Step 1C1/33) got" + "; jpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1J/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['JPU']) 
                    # 
            except:
                pass
        if 'KPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['KPU'] = map2image4kpu()
                message2print = "{(Step 1C1/33) got" + "; kpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1K/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['KPU']) 
                    # 
            except:
                pass
        if 'LPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['LPU'] = map2image4lpu()
                message2print = "{(Step 1C1/33) got" + "; lpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1L/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['LPU']) 
                    # 
            except:
                pass
        if 'MPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['MPU'] = map2image4mpu()
                message2print = "{(Step 1C1/33) got" + "; mpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1M/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['MPU']) 
                    # 
            except:
                pass
        if 'NPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['NPU'] = map2image4npu()
                message2print = "{(Step 1C1/33) got" + "; npuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1N/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['NPU']) 
                    # 
            except:
                pass
        if 'OPU' in keys2taskmapimage:                    
            try:
                control2mapimage4xi['OPU'] = map2image4opu()
                message2print = "{(Step 1C1/33) got" + "; opuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1O/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['OPU']) 
                    # 
            except:
                pass
        if 'PPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['PPU'] = map2image4ppu()
                message2print = "{(Step 1C1/33) got" + "; ppuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1P/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['PPU']) 
                    # 
            except:
                pass
        if 'QPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['QPU'] = map2image4qpu()
                message2print = "{(Step 1C1/33) got" + "; qpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1Q/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['QPU']) 
                    #                 
            except:
                pass
        if 'RPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['RPU'] = map2image4rpu()
                message2print = "{(Step 1C1/33) got" + "; rpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1R/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['RPU']) 
                    # 
            except:
                pass
        if 'SPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['SPU'] = map2image4spu()
                message2print = "{(Step 1C1/33) got" + "; spuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1S/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['SPU']) 
                    # 
            except:
                pass
        if 'TPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['TPU'] = map2image4tpu()
                message2print = "{(Step 1C1/33) got" + "; tpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1T/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['TPU']) 
                    # 
            except:
                pass
        if 'UPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['UPU'] = map2image4upu()
                message2print = "{(Step 1C1/33) got" + "; upuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1U/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['UPU']) 
                    # 
            except:
                pass
        if 'VPU' in keys2taskmapimage:                    
            try:
                control2mapimage4xi['VPU'] = map2image4vpu()
                message2print = "{(Step 1C1/33) got" + "; vpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1V/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['VPU']) 
                    # 
            except:
                pass
        if 'WPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['WPU'] = map2image4wpu()
                message2print = "{(Step 1C1/33) got" + "; wpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1W/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['WPU']) 
                    # 
            except:
                pass
        if 'XPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['XPU'] = map2image4xpu()
                message2print = "{(Step 1C1/33) got" + "; xpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1X/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['XPU']) 
                    # 
            except:
                pass
        if 'YPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['YPU'] = map2image4ypu()
                message2print = "{(Step 1C1/33) got" + "; ypuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1Y/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['YPU']) 
                    # 
            except:
                pass
        if 'ZPU' in keys2taskmapimage:                     
            try:
                control2mapimage4xi['ZPU'] = map2image4zpu()
                message2print = "{(Step 1C1/33) got" + "; zpuimage-control-got-by-get2imageinfo: " + str(control2mapimage4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1Z/33) of map2image4xi - control2mapimage4xi:  ', control2mapimage4xi['ZPU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x00000000060E2780>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7256>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7252>}

            except:
                pass
               
    except:
        message2print = "{(Step 1Z/70) yielded" + "; control2mapimage4xi-yielded-by-map2image4xi: " + str(control2mapimage4xi) + "; time: " + time4xi() + "}"                
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '1Z-'     
 
        
    # ---------------------------------------------------------------------------------------------
    # RETURN CONTROL AND COMMAND DICTIONARY
    # ---------------------------------------------------------------------------------------------          
    try:
        message2print = "{(Step 70A/70) set" + "; code2ack-set-by-map2image4xi: " + str(code2ack) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                             
        # 
        message2print = "{(Step 70B/70) set" + "; code2nack-set-by-map2image4xi: " + str(code2nack) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                             
        # 
            
        message2print = "{(Step 70C/70) returning" + "; control2mapimage4xi-returning-by-map2image4xi: " + str(control2mapimage4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                             
        # 
        if debug is True:
            print('(Step 33A/33) of map2image4xi - RETURNING CONTROL2MAPIMAGE4XI:  ', control2mapimage4xi) 
            # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E678D0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7228>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7224>}, 
            #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E6E128>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7260>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7256>}, 
            #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E67F28>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7196>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7192>}}
            
            print('(Step 33A33) of map2image4xi - PASSED (Step 33A/33) ', time4xi())
            print('(Step 33B33) of map2image4xi - PASSED (Step 33B/33) ', time4xi())
            print('(Step 33C33) of map2image4xi - PASSED (Step 33C/33) ', time4xi())
            print('(Step 33D33) of map2image4xi - PASSED (Step 33D/33) ', time4xi())
            print('(Step 33E33) of map2image4xi - PASSED (Step 33E/33) ', time4xi())
            print('(Step 33F33) of map2image4xi - PASSED (Step 33F/33) ', time4xi())
            print('(Step 33G33) of map2image4xi - PASSED (Step 33G/33) ', time4xi())
            print('(Step 33H33) of map2image4xi - PASSED (Step 33H/33) ', time4xi())
            print('(Step 33I33) of map2image4xi - PASSED (Step 33I/33) ', time4xi())
            print('(Step 33J33) of map2image4xi - PASSED (Step 33J/33) ', time4xi())
            print('(Step 33K33) of map2image4xi - PASSED (Step 33K/33) ', time4xi())
            print('(Step 33L33) of map2image4xi - PASSED (Step 33L/33) ', time4xi())
            print('(Step 33M33) of map2image4xi - PASSED (Step 33M/33) ', time4xi())
            print('(Step 33N33) of map2image4xi - PASSED (Step 33N/33) ', time4xi())
            print('(Step 33O33) of map2image4xi - PASSED (Step 33O/33) ', time4xi())
            print('(Step 33P33) of map2image4xi - PASSED (Step 33P/33) ', time4xi())
            print('(Step 33Q33) of map2image4xi - PASSED (Step 33Q/33) ', time4xi())
            print('(Step 33R33) of map2image4xi - PASSED (Step 33R/33) ', time4xi())
            print('(Step 33S33) of map2image4xi - PASSED (Step 33S/33) ', time4xi())
            print('(Step 33T33) of map2image4xi - PASSED (Step 33T/33) ', time4xi())
            print('(Step 33U33) of map2image4xi - PASSED (Step 33U/33) ', time4xi())
            print('(Step 33V33) of map2image4xi - PASSED (Step 33V/33) ', time4xi())
            print('(Step 33X33) of map2image4xi - PASSED (Step 33X/33) ', time4xi())
            print('(Step 33Y33) of map2image4xi - PASSED (Step 33Y/33) ', time4xi())
            print('(Step 33Z33) of map2image4xi - PASSED (Step 33Z/33) ', time4xi())
            print('(Step 33W33) of map2image4xi - PASSED (Step 33W/33) ', time4xi())

    except:
        pass
    
    print('(Step 33A233) of map2image4xi - PASSED (Step 33A2/33) ', time4xi())
    print('(Step 33B233) of map2image4xi - PASSED (Step 33B2/33) ', time4xi())
    print('(Step 33C233) of map2image4xi - PASSED (Step 33C2/33) ', time4xi())
    print('(Step 33D233) of map2image4xi - PASSED (Step 33D2/33) ', time4xi())
    print('(Step 33E233) of map2image4xi - PASSED (Step 33E2/33) ', time4xi())
    print('(Step 33F233) of map2image4xi - PASSED (Step 33F2/33) ', time4xi())
    print('(Step 33G233) of map2image4xi - PASSED (Step 33G2/33) ', time4xi())
    print('(Step 33H233) of map2image4xi - PASSED (Step 33H2/33) ', time4xi())
    print('(Step 33I233) of map2image4xi - PASSED (Step 33I2/33) ', time4xi())
    print('(Step 33J233) of map2image4xi - PASSED (Step 33J2/33) ', time4xi())
    print('(Step 33K233) of map2image4xi - PASSED (Step 33K2/33) ', time4xi())
    print('(Step 33L233) of map2image4xi - PASSED (Step 33L2/33) ', time4xi())
    print('(Step 33M233) of map2image4xi - PASSED (Step 33M2/33) ', time4xi())
    print('(Step 33N233) of map2image4xi - PASSED (Step 33N2/33) ', time4xi())
    print('(Step 33O233) of map2image4xi - PASSED (Step 33O2/33) ', time4xi())
    print('(Step 33P233) of map2image4xi - PASSED (Step 33P2/33) ', time4xi())
    print('(Step 33Q233) of map2image4xi - PASSED (Step 33Q2/33) ', time4xi())
    print('(Step 33R233) of map2image4xi - PASSED (Step 33R2/33) ', time4xi())
    print('(Step 33S233) of map2image4xi - PASSED (Step 33S2/33) ', time4xi())
    print('(Step 33T233) of map2image4xi - PASSED (Step 33T2/33) ', time4xi())
    print('(Step 33U233) of map2image4xi - PASSED (Step 33U2/33) ', time4xi())
    print('(Step 33V233) of map2image4xi - PASSED (Step 33V2/33) ', time4xi())
    print('(Step 33X233) of map2image4xi - PASSED (Step 33X2/33) ', time4xi())
    print('(Step 33Y233) of map2image4xi - PASSED (Step 33Y2/33) ', time4xi())
    print('(Step 33Z233) of map2image4xi - PASSED (Step 33Z2/33) ', time4xi())
    print('(Step 33W233) of map2image4xi - PASSED (Step 33W2/33) ', time4xi())
    
    if debug is True:
        print('(Step 33/33) of map2image4xi - RETURN COMMAND NEXT ', time4xi())
        #              
    return control2mapimage4xi
                    
                    
#</function4xi> 

# -----------------------------------------------------------------------------------------------------------------------
#<function4xi function = "manoeuvre2copyimage4xi" usage = "
#
#   # ---------------------------------------------------------------------------------------------------------------------
#   # PHASE I: COPY FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4XI  - LET IT TO RECEIVE COPY AND TO SEND ROGER VIA PIPE                
#   # ---------------------------------------------------------------------------------------------------------------------       
#   if ack2simulate4xi is True:
#       print("(Step 42A/700) OF IMAGE2D4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4XI ", time4xi())   
#       try:
#           response2manoeuvre4copy = manoeuvre2copyimage4xi(queue4copy, channel4copy2consume, channel4copy2publish)
#           print("(Step 42B/700) OF IMAGE2D4XI5TEST - PERFORMED MANOEUVRE2COPYIMAGE4XI, RESPONSE2MANOEUVRE4COPY: ", response2manoeuvre4copy)
#           # 
#       except:
#           print("(Step 42Z/700) OF IMAGE2D4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4XI ", time4xi())     
#   else:
#       pass # trust activated thread    
#">

# ----------------------------------------------------------------------------------------------------------------------- 
def manoeuvre2copyimage4xi(queue2copymanoeuvre4xi, consumerchannel2copymanoeuvre4xi, publisherchannel2copymanoeuvre4xi):
    '''
    manoeuvres copy control and command
    '''
    # 
        
    # ---------------------------------------------------------------------------------------------
    # GLOBAL DICTIONARIES TO HANDLE PROCESSING UNITS
    # ---------------------------------------------------------------------------------------------
    global state2copy4xi                                                                                           
    global max2copystate4xi                                                                                        
    global ack2copyinfo4xi                                                                                         
    global message2copyget4xi                                 
    global message2copyput4xi
    global message2copyreceive4xi
    global message2copysend4xi
    
    global mission2copy                                                          
    
    global image2d4xi  
    global info2image4xi  
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    debug = True
    try:
        if debug is True:
            print("(Step 0D1/33) of manoeuvre2copyimage4xi - STARTED " , time4xi())
            #  
            print("(Step 0D2/33) of manoeuvre2copyimage4xi - PASSED QUEUE2READMANOEUVRE4XI: " , queue2copymanoeuvre4xi)
            # {'GPU': <queue4xi.Queue4Xi object at 0x0000000006047160>, 'ZPU': <queue4xi.Queue4Xi object at 0x0000000006047240>, 'APU': <queue4xi.Queue4Xi object at 0x0000000006047128>}

    
            print("(Step 0D3/33) of manoeuvre2copyimage4xi - PASSED CONSUMERCHANNEL2READMANOEUVRE4XI: " , consumerchannel2copymanoeuvre4xi)
            # {'GPU': <read-write PipeConnection, handle 6844>, 'ZPU': <read-write PipeConnection, handle 6876>, 'APU': <read-write PipeConnection, handle 6812>}

           
            print("(Step 0D4/33) of manoeuvre2copyimage4xi - PASSED PUBLISHERCHANNEL2READMANOEUVRE4XI: " , publisherchannel2copymanoeuvre4xi) 
            # {'GPU': <read-write PipeConnection, handle 6848>, 'ZPU': <read-write PipeConnection, handle 6880>, 'APU': <read-write PipeConnection, handle 6816>}

    
            print("(Step 0D5/33) of manoeuvre2copyimage4xi - USING STATE2READ4XI: " , state2copy4xi) 
            # {}
            
            
        keys2copymanoeuvre = queue2copymanoeuvre4xi.keys()
        if debug is True:
            print("{(Step 0/33) of manoeuvre2copyimage4xi - SET KEYS2READMANOEUVRE TO: ", keys2copymanoeuvre) 
            # dict_keys(['GPU', 'ZPU', 'APU'])
            
                  
        response2manouvre4copy = {}
    except:
        print("(Step 0Z1/33) of manoeuvre2copyimage4xi *** FAILED IN START ***  " , time4xi())
    
    # -----------------------------------------------------------------------------------------
    # (Step 0/33) PARAMETERS ARE DICTIONARIES FOR XI            
    # -----------------------------------------------------------------------------------------          
    try:
        class2print  = "manoeuvre2copyimage4xi" 
        method2print = "manoeuvre2copyimage4xi" 
    
        code2ack  = ' '
        code2nack = ' '
        
        message2print = "{(Step 0A/33) started" + "; manoeuvre2copyimage4xi-started: " + str(manoeuvre2copyimage4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                                     #  
        # 
        
        message2print = "{(Step 0B/33) passed" + "; queue2copymanoeuvre4xi-to-manoeuvre2copyimage4xi: " + str(queue2copymanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        # 
        
        message2print = "{(Step 0C/33) passed" + "; consumerchannel2copymanoeuvre4xi-to-manoeuvre2copyimage4xi: " + str(consumerchannel2copymanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        # 
        
        message2print = "{(Step 0D/33) passed" + "; publisherchannel2copymanoeuvre4xi-to-manoeuvre2copyimage4xi: " + str(publisherchannel2copymanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        #   
        
        code2ack  = code2ack + '0D-' 
    except:
        print("(Step 0Z2/33) of manoeuvre2copyimage4xi *** FAILED IN START ***  " , time4xi())
        
    # ==============================================================================================================
    # MISSION
    # ==============================================================================================================        
    if debug is True:
        print("{(Step M0/33) of manoeuvre2copyimage4xi - CHECKING MISSION AT STATE2READ4XI: " , state2copy4xi) 
        # {'GPU': 0}
        
         
    try:
        if mission2copy == "NACK":
            mission2copy = "ACK"
            print("(Step M1/33) of manoeuvre2copyimage4xi - SET MISSION2READ TO :  " , mission2copy)       
        else:
            mission2copy = "ACK"
            print("(Step M2/33) of manoeuvre2copyimage4xi - USING MISSION2READ:  " , mission2copy)
            # ACK
            
        if state2copy4xi == {}:    
            for key2copymanoeuvre in keys2copymanoeuvre:
                #----------------------------------------------------------------------------------------------------------------------
                # STATE 0
                # ---------------------------------------------------------------------------------------------------------------------     
                state2copy4xi [key2copymanoeuvre]   = 0
                message2print = "{(Step 0Z1/33) initialized" + "; state2copy4xi-initialized-by-manoeuvre2copyimage4xi to: " + str(state2copy4xi [key2copymanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                                    
                ack2copyinfo4xi [key2copymanoeuvre] = False
                message2print = "{(Step 0Z2/33) initialized" + "; ack2copyinfo4xi-initialized-by-manoeuvre2copyimage4xi to: " + str(ack2copyinfo4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                    
                message2copyget4xi [key2copymanoeuvre] = '<default4xi>default2copy4xi</default4xi>'
                message2print = "{(Step 0Z3/33) initialized" + "; message2copyget4xi-initialized-by-manoeuvre2copyimage4xi to: " + str(message2copyget4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                    
                message2copyput4xi [key2copymanoeuvre]  = '<default4xi>default2copy4xi</default4xi>'
                message2print = "{(Step 0Z4/33) initialized" + "; message2copyput4xi-initialized-by-manoeuvre2copyimage4xi to: " + str(message2copyput4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2copyreceive4xi [key2copymanoeuvre]  = '<default4xi>default2copy4xi</default4xi>'
                message2print = "{(Step 0Z5/33) initialized" + "; message2copyreceive4xi-initialized-by-manoeuvre2copyimage4xi to: " + str(message2copyreceive4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2copysend4xi [key2copymanoeuvre] = '<default4xi>default2copy4xi</default4xi>'
                message2print = "{(Step 0Z6/33) initialized" + "; message2copysend4xi-initialized-by-manoeuvre2copyimage4xi to: " + str(message2copysend4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                max2copystate4xi [key2copymanoeuvre] = 3
                message2print = "{(Step 0Z7/33) initialized" + ";  max2copystate4xi-initialized-by-manoeuvre2copyimage4xi to: " + str( max2copystate4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #    
        else:
            pass                             
    except:
        if debug is True:
            print("{(Step 0Z0/33) of manoeuvre2copyimage4xi  EXCEPTION: ", time4xi()) 
            mission2copy = "ACK" 
            print("(Step M3/33) of manoeuvre2copyimage4xi  EXCEPTIONAL MISSION2COPY:  " , mission2copy) 
            # ACK 
        if state2copy4xi == {}:                 
            for key2copymanoeuvre in keys2copymanoeuvre:
                # ------------------------------------------------------------------------------------------------------------------------
                # EXCEPTIONAL STATE 0
                # ------------------------------------------------------------------------------------------------------------------------     
                state2copy4xi [key2copymanoeuvre]   = 0
                message2print = "{(Step 0Z1/33) initialized" + "; state2copy4xi-initialized-by-manoeuvre2copyimage4xi to: " + str(state2copy4xi [key2copymanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                    
                ack2copyinfo4xi [key2copymanoeuvre] = False
                message2print = "{(Step 0Z2/33) initialized" + "; ack2copyinfo4xi-initialized-by-manoeuvre2copyimage4xi to: " + str(ack2copyinfo4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                    
                message2copyget4xi [key2copymanoeuvre] = '<default4xi>default2copy4xi</default4xi>'
                message2print = "{(Step 0Z3/33) initialized" + "; message2copyget4xi-initialized-by-manoeuvre2copyimage4xi to: " + str(message2copyget4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                    
                message2copyput4xi [key2copymanoeuvre]  = '<default4xi>default2copy4xi</default4xi>'
                message2print = "{(Step 0Z4/33) initialized" + "; message2copyput4xi-initialized-by-manoeuvre2copyimage4xi to: " + str(message2copyput4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2copyreceive4xi [key2copymanoeuvre]  = '<default4xi>default2copy4xi</default4xi>'
                message2print = "{(Step 0Z5/33) initialized" + "; message2copyreceive4xi-initialized-by-manoeuvre2copyimage4xi to: " + str(message2copyreceive4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2copysend4xi [key2copymanoeuvre] = '<default4xi>default2copy4xi</default4xi>'
                message2print = "{(Step 0Z6/33) initialized" + "; message2copysend4xi-initialized-by-manoeuvre2copyimage4xi to: " + str(message2copysend4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                max2copystate4xi [key2copymanoeuvre] = 3
                message2print = "{(Step 0Z7/33) initialized" + ";  max2copystate4xi-initialized-by-manoeuvre2copyimage4xi to: " + str( max2copystate4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #
       
    # ==============================================================================================================
    # NEXT PHASE PREPARING 
    # ==============================================================================================================                                             
    if debug is True:
        print("{(Step M0/33) of manoeuvre2copyimage4xi - NEXT PHASE PREPARING AT STATE2READ4XI: " , state2copy4xi) 
        # 
          
    for key2copymanoeuvre in keys2copymanoeuvre:
        try:
            # ------------------------------------------------------------------------------------------------------------------------
            # UPDATE 
            # ------------------------------------------------------------------------------------------------------------------------      
            state2copy4xi [key2copymanoeuvre]  = state2copy4xi [key2copymanoeuvre]  + 1                                                                   
            message2print = "{(Step 0H/33) added" + "; state2copy4xi-added-by-manoeuvre2copyimage4xi: " + str(state2copy4xi [key2copymanoeuvre] ) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            if debug is True:
                print("(Step 0h/33) of manoeuvre2copyimage4xi TO: ", key2copymanoeuvre, " STATE2READ4XI-ADDED TO: " , state2copy4xi [key2copymanoeuvre]) 
                # 1
                
                 
            if state2copy4xi [key2copymanoeuvre] > max2copystate4xi [key2copymanoeuvre]:
                state2copy4xi [key2copymanoeuvre]  = 0
                message2print = "{(Step 0I/33) set" + "; state2copy4xi-set-by-manoeuvre2copyimage4xi to: " + str(state2copy4xi [key2copymanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                
                if debug is True:
                    print("(Step 0I/33) of manoeuvre2copyimage4xi TO: ", key2copymanoeuvre, " STATE2READ4XI-ZEROED TO: " , state2copy4xi [key2copymanoeuvre]) 
                    # 
                    
                ack2copyinfo4xi [key2copymanoeuvre] = False
                message2print = "{(Step 0J/33) set" + "; ack2copyinfo4xi-set-by-manoeuvre2copyimage4xi to: " + str(ack2copyinfo4xi [key2copymanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                
                message2copyget4xi [key2copymanoeuvre] = '<default4xi>default2copy4xi</default4xi>'
                message2print = "{(Step 0K/33) set" + "; message2copyget4xi-set-by-manoeuvre2copyimage4xi to: " + str(message2copyget4xi [key2copymanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                
                message2copyput4xi [key2copymanoeuvre]  = '<default4xi>default2copy4xi</default4xi>'
                message2print = "{(Step 0L/33) set" + "; message2copyput4xi-set-by-manoeuvre2copyimage4xi to: " + str(message2copyput4xi [key2copymanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                
                message2copyreceive4xi [key2copymanoeuvre] = '<default4xi>default2copy4xi</default4xi>'
                message2print = "{(Step 0M/33) set" + "; message2copyreceive4xi-set-by-manoeuvre2copyimage4xi to: " + str(message2copyreceive4xi [key2copymanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                
                message2copysend4xi [key2copymanoeuvre]    = '<default4xi>default2copy4xi</default4xi>'
                message2print = "{(Step 0N/33) set" + "; message2copysend4xi-set-by-manoeuvre2copyimage4xi to: " + str(message2copysend4xi [key2copymanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                
                max2copystate4xi [key2copymanoeuvre] = 3
                message2print = "{(Step 0O/33) initialized" + ";  max2copystate4xi-set-by-manoeuvre2copyimage4xi to: " + str( max2copystate4xi [key2copymanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #
            else:
                pass
            if debug is True:
                print("(Step 1A/33) of manoeuvre2copyimage4xi FOR : ", key2copymanoeuvre, " CONTINUING WITH STATE2READ4XI: " , state2copy4xi [key2copymanoeuvre])
                # 
                        
        except:
            print("(Step 0z1/33) of manoeuvre2copyimage4xi *** FAILED UPDATING *** " , time4xi()) 
            try:
                print("*** key2copymanoeuvre: " , key2copymanoeuvre)
                # GPU
            except:
                pass
            try:    
                print("*** state2copy4xi: " , state2copy4xi)
                # {'GPU': 1}
            except:
                pass
            try:        
                print("*** ack2copyinfo4xi: " , ack2copyinfo4xi)
                #
            except:
                pass
            try:    
                print("*** message2copyget4xi: " , message2copyget4xi)
                #
            except:
                pass
            try:        
                print("*** message2copyput4xi: " , message2copyput4xi)
                #
            except:
                pass
            try:        
                print("*** message2copyreceive4xi: " , message2copyreceive4xi)
                #
            except:
                pass
            try:        
                print("*** message2copysend4xi: " , message2copysend4xi)
                #
            except:
                pass
            try:        
                print("*** max2copystate4xi: " , max2copystate4xi)
                #
            except:    
                pass
    
    # ==============================================================================================================
    # STATE I
    # ==============================================================================================================        
    if debug is True:
        print("(Step I/33) of manoeuvre2copyimage4xi: CONSIDERING STATE I: " , state2copy4xi)
        # 
        
           
    for key2copymanoeuvre in keys2copymanoeuvre:                     
        # ------------------------------------------------------------------------------------------------------------------------
        # STATE I - RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND COPY OR NEGATIVE BACK 
        # ------------------------------------------------------------------------------------------------------------------------
        try:
            if state2copy4xi [key2copymanoeuvre]  == 1:
                if debug is True:
                    print("(Step 1/33) of manoeuvre2copyimage4xi: ", key2copymanoeuvre, " - STATE I - TRY TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
                    
                message2print = "{(Step 1A/70) try" + "; receive-try-by-manoeuvre2copyimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                message2copyreceive4xi [key2copymanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message2copyreceive4xi [key2copymanoeuvre]  = consumerchannel2copymanoeuvre4xi [key2copymanoeuvre].recv()
                    message2print = "{(Step 1B/33) received" + "; message2copyreceive4xi-received-by-manoeuvre2copyimage4xi: " + str(message2copyreceive4xi [key2copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #
                    
                    if debug is True:
                        print("(Step 1B/33) of manoeuvre2copyimage4xi: ", key2copymanoeuvre, " - STATE I - RECEIVED MESSAGE VIA PIPE: " , message2copyreceive4xi [key2copymanoeuvre])
                        # GPU  - STATE I - RECEIVED MESSAGE VIA PIPE:  <copy4xi>copy2copy4xi</copy4xi>
                         
                    if message2copyreceive4xi [key2copymanoeuvre]  == '<copy4xi>copy2copy4xi</copy4xi>':
                        message2copysend4xi [key2copymanoeuvre]  = '<copy4xi>copy2copy4xi</copy4xi>'
                    else:
                        message2copysend4xi [key2copymanoeuvre]  = '<negative4xi>negative2copy4xi</<negative4xi>'
                        
                        
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel2copymanoeuvre4xi [key2copymanoeuvre].send(message2copysend4xi [key2copymanoeuvre])
                    
                    message2print = "{(Step 1C/33) sent" + "; message2copysend4xi-sent-by-manoeuvre2copyimage4xi: " + str(message2copysend4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    # 
                    if debug is True:
                        print("(Step 1C/33) of manoeuvre2copyimage4xi: ", key2copymanoeuvre, " - STATE I - SENT MESSAGE VIA PIPE: " , message2copysend4xi [key2copymanoeuvre])
                        # 
                        
                    
                    code2ack  = code2ack + '1C-'
                except:
                    message2print = "{(Step 1Z/33) failed" + "; message2copyreceive4xi-failed-by-manoeuvre2copyimage4xi: " + str(message2copyreceive4xi [key2copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '1Z-' 
                    
                    print("(Step 1Z1/33) of manoeuvre2copyimage4xi: ", key2copymanoeuvre, " - STATE I *** FAILED TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
            else:
                pass
        except:
            print("(Step 1Z2/33) of manoeuvre2copyimage4xi: ", key2copymanoeuvre, " - STATE I *** FAILED *** " , time4xi())

    # ==============================================================================================================
    # STATE II
    # ==============================================================================================================        
    if debug is True:
        print("(Step II/33) of manoeuvre2copyimage4xi: CONSIDERING STATE II : " , state2copy4xi)
        #
        
                  
    for key2copymanoeuvre in keys2copymanoeuvre:        
        try:
            if state2copy4xi [key2copymanoeuvre]  == 2:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE II - RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK 
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                    print("(Step 1/33) of manoeuvre2copyimage4xi - STATE II - ", key2copymanoeuvre, " TRYING TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #
                                 
                message2print = "{(Step 2A/70) try" + "; receive-try-by-manoeuvre2copyimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                message2copyreceive4xi [key2copymanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message2copyreceive4xi [key2copymanoeuvre]  = consumerchannel2copymanoeuvre4xi [key2copymanoeuvre].recv()
                    
                    message2print = "{(Step 2B/33) received" + "; message2copyreceive4xi-received-by-manoeuvre2copyimage4xi: " + str(message2copyreceive4xi [key2copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # 
                    if debug is True:
                        print("(Step 2B/33) of manoeuvre2copyimage4xi - STATE II - FROM ", key2copymanoeuvre, " RECEIVED " , message2copyreceive4xi [key2copymanoeuvre] )
                        # FROM  GPU  RECEIVED  <ready4xi>ready2copy4xi</ready4xi>  
           
                    if message2copyreceive4xi [key2copymanoeuvre]  == '<ready4xi>ready2copy4xi</ready4xi>':
                        message2copysend4xi [key2copymanoeuvre]  = '<ready4xi>ready2copy4xi</ready4xi>'
                    else:
                        message2copysend4xi [key2copymanoeuvre]  = '<negative4xi>negative2copy4xi</<negative4xi>'
                    
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel2copymanoeuvre4xi [key2copymanoeuvre].send(message2copysend4xi [key2copymanoeuvre])
                    
                    message2print = "{(Step 2C/33) sent" + "; message2copysend4xi-sent-by-manoeuvre2copyimage4xi: " + str(message2copysend4xi [key2copymanoeuvre])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    # 
                    if debug is True:
                        print("(Step 2C/33) of manoeuvre2copyimage4xi - STATE II - TO ", key2copymanoeuvre, " SENT " , message2copyreceive4xi [key2copymanoeuvre] )
                        #                       
                    
                    code2ack  = code2ack + '2C-'
                except:
                    message2print = "{(Step 2Z/33) failed" + "; message2copyreceive4xi-failed-by-manoeuvre2copyimage4xi: " + str(message2copyreceive4xi [key2copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '2Z-'
                    print("(Step 1/33) of manoeuvre2copyimage4xi - STATE II - ", key2copymanoeuvre, " *** FAILED TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #  
            else:
                pass        
        except:
            print("(Step 1/33) of manoeuvre2copyimage4xi - STATE II - ", key2copymanoeuvre, " *** FAILED *** " , time4xi())
        

    # ==============================================================================================================
    # STATE III
    # ==============================================================================================================        
    if debug is True:
        print("(Step III/33) of manoeuvre2copyimage4xi: CONSIDERING STATE III : " , state2copy4xi)
        # 
            
    for key2copymanoeuvre in keys2copymanoeuvre:
        try:   
            if state2copy4xi [key2copymanoeuvre]  == 3:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE III - GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                        print("(Step 3A/33) of manoeuvre2copyimage4xi - STATE III - ", key2copymanoeuvre, " GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE " , time4xi())
                        #     
                info2image4xi [key2copymanoeuvre]  = None
                message2print = "{(Step 3A/70) try" + "; info2image4xi-try-by-manoeuvre2copyimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                try: 
                    # ----------------------------------------------------------------------------------------------------------------
                    # GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE
                    # ----------------------------------------------------------------------------------------------------------------        
                    info2image4xi [key2copymanoeuvre]  = queue2copymanoeuvre4xi [key2copymanoeuvre].get()
                    
                    message2print = "{(Step 3B/33) got" + "; info2image4xi-got-by-manoeuvre2copyimage4xi: " + str(info2image4xi [key2copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # 
                    if debug is True:
                        print("(Step 3B/33) of manoeuvre2copyimage4xi - STATE III - ", key2copymanoeuvre, " GOT INFO2IMAGE4XI: " , info2image4xi [key2copymanoeuvre])
                        #  
                    
                    if info2image4xi [key2copymanoeuvre]  is None:
                        code2nack  = code2nack + '3Z1-'
                        ack2copyinfo4xi [key2copymanoeuvre]  = False 
                    else:    
                        code2ack  = code2ack + '3C-'
                        ack2copyinfo4xi [key2copymanoeuvre]  = True
                except:
                    message2print = "{(Step 3Z1/33) failed" + "; queue2copymanoeuvre4xi-failed-by-manoeuvre2copyimage4xi: " + str(queue2copymanoeuvre4xi [key2copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '3Z1-'
                    
                message2copysend4xi [key2copymanoeuvre]  = ' '
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND CONTROL INFO ABOUT IMAGE OPERATION - EITHER ACK OR NACK  
                    # ----------------------------------------------------------------------------------------------------------------         
                    if ack2copyinfo4xi [key2copymanoeuvre]  is True:
                        message2copysend4xi [key2copymanoeuvre]  = '<ack4xi>ack2imageinfo4xi</ack4xi>'
                    else:
                        message2copysend4xi [key2copymanoeuvre]  = '<nack4xi>nack2imageinfo4xi</nack4xi>'
                    message2print = "{(Step 4B/33) set" + "; message2copysend4xi-set-by-manoeuvre2copyimage4xi to: " + str(message2copysend4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #       
                except:
                    message2print = "{(Step 4Z1/33) failed" + "; message2copysend4xi-failed-by-manoeuvre2copyimage4xi: " + str(message2copysend4xi [key2copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    
                    code2nack  = code2nack + '4Z1-'    
                try:                
                    message2print = "{(Step 4C/70) using" + "; publisherchannel2copymanoeuvre4xi-calling-by-manoeuvre2copyimage4xi: " + str(publisherchannel2copymanoeuvre4xi [key2copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    # 
                    message2print = "{{(Step 4D/70) passing" + "; message2copysend4xi-passing-to-send-by-manoeuvre2copyimage4xi: " + str(message2copysend4xi [key2copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    #              
                except:
                    message2print = "{(Step 4Z1/33) failed" + "; message2copysend4xi-failed-by-manoeuvre2copyimage4xi: " + str(message2copysend4xi [key2copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '4Z2-'                
                try:    
                    publisherchannel2copymanoeuvre4xi [key2copymanoeuvre].send(message2copysend4xi [key2copymanoeuvre] )
                    
                    message2print = "{(Step 4E/33) sent" + "; message2copysend4xi-sent-by-manoeuvre2copyimage4xi: " + str(message2copysend4xi [key2copymanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    #            
                    code2ack  = code2ack + '4E-'
                    
                    if debug is True:
                        print("(Step 4EB/33) of manoeuvre2copyimage4xi - STATE III - ", key2copymanoeuvre, " SENT MESSAGE: " , message2copysend4xi [key2copymanoeuvre])
                        #    
                except:
                    message2print = "{(Step 4Z3/33) failed" + "; message2copysend4xi-failed-by-manoeuvre2copyimage4xi: " + str(message2copysend4xi [key2copymanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '4Z3-'                
            else:
                pass
        except:
            print("(Step 1/33) of manoeuvre2copyimage4xi - STATE III - ", key2copymanoeuvre, " *** FAILED *** " , time4xi())
            
    # ==============================================================================================================
    # PREPARE RETURN - DICTIONARY LEVEL
    # ==============================================================================================================        
    if debug is True:
        try:
            print("(Step 5A/33) of manoeuvre2copyimage4xi - TRYING TO DEBUG PREPARING OF RETURN AT STATE: " , state2copy4xi)
            # 
            
            print("(Step 5B/33) of manoeuvre2copyimage4xi - response2manouvre4copy: " , response2manouvre4copy)
            # 
            
            print("(Step 5C/33) of manoeuvre2copyimage4xi - ack2copyinfo4xi: " , ack2copyinfo4xi)
            # 
            
            print("(Step 5D/33) of manoeuvre2copyimage4xi - message2copyget4xi: ", message2copyget4xi)
            # 
            
            print("(Step 5E/33) of manoeuvre2copyimage4xi - message2copyput4xi: " , message2copyput4xi)
            # 
            
            print("(Step 5F/33) of manoeuvre2copyimage4xi - message2copyreceive4xi: " , message2copyreceive4xi)
            # 
            
            print("(Step 5G/33) of manoeuvre2copyimage4xi - message2copysend4xi: " , message2copysend4xi)
            # 
            
            
        except:
            print("(Step 5Z1/33) of manoeuvre2copyimage4xi *** FAILED TO PREPARE RETURN WITH STATE: " , state2copy4xi)
    
    print("(Step 5B/33) of manoeuvre2copyimage4xi - TRYING TO PREPARING OF RETURN AT STATE: " , state2copy4xi)    
    try:        
        response2manouvre4copy ['ACK2INFO4XI']        = ack2copyinfo4xi 
        response2manouvre4copy ['MESSAGE2GET4XI']     = message2copyget4xi
        response2manouvre4copy ['MESSAGE2PUT4XI']     = message2copyput4xi
        response2manouvre4copy ['MESSAGE2RECEIVE4XI'] = message2copyreceive4xi
        response2manouvre4copy ['MESSAGE2SEND4XI']    = message2copysend4xi
        response2manouvre4copy ['STATE2MANOEUVRE4XI'] = state2copy4xi
    except:
        print("(Step 5Z2/33) of manoeuvre2copyimage4xi *** FAILED IN PREPARING RETURN KEY2READMANOEUVRE AT STATE: " , state2copy4xi)   
                             
    message2print = "{(Step 33/33) returning" + "; response2manouvre4copy-returning-by-manoeuvre2copyimage4xi: " + str(response2manouvre4copy) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             


    if debug is True:
        print("(Step 33/33) of manoeuvre2copyimage4xi - RETURNING  WITH STATE: " , state2copy4xi, " RESPONSE2MANOUVRE4READ " , response2manouvre4copy)
        #1 
        # 
 
        #2
        #
 
        #3 
        # 

        #4
        #
        

    return response2manouvre4copy           
          
#</function4xi>

# -----------------------------------------------------------------------------------------------------------------------
#<function4xi function = "manoeuvre2copyimagetobuffer4xi" usage = "
#   # -------------------------------------------------------------------------------------------------------------------------------------
#   # PHASE I: COPY2IMAGETOBUFFER FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4XI  - LET IT TO RECEIVE COPY AND TO SEND ROGER VIA PIPE                
#   # -------------------------------------------------------------------------------------------------------------------------------------       
#   if ack2simulate4xi is True:
#       print("(Step 62A/700) OF IMAGE2D4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4XI ", time4xi())   
#       try: 
#           response2manoeuvre4copy = manoeuvre2copyimagetobuffer4xi(queue4copyimagetobuffer, channel4copyimagetobuffer2consume, channel4copyimagetobuffer2publish)
#           print("(Step 62B/700) OF IMAGE2D4XI5TEST - PERFORMED MANOEUVRE2COPYIMAGE4XI, RESPONSE2MANOEUVRE4COPY: ", response2manoeuvre4copy)
#           # 
#       except:
#           print("(Step 62Z/700) OF IMAGE2D4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4XI ", time4xi())     
#   else:
#       pass # trust activated thread    
#">

# ----------------------------------------------------------------------------------------------------------------------- 
def manoeuvre2copyimagetobuffer4xi(queue2copyimagetobuffermanoeuvre4xi, consumerchannel2copyimagetobuffermanoeuvre4xi, publisherchannel2copyimagetobuffermanoeuvre4xi):
    '''
    manoeuvres copyimagetobuffer control and command
    '''
    # 
        
    # ---------------------------------------------------------------------------------------------
    # GLOBAL DICTIONARIES TO HANDLE PROCESSING UNITS
    # ---------------------------------------------------------------------------------------------
    global state2copyimagetobuffer4xi                                                                                           
    global max2copyimagetobufferstate4xi                                                                                        
    global ack2copyimagetobufferinfo4xi                                                                                         
    global message2copyimagetobufferget4xi                                 
    global message2copyimagetobufferput4xi
    global message2copyimagetobufferreceive4xi
    global message2copyimagetobuffersend4xi
    
    global mission2copyimagetobuffer                                                          
    
    global image2d4xi  
    global info2image4xi  
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    debug = True
    try:
        if debug is True:
            print("(Step 0D1/33) of manoeuvre2copyimagetobuffer4xi - STARTED " , time4xi())
            # 
            print("(Step 0D2/33) of manoeuvre2copyimagetobuffer4xi - PASSED QUEUE2READMANOEUVRE4XI: " , queue2copyimagetobuffermanoeuvre4xi)
            # 
    
            print("(Step 0D3/33) of manoeuvre2copyimagetobuffer4xi - PASSED CONSUMERCHANNEL2READMANOEUVRE4XI: " , consumerchannel2copyimagetobuffermanoeuvre4xi)
            # 
           
            print("(Step 0D4/33) of manoeuvre2copyimagetobuffer4xi - PASSED PUBLISHERCHANNEL2READMANOEUVRE4XI: " , publisherchannel2copyimagetobuffermanoeuvre4xi) 
            # 
    
            print("(Step 0D5/33) of manoeuvre2copyimagetobuffer4xi - USING STATE2READ4XI: " , state2copyimagetobuffer4xi) 
            #
            
            
        keys2copyimagetobuffermanoeuvre = queue2copyimagetobuffermanoeuvre4xi.keys()
        if debug is True:
            print("{(Step 0/33) of manoeuvre2copyimagetobuffer4xi - SET KEYS2READMANOEUVRE TO: ", keys2copyimagetobuffermanoeuvre) 
            #
            
                  
        response2manouvre4copyimagetobuffer = {}
    except:
        print("(Step 0Z1/33) of manoeuvre2copyimagetobuffer4xi *** FAILED IN START ***  " , time4xi())
    
    # -----------------------------------------------------------------------------------------
    # (Step 0/33) PARAMETERS ARE DICTIONARIES FOR XI            
    # -----------------------------------------------------------------------------------------          
    try:
        class2print  = "manoeuvre2copyimagetobuffer4xi" 
        method2print = "manoeuvre2copyimagetobuffer4xi" 
    
        code2ack  = ' '
        code2nack = ' '
        
        message2print = "{(Step 0A/33) started" + "; manoeuvre2copyimagetobuffer4xi-started: " + str(manoeuvre2copyimagetobuffer4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                                     #  
        # 
        
        message2print = "{(Step 0B/33) passed" + "; queue2copyimagetobuffermanoeuvre4xi-to-manoeuvre2copyimagetobuffer4xi: " + str(queue2copyimagetobuffermanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        # 
        
        message2print = "{(Step 0C/33) passed" + "; consumerchannel2copyimagetobuffermanoeuvre4xi-to-manoeuvre2copyimagetobuffer4xi: " + str(consumerchannel2copyimagetobuffermanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        # 
        
        message2print = "{(Step 0D/33) passed" + "; publisherchannel2copyimagetobuffermanoeuvre4xi-to-manoeuvre2copyimagetobuffer4xi: " + str(publisherchannel2copyimagetobuffermanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        #   
        
        code2ack  = code2ack + '0D-' 
    except:
        print("(Step 0Z2/33) of manoeuvre2copyimagetobuffer4xi *** FAILED IN START ***  " , time4xi())
        
    # ==============================================================================================================
    # MISSION
    # ==============================================================================================================        
    if debug is True:
        print("{(Step M0/33) of manoeuvre2copyimagetobuffer4xi - CHECKING MISSION AT STATE2READ4XI: " , state2copyimagetobuffer4xi) 
        #
        
         
    try:
        if mission2copyimagetobuffer == "NACK":
            mission2copyimagetobuffer = "ACK"
            print("(Step M1/33) of manoeuvre2copyimagetobuffer4xi - SET MISSION2READ TO :  " , mission2copyimagetobuffer)       
        else:
            mission2copyimagetobuffer = "ACK"
            print("(Step M2/33) of manoeuvre2copyimagetobuffer4xi - USING MISSION2READ:  " , mission2copyimagetobuffer)
            # 
        if state2copyimagetobuffer4xi == {}:    
            for key2copyimagetobuffermanoeuvre in keys2copyimagetobuffermanoeuvre:
                #----------------------------------------------------------------------------------------------------------------------
                # STATE 0
                # ---------------------------------------------------------------------------------------------------------------------     
                state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre]   = 0
                message2print = "{(Step 0Z1/33) initialized" + "; state2copyimagetobuffer4xi-initialized-by-manoeuvre2copyimagetobuffer4xi to: " + str(state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                                    
                ack2copyimagetobufferinfo4xi [key2copyimagetobuffermanoeuvre] = False
                message2print = "{(Step 0Z2/33) initialized" + "; ack2copyimagetobufferinfo4xi-initialized-by-manoeuvre2copyimagetobuffer4xi to: " + str(ack2copyimagetobufferinfo4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                    
                message2copyimagetobufferget4xi [key2copyimagetobuffermanoeuvre] = '<default4xi>default2copyimagetobuffer4xi</default4xi>'
                message2print = "{(Step 0Z3/33) initialized" + "; message2copyimagetobufferget4xi-initialized-by-manoeuvre2copyimagetobuffer4xi to: " + str(message2copyimagetobufferget4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                    
                message2copyimagetobufferput4xi [key2copyimagetobuffermanoeuvre]  = '<default4xi>default2copyimagetobuffer4xi</default4xi>'
                message2print = "{(Step 0Z4/33) initialized" + "; message2copyimagetobufferput4xi-initialized-by-manoeuvre2copyimagetobuffer4xi to: " + str(message2copyimagetobufferput4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre]  = '<default4xi>default2copyimagetobuffer4xi</default4xi>'
                message2print = "{(Step 0Z5/33) initialized" + "; message2copyimagetobufferreceive4xi-initialized-by-manoeuvre2copyimagetobuffer4xi to: " + str(message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre] = '<default4xi>default2copyimagetobuffer4xi</default4xi>'
                message2print = "{(Step 0Z6/33) initialized" + "; message2copyimagetobuffersend4xi-initialized-by-manoeuvre2copyimagetobuffer4xi to: " + str(message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                max2copyimagetobufferstate4xi [key2copyimagetobuffermanoeuvre] = 3
                message2print = "{(Step 0Z7/33) initialized" + ";  max2copyimagetobufferstate4xi-initialized-by-manoeuvre2copyimagetobuffer4xi to: " + str( max2copyimagetobufferstate4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #    
        else:
            pass                             
    except:
        if debug is True:
            print("{(Step 0Z0/33) of manoeuvre2copyimagetobuffer4xi  EXCEPTION: ", time4xi()) 
            mission2copyimagetobuffer = "ACK" 
            print("(Step M3/33) of manoeuvre2copyimagetobuffer4xi  EXCEPTIONAL MISSION2COPYIMAGETOBUFFER:  " , mission2copyimagetobuffer) 
            # 
        if state2copyimagetobuffer4xi == {}:                 
            for key2copyimagetobuffermanoeuvre in keys2copyimagetobuffermanoeuvre:
                # ------------------------------------------------------------------------------------------------------------------------
                # EXCEPTIONAL STATE 0
                # ------------------------------------------------------------------------------------------------------------------------     
                state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre]   = 0
                message2print = "{(Step 0Z1/33) initialized" + "; state2copyimagetobuffer4xi-initialized-by-manoeuvre2copyimagetobuffer4xi to: " + str(state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                    
                ack2copyimagetobufferinfo4xi [key2copyimagetobuffermanoeuvre] = False
                message2print = "{(Step 0Z2/33) initialized" + "; ack2copyimagetobufferinfo4xi-initialized-by-manoeuvre2copyimagetobuffer4xi to: " + str(ack2copyimagetobufferinfo4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                    
                message2copyimagetobufferget4xi [key2copyimagetobuffermanoeuvre] = '<default4xi>default2copyimagetobuffer4xi</default4xi>'
                message2print = "{(Step 0Z3/33) initialized" + "; message2copyimagetobufferget4xi-initialized-by-manoeuvre2copyimagetobuffer4xi to: " + str(message2copyimagetobufferget4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                    
                message2copyimagetobufferput4xi [key2copyimagetobuffermanoeuvre]  = '<default4xi>default2copyimagetobuffer4xi</default4xi>'
                message2print = "{(Step 0Z4/33) initialized" + "; message2copyimagetobufferput4xi-initialized-by-manoeuvre2copyimagetobuffer4xi to: " + str(message2copyimagetobufferput4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre]  = '<default4xi>default2copyimagetobuffer4xi</default4xi>'
                message2print = "{(Step 0Z5/33) initialized" + "; message2copyimagetobufferreceive4xi-initialized-by-manoeuvre2copyimagetobuffer4xi to: " + str(message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre] = '<default4xi>default2copyimagetobuffer4xi</default4xi>'
                message2print = "{(Step 0Z6/33) initialized" + "; message2copyimagetobuffersend4xi-initialized-by-manoeuvre2copyimagetobuffer4xi to: " + str(message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                max2copyimagetobufferstate4xi [key2copyimagetobuffermanoeuvre] = 3
                message2print = "{(Step 0Z7/33) initialized" + ";  max2copyimagetobufferstate4xi-initialized-by-manoeuvre2copyimagetobuffer4xi to: " + str( max2copyimagetobufferstate4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #
       
    # ==============================================================================================================
    # NEXT PHASE PREPARING 
    # ==============================================================================================================                                             
    if debug is True:
        print("{(Step M0/33) of manoeuvre2copyimagetobuffer4xi - NEXT PHASE PREPARING AT STATE2READ4XI: " , state2copyimagetobuffer4xi) 
        # 
          
    for key2copyimagetobuffermanoeuvre in keys2copyimagetobuffermanoeuvre:
        try:
            # ------------------------------------------------------------------------------------------------------------------------
            # UPDATE 
            # ------------------------------------------------------------------------------------------------------------------------      
            state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre]  = state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre]  + 1                                                                   
            message2print = "{(Step 0H/33) added" + "; state2copyimagetobuffer4xi-added-by-manoeuvre2copyimagetobuffer4xi: " + str(state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            if debug is True:
                print("(Step 0h/33) of manoeuvre2copyimagetobuffer4xi TO: ", key2copyimagetobuffermanoeuvre, " STATE2READ4XI-ADDED TO: " , state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre]) 
                #
                
                 
            if state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre] > max2copyimagetobufferstate4xi [key2copyimagetobuffermanoeuvre]:
                state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre]  = 0
                message2print = "{(Step 0I/33) set" + "; state2copyimagetobuffer4xi-set-by-manoeuvre2copyimagetobuffer4xi to: " + str(state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                
                if debug is True:
                    print("(Step 0I/33) of manoeuvre2copyimagetobuffer4xi TO: ", key2copyimagetobuffermanoeuvre, " STATE2READ4XI-ZEROED TO: " , state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre]) 
                    # 
                    
                ack2copyimagetobufferinfo4xi [key2copyimagetobuffermanoeuvre] = False
                message2print = "{(Step 0J/33) set" + "; ack2copyimagetobufferinfo4xi-set-by-manoeuvre2copyimagetobuffer4xi to: " + str(ack2copyimagetobufferinfo4xi [key2copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                
                message2copyimagetobufferget4xi [key2copyimagetobuffermanoeuvre] = '<default4xi>default2copyimagetobuffer4xi</default4xi>'
                message2print = "{(Step 0K/33) set" + "; message2copyimagetobufferget4xi-set-by-manoeuvre2copyimagetobuffer4xi to: " + str(message2copyimagetobufferget4xi [key2copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                
                message2copyimagetobufferput4xi [key2copyimagetobuffermanoeuvre]  = '<default4xi>default2copyimagetobuffer4xi</default4xi>'
                message2print = "{(Step 0L/33) set" + "; message2copyimagetobufferput4xi-set-by-manoeuvre2copyimagetobuffer4xi to: " + str(message2copyimagetobufferput4xi [key2copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                
                message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre] = '<default4xi>default2copyimagetobuffer4xi</default4xi>'
                message2print = "{(Step 0M/33) set" + "; message2copyimagetobufferreceive4xi-set-by-manoeuvre2copyimagetobuffer4xi to: " + str(message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                
                message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre]    = '<default4xi>default2copyimagetobuffer4xi</default4xi>'
                message2print = "{(Step 0N/33) set" + "; message2copyimagetobuffersend4xi-set-by-manoeuvre2copyimagetobuffer4xi to: " + str(message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                
                max2copyimagetobufferstate4xi [key2copyimagetobuffermanoeuvre] = 3
                message2print = "{(Step 0O/33) initialized" + ";  max2copyimagetobufferstate4xi-set-by-manoeuvre2copyimagetobuffer4xi to: " + str( max2copyimagetobufferstate4xi [key2copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #
            else:
                pass
            if debug is True:
                print("(Step 1A/33) of manoeuvre2copyimagetobuffer4xi FOR : ", key2copyimagetobuffermanoeuvre, " CONTINUING WITH STATE2READ4XI: " , state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre])
                # 
                        
        except:
            print("(Step 0z1/33) of manoeuvre2copyimagetobuffer4xi *** FAILED UPDATING *** " , time4xi())
            print("key2copyimagetobuffermanoeuvre: " , key2copyimagetobuffermanoeuvre)
            # 
            print("state2copyimagetobuffer4xi: " , state2copyimagetobuffer4xi)
            #
            print("ack2copyimagetobufferinfo4xi: " , ack2copyimagetobufferinfo4xi)
            #
            print("message2copyimagetobufferget4xi: " , message2copyimagetobufferget4xi)
            #
            print("message2copyimagetobufferput4xi: " , message2copyimagetobufferput4xi)
            #
            print("message2copyimagetobufferreceive4xi: " , message2copyimagetobufferreceive4xi)
            #
            print("message2copyimagetobuffersend4xi: " , message2copyimagetobuffersend4xi)
            #
            print("max2copyimagetobufferstate4xi: " , max2copyimagetobufferstate4xi)
            #
               
    
    # ==============================================================================================================
    # STATE I
    # ==============================================================================================================        
    if debug is True:
        print("(Step I/33) of manoeuvre2copyimagetobuffer4xi: CONSIDERING STATE I: " , state2copyimagetobuffer4xi)
        # 
        
           
    for key2copyimagetobuffermanoeuvre in keys2copyimagetobuffermanoeuvre:                     
        # ------------------------------------------------------------------------------------------------------------------------
        # STATE I - RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND COPY OR NEGATIVE BACK 
        # ------------------------------------------------------------------------------------------------------------------------
        try:
            if state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre]  == 1:
                if debug is True:
                    print("(Step 1/33) of manoeuvre2copyimagetobuffer4xi: ", key2copyimagetobuffermanoeuvre, " - STATE I - TRY TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
                    
                message2print = "{(Step 1A/70) try" + "; receive-try-by-manoeuvre2copyimagetobuffer4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre]  = consumerchannel2copyimagetobuffermanoeuvre4xi [key2copyimagetobuffermanoeuvre].recv()
                    message2print = "{(Step 1B/33) received" + "; message2copyimagetobufferreceive4xi-received-by-manoeuvre2copyimagetobuffer4xi: " + str(message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #
                    
                    if debug is True:
                        print("(Step 1B/33) of manoeuvre2copyimagetobuffer4xi: ", key2copyimagetobuffermanoeuvre, " - STATE I - RECEIVED MESSAGE VIA PIPE: " , message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre])
                        # GPU  - STATE I - RECEIVED MESSAGE VIA PIPE:  <copy4xi>copy2copyimagetobuffer4xi</copy4xi>
                         
                    if message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre]  == '<copy4xi>copy2copyimagetobuffer4xi</copy4xi>':
                        message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre]  = '<copy4xi>copy2copyimagetobuffer4xi</copy4xi>'
                    else:
                        message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre]  = '<negative4xi>negative2copyimagetobuffer4xi</<negative4xi>'
                        
                        
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel2copyimagetobuffermanoeuvre4xi [key2copyimagetobuffermanoeuvre].send(message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre])
                    
                    message2print = "{(Step 1C/33) sent" + "; message2copyimagetobuffersend4xi-sent-by-manoeuvre2copyimagetobuffer4xi: " + str(message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    # 
                    if debug is True:
                        print("(Step 1C/33) of manoeuvre2copyimagetobuffer4xi: ", key2copyimagetobuffermanoeuvre, " - STATE I - SENT MESSAGE VIA PIPE: " , message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre])
                        # 
                        
                    
                    code2ack  = code2ack + '1C-'
                except:
                    message2print = "{(Step 1Z/33) failed" + "; message2copyimagetobufferreceive4xi-failed-by-manoeuvre2copyimagetobuffer4xi: " + str(message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '1Z-' 
                    
                    print("(Step 1Z1/33) of manoeuvre2copyimagetobuffer4xi: ", key2copyimagetobuffermanoeuvre, " - STATE I *** FAILED TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
            else:
                pass
        except:
            print("(Step 1Z2/33) of manoeuvre2copyimagetobuffer4xi: ", key2copyimagetobuffermanoeuvre, " - STATE I *** FAILED *** " , time4xi())

    # ==============================================================================================================
    # STATE II
    # ==============================================================================================================        
    if debug is True:
        print("(Step II/33) of manoeuvre2copyimagetobuffer4xi: CONSIDERING STATE II : " , state2copyimagetobuffer4xi)
        #
        
                  
    for key2copyimagetobuffermanoeuvre in keys2copyimagetobuffermanoeuvre:        
        try:
            if state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre]  == 2:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE II - RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK 
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                    print("(Step 1/33) of manoeuvre2copyimagetobuffer4xi - STATE II - ", key2copyimagetobuffermanoeuvre, " TRYING TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #
                                 
                message2print = "{(Step 2A/70) try" + "; receive-try-by-manoeuvre2copyimagetobuffer4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre]  = consumerchannel2copyimagetobuffermanoeuvre4xi [key2copyimagetobuffermanoeuvre].recv()
                    
                    message2print = "{(Step 2B/33) received" + "; message2copyimagetobufferreceive4xi-received-by-manoeuvre2copyimagetobuffer4xi: " + str(message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # 
                    if debug is True:
                        print("(Step 2B/33) of manoeuvre2copyimagetobuffer4xi - STATE II - FROM ", key2copyimagetobuffermanoeuvre, " RECEIVED " , message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre] )
                        # FROM  GPU  RECEIVED  <ready4xi>ready2copyimagetobuffer4xi</ready4xi>  
           
                    if message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre]  == '<ready4xi>ready2copyimagetobuffer4xi</ready4xi>':
                        message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre]  = '<ready4xi>ready2copyimagetobuffer4xi</ready4xi>'
                    else:
                        message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre]  = '<negative4xi>negative2copyimagetobuffery4xi</<negative4xi>'
                    
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel2copyimagetobuffermanoeuvre4xi [key2copyimagetobuffermanoeuvre].send(message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre])
                    
                    message2print = "{(Step 2C/33) sent" + "; message2copyimagetobuffersend4xi-sent-by-manoeuvre2copyimagetobuffer4xi: " + str(message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    # 
                    if debug is True:
                        print("(Step 2C/33) of manoeuvre2copyimagetobuffer4xi - STATE II - TO ", key2copyimagetobuffermanoeuvre, " SENT " , message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre] )
                        #                       
                    
                    code2ack  = code2ack + '2C-'
                except:
                    message2print = "{(Step 2Z/33) failed" + "; message2copyimagetobufferreceive4xi-failed-by-manoeuvre2copyimagetobuffer4xi: " + str(message2copyimagetobufferreceive4xi [key2copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '2Z-'
                    print("(Step 1/33) of manoeuvre2copyimagetobuffer4xi - STATE II - ", key2copyimagetobuffermanoeuvre, " *** FAILED TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #  
            else:
                pass        
        except:
            print("(Step 1/33) of manoeuvre2copyimagetobuffer4xi - STATE II - ", key2copyimagetobuffermanoeuvre, " *** FAILED *** " , time4xi())
        

    # ==============================================================================================================
    # STATE III
    # ==============================================================================================================        
    if debug is True:
        print("(Step III/33) of manoeuvre2copyimagetobuffer4xi: CONSIDERING STATE III : " , state2copyimagetobuffer4xi)
        # 
            
    for key2copyimagetobuffermanoeuvre in keys2copyimagetobuffermanoeuvre:
        try:   
            if state2copyimagetobuffer4xi [key2copyimagetobuffermanoeuvre]  == 3:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE III - GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                        print("(Step 3A/33) of manoeuvre2copyimagetobuffer4xi - STATE III - ", key2copyimagetobuffermanoeuvre, " GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE " , time4xi())
                        #     
                info2image4xi [key2copyimagetobuffermanoeuvre]  = None
                message2print = "{(Step 3A/70) try" + "; info2image4xi-try-by-manoeuvre2copyimagetobuffer4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                try: 
                    # ----------------------------------------------------------------------------------------------------------------
                    # GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE
                    # ----------------------------------------------------------------------------------------------------------------        
                    info2image4xi [key2copyimagetobuffermanoeuvre]  = queue2copyimagetobuffermanoeuvre4xi [key2copyimagetobuffermanoeuvre].get()
                    
                    message2print = "{(Step 3B/33) got" + "; info2image4xi-got-by-manoeuvre2copyimagetobuffer4xi: " + str(info2image4xi [key2copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # 
                    if debug is True:
                        print("(Step 3B/33) of manoeuvre2copyimagetobuffer4xi - STATE III - ", key2copyimagetobuffermanoeuvre, " GOT INFO2IMAGE4XI: " , info2image4xi [key2copyimagetobuffermanoeuvre])
                        #  
                    
                    if info2image4xi [key2copyimagetobuffermanoeuvre]  is None:
                        code2nack  = code2nack + '3Z1-'
                        ack2copyimagetobufferinfo4xi [key2copyimagetobuffermanoeuvre]  = False 
                    else:    
                        code2ack  = code2ack + '3C-'
                        ack2copyimagetobufferinfo4xi [key2copyimagetobuffermanoeuvre]  = True
                except:
                    message2print = "{(Step 3Z1/33) failed" + "; queue2copyimagetobuffermanoeuvre4xi-failed-by-manoeuvre2copyimagetobuffer4xi: " + str(queue2copyimagetobuffermanoeuvre4xi [key2copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '3Z1-'
                    
                message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre]  = ' '
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND CONTROL INFO ABOUT IMAGE OPERATION - EITHER ACK OR NACK  
                    # ----------------------------------------------------------------------------------------------------------------         
                    if ack2copyimagetobufferinfo4xi [key2copyimagetobuffermanoeuvre]  is True:
                        message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre]  = '<ack4xi>ack2imageinfo4xi</ack4xi>'
                    else:
                        message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre]  = '<nack4xi>nack2imageinfo4xi</nack4xi>'
                    message2print = "{(Step 4B/33) set" + "; message2copyimagetobuffersend4xi-set-by-manoeuvre2copyimagetobuffer4xi to: " + str(message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #       
                except:
                    message2print = "{(Step 4Z1/33) failed" + "; message2copyimagetobuffersend4xi-failed-by-manoeuvre2copyimagetobuffer4xi: " + str(message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    
                    code2nack  = code2nack + '4Z1-'    
                try:                
                    message2print = "{(Step 4C/70) using" + "; publisherchannel2copyimagetobuffermanoeuvre4xi-calling-by-manoeuvre2copyimagetobuffer4xi: " + str(publisherchannel2copyimagetobuffermanoeuvre4xi [key2copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    # 
                    message2print = "{{(Step 4D/70) passing" + "; message2copyimagetobuffersend4xi-passing-to-send-by-manoeuvre2copyimagetobuffer4xi: " + str(message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    #              
                except:
                    message2print = "{(Step 4Z1/33) failed" + "; message2copyimagetobuffersend4xi-failed-by-manoeuvre2copyimagetobuffer4xi: " + str(message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '4Z2-'                
                try:    
                    publisherchannel2copyimagetobuffermanoeuvre4xi [key2copyimagetobuffermanoeuvre].send(message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre] )
                    
                    message2print = "{(Step 4E/33) sent" + "; message2copyimagetobuffersend4xi-sent-by-manoeuvre2copyimagetobuffer4xi: " + str(message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    #            
                    code2ack  = code2ack + '4E-'
                    
                    if debug is True:
                        print("(Step 4EB/33) of manoeuvre2copyimagetobuffer4xi - STATE III - ", key2copyimagetobuffermanoeuvre, " SENT MESSAGE: " , message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre])
                        #    
                except:
                    message2print = "{(Step 4Z3/33) failed" + "; message2copyimagetobuffersend4xi-failed-by-manoeuvre2copyimagetobuffer4xi: " + str(message2copyimagetobuffersend4xi [key2copyimagetobuffermanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '4Z3-'                
            else:
                pass
        except:
            print("(Step 1/33) of manoeuvre2copyimagetobuffer4xi - STATE III - ", key2copyimagetobuffermanoeuvre, " *** FAILED *** " , time4xi())
            
    # ==============================================================================================================
    # PREPARE RETURN - DICTIONARY LEVEL
    # ==============================================================================================================        
    if debug is True:
        try:
            print("(Step 5A/33) of manoeuvre2copyimagetobuffer4xi - TRYING TO DEBUG PREPARING OF RETURN AT STATE: " , state2copyimagetobuffer4xi)
            # 
            
            print("(Step 5B/33) of manoeuvre2copyimagetobuffer4xi - response2manouvre4copyimagetobuffer: " , response2manouvre4copyimagetobuffer)
            # 
            
            print("(Step 5C/33) of manoeuvre2copyimagetobuffer4xi - ack2copyimagetobufferinfo4xi: " , ack2copyimagetobufferinfo4xi)
            # 
            
            print("(Step 5D/33) of manoeuvre2copyimagetobuffer4xi - message2copyimagetobufferget4xi: ", message2copyimagetobufferget4xi)
            # 
            
            print("(Step 5E/33) of manoeuvre2copyimagetobuffer4xi - message2copyimagetobufferput4xi: " , message2copyimagetobufferput4xi)
            # 
            
            print("(Step 5F/33) of manoeuvre2copyimagetobuffer4xi - message2copyimagetobufferreceive4xi: " , message2copyimagetobufferreceive4xi)
            # 
            
            print("(Step 5G/33) of manoeuvre2copyimagetobuffer4xi - message2copyimagetobuffersend4xi: " , message2copyimagetobuffersend4xi)
            # 
            
            
        except:
            print("(Step 5Z1/33) of manoeuvre2copyimagetobuffer4xi *** FAILED TO PREPARE RETURN WITH STATE: " , state2copyimagetobuffer4xi)
    
    print("(Step 5B/33) of manoeuvre2copyimagetobuffer4xi - TRYING TO PREPARING OF RETURN AT STATE: " , state2copyimagetobuffer4xi)    
    try:        
        response2manouvre4copyimagetobuffer ['ACK2INFO4XI']        = ack2copyimagetobufferinfo4xi 
        response2manouvre4copyimagetobuffer ['MESSAGE2GET4XI']     = message2copyimagetobufferget4xi
        response2manouvre4copyimagetobuffer ['MESSAGE2PUT4XI']     = message2copyimagetobufferput4xi
        response2manouvre4copyimagetobuffer ['MESSAGE2RECEIVE4XI'] = message2copyimagetobufferreceive4xi
        response2manouvre4copyimagetobuffer ['MESSAGE2SEND4XI']    = message2copyimagetobuffersend4xi
        response2manouvre4copyimagetobuffer ['STATE2MANOEUVRE4XI'] = state2copyimagetobuffer4xi
    except:
        print("(Step 5Z2/33) of manoeuvre2copyimagetobuffer4xi *** FAILED IN PREPARING RETURN KEY2READMANOEUVRE AT STATE: " , state2copyimagetobuffer4xi)   
                             
    message2print = "{(Step 33/33) returning" + "; response2manouvre4copyimagetobuffer-returning-by-manoeuvre2copyimagetobuffer4xi: " + str(response2manouvre4copyimagetobuffer) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             


    if debug is True:
        print("(Step 33/33) of manoeuvre2copyimagetobuffer4xi - RETURNING  WITH STATE: " , state2copyimagetobuffer4xi, " RESPONSE2MANOUVRE4READ " , response2manouvre4copyimagetobuffer)
        #1 
        # 
 
        #2
        #
 
        #3 
        # 

        #4
        #
        

    return response2manouvre4copyimagetobuffer           
          
#</function4xi>

# -----------------------------------------------------------------------------------------------------------------------
#<function4xi function = "manoeuvre2copybuffertoimage4xi" usage = "
#   # -------------------------------------------------------------------------------------------------------------------------------------
#   # PHASE I: COPY2BUFFERTOIMAGE FUNCTION  TESTS - SIMULATE MANOEUVRE2COPYIMAGE4XI  - LET IT TO RECEIVE COPY AND TO SEND ROGER VIA PIPE                
#   # -------------------------------------------------------------------------------------------------------------------------------------       
#   if ack2simulate4xi is True:
#       print("(Step 82A/700) OF IMAGE2D4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4XI ", time4xi())   
#       try: 
#           response2manoeuvre4copy = manoeuvre2copybuffertoimage4xi(queue4copyimagetobuffer, channel4copybuffertoimage2consume, channel4copybuffertoimage2publish)
#           print("(Step 82B/700) OF IMAGE2D4XI5TEST - PERFORMED MANOEUVRE2COPYIMAGE4XI, RESPONSE2MANOEUVRE4COPY: ", response2manoeuvre4copy)
#           # 
#       except:
#           print("(Step 82Z/700) OF IMAGE2D4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2COPYIMAGE4XI ", time4xi())     
#   else:
#       pass # trust activated thread    
#">

# ----------------------------------------------------------------------------------------------------------------------- 
def manoeuvre2copybuffertoimage4xi(queue2copybuffertoimagemanoeuvre4xi, consumerchannel2copybuffertoimagemanoeuvre4xi, publisherchannel2copybuffertoimagemanoeuvre4xi):
    '''
    manoeuvres copybuffertoimage control and command
    '''
    # 
        
    # ---------------------------------------------------------------------------------------------
    # GLOBAL DICTIONARIES TO HANDLE PROCESSING UNITS
    # ---------------------------------------------------------------------------------------------
    global state2copybuffertoimage4xi                                                                                           
    global max2copybuffertoimagestate4xi                                                                                        
    global ack2copybuffertoimageinfo4xi                                                                                         
    global message2copybuffertoimageget4xi                                 
    global message2copybuffertoimageput4xi
    global message2copybuffertoimagereceive4xi
    global message2copybuffertoimagesend4xi
    
    global mission2copybuffertoimage                                                          
    
    global image2d4xi  
    global info2image4xi  
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    debug = True
    try:
        if debug is True:
            print("(Step 0D1/33) of manoeuvre2copybuffertoimage4xi - STARTED " , time4xi())
            # 
            print("(Step 0D2/33) of manoeuvre2copybuffertoimage4xi - PASSED QUEUE2READMANOEUVRE4XI: " , queue2copybuffertoimagemanoeuvre4xi)
            # 
    
            print("(Step 0D3/33) of manoeuvre2copybuffertoimage4xi - PASSED CONSUMERCHANNEL2READMANOEUVRE4XI: " , consumerchannel2copybuffertoimagemanoeuvre4xi)
            # 
           
            print("(Step 0D4/33) of manoeuvre2copybuffertoimage4xi - PASSED PUBLISHERCHANNEL2READMANOEUVRE4XI: " , publisherchannel2copybuffertoimagemanoeuvre4xi) 
            # 
    
            print("(Step 0D5/33) of manoeuvre2copybuffertoimage4xi - USING STATE2READ4XI: " , state2copybuffertoimage4xi) 
            #
            
            
        keys2copybuffertoimagemanoeuvre = queue2copybuffertoimagemanoeuvre4xi.keys()
        if debug is True:
            print("{(Step 0/33) of manoeuvre2copybuffertoimage4xi - SET KEYS2READMANOEUVRE TO: ", keys2copybuffertoimagemanoeuvre) 
            #
            
                  
        response2manouvre4copybuffertoimage = {}
    except:
        print("(Step 0Z1/33) of manoeuvre2copybuffertoimage4xi *** FAILED IN START ***  " , time4xi())
    
    # -----------------------------------------------------------------------------------------
    # (Step 0/33) PARAMETERS ARE DICTIONARIES FOR XI            
    # -----------------------------------------------------------------------------------------          
    try:
        class2print  = "manoeuvre2copybuffertoimage4xi" 
        method2print = "manoeuvre2copybuffertoimage4xi" 
    
        code2ack  = ' '
        code2nack = ' '
        
        message2print = "{(Step 0A/33) started" + "; manoeuvre2copybuffertoimage4xi-started: " + str(manoeuvre2copybuffertoimage4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                                     #  
        # 
        
        message2print = "{(Step 0B/33) passed" + "; queue2copybuffertoimagemanoeuvre4xi-to-manoeuvre2copybuffertoimage4xi: " + str(queue2copybuffertoimagemanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        # 
        
        message2print = "{(Step 0C/33) passed" + "; consumerchannel2copybuffertoimagemanoeuvre4xi-to-manoeuvre2copybuffertoimage4xi: " + str(consumerchannel2copybuffertoimagemanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        # 
        
        message2print = "{(Step 0D/33) passed" + "; publisherchannel2copybuffertoimagemanoeuvre4xi-to-manoeuvre2copybuffertoimage4xi: " + str(publisherchannel2copybuffertoimagemanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        #   
        
        code2ack  = code2ack + '0D-' 
    except:
        print("(Step 0Z2/33) of manoeuvre2copybuffertoimage4xi *** FAILED IN START ***  " , time4xi())
        
    # ==============================================================================================================
    # MISSION
    # ==============================================================================================================        
    if debug is True:
        print("{(Step M0/33) of manoeuvre2copybuffertoimage4xi - CHECKING MISSION AT STATE2READ4XI: " , state2copybuffertoimage4xi) 
        #
        
         
    try:
        if mission2copybuffertoimage == "NACK":
            mission2copybuffertoimage = "ACK"
            print("(Step M1/33) of manoeuvre2copybuffertoimage4xi - SET MISSION2READ TO :  " , mission2copybuffertoimage)       
        else:
            mission2copybuffertoimage = "ACK"
            print("(Step M2/33) of manoeuvre2copybuffertoimage4xi - USING MISSION2READ:  " , mission2copybuffertoimage)
            # 
        if state2copybuffertoimage4xi == {}:    
            for key2copybuffertoimagemanoeuvre in keys2copybuffertoimagemanoeuvre:
                #----------------------------------------------------------------------------------------------------------------------
                # STATE 0
                # ---------------------------------------------------------------------------------------------------------------------     
                state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre]   = 0
                message2print = "{(Step 0Z1/33) initialized" + "; state2copybuffertoimage4xi-initialized-by-manoeuvre2copybuffertoimage4xi to: " + str(state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                                    
                ack2copybuffertoimageinfo4xi [key2copybuffertoimagemanoeuvre] = False
                message2print = "{(Step 0Z2/33) initialized" + "; ack2copybuffertoimageinfo4xi-initialized-by-manoeuvre2copybuffertoimage4xi to: " + str(ack2copybuffertoimageinfo4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                    
                message2copybuffertoimageget4xi [key2copybuffertoimagemanoeuvre] = '<default4xi>default2copybuffertoimage4xi</default4xi>'
                message2print = "{(Step 0Z3/33) initialized" + "; message2copybuffertoimageget4xi-initialized-by-manoeuvre2copybuffertoimage4xi to: " + str(message2copybuffertoimageget4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                    
                message2copybuffertoimageput4xi [key2copybuffertoimagemanoeuvre]  = '<default4xi>default2copybuffertoimage4xi</default4xi>'
                message2print = "{(Step 0Z4/33) initialized" + "; message2copybuffertoimageput4xi-initialized-by-manoeuvre2copybuffertoimage4xi to: " + str(message2copybuffertoimageput4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre]  = '<default4xi>default2copybuffertoimage4xi</default4xi>'
                message2print = "{(Step 0Z5/33) initialized" + "; message2copybuffertoimagereceive4xi-initialized-by-manoeuvre2copybuffertoimage4xi to: " + str(message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre] = '<default4xi>default2copybuffertoimage4xi</default4xi>'
                message2print = "{(Step 0Z6/33) initialized" + "; message2copybuffertoimagesend4xi-initialized-by-manoeuvre2copybuffertoimage4xi to: " + str(message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                max2copybuffertoimagestate4xi [key2copybuffertoimagemanoeuvre] = 3
                message2print = "{(Step 0Z7/33) initialized" + ";  max2copybuffertoimagestate4xi-initialized-by-manoeuvre2copybuffertoimage4xi to: " + str( max2copybuffertoimagestate4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #    
        else:
            pass                             
    except:
        if debug is True:
            print("{(Step 0Z0/33) of manoeuvre2copybuffertoimage4xi  EXCEPTION: ", time4xi()) 
            mission2copybuffertoimage = "ACK" 
            print("(Step M3/33) of manoeuvre2copybuffertoimage4xi ** EXCEPTIONAL COPYBUFFERTOIMAGE:  " , mission2copybuffertoimage) 
            # 
        if state2copybuffertoimage4xi == {}:                 
            for key2copybuffertoimagemanoeuvre in keys2copybuffertoimagemanoeuvre:
                # ------------------------------------------------------------------------------------------------------------------------
                # EXCEPTIONAL STATE 0
                # ------------------------------------------------------------------------------------------------------------------------     
                state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre]   = 0
                message2print = "{(Step 0Z1/33) initialized" + "; state2copybuffertoimage4xi-initialized-by-manoeuvre2copybuffertoimage4xi to: " + str(state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                    
                ack2copybuffertoimageinfo4xi [key2copybuffertoimagemanoeuvre] = False
                message2print = "{(Step 0Z2/33) initialized" + "; ack2copybuffertoimageinfo4xi-initialized-by-manoeuvre2copybuffertoimage4xi to: " + str(ack2copybuffertoimageinfo4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                    
                message2copybuffertoimageget4xi [key2copybuffertoimagemanoeuvre] = '<default4xi>default2copybuffertoimage4xi</default4xi>'
                message2print = "{(Step 0Z3/33) initialized" + "; message2copybuffertoimageget4xi-initialized-by-manoeuvre2copybuffertoimage4xi to: " + str(message2copybuffertoimageget4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                    
                message2copybuffertoimageput4xi [key2copybuffertoimagemanoeuvre]  = '<default4xi>default2copybuffertoimage4xi</default4xi>'
                message2print = "{(Step 0Z4/33) initialized" + "; message2copybuffertoimageput4xi-initialized-by-manoeuvre2copybuffertoimage4xi to: " + str(message2copybuffertoimageput4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre]  = '<default4xi>default2copybuffertoimage4xi</default4xi>'
                message2print = "{(Step 0Z5/33) initialized" + "; message2copybuffertoimagereceive4xi-initialized-by-manoeuvre2copybuffertoimage4xi to: " + str(message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre] = '<default4xi>default2copybuffertoimage4xi</default4xi>'
                message2print = "{(Step 0Z6/33) initialized" + "; message2copybuffertoimagesend4xi-initialized-by-manoeuvre2copybuffertoimage4xi to: " + str(message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                max2copybuffertoimagestate4xi [key2copybuffertoimagemanoeuvre] = 3
                message2print = "{(Step 0Z7/33) initialized" + ";  max2copybuffertoimagestate4xi-initialized-by-manoeuvre2copybuffertoimage4xi to: " + str( max2copybuffertoimagestate4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #
       
    # ==============================================================================================================
    # NEXT PHASE PREPARING 
    # ==============================================================================================================                                             
    if debug is True:
        print("{(Step M0/33) of manoeuvre2copybuffertoimage4xi - NEXT PHASE PREPARING AT STATE2READ4XI: " , state2copybuffertoimage4xi) 
        # 
          
    for key2copybuffertoimagemanoeuvre in keys2copybuffertoimagemanoeuvre:
        try:
            # ------------------------------------------------------------------------------------------------------------------------
            # UPDATE 
            # ------------------------------------------------------------------------------------------------------------------------      
            state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre]  = state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre]  + 1                                                                   
            message2print = "{(Step 0H/33) added" + "; state2copybuffertoimage4xi-added-by-manoeuvre2copybuffertoimage4xi: " + str(state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            if debug is True:
                print("(Step 0h/33) of manoeuvre2copybuffertoimage4xi TO: ", key2copybuffertoimagemanoeuvre, " STATE2READ4XI-ADDED TO: " , state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre]) 
                #
                
                 
            if state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre] > max2copybuffertoimagestate4xi [key2copybuffertoimagemanoeuvre]:
                state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre]  = 0
                message2print = "{(Step 0I/33) set" + "; state2copybuffertoimage4xi-set-by-manoeuvre2copybuffertoimage4xi to: " + str(state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                
                if debug is True:
                    print("(Step 0I/33) of manoeuvre2copybuffertoimage4xi TO: ", key2copybuffertoimagemanoeuvre, " STATE2READ4XI-ZEROED TO: " , state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre]) 
                    # 
                    
                ack2copybuffertoimageinfo4xi [key2copybuffertoimagemanoeuvre] = False
                message2print = "{(Step 0J/33) set" + "; ack2copybuffertoimageinfo4xi-set-by-manoeuvre2copybuffertoimage4xi to: " + str(ack2copybuffertoimageinfo4xi [key2copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                
                message2copybuffertoimageget4xi [key2copybuffertoimagemanoeuvre] = '<default4xi>default2copybuffertoimage4xi</default4xi>'
                message2print = "{(Step 0K/33) set" + "; message2copybuffertoimageget4xi-set-by-manoeuvre2copybuffertoimage4xi to: " + str(message2copybuffertoimageget4xi [key2copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                
                message2copybuffertoimageput4xi [key2copybuffertoimagemanoeuvre]  = '<default4xi>default2copybuffertoimage4xi</default4xi>'
                message2print = "{(Step 0L/33) set" + "; message2copybuffertoimageput4xi-set-by-manoeuvre2copybuffertoimage4xi to: " + str(message2copybuffertoimageput4xi [key2copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                
                message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre] = '<default4xi>default2copybuffertoimage4xi</default4xi>'
                message2print = "{(Step 0M/33) set" + "; message2copybuffertoimagereceive4xi-set-by-manoeuvre2copybuffertoimage4xi to: " + str(message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                
                message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre]    = '<default4xi>default2copybuffertoimage4xi</default4xi>'
                message2print = "{(Step 0N/33) set" + "; message2copybuffertoimagesend4xi-set-by-manoeuvre2copybuffertoimage4xi to: " + str(message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                
                max2copybuffertoimagestate4xi [key2copybuffertoimagemanoeuvre] = 3
                message2print = "{(Step 0O/33) initialized" + ";  max2copybuffertoimagestate4xi-set-by-manoeuvre2copybuffertoimage4xi to: " + str( max2copybuffertoimagestate4xi [key2copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #
            else:
                pass
            if debug is True:
                print("(Step 1A/33) of manoeuvre2copybuffertoimage4xi FOR : ", key2copybuffertoimagemanoeuvre, " CONTINUING WITH STATE2READ4XI: " , state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre])
                # 
                        
        except:
            print("(Step 0z1/33) of manoeuvre2copybuffertoimage4xi *** FAILED UPDATING *** " , time4xi())
            print("key2copybuffertoimagemanoeuvre: " , key2copybuffertoimagemanoeuvre)
            # 
            print("state2copybuffertoimage4xi: " , state2copybuffertoimage4xi)
            #
            print("ack2copybuffertoimageinfo4xi: " , ack2copybuffertoimageinfo4xi)
            #
            print("message2copybuffertoimageget4xi: " , message2copybuffertoimageget4xi)
            #
            print("message2copybuffertoimageput4xi: " , message2copybuffertoimageput4xi)
            #
            print("message2copybuffertoimagereceive4xi: " , message2copybuffertoimagereceive4xi)
            #
            print("message2copybuffertoimagesend4xi: " , message2copybuffertoimagesend4xi)
            #
            print("max2copybuffertoimagestate4xi: " , max2copybuffertoimagestate4xi)
            #
               
    
    # ==============================================================================================================
    # STATE I
    # ==============================================================================================================        
    if debug is True:
        print("(Step I/33) of manoeuvre2copybuffertoimage4xi: CONSIDERING STATE I: " , state2copybuffertoimage4xi)
        # 
        
           
    for key2copybuffertoimagemanoeuvre in keys2copybuffertoimagemanoeuvre:                     
        # ------------------------------------------------------------------------------------------------------------------------
        # STATE I - RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND COPY OR NEGATIVE BACK 
        # ------------------------------------------------------------------------------------------------------------------------
        try:
            if state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre]  == 1:
                if debug is True:
                    print("(Step 1/33) of manoeuvre2copybuffertoimage4xi: ", key2copybuffertoimagemanoeuvre, " - STATE I - TRY TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
                    
                message2print = "{(Step 1A/70) try" + "; receive-try-by-manoeuvre2copybuffertoimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre]  = consumerchannel2copybuffertoimagemanoeuvre4xi [key2copybuffertoimagemanoeuvre].recv()
                    message2print = "{(Step 1B/33) received" + "; message2copybuffertoimagereceive4xi-received-by-manoeuvre2copybuffertoimage4xi: " + str(message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #
                    
                    if debug is True:
                        print("(Step 1B/33) of manoeuvre2copybuffertoimage4xi: ", key2copybuffertoimagemanoeuvre, " - STATE I - RECEIVED MESSAGE VIA PIPE: " , message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre])
                        # GPU  - STATE I - RECEIVED MESSAGE VIA PIPE:  <copy4xi>copy2copybuffertoimage4xi</copy4xi>
                         
                    if message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre]  == '<copy4xi>copy2copybuffertoimage4xi</copy4xi>':
                        message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre]  = '<copy4xi>copy2copybuffertoimage4xi</copy4xi>'
                    else:
                        message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre]  = '<negative4xi>negative2copybuffertoimage4xi</<negative4xi>'
                        
                        
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel2copybuffertoimagemanoeuvre4xi [key2copybuffertoimagemanoeuvre].send(message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre])
                    
                    message2print = "{(Step 1C/33) sent" + "; message2copybuffertoimagesend4xi-sent-by-manoeuvre2copybuffertoimage4xi: " + str(message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    # 
                    if debug is True:
                        print("(Step 1C/33) of manoeuvre2copybuffertoimage4xi: ", key2copybuffertoimagemanoeuvre, " - STATE I - SENT MESSAGE VIA PIPE: " , message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre])
                        # 
                        
                    
                    code2ack  = code2ack + '1C-'
                except:
                    message2print = "{(Step 1Z/33) failed" + "; message2copybuffertoimagereceive4xi-failed-by-manoeuvre2copybuffertoimage4xi: " + str(message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '1Z-' 
                    
                    print("(Step 1Z1/33) of manoeuvre2copybuffertoimage4xi: ", key2copybuffertoimagemanoeuvre, " - STATE I *** FAILED TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
            else:
                pass
        except:
            print("(Step 1Z2/33) of manoeuvre2copybuffertoimage4xi: ", key2copybuffertoimagemanoeuvre, " - STATE I *** FAILED *** " , time4xi())

    # ==============================================================================================================
    # STATE II
    # ==============================================================================================================        
    if debug is True:
        print("(Step II/33) of manoeuvre2copybuffertoimage4xi: CONSIDERING STATE II : " , state2copybuffertoimage4xi)
        #
        
                  
    for key2copybuffertoimagemanoeuvre in keys2copybuffertoimagemanoeuvre:        
        try:
            if state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre]  == 2:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE II - RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK 
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                    print("(Step 1/33) of manoeuvre2copybuffertoimage4xi - STATE II - ", key2copybuffertoimagemanoeuvre, " TRYING TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #
                                 
                message2print = "{(Step 2A/70) try" + "; receive-try-by-manoeuvre2copybuffertoimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre]  = consumerchannel2copybuffertoimagemanoeuvre4xi [key2copybuffertoimagemanoeuvre].recv()
                    
                    message2print = "{(Step 2B/33) received" + "; message2copybuffertoimagereceive4xi-received-by-manoeuvre2copybuffertoimage4xi: " + str(message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # 
                    if debug is True:
                        print("(Step 2B/33) of manoeuvre2copybuffertoimage4xi - STATE II - FROM ", key2copybuffertoimagemanoeuvre, " RECEIVED " , message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre] )
                        # FROM  GPU  RECEIVED  <ready4xi>ready2copybuffertoimage4xi</ready4xi> 
           
                    if message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre]  == '<ready4xi>ready2copybuffertoimage4xi</ready4xi>':
                        message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre]  = '<ready4xi>ready2copybuffertoimage4xi</ready4xi>'
                    else:
                        message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre]  = '<negative4xi>negative2copybuffertoimagey4xi</<negative4xi>'
                    
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel2copybuffertoimagemanoeuvre4xi [key2copybuffertoimagemanoeuvre].send(message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre])
                    
                    message2print = "{(Step 2C/33) sent" + "; message2copybuffertoimagesend4xi-sent-by-manoeuvre2copybuffertoimage4xi: " + str(message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    # 
                    if debug is True:
                        print("(Step 2C/33) of manoeuvre2copybuffertoimage4xi - STATE II - TO ", key2copybuffertoimagemanoeuvre, " SENT " , message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre] )
                        #                       
                    
                    code2ack  = code2ack + '2C-'
                except:
                    message2print = "{(Step 2Z/33) failed" + "; message2copybuffertoimagereceive4xi-failed-by-manoeuvre2copybuffertoimage4xi: " + str(message2copybuffertoimagereceive4xi [key2copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '2Z-'
                    print("(Step 1/33) of manoeuvre2copybuffertoimage4xi - STATE II - ", key2copybuffertoimagemanoeuvre, " *** FAILED TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #  
            else:
                pass        
        except:
            print("(Step 1/33) of manoeuvre2copybuffertoimage4xi - STATE II - ", key2copybuffertoimagemanoeuvre, " *** FAILED *** " , time4xi())
        

    # ==============================================================================================================
    # STATE III
    # ==============================================================================================================        
    if debug is True:
        print("(Step III/33) of manoeuvre2copybuffertoimage4xi: CONSIDERING STATE III : " , state2copybuffertoimage4xi)
        # 
            
    for key2copybuffertoimagemanoeuvre in keys2copybuffertoimagemanoeuvre:
        try:   
            if state2copybuffertoimage4xi [key2copybuffertoimagemanoeuvre]  == 3:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE III - GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                        print("(Step 3A/33) of manoeuvre2copybuffertoimage4xi - STATE III - ", key2copybuffertoimagemanoeuvre, " GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE " , time4xi())
                        #     
                info2image4xi [key2copybuffertoimagemanoeuvre]  = None
                message2print = "{(Step 3A/70) try" + "; info2image4xi-try-by-manoeuvre2copybuffertoimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                try: 
                    # ----------------------------------------------------------------------------------------------------------------
                    # GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE
                    # ----------------------------------------------------------------------------------------------------------------        
                    info2image4xi [key2copybuffertoimagemanoeuvre]  = queue2copybuffertoimagemanoeuvre4xi [key2copybuffertoimagemanoeuvre].get()
                    
                    message2print = "{(Step 3B/33) got" + "; info2image4xi-got-by-manoeuvre2copybuffertoimage4xi: " + str(info2image4xi [key2copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # 
                    if debug is True:
                        print("(Step 3B/33) of manoeuvre2copybuffertoimage4xi - STATE III - ", key2copybuffertoimagemanoeuvre, " GOT INFO2IMAGE4XI: " , info2image4xi [key2copybuffertoimagemanoeuvre])
                        #  
                    
                    if info2image4xi [key2copybuffertoimagemanoeuvre]  is None:
                        code2nack  = code2nack + '3Z1-'
                        ack2copybuffertoimageinfo4xi [key2copybuffertoimagemanoeuvre]  = False 
                    else:    
                        code2ack  = code2ack + '3C-'
                        ack2copybuffertoimageinfo4xi [key2copybuffertoimagemanoeuvre]  = True
                except:
                    message2print = "{(Step 3Z1/33) failed" + "; queue2copybuffertoimagemanoeuvre4xi-failed-by-manoeuvre2copybuffertoimage4xi: " + str(queue2copybuffertoimagemanoeuvre4xi [key2copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '3Z1-'
                    
                message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre]  = ' '
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND CONTROL INFO ABOUT IMAGE OPERATION - EITHER ACK OR NACK  
                    # ----------------------------------------------------------------------------------------------------------------         
                    if ack2copybuffertoimageinfo4xi [key2copybuffertoimagemanoeuvre]  is True:
                        message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre]  = '<ack4xi>ack2imageinfo4xi</ack4xi>'
                    else:
                        message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre]  = '<nack4xi>nack2imageinfo4xi</nack4xi>'
                    message2print = "{(Step 4B/33) set" + "; message2copybuffertoimagesend4xi-set-by-manoeuvre2copybuffertoimage4xi to: " + str(message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #       
                except:
                    message2print = "{(Step 4Z1/33) failed" + "; message2copybuffertoimagesend4xi-failed-by-manoeuvre2copybuffertoimage4xi: " + str(message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    
                    code2nack  = code2nack + '4Z1-'    
                try:                
                    message2print = "{(Step 4C/70) using" + "; publisherchannel2copybuffertoimagemanoeuvre4xi-calling-by-manoeuvre2copybuffertoimage4xi: " + str(publisherchannel2copybuffertoimagemanoeuvre4xi [key2copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    # 
                    message2print = "{{(Step 4D/70) passing" + "; message2copybuffertoimagesend4xi-passing-to-send-by-manoeuvre2copybuffertoimage4xi: " + str(message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    #              
                except:
                    message2print = "{(Step 4Z1/33) failed" + "; message2copybuffertoimagesend4xi-failed-by-manoeuvre2copybuffertoimage4xi: " + str(message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '4Z2-'                
                try:    
                    publisherchannel2copybuffertoimagemanoeuvre4xi [key2copybuffertoimagemanoeuvre].send(message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre] )
                    
                    message2print = "{(Step 4E/33) sent" + "; message2copybuffertoimagesend4xi-sent-by-manoeuvre2copybuffertoimage4xi: " + str(message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    #            
                    code2ack  = code2ack + '4E-'
                    
                    if debug is True:
                        print("(Step 4EB/33) of manoeuvre2copybuffertoimage4xi - STATE III - ", key2copybuffertoimagemanoeuvre, " SENT MESSAGE: " , message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre])
                        #    
                except:
                    message2print = "{(Step 4Z3/33) failed" + "; message2copybuffertoimagesend4xi-failed-by-manoeuvre2copybuffertoimage4xi: " + str(message2copybuffertoimagesend4xi [key2copybuffertoimagemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '4Z3-'                
            else:
                pass
        except:
            print("(Step 1/33) of manoeuvre2copybuffertoimage4xi - STATE III - ", key2copybuffertoimagemanoeuvre, " *** FAILED *** " , time4xi())
            
    # ==============================================================================================================
    # PREPARE RETURN - DICTIONARY LEVEL
    # ==============================================================================================================        
    if debug is True:
        try:
            print("(Step 5A/33) of manoeuvre2copybuffertoimage4xi - TRYING TO DEBUG PREPARING OF RETURN AT STATE: " , state2copybuffertoimage4xi)
            # 
            
            print("(Step 5B/33) of manoeuvre2copybuffertoimage4xi - response2manouvre4copybuffertoimage: " , response2manouvre4copybuffertoimage)
            # 
            
            print("(Step 5C/33) of manoeuvre2copybuffertoimage4xi - ack2copybuffertoimageinfo4xi: " , ack2copybuffertoimageinfo4xi)
            # 
            
            print("(Step 5D/33) of manoeuvre2copybuffertoimage4xi - message2copybuffertoimageget4xi: ", message2copybuffertoimageget4xi)
            # 
            
            print("(Step 5E/33) of manoeuvre2copybuffertoimage4xi - message2copybuffertoimageput4xi: " , message2copybuffertoimageput4xi)
            # 
            
            print("(Step 5F/33) of manoeuvre2copybuffertoimage4xi - message2copybuffertoimagereceive4xi: " , message2copybuffertoimagereceive4xi)
            # 
            
            print("(Step 5G/33) of manoeuvre2copybuffertoimage4xi - message2copybuffertoimagesend4xi: " , message2copybuffertoimagesend4xi)
            # 
            
            
        except:
            print("(Step 5Z1/33) of manoeuvre2copybuffertoimage4xi *** FAILED TO PREPARE RETURN WITH STATE: " , state2copybuffertoimage4xi)
    
    print("(Step 5B/33) of manoeuvre2copybuffertoimage4xi - TRYING TO PREPARING OF RETURN AT STATE: " , state2copybuffertoimage4xi)    
    try:        
        response2manouvre4copybuffertoimage ['ACK2INFO4XI']        = ack2copybuffertoimageinfo4xi 
        response2manouvre4copybuffertoimage ['MESSAGE2GET4XI']     = message2copybuffertoimageget4xi
        response2manouvre4copybuffertoimage ['MESSAGE2PUT4XI']     = message2copybuffertoimageput4xi
        response2manouvre4copybuffertoimage ['MESSAGE2RECEIVE4XI'] = message2copybuffertoimagereceive4xi
        response2manouvre4copybuffertoimage ['MESSAGE2SEND4XI']    = message2copybuffertoimagesend4xi
        response2manouvre4copybuffertoimage ['STATE2MANOEUVRE4XI'] = state2copybuffertoimage4xi
    except:
        print("(Step 5Z2/33) of manoeuvre2copybuffertoimage4xi *** FAILED IN PREPARING RETURN KEY2READMANOEUVRE AT STATE: " , state2copybuffertoimage4xi)   
                             
    message2print = "{(Step 33/33) returning" + "; response2manouvre4copybuffertoimage-returning-by-manoeuvre2copybuffertoimage4xi: " + str(response2manouvre4copybuffertoimage) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             


    if debug is True:
        print("(Step 33/33) of manoeuvre2copybuffertoimage4xi - RETURNING  WITH STATE: " , state2copybuffertoimage4xi, " RESPONSE2MANOUVRE4READ " , response2manouvre4copybuffertoimage)
        #{'GPU': 1, 'ZPU': 1, 'APU': 1}  RESPONSE2MANOUVRE4READ  
        #      {'MESSAGE2RECEIVE4XI': {'GPU': '<copy4xi>copy2copybuffertoimage4xi</copy4xi>', 'ZPU': '<copy4xi>copy2copybuffertoimage4xi</copy4xi>', 'APU': '<copy4xi>copy2copybuffertoimage4xi</copy4xi>'}, 
        #       'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False}, 'MESSAGE2GET4XI': {'GPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default2copybuffertoimage4xi</default4xi>'}, 
        #       'STATE2MANOEUVRE4XI': {'GPU': 1, 'ZPU': 1, 'APU': 1}, 
        #       'MESSAGE2SEND4XI': {'GPU': '<roger4xi>roger2copybuffertoimage4xi</roger4xi>', 'ZPU': '<roger4xi>roger2copybuffertoimage4xi</roger4xi>', 'APU': '<roger4xi>roger2copybuffertoimage4xi</roger4xi>'}, 
        #       'MESSAGE2PUT4XI': {'GPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default2copybuffertoimage4xi</default4xi>'}}

 
        #2 {'GPU': 2, 'ZPU': 2, 'APU': 2}  RESPONSE2MANOUVRE4READ  
        # {'MESSAGE2RECEIVE4XI': {'GPU': '<ready4xi>ready2copybuffertoimage4xi</ready4xi>', 'ZPU': '<ready4xi>ready2copybuffertoimage4xi</ready4xi>', 'APU': '<ready4xi>ready2copybuffertoimage4xi</ready4xi>'}, 
        # 'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False}, 
        # 'MESSAGE2GET4XI': {'GPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default2copybuffertoimage4xi</default4xi>'}, 
        # 'STATE2MANOEUVRE4XI': {'GPU': 2, 'ZPU': 2, 'APU': 2}, 
        # 'MESSAGE2SEND4XI': {'GPU': '<ready4xi>ready2copybuffertoimage4xi</ready4xi>', 'ZPU': '<ready4xi>ready2copybuffertoimage4xi</ready4xi>', 'APU': '<ready4xi>ready2copybuffertoimage4xi</ready4xi>'}, 
        # 'MESSAGE2PUT4XI': {'GPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default2copybuffertoimage4xi</default4xi>'}}


        #3 
        #{'GPU': 3, 'ZPU': 3, 'APU': 3}  RESPONSE2MANOUVRE4READ  
        #  {'MESSAGE2RECEIVE4XI': {'GPU': '<ready4xi>ready2copybuffertoimage4xi</ready4xi>', 'ZPU': '<ready4xi>ready2copybuffertoimage4xi</ready4xi>', 'APU': '<ready4xi>ready2copybuffertoimage4xi</ready4xi>'}, 
        #   'ACK2INFO4XI': {'GPU': True, 'ZPU': True, 'APU': True}, 
        #   'MESSAGE2GET4XI': {'GPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default2copybuffertoimage4xi</default4xi>'}, 
        #   'STATE2MANOEUVRE4XI': {'GPU': 3, 'ZPU': 3, 'APU': 3}, 
        #   'MESSAGE2SEND4XI': {'GPU': '<ack4xi>ack2imageinfo4xi</ack4xi>', 'ZPU': '<ack4xi>ack2imageinfo4xi</ack4xi>', 'APU': '<ack4xi>ack2imageinfo4xi</ack4xi>'}, 
        #   'MESSAGE2PUT4XI': {'GPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default2copybuffertoimage4xi</default4xi>'}}
 

        #4
        #{'GPU': 0, 'ZPU': 0, 'APU': 0}  RESPONSE2MANOUVRE4READ  
        # {'MESSAGE2RECEIVE4XI': {'GPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default2copybuffertoimage4xi</default4xi>'},
        #  'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False}, 
        #  'MESSAGE2GET4XI': {'GPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default2copybuffertoimage4xi</default4xi>'}, 
        #  'STATE2MANOEUVRE4XI': {'GPU': 0, 'ZPU': 0, 'APU': 0}, 
        #  'MESSAGE2SEND4XI': {'GPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default2copybuffertoimage4xi</default4xi>'}, 
        #  'MESSAGE2PUT4XI': {'GPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'ZPU': '<default4xi>default2copybuffertoimage4xi</default4xi>', 'APU': '<default4xi>default2copybuffertoimage4xi</default4xi>'}}

        

    return response2manouvre4copybuffertoimage           
          
#</function4xi>



# -----------------------------------------------------------------------------------------------------------------------
#<function4xi function = "manoeuvre2readimage4xi" usage = "
#
#   # ---------------------------------------------------------------------------------------------------------------------------
#   # PHASE I: READ FUNCTION  TESTS - SIMULATE MANOEUVRE2READIMAGE4XI THREAD - LET IT TO RECEIVE COPY AND TO SEND ROGER VIA PIPE                
#   # ---------------------------------------------------------------------------------------------------------------------------       
#   if ack2simulate4xi is True:
#       print("(Step 18A/700) OF IMAGE2D4XI5TEST - TRYING TO PASS PARAMETERS TO MANOEUVRE2READIMAGE4XI ", time4xi()) 
#       response2manoeuvre4read = {}
#       try:
#          # -----------------------------------------------------------------------------------------
#          # NOTE: DICTIONARY PARAMETERS MUST BE GIVEN TO VIRTUAL PROCESSING UNIT XI FUNCTION !
#          # -----------------------------------------------------------------------------------------
#          print("(Step 18B/700) OF IMAGE2D4XI5TEST - PASSING QUEUE2READ4XI ", queue4read)
#          # {'GPU': <queue4xi.Queue4Xi object at 0x0000000005D64B00>, 'ZPU': <queue4xi.Queue4Xi object at 0x0000000005D649B0>, 'APU': <queue4xi.Queue4Xi object at 0x0000000005D64748>}
#          # 
#          print("(Step 18C/700) OF IMAGE2D4XI5TEST - CHANNEL2READCONSUME4XI ", channel4read2consume)
#          # {'GPU': <read-write PipeConnection, handle 6580>, 'ZPU': <read-write PipeConnection, handle 6612>, 'APU': <read-write PipeConnection, handle 6548>}.
#          print("(Step 18D/700) OF IMAGE2D4XI5TEST - CHANNEL2READPUBLISH4XI ", channel4read2publish)
#          # {'GPU': <read-write PipeConnection, handle 6584>, 'ZPU': <read-write PipeConnection, handle 6616>, 'APU': <read-write PipeConnection, handle 6552>}
#       except:
#          print("(Step 18Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO PASS PARAMETERS TO MANOEUVRE2READIMAGE4XI ", time4xi()) 
#          
#       print("(Step 18E/700) OF IMAGE2D4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2READIMAGE4XI ", manoeuvre2readimage4xi)             
#       response2manoeuvre4read = {}
#       try:     
#          response2manoeuvre4read = manoeuvre2readimage4xi(queue4read, channel4read2consume, channel4read2publish)
#          print("(Step 18F/700) OF IMAGE2D4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2READIMAGE4XI ", manoeuvre2readimage4xi)
#          # <function manoeuvre2readimage4xi at 0x000000000597A048>
#       except:
#           print("(Step 18Z2/700) OF IMAGE2D4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2READIMAGE4XI ", manoeuvre2readimage4xi)     
#   else:
#       pass # trust activated thread    
#">

# ----------------------------------------------------------------------------------------------------------------------- 
def manoeuvre2readimage4xi(queue2readmanoeuvre4xi, consumerchannel2readmanoeuvre4xi, publisherchannel2readmanoeuvre4xi):
    '''
    manoeuvres read control and command
    '''
    # 
        
    # ---------------------------------------------------------------------------------------------
    # GLOBAL DICTIONARIES TO HANDLE PROCESSING UNITS
    # ---------------------------------------------------------------------------------------------
    global state2read4xi                                                                                           
    global max2readstate4xi                                                                                        
    global ack2readinfo4xi                                                                                         
    global message2readget4xi                                 
    global message2readput4xi
    global message2readreceive4xi
    global message2readsend4xi
    
    global mission2read                                                          # MISSION TO READ
    
    global image2d4xi  
    global info2image4xi  
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    debug = True
    try:
        if debug is True:
            print("(Step 0D1/33) of manoeuvre2readimage4xi - STARTED " , time4xi())
            # 04:28:06 11/03/11 Pacific Daylight Time
            print("(Step 0D2/33) of manoeuvre2readimage4xi - PASSED QUEUE2READMANOEUVRE4XI: " , queue2readmanoeuvre4xi)
            # {'GPU': <queue4xi.Queue4Xi object at 0x0000000005DFBEF0>, 'ZPU': <queue4xi.Queue4Xi object at 0x0000000005DFBCC0>, 'APU': <queue4xi.Queue4Xi object at 0x0000000005DFBB38>}
    
            print("(Step 0D3/33) of manoeuvre2readimage4xi - PASSED CONSUMERCHANNEL2READMANOEUVRE4XI: " , consumerchannel2readmanoeuvre4xi)
            # {'GPU': <read-write PipeConnection, handle 6580>, 'ZPU': <read-write PipeConnection, handle 6612>, 'APU': <read-write PipeConnection, handle 6548>}
           
            print("(Step 0D4/33) of manoeuvre2readimage4xi - PASSED PUBLISHERCHANNEL2READMANOEUVRE4XI: " , publisherchannel2readmanoeuvre4xi) 
            # {'GPU': <read-write PipeConnection, handle 6584>, 'ZPU': <read-write PipeConnection, handle 6616>, 'APU': <read-write PipeConnection, handle 6552>}
    
            print("(Step 0D5/33) of manoeuvre2readimage4xi - USING STATE2READ4XI: " , state2read4xi) 
            #1 {'GPU': 1, 'ZPU': 1, 'APU': 1}  
            
            
        keys2readmanoeuvre = queue2readmanoeuvre4xi.keys()
        if debug is True:
            print("{(Step 0/33) of manoeuvre2readimage4xi - SET KEYS2READMANOEUVRE TO: ", keys2readmanoeuvre) 
            #1 dict_keys(['GPU', 'ZPU', 'APU'])
            #
                  
        response2manouvre4read = {}
    except:
        print("(Step 0Z1/33) of manoeuvre2readimage4xi *** FAILED IN START ***  " , time4xi())
    
    # -----------------------------------------------------------------------------------------
    # (Step 0/33) PARAMETERS ARE DICTIONARIES FOR XI            
    # -----------------------------------------------------------------------------------------          
    try:
        class2print  = "manoeuvre2readimage4xi" 
        method2print = "manoeuvre2readimage4xi" 
    
        code2ack  = ' '
        code2nack = ' '
        
        message2print = "{(Step 0A/33) started" + "; manoeuvre2readimage4xi-started: " + str(manoeuvre2readimage4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                                     #  
        # 
        
        message2print = "{(Step 0B/33) passed" + "; queue2readmanoeuvre4xi-to-manoeuvre2readimage4xi: " + str(queue2readmanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        # 
        
        message2print = "{(Step 0C/33) passed" + "; consumerchannel2readmanoeuvre4xi-to-manoeuvre2readimage4xi: " + str(consumerchannel2readmanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        # 
        
        message2print = "{(Step 0D/33) passed" + "; publisherchannel2readmanoeuvre4xi-to-manoeuvre2readimage4xi: " + str(publisherchannel2readmanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        #   
        
        code2ack  = code2ack + '0D-' 
    except:
        print("(Step 0Z2/33) of manoeuvre2readimage4xi *** FAILED IN START ***  " , time4xi())
        
    # ==============================================================================================================
    # MISSION
    # ==============================================================================================================        
    if debug is True:
        print("{(Step M0/33) of manoeuvre2readimage4xi - CHECKING MISSION AT STATE2READ4XI: " , state2read4xi) 
        #1 {}
         
    try:
        if mission2read == "NACK":
            mission2read = "ACK"
            print("(Step M1/33) of manoeuvre2readimage4xi - SET MISSION2READ TO :  " , mission2read)       
        else:
            mission2read = "ACK"
            print("(Step M2/33) of manoeuvre2readimage4xi - USING MISSION2READ:  " , mission2read)
            # 
        if state2read4xi == {}:    
            for key2readmanoeuvre in keys2readmanoeuvre:
                #----------------------------------------------------------------------------------------------------------------------
                # STATE 0
                # ---------------------------------------------------------------------------------------------------------------------     
                state2read4xi [key2readmanoeuvre]   = 0
                message2print = "{(Step 0Z1/33) initialized" + "; state2read4xi-initialized-by-manoeuvre2readimage4xi to: " + str(state2read4xi [key2readmanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                    
                ack2readinfo4xi [key2readmanoeuvre] = False
                message2print = "{(Step 0Z2/33) initialized" + "; ack2readinfo4xi-initialized-by-manoeuvre2readimage4xi to: " + str(ack2readinfo4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # False
                    
                message2readget4xi [key2readmanoeuvre] = '<default4xi>default2read4xi</default4xi>'
                message2print = "{(Step 0Z3/33) initialized" + "; message2readget4xi-initialized-by-manoeuvre2readimage4xi to: " + str(message2readget4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # <default4xi>default2read4xi</default4xi>
                    
                message2readput4xi [key2readmanoeuvre]  = '<default4xi>default2read4xi</default4xi>'
                message2print = "{(Step 0Z4/33) initialized" + "; message2readput4xi-initialized-by-manoeuvre2readimage4xi to: " + str(message2readput4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # <default4xi>default2read4xi</default4xi>
                    
                message2readreceive4xi [key2readmanoeuvre]  = '<default4xi>default2read4xi</default4xi>'
                message2print = "{(Step 0Z5/33) initialized" + "; message2readreceive4xi-initialized-by-manoeuvre2readimage4xi to: " + str(message2readreceive4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # <default4xi>default2read4xi</default4xi>
                    
                message2readsend4xi [key2readmanoeuvre] = '<default4xi>default2read4xi</default4xi>'
                message2print = "{(Step 0Z6/33) initialized" + "; message2readsend4xi-initialized-by-manoeuvre2readimage4xi to: " + str(message2readsend4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # <default4xi>default2read4xi</default4xi>
                    
                max2readstate4xi [key2readmanoeuvre] = 3
                message2print = "{(Step 0Z7/33) initialized" + ";  max2readstate4xi-initialized-by-manoeuvre2readimage4xi to: " + str( max2readstate4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #    
        else:
            pass                             
    except:
        if debug is True:
            print("{(Step 0Z0/33) of manoeuvre2readimage4xi  EXCEPTION: ", time4xi()) 
            mission2read = "ACK" 
            print("(Step M3/33) of manoeuvre2readimage4xi  EXCEPTIONAL MISSION2READ:  " , mission2read) 
            # 
        if state2read4xi == {}:                 
            for key2readmanoeuvre in keys2readmanoeuvre:
                # ------------------------------------------------------------------------------------------------------------------------
                # EXCEPTIONAL STATE 0
                # ------------------------------------------------------------------------------------------------------------------------     
                state2read4xi [key2readmanoeuvre]   = 0
                message2print = "{(Step 0Z1/33) initialized" + "; state2read4xi-initialized-by-manoeuvre2readimage4xi to: " + str(state2read4xi [key2readmanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                    
                ack2readinfo4xi [key2readmanoeuvre] = False
                message2print = "{(Step 0Z2/33) initialized" + "; ack2readinfo4xi-initialized-by-manoeuvre2readimage4xi to: " + str(ack2readinfo4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # False
                    
                message2readget4xi [key2readmanoeuvre] = '<default4xi>default2read4xi</default4xi>'
                message2print = "{(Step 0Z3/33) initialized" + "; message2readget4xi-initialized-by-manoeuvre2readimage4xi to: " + str(message2readget4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # <default4xi>default2read4xi</default4xi>
                    
                message2readput4xi [key2readmanoeuvre]  = '<default4xi>default2read4xi</default4xi>'
                message2print = "{(Step 0Z4/33) initialized" + "; message2readput4xi-initialized-by-manoeuvre2readimage4xi to: " + str(message2readput4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # <default4xi>default2read4xi</default4xi>
                    
                message2readreceive4xi [key2readmanoeuvre]  = '<default4xi>default2read4xi</default4xi>'
                message2print = "{(Step 0Z5/33) initialized" + "; message2readreceive4xi-initialized-by-manoeuvre2readimage4xi to: " + str(message2readreceive4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # <default4xi>default2read4xi</default4xi>
                    
                message2readsend4xi [key2readmanoeuvre] = '<default4xi>default2read4xi</default4xi>'
                message2print = "{(Step 0Z6/33) initialized" + "; message2readsend4xi-initialized-by-manoeuvre2readimage4xi to: " + str(message2readsend4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # <default4xi>default2read4xi</default4xi>
                    
                max2readstate4xi [key2readmanoeuvre] = 3
                message2print = "{(Step 0Z7/33) initialized" + ";  max2readstate4xi-initialized-by-manoeuvre2readimage4xi to: " + str( max2readstate4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #
       
    # ==============================================================================================================
    # NEXT PHASE PREPARING 
    # ==============================================================================================================                                             
    if debug is True:
        print("{(Step M0/33) of manoeuvre2readimage4xi - NEXT PHASE PREPARING AT STATE2READ4XI: " , state2read4xi) 
        # {'GPU': 1, 'ZPU': 1, 'APU': 1}
        # {'GPU': 2, 'ZPU': 2, 'APU': 2}
        # {'GPU': 3, 'ZPU': 3, 'APU': 3}    
    for key2readmanoeuvre in keys2readmanoeuvre:
        try:
            # ------------------------------------------------------------------------------------------------------------------------
            # UPDATE 
            # ------------------------------------------------------------------------------------------------------------------------      
            state2read4xi [key2readmanoeuvre]  = state2read4xi [key2readmanoeuvre]  + 1                                                                   
            message2print = "{(Step 0H/33) added" + "; state2read4xi-added-by-manoeuvre2readimage4xi: " + str(state2read4xi [key2readmanoeuvre] ) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            if debug is True:
                print("(Step 0h/33) of manoeuvre2readimage4xi TO: ", key2readmanoeuvre, " STATE2READ4XI-ADDED TO: " , state2read4xi [key2readmanoeuvre]) 
                #1 TO:  APU  STATE2READ4XI-ADDED TO:  1; TO:  ZPU  STATE2READ4XI-ADDED TO:  1;  TO:  APU  STATE2READ4XI-ADDED TO:  1
                #2 TO:  APU  STATE2READ4XI-ADDED TO:  2; TO:  ZPU  STATE2READ4XI-ADDED TO:  2;  TO:  APU  STATE2READ4XI-ADDED TO:  2
                 
            if state2read4xi [key2readmanoeuvre] > max2readstate4xi [key2readmanoeuvre]:
                state2read4xi [key2readmanoeuvre]  = 0
                message2print = "{(Step 0I/33) set" + "; state2read4xi-set-by-manoeuvre2readimage4xi to: " + str(state2read4xi [key2readmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 0
                if debug is True:
                    print("(Step 0I/33) of manoeuvre2readimage4xi TO: ", key2readmanoeuvre, " STATE2READ4XI-ZEROED TO: " , state2read4xi [key2readmanoeuvre]) 
                    # GPU  STATE2READ4XI-ZEROED TO:  0; ZPU  STATE2READ4XI-ZEROED TO:  0; APU  STATE2READ4XI-ZEROED TO:  0
                ack2readinfo4xi [key2readmanoeuvre] = False
                message2print = "{(Step 0J/33) set" + "; ack2readinfo4xi-set-by-manoeuvre2readimage4xi to: " + str(ack2readinfo4xi [key2readmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # False
                
                message2readget4xi [key2readmanoeuvre] = '<default4xi>default2read4xi</default4xi>'
                message2print = "{(Step 0K/33) set" + "; message2readget4xi-set-by-manoeuvre2readimage4xi to: " + str(message2readget4xi [key2readmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # <default4xi>default2read4xi</default4xi>
                
                message2readput4xi [key2readmanoeuvre]  = '<default4xi>default2read4xi</default4xi>'
                message2print = "{(Step 0L/33) set" + "; message2readput4xi-set-by-manoeuvre2readimage4xi to: " + str(message2readput4xi [key2readmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # <default4xi>default2read4xi</default4xi>
                
                message2readreceive4xi [key2readmanoeuvre] = '<default4xi>default2read4xi</default4xi>'
                message2print = "{(Step 0M/33) set" + "; message2readreceive4xi-set-by-manoeuvre2readimage4xi to: " + str(message2readreceive4xi [key2readmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # <default4xi>default2read4xi</default4xi>
                
                message2readsend4xi [key2readmanoeuvre]    = '<default4xi>default2read4xi</default4xi>'
                message2print = "{(Step 0N/33) set" + "; message2readsend4xi-set-by-manoeuvre2readimage4xi to: " + str(message2readsend4xi [key2readmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # <default4xi>default2read4xi</default4xi>
                
                max2readstate4xi [key2readmanoeuvre] = 3
                message2print = "{(Step 0O/33) initialized" + ";  max2readstate4xi-set-by-manoeuvre2readimage4xi to: " + str( max2readstate4xi [key2readmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #
            else:
                pass
            if debug is True:
                print("(Step 1A/33) of manoeuvre2readimage4xi FOR : ", key2readmanoeuvre, " CONTINUING WITH STATE2READ4XI: " , state2read4xi [key2readmanoeuvre])
                # FOR :  APU  CONTINUING WITH STATE2READ4XI:  1           
        except:
            print("(Step 0z1/33) of manoeuvre2readimage4xi *** FAILED UPDATING *** " , time4xi())
            print("key2readmanoeuvre: " , key2readmanoeuvre)
            # 
            print("state2read4xi: " , state2read4xi)
            #
            print("ack2readinfo4xi: " , ack2readinfo4xi)
            #
            print("message2readget4xi: " , message2readget4xi)
            #
            print("message2readput4xi: " , message2readput4xi)
            #
            print("message2readreceive4xi: " , message2readreceive4xi)
            #
            print("message2readsend4xi: " , message2readsend4xi)
            #
            print("max2readstate4xi: " , max2readstate4xi)
            #
               
    
    # ==============================================================================================================
    # STATE I
    # ==============================================================================================================        
    if debug is True:
        print("(Step I/33) of manoeuvre2readimage4xi: CONSIDERING STATE I: " , state2read4xi)
        # CONSIDERING STATE I:  {'GPU': 1, 'ZPU': 1, 'APU': 1}
           
    for key2readmanoeuvre in keys2readmanoeuvre:                     
        # ------------------------------------------------------------------------------------------------------------------------
        # STATE I - RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND COPY OR NEGATIVE BACK 
        # ------------------------------------------------------------------------------------------------------------------------
        try:
            if state2read4xi [key2readmanoeuvre]  == 1:
                if debug is True:
                    print("(Step 1/33) of manoeuvre2readimage4xi: ", key2readmanoeuvre, " - STATE I - TRY TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # APU  - STATE I - TRY TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK  23:43:53 11/02/11 Pacific Daylight Time
                    
                message2print = "{(Step 1A/70) try" + "; receive-try-by-manoeuvre2readimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                message2readreceive4xi [key2readmanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message2readreceive4xi [key2readmanoeuvre]  = consumerchannel2readmanoeuvre4xi [key2readmanoeuvre].recv()
                    message2print = "{(Step 1B/33) received" + "; message2readreceive4xi-received-by-manoeuvre2readimage4xi: " + str(message2readreceive4xi [key2readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #
                    
                    if debug is True:
                        print("(Step 1B/33) of manoeuvre2readimage4xi: ", key2readmanoeuvre, " - STATE I - RECEIVED MESSAGE VIA PIPE: " , message2readreceive4xi [key2readmanoeuvre])
                        # GPU  - STATE I - RECEIVED MESSAGE VIA PIPE:  <copy4xi>copy2read4xi</copy4xi>; 
                        # ZPU  - STATE I - RECEIVED MESSAGE VIA PIPE:  <copy4xi>copy2read4xi</copy4xi>
                        # APU  - STATE I - RECEIVED MESSAGE VIA PIPE:  <copy4xi>copy2read4xi</copy4xi>
                        #         
                    if message2readreceive4xi [key2readmanoeuvre]  == '<copy4xi>copy2read4xi</copy4xi>':
                        message2readsend4xi [key2readmanoeuvre]  = '<copy4xi>copy2read4xi</copy4xi>'
                    else:
                        message2readsend4xi [key2readmanoeuvre]  = '<negative4xi>negative2read4xi</<negative4xi>'
                        
                        
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel2readmanoeuvre4xi [key2readmanoeuvre].send(message2readsend4xi [key2readmanoeuvre])
                    
                    message2print = "{(Step 1C/33) sent" + "; message2readsend4xi-sent-by-manoeuvre2readimage4xi: " + str(message2readsend4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    # <roger4xi>roger2read4xi</roger4xi>
                    if debug is True:
                        print("(Step 1C/33) of manoeuvre2readimage4xi: ", key2readmanoeuvre, " - STATE I - SENT MESSAGE VIA PIPE: " , message2readsend4xi [key2readmanoeuvre])
                        # GPU  - STATE I - SENT MESSAGE VIA PIPE:  <roger4xi>roger2read4xi</roger4xi>
                        # ZPU  - STATE I - SENT MESSAGE VIA PIPE:  <roger4xi>roger2read4xi</roger4xi>
                        # APU  - STATE I - SENT MESSAGE VIA PIPE:  <roger4xi>roger2read4xi</roger4xi>
                        # 
                    
                    code2ack  = code2ack + '1C-'
                except:
                    message2print = "{(Step 1Z/33) failed" + "; message2readreceive4xi-failed-by-manoeuvre2readimage4xi: " + str(message2readreceive4xi [key2readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '1Z-' 
                    
                    print("(Step 1Z1/33) of manoeuvre2readimage4xi: ", key2readmanoeuvre, " - STATE I *** FAILED TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
            else:
                pass
        except:
            print("(Step 1Z2/33) of manoeuvre2readimage4xi: ", key2readmanoeuvre, " - STATE I *** FAILED *** " , time4xi())

    # ==============================================================================================================
    # STATE II
    # ==============================================================================================================        
    if debug is True:
        print("(Step II/33) of manoeuvre2readimage4xi: CONSIDERING STATE II : " , state2read4xi)
        #1 {'GPU': 1, 'ZPU': 1, 'APU': 1}
        #2 {'GPU': 2, 'ZPU': 2, 'APU': 2} 
                  
    for key2readmanoeuvre in keys2readmanoeuvre:        
        try:
            if state2read4xi [key2readmanoeuvre]  == 2:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE II - RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK 
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                    print("(Step 1/33) of manoeuvre2readimage4xi - STATE II - ", key2readmanoeuvre, " TRYING TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #             
                message2print = "{(Step 2A/70) try" + "; receive-try-by-manoeuvre2readimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                message2readreceive4xi [key2readmanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message2readreceive4xi [key2readmanoeuvre]  = consumerchannel2readmanoeuvre4xi [key2readmanoeuvre].recv()
                    
                    message2print = "{(Step 2B/33) received" + "; message2readreceive4xi-received-by-manoeuvre2readimage4xi: " + str(message2readreceive4xi [key2readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # <ready4xi>ready2read4xi</ready4xi> 
                    if debug is True:
                        print("(Step 2B/33) of manoeuvre2readimage4xi - STATE II - FROM ", key2readmanoeuvre, " RECEIVED " , message2readreceive4xi [key2readmanoeuvre] )
                        # FROM  GPU  RECEIVED  <ready4xi>ready2read4xi</ready4xi>   
           
                    if message2readreceive4xi [key2readmanoeuvre]  == '<ready4xi>ready2read4xi</ready4xi>':
                        message2readsend4xi [key2readmanoeuvre]  = '<ready4xi>ready2read4xi</ready4xi>'
                    else:
                        message2readsend4xi [key2readmanoeuvre]  = '<negative4xi>negative2ready4xi</<negative4xi>'
                    
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel2readmanoeuvre4xi [key2readmanoeuvre].send(message2readsend4xi [key2readmanoeuvre])
                    
                    message2print = "{(Step 2C/33) sent" + "; message2readsend4xi-sent-by-manoeuvre2readimage4xi: " + str(message2readsend4xi [key2readmanoeuvre])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    # <ready4xi>ready2read4xi</ready4xi>
                    if debug is True:
                        print("(Step 2C/33) of manoeuvre2readimage4xi - STATE II - TO ", key2readmanoeuvre, " SENT " , message2readreceive4xi [key2readmanoeuvre] )
                        #                       
                    
                    code2ack  = code2ack + '2C-'
                except:
                    message2print = "{(Step 2Z/33) failed" + "; message2readreceive4xi-failed-by-manoeuvre2readimage4xi: " + str(message2readreceive4xi [key2readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '2Z-'
                    print("(Step 1/33) of manoeuvre2readimage4xi - STATE II - ", key2readmanoeuvre, " *** FAILED TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #  
            else:
                pass        
        except:
            print("(Step 1/33) of manoeuvre2readimage4xi - STATE II - ", key2readmanoeuvre, " *** FAILED *** " , time4xi())
        

    # ==============================================================================================================
    # STATE III
    # ==============================================================================================================        
    if debug is True:
        print("(Step III/33) of manoeuvre2readimage4xi: CONSIDERING STATE III : " , state2read4xi)
        # {'GPU': 1, 'ZPU': 1, 'APU': 1}; {'GPU': 2, 'ZPU': 2, 'APU': 2}; {'GPU': 3, 'ZPU': 3, 'APU': 3}
        #           
    for key2readmanoeuvre in keys2readmanoeuvre:
        try:   
            if state2read4xi [key2readmanoeuvre]  == 3:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE III - GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                        print("(Step 3A/33) of manoeuvre2readimage4xi - STATE III - ", key2readmanoeuvre, " GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE " , time4xi())
                        #     
                info2image4xi [key2readmanoeuvre]  = None
                message2print = "{(Step 3A/70) try" + "; info2image4xi-try-by-manoeuvre2readimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                try: 
                    # ----------------------------------------------------------------------------------------------------------------
                    # GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE
                    # ----------------------------------------------------------------------------------------------------------------        
                    info2image4xi [key2readmanoeuvre]  = queue2readmanoeuvre4xi [key2readmanoeuvre].get()
                    
                    message2print = "{(Step 3B/33) got" + "; info2image4xi-got-by-manoeuvre2readimage4xi: " + str(info2image4xi [key2readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # 
                    if debug is True:
                        print("(Step 3B/33) of manoeuvre2readimage4xi - STATE III - ", key2readmanoeuvre, " GOT INFO2IMAGE4XI: " , info2image4xi [key2readmanoeuvre])
                        # ..//..//..//..//..//web//images//png//dragonxi.png    
                    
                    if info2image4xi [key2readmanoeuvre]  is None:
                        code2nack  = code2nack + '3Z1-'
                        ack2readinfo4xi [key2readmanoeuvre]  = False 
                    else:    
                        code2ack  = code2ack + '3C-'
                        ack2readinfo4xi [key2readmanoeuvre]  = True
                except:
                    message2print = "{(Step 3Z1/33) failed" + "; queue2readmanoeuvre4xi-failed-by-manoeuvre2readimage4xi: " + str(queue2readmanoeuvre4xi [key2readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '3Z1-'
                    
                message2readsend4xi [key2readmanoeuvre]  = ' '
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND CONTROL INFO ABOUT IMAGE OPERATION - EITHER ACK OR NACK  
                    # ----------------------------------------------------------------------------------------------------------------         
                    if ack2readinfo4xi [key2readmanoeuvre]  is True:
                        message2readsend4xi [key2readmanoeuvre]  = '<ack4xi>ack2imageinfo4xi</ack4xi>'
                    else:
                        message2readsend4xi [key2readmanoeuvre]  = '<nack4xi>nack2imageinfo4xi</nack4xi>'
                    message2print = "{(Step 4B/33) set" + "; message2readsend4xi-set-by-manoeuvre2readimage4xi to: " + str(message2readsend4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <ack4xi>ack2imageinfo4xi</ack4xi>       
                except:
                    message2print = "{(Step 4Z1/33) failed" + "; message2readsend4xi-failed-by-manoeuvre2readimage4xi: " + str(message2readsend4xi [key2readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    
                    code2nack  = code2nack + '4Z1-'    
                try:                
                    message2print = "{(Step 4C/70) using" + "; publisherchannel2readmanoeuvre4xi-calling-by-manoeuvre2readimage4xi: " + str(publisherchannel2readmanoeuvre4xi [key2readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    # <read-write PipeConnection, handle 412>
                    message2print = "{{(Step 4D/70) passing" + "; message2readsend4xi-passing-to-send-by-manoeuvre2readimage4xi: " + str(message2readsend4xi [key2readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    #              
                except:
                    message2print = "{(Step 4Z1/33) failed" + "; message2readsend4xi-failed-by-manoeuvre2readimage4xi: " + str(message2readsend4xi [key2readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '4Z2-'                
                try:    
                    publisherchannel2readmanoeuvre4xi [key2readmanoeuvre].send(message2readsend4xi [key2readmanoeuvre] )
                    
                    message2print = "{(Step 4E/33) sent" + "; message2readsend4xi-sent-by-manoeuvre2readimage4xi: " + str(message2readsend4xi [key2readmanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    # <ack4xi>ack2imageinfo4xi</ack4xi>            
                    code2ack  = code2ack + '4E-'
                    
                    if debug is True:
                        print("(Step 4EB/33) of manoeuvre2readimage4xi - STATE III - ", key2readmanoeuvre, " SENT MESSAGE: " , message2readsend4xi [key2readmanoeuvre])
                        #    
                except:
                    message2print = "{(Step 4Z3/33) failed" + "; message2readsend4xi-failed-by-manoeuvre2readimage4xi: " + str(message2readsend4xi [key2readmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '4Z3-'                
            else:
                pass
        except:
            print("(Step 1/33) of manoeuvre2readimage4xi - STATE III - ", key2readmanoeuvre, " *** FAILED *** " , time4xi())
            
    # ==============================================================================================================
    # PREPARE RETURN - DICTIONARY LEVEL
    # ==============================================================================================================        
    if debug is True:
        try:
            print("(Step 5A/33) of manoeuvre2readimage4xi - TRYING TO DEBUG PREPARING OF RETURN AT STATE: " , state2read4xi)
            # {'GPU': 1, 'ZPU': 1, 'APU': 1} 
            
            print("(Step 5B/33) of manoeuvre2readimage4xi - response2manouvre4read: " , response2manouvre4read)
            # {}
            
            print("(Step 5C/33) of manoeuvre2readimage4xi - ack2readinfo4xi: " , ack2readinfo4xi)
            # {'GPU': False, 'ZPU': False, 'APU': False}
            
            print("(Step 5D/33) of manoeuvre2readimage4xi - message2readget4xi: ", message2readget4xi)
            # {'GPU': '<default4xi>default2read4xi</default4xi>', 'ZPU': '<default4xi>default2read4xi</default4xi>', 'APU': '<default4xi>default2read4xi</default4xi>'}
            
            print("(Step 5E/33) of manoeuvre2readimage4xi - message2readput4xi: " , message2readput4xi)
            # {'GPU': '<default4xi>default2read4xi</default4xi>', 'ZPU': '<default4xi>default2read4xi</default4xi>', 'APU': '<default4xi>default2read4xi</default4xi>'}
            
            print("(Step 5F/33) of manoeuvre2readimage4xi - message2readreceive4xi: " , message2readreceive4xi)
            # {'GPU': '<copy4xi>copy2read4xi</copy4xi>', 'ZPU': '<copy4xi>copy2read4xi</copy4xi>', 'APU': '<copy4xi>copy2read4xi</copy4xi>'}
            
            print("(Step 5G/33) of manoeuvre2readimage4xi - message2readsend4xi: " , message2readsend4xi)
            # {'GPU': '<roger4xi>roger2read4xi</roger4xi>', 'ZPU': '<roger4xi>roger2read4xi</roger4xi>', 'APU': '<roger4xi>roger2read4xi</roger4xi>'}
            
            
        except:
            print("(Step 5Z1/33) of manoeuvre2readimage4xi *** FAILED TO PREPARE RETURN WITH STATE: " , state2read4xi)
    
    print("(Step 5B/33) of manoeuvre2readimage4xi - TRYING TO PREPARING OF RETURN AT STATE: " , state2read4xi)    
    try:        
        response2manouvre4read ['ACK2INFO4XI']        = ack2readinfo4xi 
        response2manouvre4read ['MESSAGE2GET4XI']     = message2readget4xi
        response2manouvre4read ['MESSAGE2PUT4XI']     = message2readput4xi
        response2manouvre4read ['MESSAGE2RECEIVE4XI'] = message2readreceive4xi
        response2manouvre4read ['MESSAGE2SEND4XI']    = message2readsend4xi
        response2manouvre4read ['STATE2MANOEUVRE4XI'] = state2read4xi
    except:
        print("(Step 5Z2/33) of manoeuvre2readimage4xi *** FAILED IN PREPARING RETURN KEY2READMANOEUVRE AT STATE: " , state2read4xi)   
                             
    message2print = "{(Step 33/33) returning" + "; response2manouvre4read-returning-by-manoeuvre2readimage4xi: " + str(response2manouvre4read) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             


    if debug is True:
        print("(Step 33/33) of manoeuvre2readimage4xi - RETURNING  WITH STATE: " , state2read4xi, " RESPONSE2MANOUVRE4READ " , response2manouvre4read)
        #1 
        # {'GPU': 1, 'ZPU': 1, 'APU': 1} RESPONSE2MANOUVRE4READ  
        #   {'MESSAGE2RECEIVE4XI': {'GPU': '<copy4xi>copy2read4xi</copy4xi>', 'ZPU': '<copy4xi>copy2read4xi</copy4xi>', 'APU': '<copy4xi>copy2read4xi</copy4xi>'}, 
        #    'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False}, 
        #    'MESSAGE2GET4XI': {'GPU': '<default4xi>default2read4xi</default4xi>', 'ZPU': '<default4xi>default2read4xi</default4xi>', 'APU': '<default4xi>default2read4xi</default4xi>'}, 
        #    'STATE2MANOEUVRE4XI': {'GPU': 1, 'ZPU': 1, 'APU': 1}, 
        #    'MESSAGE2SEND4XI': {'GPU': '<roger4xi>roger2read4xi</roger4xi>', 'ZPU': '<roger4xi>roger2read4xi</roger4xi>', 'APU': '<roger4xi>roger2read4xi</roger4xi>'}, 
        #    'MESSAGE2PUT4XI': {'GPU': '<default4xi>default2read4xi</default4xi>', 'ZPU': '<default4xi>default2read4xi</default4xi>', 'APU': '<default4xi>default2read4xi</default4xi>'}}
 
        #2 {'GPU': 2, 'ZPU': 2, 'APU': 2}  RESPONSE2MANOUVRE4READ  
        #   {'MESSAGE2RECEIVE4XI': {'GPU': '<ready4xi>ready2read4xi</ready4xi>', 'ZPU': '<ready4xi>ready2read4xi</ready4xi>', 'APU': '<ready4xi>ready2read4xi</ready4xi>'}, 
        #    'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False}, 
        #    'MESSAGE2GET4XI': {'GPU': '<default4xi>default2read4xi</default4xi>', 'ZPU': '<default4xi>default2read4xi</default4xi>', 'APU': '<default4xi>default2read4xi</default4xi>'}, 
        #    'STATE2MANOEUVRE4XI': {'GPU': 2, 'ZPU': 2, 'APU': 2}, 
        #    'MESSAGE2SEND4XI': {'GPU': '<ready4xi>ready2read4xi</ready4xi>', 'ZPU': '<ready4xi>ready2read4xi</ready4xi>', 'APU': '<ready4xi>ready2read4xi</ready4xi>'}, 
        #    'MESSAGE2PUT4XI': {'GPU': '<default4xi>default2read4xi</default4xi>', 'ZPU': '<default4xi>default2read4xi</default4xi>', 'APU': '<default4xi>default2read4xi</default4xi>'}}
 
        #3 {'GPU': 3, 'ZPU': 3, 'APU': 3}  RESPONSE2MANOUVRE4READ 
        #   {'MESSAGE2RECEIVE4XI': {'GPU': '<ready4xi>ready2read4xi</ready4xi>', 'ZPU': '<ready4xi>ready2read4xi</ready4xi>', 'APU': '<ready4xi>ready2read4xi</ready4xi>'},
        #    'ACK2INFO4XI': {'GPU': True, 'ZPU': True, 'APU': True}, 
        #    'MESSAGE2GET4XI': {'GPU': '<default4xi>default2read4xi</default4xi>', 'ZPU': '<default4xi>default2read4xi</default4xi>', 'APU': '<default4xi>default2read4xi</default4xi>'}, 
        #    'STATE2MANOEUVRE4XI': {'GPU': 3, 'ZPU': 3, 'APU': 3}, 
        #    'MESSAGE2SEND4XI': {'GPU': '<ack4xi>ack2imageinfo4xi</ack4xi>', 'ZPU': '<ack4xi>ack2imageinfo4xi</ack4xi>', 'APU': '<ack4xi>ack2imageinfo4xi</ack4xi>'}, 
        #    'MESSAGE2PUT4XI': {'GPU': '<default4xi>default2read4xi</default4xi>', 'ZPU': '<default4xi>default2read4xi</default4xi>', 'APU': '<default4xi>default2read4xi</default4xi>'}}

        #0
        #   {'GPU': 0, 'ZPU': 0, 'APU': 0} RESPONSE2MANOUVRE4READ
        #     {'MESSAGE2RECEIVE4XI': {'GPU': '<default4xi>default2read4xi</default4xi>', 'ZPU': '<default4xi>default2read4xi</default4xi>', 'APU': '<default4xi>default2read4xi</default4xi>'}, 
        #      'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False},
        #      'MESSAGE2GET4XI': {'GPU': '<default4xi>default2read4xi</default4xi>', 'ZPU': '<default4xi>default2read4xi</default4xi>', 'APU': '<default4xi>default2read4xi</default4xi>'}, 
        #      'STATE2MANOEUVRE4XI': {'GPU': 0, 'ZPU': 0, 'APU': 0}, 
        #      'MESSAGE2SEND4XI': {'GPU': '<default4xi>default2read4xi</default4xi>', 'ZPU': '<default4xi>default2read4xi</default4xi>', 'APU': '<default4xi>default2read4xi</default4xi>'}, 
        #      'MESSAGE2PUT4XI': {'GPU': '<default4xi>default2read4xi</default4xi>', 'ZPU': '<default4xi>default2read4xi</default4xi>', 'APU': '<default4xi>default2read4xi</default4xi>'}}

    return response2manouvre4read           
          
#</function4xi>


# -----------------------------------------------------------------------------------------------------------------------
#<function4xi function = "manoeuvre2writeimage4xi" usage = "
#   if ack2simulate4xi is True:
#       print("(Step 18C/700) OF IMAGE2D4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2READIMAGE4XI ", time4xi()) 
#       response2manoeuvre4write = {}
#       try:
#          # -----------------------------------------------------------------------------------------
#          # NOTE: DICTIONARY PARAMETERS MUST BE GIVEN TO VIRTUAL PROCESSING UNIT XI FUNCTION !
#          # -----------------------------------------------------------------------------------------
#          response2manoeuvre4write = manoeuvre2writeimage4xi(queue2write4xi, channel2writeconsume4xi, channel2writepublish4xi)
#          print("(Step 18D/700) OF IMAGE2D4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2READIMAGE4XI ", manoeuvre2writeimage4xi)
#          # 
#       except:
#           print("(Step 18Z/700) OF IMAGE2D4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2READIMAGE4XI ", time4xi())     
#   else:
#       pass # trust activated thwrite    
#">

# ----------------------------------------------------------------------------------------------------------------------- 
def manoeuvre2writeimage4xi(queue2writemanoeuvre4xi, consumerchannel2writemanoeuvre4xi, publisherchannel2writemanoeuvre4xi):
    '''
    manoeuvres write control and command
    '''
    # 
        
    # ---------------------------------------------------------------------------------------------
    # GLOBAL DICTIONARIES TO HANDLE PROCESSING UNITS
    # ---------------------------------------------------------------------------------------------
    global state2write4xi                                                                                           
    global max2writestate4xi                                                                                        
    global ack2writeinfo4xi                                                                                         
    global message2writeget4xi                                 
    global message2writeput4xi
    global message2writereceive4xi
    global message2writesend4xi
    
    global mission2write                                                          
    
    global image2d4xi  
    global info2image4xi  
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    debug = True
    try:
        if debug is True:
            print("(Step 0D1/33) of manoeuvre2writeimage4xi - STARTED " , time4xi())
            # 
            print("(Step 0D2/33) of manoeuvre2writeimage4xi - PASSED QUEUE2READMANOEUVRE4XI: " , queue2writemanoeuvre4xi)
            # {'GPU': <queue4xi.Queue4Xi object at 0x0000000005F6A5F8>, 'ZPU': <queue4xi.Queue4Xi object at 0x0000000005F6A710>, 'APU': <queue4xi.Queue4Xi object at 0x0000000005F63828>}
            # {'GPU': <queue4xi.Queue4Xi object at 0x0000000005F6A5F8>, 'ZPU': <queue4xi.Queue4Xi object at 0x0000000005F6A710>, 'APU': <queue4xi.Queue4Xi object at 0x0000000005F63828>}
    
            print("(Step 0D3/33) of manoeuvre2writeimage4xi - PASSED CONSUMERCHANNEL2READMANOEUVRE4XI: " , consumerchannel2writemanoeuvre4xi)
            # {'GPU': <read-write PipeConnection, handle 6716>, 'ZPU': <read-write PipeConnection, handle 6748>, 'APU': <read-write PipeConnection, handle 6684>}
            # 
           
            print("(Step 0D4/33) of manoeuvre2writeimage4xi - PASSED PUBLISHERCHANNEL2READMANOEUVRE4XI: " , publisherchannel2writemanoeuvre4xi) 
            # {'GPU': <read-write PipeConnection, handle 6720>, 'ZPU': <read-write PipeConnection, handle 6752>, 'APU': <read-write PipeConnection, handle 6688>}
            # {'GPU': <read-write PipeConnection, handle 6720>, 'ZPU': <read-write PipeConnection, handle 6752>, 'APU': <read-write PipeConnection, handle 6688>}
    
            print("(Step 0D5/33) of manoeuvre2writeimage4xi - USING STATE2READ4XI: " , state2write4xi) 
            # {}; 
            
            
        keys2writemanoeuvre = queue2writemanoeuvre4xi.keys()
        if debug is True:
            print("{(Step 0/33) of manoeuvre2writeimage4xi - SET KEYS2READMANOEUVRE TO: ", keys2writemanoeuvre) 
            # dict_keys(['GPU', 'ZPU', 'APU'])
            
                  
        response2manouvre4write = {}
    except:
        print("(Step 0Z1/33) of manoeuvre2writeimage4xi *** FAILED IN START ***  " , time4xi())
    
    # -----------------------------------------------------------------------------------------
    # (Step 0/33) PARAMETERS ARE DICTIONARIES FOR XI            
    # -----------------------------------------------------------------------------------------          
    try:
        class2print  = "manoeuvre2writeimage4xi" 
        method2print = "manoeuvre2writeimage4xi" 
    
        code2ack  = ' '
        code2nack = ' '
        
        message2print = "{(Step 0A/33) started" + "; manoeuvre2writeimage4xi-started: " + str(manoeuvre2writeimage4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                                     #  
        # 
        
        message2print = "{(Step 0B/33) passed" + "; queue2writemanoeuvre4xi-to-manoeuvre2writeimage4xi: " + str(queue2writemanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        # 
        
        message2print = "{(Step 0C/33) passed" + "; consumerchannel2writemanoeuvre4xi-to-manoeuvre2writeimage4xi: " + str(consumerchannel2writemanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        # 
        
        message2print = "{(Step 0D/33) passed" + "; publisherchannel2writemanoeuvre4xi-to-manoeuvre2writeimage4xi: " + str(publisherchannel2writemanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        #   
        
        code2ack  = code2ack + '0D-' 
    except:
        print("(Step 0Z2/33) of manoeuvre2writeimage4xi *** FAILED IN START ***  " , time4xi())
        
    # ==============================================================================================================
    # MISSION
    # ==============================================================================================================        
    if debug is True:
        print("{(Step M0/33) of manoeuvre2writeimage4xi - CHECKING MISSION AT STATE2READ4XI: " , state2write4xi) 
        #
        
         
    try:
        if mission2write == "NACK":
            mission2write = "ACK"
            print("(Step M1/33) of manoeuvre2writeimage4xi - SET MISSION2READ TO :  " , mission2write)       
        else:
            mission2write = "ACK"
            print("(Step M2/33) of manoeuvre2writeimage4xi - USING MISSION2READ:  " , mission2write)
            # 
        if state2write4xi == {}:    
            for key2writemanoeuvre in keys2writemanoeuvre:
                #----------------------------------------------------------------------------------------------------------------------
                # STATE 0
                # ---------------------------------------------------------------------------------------------------------------------     
                state2write4xi [key2writemanoeuvre]   = 0
                message2print = "{(Step 0Z1/33) initialized" + "; state2write4xi-initialized-by-manoeuvre2writeimage4xi to: " + str(state2write4xi [key2writemanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                                    
                ack2writeinfo4xi [key2writemanoeuvre] = False
                message2print = "{(Step 0Z2/33) initialized" + "; ack2writeinfo4xi-initialized-by-manoeuvre2writeimage4xi to: " + str(ack2writeinfo4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                    
                message2writeget4xi [key2writemanoeuvre] = '<default4xi>default2write4xi</default4xi>'
                message2print = "{(Step 0Z3/33) initialized" + "; message2writeget4xi-initialized-by-manoeuvre2writeimage4xi to: " + str(message2writeget4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                    
                message2writeput4xi [key2writemanoeuvre]  = '<default4xi>default2write4xi</default4xi>'
                message2print = "{(Step 0Z4/33) initialized" + "; message2writeput4xi-initialized-by-manoeuvre2writeimage4xi to: " + str(message2writeput4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2writereceive4xi [key2writemanoeuvre]  = '<default4xi>default2write4xi</default4xi>'
                message2print = "{(Step 0Z5/33) initialized" + "; message2writereceive4xi-initialized-by-manoeuvre2writeimage4xi to: " + str(message2writereceive4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2writesend4xi [key2writemanoeuvre] = '<default4xi>default2write4xi</default4xi>'
                message2print = "{(Step 0Z6/33) initialized" + "; message2writesend4xi-initialized-by-manoeuvre2writeimage4xi to: " + str(message2writesend4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                #
                
                max2writestate4xi [key2writemanoeuvre] = 3
                message2print = "{(Step 0Z7/33) initialized" + ";  max2writestate4xi-initialized-by-manoeuvre2writeimage4xi to: " + str( max2writestate4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #    
        else:
            pass                             
    except:
        if debug is True:
            print("{(Step 0Z0/33) of manoeuvre2writeimage4xi  EXCEPTION: ", time4xi()) 
            mission2write = "ACK" 
            print("(Step M3/33) of manoeuvre2writeimage4xi  EXCEPTIONAL MISSION2WRITE:  " , mission2write) 
            # 
        if state2write4xi == {}:                 
            for key2writemanoeuvre in keys2writemanoeuvre:
                # ------------------------------------------------------------------------------------------------------------------------
                # EXCEPTIONAL STATE 0
                # ------------------------------------------------------------------------------------------------------------------------     
                state2write4xi [key2writemanoeuvre]   = 0
                message2print = "{(Step 0Z1/33) initialized" + "; state2write4xi-initialized-by-manoeuvre2writeimage4xi to: " + str(state2write4xi [key2writemanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                    
                ack2writeinfo4xi [key2writemanoeuvre] = False
                message2print = "{(Step 0Z2/33) initialized" + "; ack2writeinfo4xi-initialized-by-manoeuvre2writeimage4xi to: " + str(ack2writeinfo4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                    
                message2writeget4xi [key2writemanoeuvre] = '<default4xi>default2write4xi</default4xi>'
                message2print = "{(Step 0Z3/33) initialized" + "; message2writeget4xi-initialized-by-manoeuvre2writeimage4xi to: " + str(message2writeget4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                    
                message2writeput4xi [key2writemanoeuvre]  = '<default4xi>default2write4xi</default4xi>'
                message2print = "{(Step 0Z4/33) initialized" + "; message2writeput4xi-initialized-by-manoeuvre2writeimage4xi to: " + str(message2writeput4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2writereceive4xi [key2writemanoeuvre]  = '<default4xi>default2write4xi</default4xi>'
                message2print = "{(Step 0Z5/33) initialized" + "; message2writereceive4xi-initialized-by-manoeuvre2writeimage4xi to: " + str(message2writereceive4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2writesend4xi [key2writemanoeuvre] = '<default4xi>default2write4xi</default4xi>'
                message2print = "{(Step 0Z6/33) initialized" + "; message2writesend4xi-initialized-by-manoeuvre2writeimage4xi to: " + str(message2writesend4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                #

                max2writestate4xi [key2writemanoeuvre] = 3
                message2print = "{(Step 0Z7/33) initialized" + ";  max2writestate4xi-initialized-by-manoeuvre2writeimage4xi to: " + str( max2writestate4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #
       
    # ==============================================================================================================
    # NEXT PHASE PREPARING 
    # ==============================================================================================================                                             
    if debug is True:
        print("{(Step M0/33) of manoeuvre2writeimage4xi - NEXT PHASE PREPARING AT STATE2READ4XI: " , state2write4xi) 
        # 
          
    for key2writemanoeuvre in keys2writemanoeuvre:
        try:
            # ------------------------------------------------------------------------------------------------------------------------
            # UPDATE 
            # ------------------------------------------------------------------------------------------------------------------------      
            state2write4xi [key2writemanoeuvre]  = state2write4xi [key2writemanoeuvre]  + 1                                                                   
            message2print = "{(Step 0H/33) added" + "; state2write4xi-added-by-manoeuvre2writeimage4xi: " + str(state2write4xi [key2writemanoeuvre] ) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            if debug is True:
                print("(Step 0h/33) of manoeuvre2writeimage4xi TO: ", key2writemanoeuvre, " STATE2READ4XI-ADDED TO: " , state2write4xi [key2writemanoeuvre]) 
                #
                
                 
            if state2write4xi [key2writemanoeuvre] > max2writestate4xi [key2writemanoeuvre]:
                state2write4xi [key2writemanoeuvre]  = 0
                message2print = "{(Step 0I/33) set" + "; state2write4xi-set-by-manoeuvre2writeimage4xi to: " + str(state2write4xi [key2writemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                
                if debug is True:
                    print("(Step 0I/33) of manoeuvre2writeimage4xi TO: ", key2writemanoeuvre, " STATE2READ4XI-ZEROED TO: " , state2write4xi [key2writemanoeuvre]) 
                    # 
                    
                ack2writeinfo4xi [key2writemanoeuvre] = False
                message2print = "{(Step 0J/33) set" + "; ack2writeinfo4xi-set-by-manoeuvre2writeimage4xi to: " + str(ack2writeinfo4xi [key2writemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                
                message2writeget4xi [key2writemanoeuvre] = '<default4xi>default2write4xi</default4xi>'
                message2print = "{(Step 0K/33) set" + "; message2writeget4xi-set-by-manoeuvre2writeimage4xi to: " + str(message2writeget4xi [key2writemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                
                message2writeput4xi [key2writemanoeuvre]  = '<default4xi>default2write4xi</default4xi>'
                message2print = "{(Step 0L/33) set" + "; message2writeput4xi-set-by-manoeuvre2writeimage4xi to: " + str(message2writeput4xi [key2writemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                
                message2writereceive4xi [key2writemanoeuvre] = '<default4xi>default2write4xi</default4xi>'
                message2print = "{(Step 0M/33) set" + "; message2writereceive4xi-set-by-manoeuvre2writeimage4xi to: " + str(message2writereceive4xi [key2writemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                
                message2writesend4xi [key2writemanoeuvre]    = '<default4xi>default2write4xi</default4xi>'
                message2print = "{(Step 0N/33) set" + "; message2writesend4xi-set-by-manoeuvre2writeimage4xi to: " + str(message2writesend4xi [key2writemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                #

                max2writestate4xi [key2writemanoeuvre] = 3
                message2print = "{(Step 0O/33) initialized" + ";  max2writestate4xi-set-by-manoeuvre2writeimage4xi to: " + str( max2writestate4xi [key2writemanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #
            else:
                pass
            if debug is True:
                print("(Step 1A/33) of manoeuvre2writeimage4xi FOR : ", key2writemanoeuvre, " CONTINUING WITH STATE2READ4XI: " , state2write4xi [key2writemanoeuvre])
                # 
                        
        except:
            print("(Step 0z1/33) of manoeuvre2writeimage4xi *** FAILED UPDATING *** " , time4xi())
            print("key2writemanoeuvre: " , key2writemanoeuvre)
            # 
            print("state2write4xi: " , state2write4xi)
            #
            print("ack2writeinfo4xi: " , ack2writeinfo4xi)
            #
            print("message2writeget4xi: " , message2writeget4xi)
            #
            print("message2writeput4xi: " , message2writeput4xi)
            #
            print("message2writereceive4xi: " , message2writereceive4xi)
            #
            print("message2writesend4xi: " , message2writesend4xi)
            #

            print("max2writestate4xi: " , max2writestate4xi)
            #
               
    
    # ==============================================================================================================
    # STATE I
    # ==============================================================================================================        
    if debug is True:
        print("(Step I/33) of manoeuvre2writeimage4xi: CONSIDERING STATE I: " , state2write4xi)
        # {'GPU': 1, 'ZPU': 1, 'APU': 1} 
        
           
    for key2writemanoeuvre in keys2writemanoeuvre:                     
        # ------------------------------------------------------------------------------------------------------------------------
        # STATE I - RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND COPY OR NEGATIVE BACK 
        # ------------------------------------------------------------------------------------------------------------------------
        try:
            if state2write4xi [key2writemanoeuvre]  == 1:
                if debug is True:
                    print("(Step 1/33) of manoeuvre2writeimage4xi: ", key2writemanoeuvre, " - STATE I - TRY TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
                    
                message2print = "{(Step 1A/70) try" + "; receive-try-by-manoeuvre2writeimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                message2writereceive4xi [key2writemanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message2writereceive4xi [key2writemanoeuvre]  = consumerchannel2writemanoeuvre4xi [key2writemanoeuvre].recv()
                    message2print = "{(Step 1B/33) received" + "; message2writereceive4xi-received-by-manoeuvre2writeimage4xi: " + str(message2writereceive4xi [key2writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #
                    
                    if debug is True:
                        print("(Step 1B1/33) of manoeuvre2writeimage4xi: ", key2writemanoeuvre, " - STATE I - RECEIVED MESSAGE VIA PIPE: " , message2writereceive4xi [key2writemanoeuvre])
                        # APU  - STATE I - RECEIVED MESSAGE VIA PIPE:  <copy4xi>copy2write4xi</copy4xi>
                         
                    if message2writereceive4xi [key2writemanoeuvre]  == '<copy4xi>copy2write4xi</copy4xi>':
                        message2writesend4xi [key2writemanoeuvre]  = '<copy4xi>copy2write4xi</copy4xi>'
                        if debug is True:
                            print("FIRST FROM ", key2writemanoeuvre, " - STATE I - RECEIVED FROM MESSAGE2WRITERECEIVE4XI: " , message2writereceive4xi [key2writemanoeuvre])
                            # FROM  GPU  - STATE I - RECEIVED FROM MESSAGE2WRITERECEIVE4XI:  <copy4xi>copy2write4xi</copy4xi>
                            
                            print("FIRST TO ", key2writemanoeuvre, " - STATE I - SET MESSAGE2WRITESEND4XI TO: " , message2writesend4xi [key2writemanoeuvre])
                            # TO  GPU  - STATE I - SET MESSAGE2WRITESEND4XI TO:  <roger4xi>roger2write4xi</roger4xi>
                    else:
                        message2writesend4xi [key2writemanoeuvre]  = '<negative4xi>negative2write4xi</<negative4xi>'
                        if debug is True:
                            print("SECOND FROM ", key2writemanoeuvre, " - STATE I - RECEIVED FROM MESSAGE2WRITERECEIVE4XI: " , message2writereceive4xi [key2writemanoeuvre])
                            #
                            
                            print("SECOND TO ", key2writemanoeuvre, " - STATE I - SET MESSAGE2WRITESEND4Xi TO: " , message2writesend4xi [key2writemanoeuvre])
                            # 
                            
                        
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                

                    publisherchannel2writemanoeuvre4xi [key2writemanoeuvre].send(message2writesend4xi [key2writemanoeuvre])
                    
                    message2print = "{(Step 1C/33) sent" + "; message2writesend4xi-sent-by-manoeuvre2writeimage4xi: " + str(message2writesend4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    # 
                    if debug is True:
                        print("(Step 1C/33) of manoeuvre2writeimage4xi: ", key2writemanoeuvre, " - STATE I - SENT MESSAGE VIA PIPE: " , message2writesend4xi [key2writemanoeuvre])
                        # ZPU, GPU AND APU  - STATE I - SENT MESSAGE VIA PIPE:  <roger4xi>roger2write4xi</roger4xi>
                        
                    
                    code2ack  = code2ack + '1C-'
                except:
                    message2print = "{(Step 1Z/33) failed" + "; message2writereceive4xi-failed-by-manoeuvre2writeimage4xi: " + str(message2writereceive4xi [key2writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '1Z-' 
                    
                    print("(Step 1Z1/33) of manoeuvre2writeimage4xi: ", key2writemanoeuvre, " - STATE I *** FAILED TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
            else:
                pass
        except:
            print("(Step 1Z2/33) of manoeuvre2writeimage4xi: ", key2writemanoeuvre, " - STATE I *** FAILED *** " , time4xi())

    # ==============================================================================================================
    # STATE II
    # ==============================================================================================================        
    if debug is True:
        print("(Step II/33) of manoeuvre2writeimage4xi: CONSIDERING STATE II : " , state2write4xi)
        # {'GPU': 2, 'ZPU': 2, 'APU': 2}
        
                  
    for key2writemanoeuvre in keys2writemanoeuvre:        
        try:
            if state2write4xi [key2writemanoeuvre]  == 2:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE II - RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK 
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                    print("(Step 1/33) of manoeuvre2writeimage4xi - STATE II - ", key2writemanoeuvre, " TRYING TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #
                                 
                message2print = "{(Step 2A/70) try" + "; receive-try-by-manoeuvre2writeimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                message2writereceive4xi [key2writemanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE  
                    # ----------------------------------------------------------------------------------------------------------------         
                    message2writereceive4xi [key2writemanoeuvre]  = consumerchannel2writemanoeuvre4xi [key2writemanoeuvre].recv()
                    
                    message2print = "{(Step 2B/33) received" + "; message2writereceive4xi-received-by-manoeuvre2writeimage4xi: " + str(message2writereceive4xi [key2writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # 
                    if debug is True:
                        print("(Step 2B/33) of manoeuvre2writeimage4xi - STATE II - FROM ", key2writemanoeuvre, " RECEIVED " , message2writereceive4xi [key2writemanoeuvre] )
                        # FROM  GPU  RECEIVED  <ready4xi>ready2write4xi</ready4xi>
                        # FROM  ZPU  RECEIVED  <ready4xi>ready2write4xi</ready4xi>
                        # FROM  APU  RECEIVED  <ready4xi>ready2write4xi</ready4xi>  
           
                    if message2writereceive4xi [key2writemanoeuvre]  == '<ready4xi>ready2write4xi</ready4xi>':
                        message2writesend4xi [key2writemanoeuvre]  = '<ready4xi>ready2write4xi</ready4xi>'

                    else:
                        message2writesend4xi [key2writemanoeuvre]  = '<negative4xi>negative2write4xi</<negative4xi>'

                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                

                    publisherchannel2writemanoeuvre4xi [key2writemanoeuvre].send(message2writesend4xi [key2writemanoeuvre])
                    
                    message2print = "{(Step 2C/33) sent" + "; message2writesend4xi-sent-by-manoeuvre2writeimage4xi: " + str(message2writesend4xi [key2writemanoeuvre])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    # 
                    if debug is True:
                        print("(Step 2C/33) of manoeuvre2writeimage4xi - STATE II - TO ", key2writemanoeuvre, " SENT " , message2writereceive4xi [key2writemanoeuvre] )
                        #                   
                    
                    code2ack  = code2ack + '2C-'
                except:
                    message2print = "{(Step 2Z/33) failed" + "; message2writereceive4xi-failed-by-manoeuvre2writeimage4xi: " + str(message2writereceive4xi [key2writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '2Z-'
                    print("(Step 1/33) of manoeuvre2writeimage4xi - STATE II - ", key2writemanoeuvre, " *** FAILED TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #  
            else:
                pass        
        except:
            print("(Step 1/33) of manoeuvre2writeimage4xi - STATE II - ", key2writemanoeuvre, " *** FAILED *** " , time4xi())
        

    # ==============================================================================================================
    # STATE III
    # ==============================================================================================================        
    if debug is True:
        print("(Step III/33) of manoeuvre2writeimage4xi: CONSIDERING STATE III : " , state2write4xi)
        # 
            
    for key2writemanoeuvre in keys2writemanoeuvre:
        try:   
            if state2write4xi [key2writemanoeuvre]  == 3:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE III - GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                        print("(Step 3A/33) of manoeuvre2writeimage4xi - STATE III - ", key2writemanoeuvre, " GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE " , time4xi())
                        #     
                info2image4xi [key2writemanoeuvre]  = None
                message2print = "{(Step 3A/70) try" + "; info2image4xi-try-by-manoeuvre2writeimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                try: 
                    # ----------------------------------------------------------------------------------------------------------------
                    # GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE
                    # ----------------------------------------------------------------------------------------------------------------        
                    info2image4xi [key2writemanoeuvre]  = queue2writemanoeuvre4xi [key2writemanoeuvre].get()
                    
                    message2print = "{(Step 3B/33) got" + "; info2image4xi-got-by-manoeuvre2writeimage4xi: " + str(info2image4xi [key2writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # 
                    if debug is True:
                        print("(Step 3B/33) of manoeuvre2writeimage4xi - STATE III - ", key2writemanoeuvre, " GOT INFO2IMAGE4XI: " , info2image4xi [key2writemanoeuvre])
                        #  
                    
                    if info2image4xi [key2writemanoeuvre]  is None:
                        code2nack  = code2nack + '3Z1-'
                        ack2writeinfo4xi [key2writemanoeuvre]  = False 
                    else:    
                        code2ack  = code2ack + '3C-'
                        ack2writeinfo4xi [key2writemanoeuvre]  = True
                except:
                    message2print = "{(Step 3Z1/33) failed" + "; queue2writemanoeuvre4xi-failed-by-manoeuvre2writeimage4xi: " + str(queue2writemanoeuvre4xi [key2writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '3Z1-'
                    
                message2writesend4xi [key2writemanoeuvre]  = ' '

                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND CONTROL INFO ABOUT IMAGE OPERATION - EITHER ACK OR NACK  
                    # ----------------------------------------------------------------------------------------------------------------         
                    if ack2writeinfo4xi [key2writemanoeuvre] is True:
                        message2writesend4xi [key2writemanoeuvre]  = '<ack4xi>ack2imageinfo4xi</ack4xi>'

                    else:
                        message2writesend4xi [key2writemanoeuvre]  = '<nack4xi>nack2imageinfo4xi</nack4xi>'

                    message2print = "{(Step 4B/33) set" + "; message2writesend4xi-set-by-manoeuvre2writeimage4xi to: " + str(message2writesend4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #       
                except:

                    message2print = "{(Step 4Z1/33) failed" + "; message2writesend4xi-failed-by-manoeuvre2writeimage4xi: " + str(message2writesend4xi [key2writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    
                    code2nack  = code2nack + '4Z1-'    
                try:                
                    message2print = "{(Step 4C/70) using" + "; publisherchannel2writemanoeuvre4xi-calling-by-manoeuvre2writeimage4xi: " + str(publisherchannel2writemanoeuvre4xi [key2writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    # 
                    message2print = "{{(Step 4D/70) passing" + "; message2writesend4xi-passing-to-send-by-manoeuvre2writeimage4xi: " + str(message2writesend4xi [key2writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
       
                except:
                    message2print = "{(Step 4Z1/33) failed" + "; message2writesend4xi-failed-by-manoeuvre2writeimage4xi: " + str(message2writesend4xi [key2writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '4Z2-'                
                try:
    
                    publisherchannel2writemanoeuvre4xi [key2writemanoeuvre].send(message2writesend4xi [key2writemanoeuvre] )
                    
                    message2print = "{(Step 4E/33) sent" + "; message2writesend4xi-sent-by-manoeuvre2writeimage4xi: " + str(message2writesend4xi [key2writemanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    #            
                    code2ack  = code2ack + '4E-'
                    
                    if debug is True:
                        print("(Step 4EB/33) of manoeuvre2writeimage4xi - STATE III - ", key2writemanoeuvre, " SENT MESSAGE: " , message2writesend4xi [key2writemanoeuvre])
                        #    
                except:

                    message2print = "{(Step 4Z3/33) failed" + "; message2writesend4xi-failed-by-manoeuvre2writeimage4xi: " + str(message2writesend4xi [key2writemanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '4Z3-'                
            else:
                pass
        except:
            print("(Step 1/33) of manoeuvre2writeimage4xi - STATE III - ", key2writemanoeuvre, " *** FAILED *** " , time4xi())
            
    # ==============================================================================================================
    # PREPARE RETURN - DICTIONARY LEVEL
    # ==============================================================================================================        
    if debug is True:
        try:
            print("(Step 5A/33) of manoeuvre2writeimage4xi - TRYING TO DEBUG PREPARING OF RETURN AT STATE: " , state2write4xi)
            # {'GPU': 2, 'ZPU': 2, 'APU': 2}
            
            print("(Step 5B/33) of manoeuvre2writeimage4xi - response2manouvre4write: " , response2manouvre4write)
            # 
            
            print("(Step 5C/33) of manoeuvre2writeimage4xi - ack2writeinfo4xi: " , ack2writeinfo4xi)
            # 
            
            print("(Step 5D/33) of manoeuvre2writeimage4xi - message2writeget4xi: ", message2writeget4xi)
            # 
            
            print("(Step 5E/33) of manoeuvre2writeimage4xi - message2writeput4xi: " , message2writeput4xi)
            # 
            
            print("(Step 5F/33) of manoeuvre2writeimage4xi - message2writereceive4xi: " , message2writereceive4xi)
            # 

            
            print("(Step 5G/33) of manoeuvre2writeimage4xi - message2writesend4xi: " , message2writesend4xi)
            
            # 
            
            
        except:
            print("(Step 5Z1/33) of manoeuvre2writeimage4xi *** FAILED TO PREPARE RETURN WITH STATE: " , state2write4xi)
    
    print("(Step 5B/33) of manoeuvre2writeimage4xi - TRYING TO PREPARING OF RETURN AT STATE: " , state2write4xi)    
    try:        
        response2manouvre4write ['ACK2INFO4XI']        = ack2writeinfo4xi 
        response2manouvre4write ['MESSAGE2GET4XI']     = message2writeget4xi
        response2manouvre4write ['MESSAGE2PUT4XI']     = message2writeput4xi
        response2manouvre4write ['MESSAGE2RECEIVE4XI'] = message2writereceive4xi
        response2manouvre4write ['MESSAGE2SEND4XI']    = message2writesend4xi
        response2manouvre4write ['STATE2MANOEUVRE4XI'] = state2write4xi
    except:
        print("(Step 5Z2/33) of manoeuvre2writeimage4xi *** FAILED IN PREPARING RETURN KEY2READMANOEUVRE AT STATE: " , state2write4xi)   
                             
    message2print = "{(Step 33/33) returning" + "; response2manouvre4write-returning-by-manoeuvre2writeimage4xi: " + str(response2manouvre4write) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             


    if debug is True: 
        print("(Step 33/33) of manoeuvre2writeimage4xi - RETURNING  WITH STATE: " , state2write4xi, " RESPONSE2MANOUVRE4READ " , response2manouvre4write)
        #1 
        # {'GPU': 1, 'ZPU': 1, 'APU': 1}  RESPONSE2MANOUVRE4READ  
        #         {'MESSAGE2RECEIVE4XI': {'GPU': '<copy4xi>copy2write4xi</copy4xi>', 'ZPU': '<copy4xi>copy2write4xi</copy4xi>', 'APU': '<copy4xi>copy2write4xi</copy4xi>'}, 
        #          'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False}, 
        #          'MESSAGE2GET4XI': {'GPU': '<default4xi>default2write4xi</default4xi>', 'ZPU': '<default4xi>default2write4xi</default4xi>', 'APU': '<default4xi>default2write4xi</default4xi>'}, 
        #          'STATE2MANOEUVRE4XI': {'GPU': 1, 'ZPU': 1, 'APU': 1}, 
        #          'MESSAGE2SEND4XI': {'GPU': '<roger4xi>roger2write4xi</roger4xi>', 'ZPU': '<roger4xi>roger2write4xi</roger4xi>', 'APU': '<roger4xi>roger2write4xi</roger4xi>'}, 
        #          'MESSAGE2PUT4XI': {'GPU': '<default4xi>default2write4xi</default4xi>', 'ZPU': '<default4xi>default2write4xi</default4xi>', 'APU': '<default4xi>default2write4xi</default4xi>'}}
 
 
        #2 
        # {'GPU': 2, 'ZPU': 2, 'APU': 2}  RESPONSE2MANOUVRE4READ  {'MESSAGE2RECEIVE4XI': {'GPU': '<ready4xi>ready2write4xi</ready4xi>', 'ZPU': '<ready4xi>ready2write4xi</ready4xi>', 'APU': '<ready4xi>ready2write4xi</ready4xi>'},
        #          'ACK2INFO4XI': {'GPU': False, 'ZPU': False, 'APU': False},
        #          'MESSAGE2GET4XI': {'GPU': '<default4xi>default2write4xi</default4xi>', 'ZPU': '<default4xi>default2write4xi</default4xi>', 'APU': '<default4xi>default2write4xi</default4xi>'},
        #          'STATE2MANOEUVRE4XI': {'GPU': 2, 'ZPU': 2, 'APU': 2},
        #          'MESSAGE2SEND4XI': {'GPU': '<ready4xi>ready2write4xi</ready4xi>', 'ZPU': '<ready4xi>ready2write4xi</ready4xi>', 'APU': '<ready4xi>ready2write4xi</ready4xi>'},
        #          'MESSAGE2PUT4XI': {'GPU': '<default4xi>default2write4xi</default4xi>', 'ZPU': '<default4xi>default2write4xi</default4xi>', 'APU': '<default4xi>default2write4xi</default4xi>'}}

        #3  
        # {'GPU': 3, 'ZPU': 3, 'APU': 3}  RESPONSE2MANOUVRE4READ  {'MESSAGE2RECEIVE4XI': {'GPU': '<ready4xi>ready2write4xi</ready4xi>', 'ZPU': '<ready4xi>ready2write4xi</ready4xi>', 'APU': '<ready4xi>ready2write4xi</ready4xi>'},
        #          'ACK2INFO4XI': {'GPU': True, 'ZPU': True, 'APU': True},
        #          'MESSAGE2GET4XI': {'GPU': '<default4xi>default2write4xi</default4xi>', 'ZPU': '<default4xi>default2write4xi</default4xi>', 'APU': '<default4xi>default2write4xi</default4xi>'},
        #          'STATE2MANOEUVRE4XI': {'GPU': 3, 'ZPU': 3, 'APU': 3},
        #          'MESSAGE2SEND4XI': {'GPU': '<ack4xi>ack2imageinfo4xi</ack4xi>', 'ZPU': '<ack4xi>ack2imageinfo4xi</ack4xi>', 'APU': '<ack4xi>ack2imageinfo4xi</ack4xi>'},
        #          'MESSAGE2PUT4XI': {'GPU': '<default4xi>default2write4xi</default4xi>', 'ZPU': '<default4xi>default2write4xi</default4xi>', 'APU': '<default4xi>default2write4xi</default4xi>'}}
 

        #4
        #
        

    return response2manouvre4write           
          
#</function4xi>

# -----------------------------------------------------------------------------------------------------------------------
#<function4xi function = "manoeuvre2mapimage4xi" usage = "
#   if ack2simulate4xi is True:
#       print("(Step 18C/700) OF IMAGE2D4XI5TEST - TRYING TO PERFORM TARGET FUNCTION MANOEUVRE2READIMAGE4XI ", time4xi()) 
#       response2manoeuvre4map = {}
#       try:
#          # -----------------------------------------------------------------------------------------
#          # NOTE: DICTIONARY PARAMETERS MUST BE GIVEN TO VIRTUAL PROCESSING UNIT XI FUNCTION !
#          # -----------------------------------------------------------------------------------------
#          response2manoeuvre4map = manoeuvre2mapimage4xi(queue2map4xi, channel2mapconsume4xi, channel2mappublish4xi)
#          print("(Step 18D/700) OF IMAGE2D4XI5TEST - PERFORMED TARGET FUNCTION MANOEUVRE2READIMAGE4XI ", manoeuvre2mapimage4xi)
#          # 
#       except:
#           print("(Step 18Z/700) OF IMAGE2D4XI5TEST *** FAILED TO PERFORM TARGET FUNCTION MANOEUVRE2READIMAGE4XI ", time4xi())     
#   else:
#       pass # trust activated thmap    
#">

# ----------------------------------------------------------------------------------------------------------------------- 
def manoeuvre2mapimage4xi(queue2mapmanoeuvre4xi, consumerchannel2mapmanoeuvre4xi, publisherchannel2mapmanoeuvre4xi):
    '''
    manoeuvres map control and command
    '''
    # 
        
    # ---------------------------------------------------------------------------------------------
    # GLOBAL DICTIONARIES TO HANDLE PROCESSING UNITS
    # ---------------------------------------------------------------------------------------------
    global state2map4xi                                                                                           
    global max2mapstate4xi                                                                                        
    global ack2mapinfo4xi                                                                                         
    global message2mapget4xi                                 
    global message2mapput4xi
    global message2mapreceive4xi
    global message2mapsend4xi
    
    global mission2map                                                          
    
    global image2d4xi  
    global info2image4xi  
    
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    debug = True
    try:
        if debug is True:
            print("(Step 0D1/33) of manoeuvre2mapimage4xi - STARTED " , time4xi())
            # 
            print("(Step 0D2/33) of manoeuvre2mapimage4xi - PASSED QUEUE2READMANOEUVRE4XI: " , queue2mapmanoeuvre4xi)
            # 
    
            print("(Step 0D3/33) of manoeuvre2mapimage4xi - PASSED CONSUMERCHANNEL2READMANOEUVRE4XI: " , consumerchannel2mapmanoeuvre4xi)
            # 
           
            print("(Step 0D4/33) of manoeuvre2mapimage4xi - PASSED PUBLISHERCHANNEL2READMANOEUVRE4XI: " , publisherchannel2mapmanoeuvre4xi) 
            # 
    
            print("(Step 0D5/33) of manoeuvre2mapimage4xi - USING STATE2READ4XI: " , state2map4xi) 
            #
            
            
        keys2mapmanoeuvre = queue2mapmanoeuvre4xi.keys()
        if debug is True:
            print("{(Step 0/33) of manoeuvre2mapimage4xi - SET KEYS2READMANOEUVRE TO: ", keys2mapmanoeuvre) 
            #
            
                  
        response2manouvre4map = {}
    except:
        print("(Step 0Z1/33) of manoeuvre2mapimage4xi *** FAILED IN START ***  " , time4xi())
    
    # -----------------------------------------------------------------------------------------
    # (Step 0/33) PARAMETERS ARE DICTIONARIES FOR XI            
    # -----------------------------------------------------------------------------------------          
    try:
        class2print  = "manoeuvre2mapimage4xi" 
        method2print = "manoeuvre2mapimage4xi" 
    
        code2ack  = ' '
        code2nack = ' '
        
        message2print = "{(Step 0A/33) started" + "; manoeuvre2mapimage4xi-started: " + str(manoeuvre2mapimage4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                                     #  
        # 
        
        message2print = "{(Step 0B/33) passed" + "; queue2mapmanoeuvre4xi-to-manoeuvre2mapimage4xi: " + str(queue2mapmanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        # 
        
        message2print = "{(Step 0C/33) passed" + "; consumerchannel2mapmanoeuvre4xi-to-manoeuvre2mapimage4xi: " + str(consumerchannel2mapmanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        # 
        
        message2print = "{(Step 0D/33) passed" + "; publisherchannel2mapmanoeuvre4xi-to-manoeuvre2mapimage4xi: " + str(publisherchannel2mapmanoeuvre4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              
        #   
        
        code2ack  = code2ack + '0D-' 
    except:
        print("(Step 0Z2/33) of manoeuvre2mapimage4xi *** FAILED IN START ***  " , time4xi())
        
    # ==============================================================================================================
    # MISSION
    # ==============================================================================================================        
    if debug is True:
        print("{(Step M0/33) of manoeuvre2mapimage4xi - CHECKING MISSION AT STATE2READ4XI: " , state2map4xi) 
        #
        
         
    try:
        if mission2map == "NACK":
            mission2map = "ACK"
            print("(Step M1/33) of manoeuvre2mapimage4xi - SET MISSION2READ TO :  " , mission2map)       
        else:
            mission2map = "ACK"
            print("(Step M2/33) of manoeuvre2mapimage4xi - USING MISSION2READ:  " , mission2map)
            # 
        if state2map4xi == {}:    
            for key2mapmanoeuvre in keys2mapmanoeuvre:
                #----------------------------------------------------------------------------------------------------------------------
                # STATE 0
                # ---------------------------------------------------------------------------------------------------------------------     
                state2map4xi [key2mapmanoeuvre]   = 0
                message2print = "{(Step 0Z1/33) initialized" + "; state2map4xi-initialized-by-manoeuvre2mapimage4xi to: " + str(state2map4xi [key2mapmanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                                    
                ack2mapinfo4xi [key2mapmanoeuvre] = False
                message2print = "{(Step 0Z2/33) initialized" + "; ack2mapinfo4xi-initialized-by-manoeuvre2mapimage4xi to: " + str(ack2mapinfo4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                    
                message2mapget4xi [key2mapmanoeuvre] = '<default4xi>default2map4xi</default4xi>'
                message2print = "{(Step 0Z3/33) initialized" + "; message2mapget4xi-initialized-by-manoeuvre2mapimage4xi to: " + str(message2mapget4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                    
                message2mapput4xi [key2mapmanoeuvre]  = '<default4xi>default2map4xi</default4xi>'
                message2print = "{(Step 0Z4/33) initialized" + "; message2mapput4xi-initialized-by-manoeuvre2mapimage4xi to: " + str(message2mapput4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2mapreceive4xi [key2mapmanoeuvre]  = '<default4xi>default2map4xi</default4xi>'
                message2print = "{(Step 0Z5/33) initialized" + "; message2mapreceive4xi-initialized-by-manoeuvre2mapimage4xi to: " + str(message2mapreceive4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2mapsend4xi [key2mapmanoeuvre] = '<default4xi>default2map4xi</default4xi>'
                message2print = "{(Step 0Z6/33) initialized" + "; message2mapsend4xi-initialized-by-manoeuvre2mapimage4xi to: " + str(message2mapsend4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                max2mapstate4xi [key2mapmanoeuvre] = 3
                message2print = "{(Step 0Z7/33) initialized" + ";  max2mapstate4xi-initialized-by-manoeuvre2mapimage4xi to: " + str( max2mapstate4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #    
        else:
            pass                             
    except:
        if debug is True:
            print("{(Step 0Z0/33) of manoeuvre2mapimage4xi  EXCEPTION: ", time4xi()) 
            mission2map = "ACK" 
            print("(Step M3/33) of manoeuvre2mapimage4xi  EXCEPTIONAL MISSION2MAP:  " , mission2map) 
            # 
        if state2map4xi == {}:                 
            for key2mapmanoeuvre in keys2mapmanoeuvre:
                # ------------------------------------------------------------------------------------------------------------------------
                # EXCEPTIONAL STATE 0
                # ------------------------------------------------------------------------------------------------------------------------     
                state2map4xi [key2mapmanoeuvre]   = 0
                message2print = "{(Step 0Z1/33) initialized" + "; state2map4xi-initialized-by-manoeuvre2mapimage4xi to: " + str(state2map4xi [key2mapmanoeuvre]  )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                    
                ack2mapinfo4xi [key2mapmanoeuvre] = False
                message2print = "{(Step 0Z2/33) initialized" + "; ack2mapinfo4xi-initialized-by-manoeuvre2mapimage4xi to: " + str(ack2mapinfo4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                    
                message2mapget4xi [key2mapmanoeuvre] = '<default4xi>default2map4xi</default4xi>'
                message2print = "{(Step 0Z3/33) initialized" + "; message2mapget4xi-initialized-by-manoeuvre2mapimage4xi to: " + str(message2mapget4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                    
                message2mapput4xi [key2mapmanoeuvre]  = '<default4xi>default2map4xi</default4xi>'
                message2print = "{(Step 0Z4/33) initialized" + "; message2mapput4xi-initialized-by-manoeuvre2mapimage4xi to: " + str(message2mapput4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2mapreceive4xi [key2mapmanoeuvre]  = '<default4xi>default2map4xi</default4xi>'
                message2print = "{(Step 0Z5/33) initialized" + "; message2mapreceive4xi-initialized-by-manoeuvre2mapimage4xi to: " + str(message2mapreceive4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                message2mapsend4xi [key2mapmanoeuvre] = '<default4xi>default2map4xi</default4xi>'
                message2print = "{(Step 0Z6/33) initialized" + "; message2mapsend4xi-initialized-by-manoeuvre2mapimage4xi to: " + str(message2mapsend4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                    
                max2mapstate4xi [key2mapmanoeuvre] = 3
                message2print = "{(Step 0Z7/33) initialized" + ";  max2mapstate4xi-initialized-by-manoeuvre2mapimage4xi to: " + str( max2mapstate4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #
       
    # ==============================================================================================================
    # NEXT PHASE PREPARING 
    # ==============================================================================================================                                             
    if debug is True:
        print("{(Step M0/33) of manoeuvre2mapimage4xi - NEXT PHASE PREPARING AT STATE2READ4XI: " , state2map4xi) 
        # 
          
    for key2mapmanoeuvre in keys2mapmanoeuvre:
        try:
            # ------------------------------------------------------------------------------------------------------------------------
            # UPDATE 
            # ------------------------------------------------------------------------------------------------------------------------      
            state2map4xi [key2mapmanoeuvre]  = state2map4xi [key2mapmanoeuvre]  + 1                                                                   
            message2print = "{(Step 0H/33) added" + "; state2map4xi-added-by-manoeuvre2mapimage4xi: " + str(state2map4xi [key2mapmanoeuvre] ) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            if debug is True:
                print("(Step 0h/33) of manoeuvre2mapimage4xi TO: ", key2mapmanoeuvre, " STATE2READ4XI-ADDED TO: " , state2map4xi [key2mapmanoeuvre]) 
                #
                
                 
            if state2map4xi [key2mapmanoeuvre] > max2mapstate4xi [key2mapmanoeuvre]:
                state2map4xi [key2mapmanoeuvre]  = 0
                message2print = "{(Step 0I/33) set" + "; state2map4xi-set-by-manoeuvre2mapimage4xi to: " + str(state2map4xi [key2mapmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                
                if debug is True:
                    print("(Step 0I/33) of manoeuvre2mapimage4xi TO: ", key2mapmanoeuvre, " STATE2READ4XI-ZEROED TO: " , state2map4xi [key2mapmanoeuvre]) 
                    # 
                    
                ack2mapinfo4xi [key2mapmanoeuvre] = False
                message2print = "{(Step 0J/33) set" + "; ack2mapinfo4xi-set-by-manoeuvre2mapimage4xi to: " + str(ack2mapinfo4xi [key2mapmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                     
                # 
                
                message2mapget4xi [key2mapmanoeuvre] = '<default4xi>default2map4xi</default4xi>'
                message2print = "{(Step 0K/33) set" + "; message2mapget4xi-set-by-manoeuvre2mapimage4xi to: " + str(message2mapget4xi [key2mapmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                               
                # 
                
                message2mapput4xi [key2mapmanoeuvre]  = '<default4xi>default2map4xi</default4xi>'
                message2print = "{(Step 0L/33) set" + "; message2mapput4xi-set-by-manoeuvre2mapimage4xi to: " + str(message2mapput4xi [key2mapmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                
                message2mapreceive4xi [key2mapmanoeuvre] = '<default4xi>default2map4xi</default4xi>'
                message2print = "{(Step 0M/33) set" + "; message2mapreceive4xi-set-by-manoeuvre2mapimage4xi to: " + str(message2mapreceive4xi [key2mapmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                
                message2mapsend4xi [key2mapmanoeuvre]    = '<default4xi>default2map4xi</default4xi>'
                message2print = "{(Step 0N/33) set" + "; message2mapsend4xi-set-by-manoeuvre2mapimage4xi to: " + str(message2mapsend4xi [key2mapmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
                
                max2mapstate4xi [key2mapmanoeuvre] = 3
                message2print = "{(Step 0O/33) initialized" + ";  max2mapstate4xi-set-by-manoeuvre2mapimage4xi to: " + str( max2mapstate4xi [key2mapmanoeuvre])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #
            else:
                pass
            if debug is True:
                print("(Step 1A/33) of manoeuvre2mapimage4xi FOR : ", key2mapmanoeuvre, " CONTINUING WITH STATE2READ4XI: " , state2map4xi [key2mapmanoeuvre])
                # 
                        
        except:
            print("(Step 0z1/33) of manoeuvre2mapimage4xi *** FAILED UPDATING *** " , time4xi())
            print("key2mapmanoeuvre: " , key2mapmanoeuvre)
            # 
            print("state2map4xi: " , state2map4xi)
            #
            print("ack2mapinfo4xi: " , ack2mapinfo4xi)
            #
            print("message2mapget4xi: " , message2mapget4xi)
            #
            print("message2mapput4xi: " , message2mapput4xi)
            #
            print("message2mapreceive4xi: " , message2mapreceive4xi)
            #
            print("message2mapsend4xi: " , message2mapsend4xi)
            #
            print("max2mapstate4xi: " , max2mapstate4xi)
            #
               
    
    # ==============================================================================================================
    # STATE I
    # ==============================================================================================================        
    if debug is True:
        print("(Step I/33) of manoeuvre2mapimage4xi: CONSIDERING STATE I: " , state2map4xi)
        # 
        
           
    for key2mapmanoeuvre in keys2mapmanoeuvre:                     
        # ------------------------------------------------------------------------------------------------------------------------
        # STATE I - RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND COPY OR NEGATIVE BACK 
        # ------------------------------------------------------------------------------------------------------------------------
        try:
            if state2map4xi [key2mapmanoeuvre]  == 1:
                if debug is True:
                    print("(Step 1/33) of manoeuvre2mapimage4xi: ", key2mapmanoeuvre, " - STATE I - TRY TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
                    
                message2print = "{(Step 1A/70) try" + "; receive-try-by-manoeuvre2mapimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                message2mapreceive4xi [key2mapmanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message2mapreceive4xi [key2mapmanoeuvre]  = consumerchannel2mapmanoeuvre4xi [key2mapmanoeuvre].recv()
                    message2print = "{(Step 1B/33) received" + "; message2mapreceive4xi-received-by-manoeuvre2mapimage4xi: " + str(message2mapreceive4xi [key2mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #
                    
                    if debug is True:
                        print("(Step 1B/33) of manoeuvre2mapimage4xi: ", key2mapmanoeuvre, " - STATE I - RECEIVED MESSAGE VIA PIPE: " , message2mapreceive4xi [key2mapmanoeuvre])
                        # GPU  - STATE I - RECEIVED MESSAGE VIA PIPE:  <copy4xi>copy2mapimage4xi</copy4xi>
                         
                    if message2mapreceive4xi [key2mapmanoeuvre]  == '<copy4xi>copy2mapimage4xi</copy4xi>':
                        message2mapsend4xi [key2mapmanoeuvre]  = '<copy4xi>copy2mapimage4xi</copy4xi>'
                    else:
                        message2mapsend4xi [key2mapmanoeuvre]  = '<negative4xi>negative2map4xi</<negative4xi>'
                        
                        
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel2mapmanoeuvre4xi [key2mapmanoeuvre].send(message2mapsend4xi [key2mapmanoeuvre])
                    
                    message2print = "{(Step 1C/33) sent" + "; message2mapsend4xi-sent-by-manoeuvre2mapimage4xi: " + str(message2mapsend4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    # 
                    if debug is True:
                        print("(Step 1C/33) of manoeuvre2mapimage4xi: ", key2mapmanoeuvre, " - STATE I - SENT MESSAGE VIA PIPE: " , message2mapsend4xi [key2mapmanoeuvre])
                        # 
                        
                    
                    code2ack  = code2ack + '1C-'
                except:
                    message2print = "{(Step 1Z/33) failed" + "; message2mapreceive4xi-failed-by-manoeuvre2mapimage4xi: " + str(message2mapreceive4xi [key2mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '1Z-' 
                    
                    print("(Step 1Z1/33) of manoeuvre2mapimage4xi: ", key2mapmanoeuvre, " - STATE I *** FAILED TO RECEIVE CONTROL AND COMMAND COPY MESSAGE VIA PIPE AND SEND ROGER OR NEGATIVE BACK " , time4xi())
                    # 
            else:
                pass
        except:
            print("(Step 1Z2/33) of manoeuvre2mapimage4xi: ", key2mapmanoeuvre, " - STATE I *** FAILED *** " , time4xi())

    # ==============================================================================================================
    # STATE II
    # ==============================================================================================================        
    if debug is True:
        print("(Step II/33) of manoeuvre2mapimage4xi: CONSIDERING STATE II : " , state2map4xi)
        #
        
                  
    for key2mapmanoeuvre in keys2mapmanoeuvre:        
        try:
            if state2map4xi [key2mapmanoeuvre]  == 2:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE II - RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK 
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                    print("(Step 1/33) of manoeuvre2mapimage4xi - STATE II - ", key2mapmanoeuvre, " TRYING TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #
                                 
                message2print = "{(Step 2A/70) try" + "; receive-try-by-manoeuvre2mapimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                message2mapreceive4xi [key2mapmanoeuvre]  = ''
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # RECEIVE CONTROL AND COMMAND MESSAGE VIA PIPE
                    # ----------------------------------------------------------------------------------------------------------------         
                    message2mapreceive4xi [key2mapmanoeuvre]  = consumerchannel2mapmanoeuvre4xi [key2mapmanoeuvre].recv()
                    
                    message2print = "{(Step 2B/33) received" + "; message2mapreceive4xi-received-by-manoeuvre2mapimage4xi: " + str(message2mapreceive4xi [key2mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # 
                    if debug is True: 
                        print("(Step 2B/33) of manoeuvre2mapimage4xi - STATE II - FROM ", key2mapmanoeuvre, " RECEIVED " , message2mapreceive4xi [key2mapmanoeuvre] )
                        # FROM  GPU  RECEIVED  <ready4xi>ready2mapimage4xi</ready4xi> 
           
                    if message2mapreceive4xi [key2mapmanoeuvre]  == '<ready4xi>ready2mapimage4xi</ready4xi>':
                        message2mapsend4xi [key2mapmanoeuvre]  = '<ready4xi>ready2mapimage4xi</ready4xi>'
                    else:
                        message2mapsend4xi [key2mapmanoeuvre]  = '<negative4xi>negative2map4xi</<negative4xi>'
                    
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND ROGER OR NEGATIVE BACK 
                    # ----------------------------------------------------------------------------------------------------------------                                
                    publisherchannel2mapmanoeuvre4xi [key2mapmanoeuvre].send(message2mapsend4xi [key2mapmanoeuvre])
                    
                    message2print = "{(Step 2C/33) sent" + "; message2mapsend4xi-sent-by-manoeuvre2mapimage4xi: " + str(message2mapsend4xi [key2mapmanoeuvre])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    # 
                    if debug is True:
                        print("(Step 2C/33) of manoeuvre2mapimage4xi - STATE II - TO ", key2mapmanoeuvre, " SENT " , message2mapreceive4xi [key2mapmanoeuvre] )
                        #                       
                    
                    code2ack  = code2ack + '2C-'
                except:
                    message2print = "{(Step 2Z/33) failed" + "; message2mapreceive4xi-failed-by-manoeuvre2mapimage4xi: " + str(message2mapreceive4xi [key2mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '2Z-'
                    print("(Step 1/33) of manoeuvre2mapimage4xi - STATE II - ", key2mapmanoeuvre, " *** FAILED TO RECEIVE CONTROL AND COMMAND READY MESSAGE VIA PIPE AND SEND READY OR NEGATIVE BACK " , time4xi())
                    #  
            else:
                pass        
        except:
            print("(Step 1/33) of manoeuvre2mapimage4xi - STATE II - ", key2mapmanoeuvre, " *** FAILED *** " , time4xi())
        

    # ==============================================================================================================
    # STATE III
    # ==============================================================================================================        
    if debug is True:
        print("(Step III/33) of manoeuvre2mapimage4xi: CONSIDERING STATE III : " , state2map4xi)
        # 
            
    for key2mapmanoeuvre in keys2mapmanoeuvre:
        try:   
            if state2map4xi [key2mapmanoeuvre]  == 3:
                # ------------------------------------------------------------------------------------------------------------------------
                # STATE III - GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE
                # ------------------------------------------------------------------------------------------------------------------------        
                if debug is True:
                        print("(Step 3A/33) of manoeuvre2mapimage4xi - STATE III - ", key2mapmanoeuvre, " GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE AND SEND ACK OR NACK VIA PIPE " , time4xi())
                        #     
                info2image4xi [key2mapmanoeuvre]  = None
                message2print = "{(Step 3A/70) try" + "; info2image4xi-try-by-manoeuvre2mapimage4xi"  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                try: 
                    # ----------------------------------------------------------------------------------------------------------------
                    # GET IMAGE INFORMATION SUCH AS IMAGE PATH VIA QUEUE
                    # ----------------------------------------------------------------------------------------------------------------        
                    info2image4xi [key2mapmanoeuvre]  = queue2mapmanoeuvre4xi [key2mapmanoeuvre].get()
                    
                    message2print = "{(Step 3B/33) got" + "; info2image4xi-got-by-manoeuvre2mapimage4xi: " + str(info2image4xi [key2mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # 
                    if debug is True:
                        print("(Step 3B/33) of manoeuvre2mapimage4xi - STATE III - ", key2mapmanoeuvre, " GOT INFO2IMAGE4XI: " , info2image4xi [key2mapmanoeuvre])
                        #  
                    
                    if info2image4xi [key2mapmanoeuvre]  is None:
                        code2nack  = code2nack + '3Z1-'
                        ack2mapinfo4xi [key2mapmanoeuvre]  = False 
                    else:    
                        code2ack  = code2ack + '3C-'
                        ack2mapinfo4xi [key2mapmanoeuvre]  = True
                except:
                    message2print = "{(Step 3Z1/33) failed" + "; queue2mapmanoeuvre4xi-failed-by-manoeuvre2mapimage4xi: " + str(queue2mapmanoeuvre4xi [key2mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '3Z1-'
                    
                message2mapsend4xi [key2mapmanoeuvre]  = ' '
                try:
                    # ----------------------------------------------------------------------------------------------------------------
                    # SEND CONTROL INFO ABOUT IMAGE OPERATION - EITHER ACK OR NACK  
                    # ----------------------------------------------------------------------------------------------------------------         
                    if ack2mapinfo4xi [key2mapmanoeuvre]  is True:
                        message2mapsend4xi [key2mapmanoeuvre]  = '<ack4xi>ack2imageinfo4xi</ack4xi>'
                    else:
                        message2mapsend4xi [key2mapmanoeuvre]  = '<nack4xi>nack2imageinfo4xi</nack4xi>'
                    message2print = "{(Step 4B/33) set" + "; message2mapsend4xi-set-by-manoeuvre2mapimage4xi to: " + str(message2mapsend4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #       
                except:
                    message2print = "{(Step 4Z1/33) failed" + "; message2mapsend4xi-failed-by-manoeuvre2mapimage4xi: " + str(message2mapsend4xi [key2mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    
                    code2nack  = code2nack + '4Z1-'    
                try:                
                    message2print = "{(Step 4C/70) using" + "; publisherchannel2mapmanoeuvre4xi-calling-by-manoeuvre2mapimage4xi: " + str(publisherchannel2mapmanoeuvre4xi [key2mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    # 
                    message2print = "{{(Step 4D/70) passing" + "; message2mapsend4xi-passing-to-send-by-manoeuvre2mapimage4xi: " + str(message2mapsend4xi [key2mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    #              
                except:
                    message2print = "{(Step 4Z1/33) failed" + "; message2mapsend4xi-failed-by-manoeuvre2mapimage4xi: " + str(message2mapsend4xi [key2mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '4Z2-'                
                try:    
                    publisherchannel2mapmanoeuvre4xi [key2mapmanoeuvre].send(message2mapsend4xi [key2mapmanoeuvre] )
                    
                    message2print = "{(Step 4E/33) sent" + "; message2mapsend4xi-sent-by-manoeuvre2mapimage4xi: " + str(message2mapsend4xi [key2mapmanoeuvre] )  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                    #            
                    code2ack  = code2ack + '4E-'
                    
                    if debug is True:
                        print("(Step 4EB/33) of manoeuvre2mapimage4xi - STATE III - ", key2mapmanoeuvre, " SENT MESSAGE: " , message2mapsend4xi [key2mapmanoeuvre])
                        #    
                except:
                    message2print = "{(Step 4Z3/33) failed" + "; message2mapsend4xi-failed-by-manoeuvre2mapimage4xi: " + str(message2mapsend4xi [key2mapmanoeuvre] ) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    code2nack  = code2nack + '4Z3-'                
            else:
                pass
        except:
            print("(Step 1/33) of manoeuvre2mapimage4xi - STATE III - ", key2mapmanoeuvre, " *** FAILED *** " , time4xi())
            
    # ==============================================================================================================
    # PREPARE RETURN - DICTIONARY LEVEL
    # ==============================================================================================================        
    if debug is True:
        try:
            print("(Step 5A/33) of manoeuvre2mapimage4xi - TRYING TO DEBUG PREPARING OF RETURN AT STATE: " , state2map4xi)
            # 
            
            print("(Step 5B/33) of manoeuvre2mapimage4xi - response2manouvre4map: " , response2manouvre4map)
            # 
            
            print("(Step 5C/33) of manoeuvre2mapimage4xi - ack2mapinfo4xi: " , ack2mapinfo4xi)
            # 
            
            print("(Step 5D/33) of manoeuvre2mapimage4xi - message2mapget4xi: ", message2mapget4xi)
            # 
            
            print("(Step 5E/33) of manoeuvre2mapimage4xi - message2mapput4xi: " , message2mapput4xi)
            # 
            
            print("(Step 5F/33) of manoeuvre2mapimage4xi - message2mapreceive4xi: " , message2mapreceive4xi)
            # 
            
            print("(Step 5G/33) of manoeuvre2mapimage4xi - message2mapsend4xi: " , message2mapsend4xi)
            # 
            
            
        except:
            print("(Step 5Z1/33) of manoeuvre2mapimage4xi *** FAILED TO PREPARE RETURN WITH STATE: " , state2map4xi)
    
    print("(Step 5B/33) of manoeuvre2mapimage4xi - TRYING TO PREPARING OF RETURN AT STATE: " , state2map4xi)    
    try:        
        response2manouvre4map ['ACK2INFO4XI']        = ack2mapinfo4xi 
        response2manouvre4map ['MESSAGE2GET4XI']     = message2mapget4xi
        response2manouvre4map ['MESSAGE2PUT4XI']     = message2mapput4xi
        response2manouvre4map ['MESSAGE2RECEIVE4XI'] = message2mapreceive4xi
        response2manouvre4map ['MESSAGE2SEND4XI']    = message2mapsend4xi
        response2manouvre4map ['STATE2MANOEUVRE4XI'] = state2map4xi
    except:
        print("(Step 5Z2/33) of manoeuvre2mapimage4xi *** FAILED IN PREPARING RETURN KEY2READMANOEUVRE AT STATE: " , state2map4xi)   
                             
    message2print = "{(Step 33/33) returning" + "; response2manouvre4map-returning-by-manoeuvre2mapimage4xi: " + str(response2manouvre4map) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             


    if debug is True:
        print("(Step 33/33) of manoeuvre2mapimage4xi - RETURNING  WITH STATE: " , state2map4xi, " RESPONSE2MANOUVRE4READ " , response2manouvre4map)
        #1 
        # 
 
        #2
        #
 
        #3 
        # 

        #4
        #
        

    return response2manouvre4map           
          
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "write2image4xi" usage = "
#                                                                                                              
#   # ---------------------------------------------------------------------------------------------
#   # PHASE I: WRITE FUNCTION  TESTS - ESTABLISH CONTROL & COMMAND              
#   # ---------------------------------------------------------------------------------------------    
#   print('=' *33)          
#   print('(Step 28A/700) OF IMAGE2D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH WRITE2IMAGE4XI ', time4xi())        
#   print('=' *33)      
#   #                         
#   respon4write2image      = {} 
#   task4write2image        = {}                                                                                    # WE ONLY WANT TO ESTABLISH CONTROL AND CONTROL FIRST
#   queue4write          = {} 
#   channel4write2publish = {} 
#   channel4write2consume = {} 
#   try:
#       task4write2image = {} 
#       for key2pu in keys2pu:
#           if KB2CC [key2pu] == 'ACK':
#               task4write2image [key2pu]  = {}
#                                               
#       response4write2image = write2image4xi(task4write2image)
#       
#       print('(Step 28B/700) OF IMAGE2D4XI5TEST - GOT RESPONSE4WRITE2IMAGE ', response4write2image)
#       # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DC0B00>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6720>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6716>}, 
#       #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DC0C18>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6752>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6748>}, 
#       #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DC05C0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6688>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6684>}}
#     except:
#       print('(Step 28Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH WRITE2IMAGE4XI ', time4xi())
#                
#   print('(Step 28C/700) OF IMAGE2D4XI5TEST - TRYING TO SET QUEUE AND CHANNELS FOR WRITE ', time4xi())               
#   try: 
#       queue4write          = {}
#       channel4write2publish = {} 
#       channel4write2consume = {}
#       for key2pu in keys2pu:
#           if KB2CC [key2pu] == 'ACK':   
#               queue4write [key2pu] = response4write2image [key2pu] ['QUEUE']
#               print(key2pu, ' SET QUEUE TO : ', queue4write [key2pu])
#               # {'GPU': <queue4xi.Queue4Xi object at 0x0000000005D65A58>; 'ZPU': <queue4xi.Queue4Xi object at 0x0000000005D65B70>; 'APU': <queue4xi.Queue4Xi object at 0x0000000005D65518>} 
#               
#               channel4write2publish [key2pu] = response4write2image [key2pu] ['PUBLISHERCHANNEL']
#               print(key2pu, ' SET CHANNEL TO PUBLISH4XI TO : ', channel4write2publish [key2pu])
#               # <read-write PipeConnection, handle 6688>
#                       
#               channel4write2consume [key2pu] = response4write2image [key2pu]['CONSUMERCHANNEL']
#               print(key2pu, ' SET CHANNEL TO CONSUME4XI TO : ', channel4write2consume [key2pu])
#               # <read-write PipeConnection, handle 6684>
#                       
#   except:
#       print('(Step 28Z2/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR WRITE ', time4xi()) 
#
#">

# -------------------------------------------------------------------------------------------------   
def write2image4xi(task4imagewrite2xi=None): 

    '''
    writes 2D images for XI
    '''
    global platform2xi
    global device2xi
    global context2xi    
    global image2d4xi                                                      # 2D-IMAGES 
    global info2image4xi 
    global control2writeimage4xi                                           # COMMAND AND CONTROL FOR 2D IMAGE FOR XIS 
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class2print = "write2image4xi"
    method2print = "write2image4xi"

    message2print = "{(Step 1A/33) started" + "; write2image4xi-started: " + str(write2image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    message2print = "{(Step 1B/33) passed" + "; task4imagewrite2xi-to-write2image4xi: " + str(task4imagewrite2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    
    if task4imagewrite2xi is None:
        task4imagewrite2xi = {}
            
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # CREATE 2D IMAGE FOR XI IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if image2d4xi is None:
            image2d4xi = create2image4xi()                                                                              # INITIALIZE IMAGE FOR XI 
            message2print = "{(Step 1C/70) created" + "; image2d4xi-created-by-write2image4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2image4xi-skipped-by-write2image4xi: " + str(write2image4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # skipped                                 
    except:
        try:
            image2d4xi = create2image4xi()
            message2print = "{(Step 1E/70) set" + "; image2d4xi-set-by-write2image4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            image2d4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; image2d4xi-yielded-by-write2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
    
    # -----------------------------------------------------------------------------------------
    #           
    # ----------------------------------------------------------------------------------------- 
    control2writeimage4xi = {}
    try:         
        keys2taskimagewrite = task4imagewrite2xi.keys()
        if debug is True:
            print('(Step 1/33) of write2image4xi - keys2taskimagewrite:  ', keys2taskimagewrite) 
            # dict_keys(['GPU', 'ZPU', 'APU'])
            
        if 'APU' in keys2taskimagewrite:
            try:
                control2writeimage4xi['APU'] = write2image4apu(task4imagewrite2xi['APU'])
                message2print = "{(Step 1CA/33) got" + "; apuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1A/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['APU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005CE9048>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6552>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6548>}

            except:
                pass     
        if 'BPU' in keys2taskimagewrite:
            try:
                control2writeimage4xi['BPU'] = write2image4bpu(task4imagewrite2xi['BPU'])
                message2print = "{(Step 1CB/33) got" + "; bpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1B/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['APU']) 
                    # 
            except:
                pass     
            
        if 'CPU' in keys2taskimagewrite:
            try:
                control2writeimage4xi['CPU'] = write2image4cpu(task4imagewrite2xi['CPU'])
                message2print = "{(Step 1CC/33) got" + "; cpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1C/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['CPU']) 
                    # 
            except:
                pass     
            
        if 'DPU' in keys2taskimagewrite:
            try:
                control2writeimage4xi['DPU'] = write2image4dpu(task4imagewrite2xi['DPU'])
                message2print = "{(Step 1CD/33) got" + "; dpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1D/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['DPU']) 
                    #       
            except:
                pass               
        if 'EPU' in keys2taskimagewrite:
            try:
                control2writeimage4xi['EPU'] = write2image4epu(task4imagewrite2xi['EPU'])
                message2print = "{(Step 1CE/33) got" + "; epuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1E/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['EPU']) 
                    #       
            except:
                pass               
        if 'FPU' in keys2taskimagewrite:
            try:
                control2writeimage4xi['FPU'] = write2image4fpu(task4imagewrite2xi['FPU'])
                message2print = "{(Step 1CF/33) got" + "; fpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1F/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['FPU']) 
                    #       
            except:
                pass               
        if 'GPU' in keys2taskimagewrite:
            try:
                control2writeimage4xi['GPU'] = write2image4gpu(task4imagewrite2xi['GPU'])
                message2print = "{(Step 1CG/33) got" + "; gpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1G/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['GPU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DF7DD8>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6584>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6580>}
      
            except:
                pass               
        if 'HPU' in keys2taskimagewrite:
            try:
                control2writeimage4xi['HPU'] = write2image4hpu(task4imagewrite2xi['HPU'])
                message2print = "{(Step 1CH/33) got" + "; hpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1H/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['HPU']) 
                    #              
            except:
                pass
        if 'IPU' in keys2taskimagewrite:    
            try:
                control2writeimage4xi['IPU'] = write2image4ipu(task4imagewrite2xi['IPU'])
                message2print = "{(Step 1CI/33) got" + "; ipuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1I/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['IPU']) 
                    # 
            except:
                pass
        if 'JPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['JPU'] = write2image4jpu(task4imagewrite2xi['JPU'])
                message2print = "{(Step 1CJ/33) got" + "; jpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1J/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['JPU']) 
                    # 
            except:
                pass
        if 'KPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['KPU'] = write2image4kpu(task4imagewrite2xi['KPU'])
                message2print = "{(Step 1CK/33) got" + "; kpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1K/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['KPU']) 
                    # 
            except:
                pass
        if 'LPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['LPU'] = write2image4lpu(task4imagewrite2xi['LPU'])
                message2print = "{(Step 1CL/33) got" + "; lpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1L/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['LPU']) 
                    # 
            except:
                pass
        if 'MPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['MPU'] = write2image4mpu(task4imagewrite2xi['MPU'])
                message2print = "{(Step 1CM/33) got" + "; mpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1M/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['MPU']) 
                    # 
            except:
                pass
        if 'NPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['NPU'] = write2image4npu(task4imagewrite2xi['NPU'])
                message2print = "{(Step 1CN/33) got" + "; npuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'OPU' in keys2taskimagewrite:                    
            try:
                control2writeimage4xi['OPU'] = write2image4opu(task4imagewrite2xi['OPU'])
                message2print = "{(Step 1C1/33) got" + "; opuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1N/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['NPU']) 
                    # 
            except:
                pass
        if 'PPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['PPU'] = write2image4ppu(task4imagewrite2xi['PPU'])
                message2print = "{(Step 1CP/33) got" + "; ppuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'QPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['QPU'] = write2image4qpu(task4imagewrite2xi['QPU'])
                message2print = "{(Step 1C1/33) got" + "; qpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1P/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['PPU']) 
                    # 
            except:
                pass
        if 'RPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['RPU'] = write2image4rpu(task4imagewrite2xi['RPU'])
                message2print = "{(Step 1CR/33) got" + "; rpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1R/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['RPU']) 
                    # 
            except:
                pass
        if 'SPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['SPU'] = write2image4spu(task4imagewrite2xi['SPU'])
                message2print = "{(Step 1CS/33) got" + "; spuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1S/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['SPU']) 
                    # 
            except:
                pass
        if 'TPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['TPU'] = write2image4tpu(task4imagewrite2xi['TPU'])
                message2print = "{(Step 1CT/33) got" + "; tpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1T/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['TPU']) 
                    # 
            except:
                pass
        if 'UPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['UPU'] = write2image4upu(task4imagewrite2xi['UPU'])
                message2print = "{(Step 1CU/33) got" + "; upuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1U/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['UPU']) 
                    # 
            except:
                pass
        if 'VPU' in keys2taskimagewrite:                    
            try:
                control2writeimage4xi['VPU'] = write2image4vpu(task4imagewrite2xi['VPU'])
                message2print = "{(Step 1CV/33) got" + "; vpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1V/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['VPU']) 
                    # 
            except:
                pass
        if 'WPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['WPU'] = write2image4wpu(task4imagewrite2xi['WPU'])
                message2print = "{(Step 1CW/33) got" + "; wpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1W/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['WPU']) 
                    # 
            except:
                pass
        if 'XPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['XPU'] = write2image4xpu(task4imagewrite2xi['XPU'])
                message2print = "{(Step 1CX/33) got" + "; xpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1X/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['XPU']) 
                    # 
            except:
                pass
        if 'YPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['YPU'] = write2image4ypu(task4imagewrite2xi['YPU'])
                message2print = "{(Step 1CY/33) got" + "; ypuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1Y/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['YPU']) 
                    # 
            except:
                pass
        if 'ZPU' in keys2taskimagewrite:                     
            try:
                control2writeimage4xi['ZPU'] = write2image4zpu(task4imagewrite2xi['ZPU'])
                message2print = "{(Step 1CZ/33) got" + "; zpuimage-control-got-by-get2imageinfo: " + str(control2writeimage4xi['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1Z/33) of write2image4xi - control2writeimage4xi:  ', control2writeimage4xi['ZPU']) 
                    # {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005DF7C88>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6616>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6612>}

            except:
                pass
               
    except:
        message2print = "{(Step 1Z/70) yielded" + "; control2writeimage4xi-yielded-by-write2image4xi: " + str(control2writeimage4xi) + "; time: " + time4xi() + "}"                
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '1Z-'     
        
    # ---------------------------------------------------------------------------------------------
    # RETURN CONTROL AND COMMAND DICTIONARY
    # ---------------------------------------------------------------------------------------------          
    message2print = "{(Step 70A/70) set" + "; code2ack-set-by-write2image4xi: " + str(code2ack) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                             
    # 
     
    message2print = "{(Step 70B/70) set" + "; code2nack-set-by-write2image4xi: " + str(code2nack) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    #   
        
    message2print = "{(Step 70C/70) returning" + "; control2writeimage4xi-returning-by-write2image4xi: " + str(control2writeimage4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    
    if debug is True:
        print("(Step 33/33) of manoeuvre2writeimage4xi - RETURNING CONTROL2WRITEIMAGE4XI " , control2writeimage4xi)
        # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005CB3CC0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6580>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6576>}, 
        #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005CB3B70>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6612>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6608>}, 
        #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005CB3908>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 6548>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 6544>}}

        
    return control2writeimage4xi
                    

                    
#</function4xi> 


 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2image4xi" usage = "
#
#   task4release2image  = {}
#   task4release2image ['APU']  = {}
#   task4release2image ['APU'] ['COUNT2REFERENCE'] = 1
#   task4release2image ['ZPU']  = {}
#   task4release2image ['ZPU'] ['COUNT2REFERENCE'] = 1     
#   response4release2image = {}    
#      
#   print('(Step 11A/700) OF IMAGE2D4XI5TEST - TRYING TO RELEASE 2D IMAGE OF XI DEVICE ', time4xi())    
#   # 
#   try:                               
#       response4release2Dimage = release2image4xi(task4release2image)                                                                                             
#       print('(Step 11B/700) OF IMAGE2D4XI5TEST - RELEASED 2D IMAGE OF XI DEVICE ', time4xi())                           
#       keys2response = response4release2Dimage.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4release2Dimage[key2response])
#           # APU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
#           # BPU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE':
#           # ...
#           # ZPU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...            
#   except:
#       print('(Step 11Z/700) OF IMAGE2D4XI5TEST *** FAILED TO RELEASE IMAGE OF XI DEVICE ', time4xi())
#                 
#">

# -------------------------------------------------------------------------------------------------   
def release2image4xi(task4release2xi=None):

    '''
    releases image2d4xi
    '''
    global image2d4xi 
    global info2image4xi 

    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class2print = "release2image4xi"
    method2print = "release2image4xi" 

    message2print = "{(Step 1A/33) started" + "; release2image4xi-started: " + str(release2image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function release2image4xi at 0x0000000003A9E8C8>
    
    message2print = "{(Step 1B/33) passed" + "; task4release2xi-to-release2image4xi: " + str(task4release2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'COUNT2REFERENCE': 1} 

    if task4release2xi is None:
        task4release2xi = {}
             
    code2ack  = ' '
    code2nack = ' '

    if image2d4xi is None:
        image2d4xi = create2image2d4xi()                                                                            
                                
        message2print = "{(Step 1C/33) release" + "; image2d4xi-release-by-release2image4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    
        
    keys2release = task4release2xi.keys()

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'APU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step A/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step A1/33) passing" + "; task-passing-to-release2image4apu: " + str(task4release2image['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            
            image2d4xi ['APU'] = release2image4apu(task4release2image['APU'])                                                      # 
             
            message2print = "{(Step A2/33) release" + "; apu-image-release-by-release2image4apu to: " + str(image2d4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            
         
            code2ack  = code2ack + 'A2-'
        else:
            pass    
    except:
        message2print = "{(Step AZ/33) yielded" + "; apu-yielded-by-release2image4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'BPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step B/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step B1/33) passing" + "; task-passing-to-release2image4bpu: " + str(task4release2image['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['BPU'] = release2image4bpu(task4release2image['BPU'])                                                      # 
         
            message2print = "{(Step B2/33) release" + "; bpu-image-release-by-release2image4bpu to: " + str(image2d4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'B2-'
        else:
            pass    
    except:
        message2print = "{(Step BZ/33) yielded" + "; bpu-yielded-by-release2image4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'CPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step C/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step C1/33) passing" + "; task-passing-to-release2image4cpu: " + str(task4release2image['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['CPU'] = release2image4cpu(task4release2image['CPU'])                                                      # 
         
            message2print = "{(Step C2/33) release" + "; cpu-image-release-by-release2image4cpu to: " + str(image2d4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'C2-'
        else:
            pass    
    except:
        message2print = "{(Step CZ/33) yielded" + "; cpu-yielded-by-release2image4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'DPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step D/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step D1/33) passing" + "; task-passing-to-release2image4dpu: " + str(task4release2image['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['DPU'] = release2image4dpu(task4release2image['DPU'])                                                      # 
         
            message2print = "{(Step D2/33) release" + "; dpu-image-release-by-release2image4dpu to: " + str(image2d4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'D2-'
        else:
            pass    
    except:
        message2print = "{(Step DZ/33) yielded" + "; dpu-yielded-by-release2image4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'EPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step E/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step E1/33) passing" + "; task-passing-to-release2image4epu: " + str(task4release2image['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['EPU'] = release2image4epu(task4release2image['EPU'])                                                      # 
         
            message2print = "{(Step E2/33) release" + "; epu-image-release-by-release2image4epu to: " + str(image2d4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'E2-'
        else:
            pass    
    except:
        message2print = "{(Step EZ/33) yielded" + "; epu-yielded-by-release2image4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'FPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step F/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step F1/33) passing" + "; task-passing-to-release2image4fpu: " + str(task4release2image['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['FPU'] = release2image4fpu(task4release2image['FPU'])                                                      # 
         
            message2print = "{(Step F2/33) release" + "; fpu-image-release-by-release2image4fpu to: " + str(image2d4xi ['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'F2-'
        else:
            pass    
    except:
        message2print = "{(Step FZ/33) yielded" + "; fpu-yielded-by-release2image4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'GPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step G/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step G1/33) passing" + "; task-passing-to-release2image4gpu: " + str(task4release2image['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['GPU'] = release2image4gpu(task4release2image['GPU'])                                                      # 
         
            message2print = "{(Step G2/33) release" + "; gpu-image-release-by-release2image4gpu to: " + str(image2d4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'G2-'
        else:
            pass    
    except:
        message2print = "{(Step GZ/33) yielded" + "; gpu-yielded-by-release2image4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'HPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step H/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step H1/33) passing" + "; task-passing-to-release2image4hpu: " + str(task4release2image['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['HPU'] = release2image4hpu(task4release2image['HPU'])                                                      # 
         
            message2print = "{(Step H2/33) release" + "; hpu-image-release-by-release2image4hpu to: " + str(image2d4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'H2-'
        else:
            pass    
    except:
        message2print = "{(Step HZ/33) yielded" + "; hpu-yielded-by-release2image4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'IPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step I/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step I1/33) passing" + "; task-passing-to-release2image4ipu: " + str(task4release2image['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['IPU'] = release2image4ipu(task4release2image['IPU'])                                                      # 
         
            message2print = "{(Step I2/33) release" + "; ipu-image-release-by-release2image4ipu to: " + str(image2d4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'I2-'
        else:
            pass    
    except:
        message2print = "{(Step IZ/33) yielded" + "; ipu-yielded-by-release2image4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'JPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step J/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step J1/33) passing" + "; task-passing-to-release2image4jpu: " + str(task4release2image['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['JPU'] = release2image4jpu(task4release2image['JPU'])                                                      # 
         
            message2print = "{(Step J2/33) release" + "; jpu-image-release-by-release2image4jpu to: " + str(image2d4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'J2-'
        else:
            pass    
    except:
        message2print = "{(Step JZ/33) yielded" + "; jpu-yielded-by-release2image4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'KPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step K/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step K1/33) passing" + "; task-passing-to-release2image4kpu: " + str(task4release2image['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['KPU'] = release2image4kpu(task4release2image['KPU'])                                                      # 
         
            message2print = "{(Step K2/33) release" + "; kpu-image-release-by-release2image4kpu to: " + str(image2d4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'K2-'
        else:
            pass    
    except:
        message2print = "{(Step KZ/33) yielded" + "; kpu-yielded-by-release2image4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'LPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step L/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step L1/33) passing" + "; task-passing-to-release2image4lpu: " + str(task4release2image['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['LPU'] = release2image4lpu(task4release2image['LPU'])                                                      # 
         
            message2print = "{(Step L2/33) release" + "; lpu-image-release-by-release2image4lpu to: " + str(image2d4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'L2-'
        else:
            pass    
    except:
        message2print = "{(Step LZ/33) yielded" + "; lpu-yielded-by-release2image4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'MPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step M/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step M1/33) passing" + "; task-passing-to-release2image4mpu: " + str(task4release2image['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['MPU'] = release2image4mpu(task4release2image['MPU'])                                                      # 
         
            message2print = "{(Step M2/33) release" + "; mpu-image-release-by-release2image4mpu to: " + str(image2d4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'M2-'
        else:
            pass    
    except:
        message2print = "{(Step MZ/33) yielded" + "; mpu-yielded-by-release2image4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'NPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step N/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step N1/33) passing" + "; task-passing-to-release2image4npu: " + str(task4release2image['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['NPU'] = release2image4npu(task4release2image['NPU'])                                                      # 
         
            message2print = "{(Step N2/33) release" + "; npu-image-release-by-release2image4npu to: " + str(image2d4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'N2-'
        else:
            pass    
    except:
        message2print = "{(Step NZ/33) yielded" + "; npu-yielded-by-release2image4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'OPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step O/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step O1/33) passing" + "; task-passing-to-release2image4opu: " + str(task4release2image['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['OPU'] = release2image4opu(task4release2image['OPU'])                                                      # 
         
            message2print = "{(Step O2/33) release" + "; opu-image-release-by-release2image4opu to: " + str(image2d4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'O2-'
        else:
            pass    
    except:
        message2print = "{(Step OZ/33) yielded" + "; opu-yielded-by-release2image4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'PPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step P/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step P1/33) passing" + "; task-passing-to-release2image4ppu: " + str(task4release2image['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['PPU'] = release2image4ppu(task4release2image['PPU'])                                                      # 
         
            message2print = "{(Step P2/33) release" + "; ppu-image-release-by-release2image4ppu to: " + str(image2d4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'P2-'
        else:
            pass    
    except:
        message2print = "{(Step PZ/33) yielded" + "; ppu-yielded-by-release2image4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'QPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step Q/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step Q1/33) passing" + "; task-passing-to-release2image4qpu: " + str(task4release2image['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['QPU'] = release2image4qpu(task4release2image['QPU'])                                                      # 
         
            message2print = "{(Step Q2/33) release" + "; qpu-image-release-by-release2image4qpu to: " + str(image2d4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'Q2-'
        else:
            pass    
    except:
        message2print = "{(Step QZ/33) yielded" + "; qpu-yielded-by-release2image4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'RPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step R/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step R1/33) passing" + "; task-passing-to-release2image4rpu: " + str(task4release2image['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['RPU'] = release2image4rpu(task4release2image['RPU'])                                                      # 
         
            message2print = "{(Step R2/33) release" + "; rpu-image-release-by-release2image4rpu to: " + str(image2d4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'R2-'
        else:
            pass    
    except:
        message2print = "{(Step RZ/33) yielded" + "; rpu-yielded-by-release2image4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'SPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step S/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step S1/33) passing" + "; task-passing-to-release2image4spu: " + str(task4release2image['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['SPU'] = release2image4spu(task4release2image['SPU'])                                                      # 
         
            message2print = "{(Step S2/33) release" + "; spu-image-release-by-release2image4spu to: " + str(image2d4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'S2-'
        else:
            pass    
    except:
        message2print = "{(Step SZ/33) yielded" + "; spu-yielded-by-release2image4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'TPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step T/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step T1/33) passing" + "; task-passing-to-release2image4tpu: " + str(task4release2image['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['TPU'] = release2image4tpu(task4release2image['TPU'])                                                      # 
         
            message2print = "{(Step T2/33) release" + "; tpu-image-release-by-release2image4tpu to: " + str(image2d4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'T2-'
        else:
            pass    
    except:
        message2print = "{(Step TZ/33) yielded" + "; tpu-yielded-by-release2image4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'UPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step U/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step U1/33) passing" + "; task-passing-to-release2image4upu: " + str(task4release2image['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['UPU'] = release2image4upu(task4release2image['UPU'])                                                      # 
         
            message2print = "{(Step U2/33) release" + "; upu-image-release-by-release2image4upu to: " + str(image2d4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'U2-'
        else:
            pass    
    except:
        message2print = "{(Step UZ/33) yielded" + "; upu-yielded-by-release2image4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'VPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step V/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step V1/33) passing" + "; task-passing-to-release2image4vpu: " + str(task4release2image['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['VPU'] = release2image4vpu(task4release2image['VPU'])                                                      # 
         
            message2print = "{(Step V2/33) release" + "; vpu-image-release-by-release2image4vpu to: " + str(image2d4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'V2-'
        else:
            pass    
    except:
        message2print = "{(Step VZ/33) yielded" + "; vpu-yielded-by-release2image4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'WPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step W/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step W1/33) passing" + "; task-passing-to-release2image4wpu: " + str(task4release2image['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['WPU'] = release2image4wpu(task4release2image['WPU'])                                                      # 
         
            message2print = "{(Step W2/33) release" + "; wpu-image-release-by-release2image4wpu to: " + str(image2d4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'W2-'
        else:
            pass    
    except:
        message2print = "{(Step WZ/33) yielded" + "; wpu-yielded-by-release2image4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'XPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step X/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step X1/33) passing" + "; task-passing-to-release2image4xpu: " + str(task4release2image['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['XPU'] = release2image4xpu(task4release2image['XPU'])                                                      # 
         
            message2print = "{(Step X2/33) release" + "; xpu-image-release-by-release2image4xpu to: " + str(image2d4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'X2-'
        else:
            pass    
    except:
        message2print = "{(Step XZ/33) yielded" + "; xpu-yielded-by-release2image4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'YPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step Y/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step Y1/33) passing" + "; task-passing-to-release2image4ypu: " + str(task4release2image['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['YPU'] = release2image4ypu(task4release2image['YPU'])                                                      # 
         
            message2print = "{(Step Y2/33) release" + "; ypu-image-release-by-release2image4ypu to: " + str(image2d4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'Y2-'
        else:
            pass    
    except:
        message2print = "{(Step YZ/33) yielded" + "; ypu-yielded-by-release2image4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'ZPU' in keys2release:
            # -----------------------------------------------------------------------------
            # (Step Z/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step Z1/33) passing" + "; task-passing-to-release2image4zpu: " + str(task4release2image['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['ZPU'] = release2image4zpu(task4release2image['ZPU'])                                                      # 
         
            message2print = "{(Step Z2/33) release" + "; zpu-image-release-by-release2image4zpu to: " + str(image2d4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'Z2-'
        else:
            pass    
    except:
        message2print = "{(Step ZZ/33) yielded" + "; zpu-yielded-by-release2image4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; image2d4xi-returning-by-release2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    if debug is True:
        print('(Step 33/33) of release2image4xi - RETURNING IMAGE2D4XI:  ', image2d4xi) 
        
    return image2d4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2image4xi" usage = "
#
#   # ---------------------------------------------------------------------------------------------
#   # (13) REFERENCE COUNT FOR TWO PROCESSING UNITS RETAINED BY INCREMENTING COUNT WITH 1             
#   # ---------------------------------------------------------------------------------------------    
#   task4retain2image  = {}
#   task4retain2image ['APU']  = {}
#   task4retain2image ['APU'] ['DIMENSION'] = 2 
#   task4retain2image ['APU'] ['COUNT2REFERENCE'] = 1
#   task4retain2image ['ZPU']  = {}
#   task4retain2image ['ZPU'] ['DIMENSION'] = 2 
#   task4retain2image ['ZPU'] ['COUNT2REFERENCE'] = 1    
#    
#   response4retain2Dimage = {}
#   print('(Step 13A/700) OF IMAGE2D4XI5TEST - TRYING TO RETAIN 2D IMAGE OF XI DEVICE ', time4xi())   
#   try:                               
#       response4retain2Dimage = retain2image4xi(task4retain2image)                                                                                                 
#       print('(Step 13B/700) OF IMAGE2D4XI5TEST - RESPONSE4RETAIN2DIMAGE : ', time4xi())                         
#       keys2response = response4retain2Dimage.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', len(response4retain2Dimage[key2response]))
#           # APU  :  20
#           # ...
#           # XPU  :  20 <-- length is the same in all processing units
#           # YPU  :  20
#           # ZPU  :  20
#                  
#   except:
#       print('(Step 13Z/700) OF IMAGE2D4XI5TEST *** FAILED TO RETAIN 2D IMAGE OF XI DEVICE ', time4xi())   
#
#">

# -------------------------------------------------------------------------------------------------   
def retain2image4xi(task4retain2xi=None):

    '''
    retains either image2d4xi
    '''
    global image2d4xi 
    global info2image4xi

    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class2print = "retain2image4xi"
    method2print = "retain2image4xi"

    message2print = "{(Step 1A/33) started" + "; retain2image4xi-started: " + str(retain2image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function retain2image4xi at 0x0000000003A9E948>   
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2xi-to-retain2image4xi: " + str(task4retain2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    #
    if task4retain2xi is None:
        task4retain2xi = {}
        
    keys2retain = task4retain2xi    
    
    code2ack  = ' '
    code2nack = ' '
    
    if image2d4xi is None:
        image2d4xi = create2image2d4xi()                                                                            
                                
        message2print = "{(Step 1C/33) retain" + "; image2d4xi-retain-by-retain2image4xi to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        code2ack  = code2ack + '1C-'
    else:
        pass    

    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'APU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step A/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step A1/33) passing" + "; task-passing-to-retain2image4apu: " + str(task4retain2image['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['APU'] = retain2image4apu(task4retain2image['APU'])                                                      # 
         
            message2print = "{(Step A2/33) retain" + "; apu-image-retain-by-retain2image4apu to: " + str(image2d4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'AZ-'
        else:
            pass    
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-retain2image4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'BPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step B/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step B1/33) passing" + "; task-passing-to-retain2image4bpu: " + str(task4retain2image['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['BPU'] = retain2image4bpu(task4retain2image['BPU'])                                                      # 
         
            message2print = "{(Step B2/33) retain" + "; bpu-image-retain-by-retain2image4bpu to: " + str(image2d4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'BZ-'
        else:
            pass    
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-retain2image4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'CPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step C/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step C1/33) passing" + "; task-passing-to-retain2image4cpu: " + str(task4retain2image['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['CPU'] = retain2image4cpu(task4retain2image['CPU'])                                                      # 
         
            message2print = "{(Step C2/33) retain" + "; cpu-image-retain-by-retain2image4cpu to: " + str(image2d4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'CZ-'
        else:
            pass    
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-retain2image4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'DPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step D/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step D1/33) passing" + "; task-passing-to-retain2image4dpu: " + str(task4retain2image['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['DPU'] = retain2image4dpu(task4retain2image['DPU'])                                                      # 
         
            message2print = "{(Step D2/33) retain" + "; dpu-image-retain-by-retain2image4dpu to: " + str(image2d4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'DZ-'
        else:
            pass    
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-retain2image4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'EPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step E/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step E1/33) passing" + "; task-passing-to-retain2image4epu: " + str(task4retain2image['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['EPU'] = retain2image4epu(task4retain2image['EPU'])                                                      # 
         
            message2print = "{(Step E2/33) retain" + "; epu-image-retain-by-retain2image4epu to: " + str(image2d4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'EZ-'
        else:
            pass    
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-retain2image4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'FPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step F/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step F1/33) passing" + "; task-passing-to-retain2image4fpu: " + str(task4retain2image['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['FPU'] = retain2image4fpu(task4retain2image['FPU'])                                                      # 
         
            message2print = "{(Step F2/33) retain" + "; fpu-image-retain-by-retain2image4fpu to: " + str(image2d4xi ['FPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'FZ-'
        else:
            pass    
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-retain2image4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'GPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step G/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step G1/33) passing" + "; task-passing-to-retain2image4gpu: " + str(task4retain2image['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['GPU'] = retain2image4gpu(task4retain2image['GPU'])                                                      # 
         
            message2print = "{(Step G2/33) retain" + "; gpu-image-retain-by-retain2image4gpu to: " + str(image2d4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'GZ-'
        else:
            pass    
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-retain2image4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'HPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step H/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step H1/33) passing" + "; task-passing-to-retain2image4hpu: " + str(task4retain2image['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['HPU'] = retain2image4hpu(task4retain2image['HPU'])                                                      # 
         
            message2print = "{(Step H2/33) retain" + "; hpu-image-retain-by-retain2image4hpu to: " + str(image2d4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'HZ-'
        else:
            pass    
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-retain2image4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'IPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step I/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step I1/33) passing" + "; task-passing-to-retain2image4ipu: " + str(task4retain2image['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['IPU'] = retain2image4ipu(task4retain2image['IPU'])                                                      # 
         
            message2print = "{(Step I2/33) retain" + "; ipu-image-retain-by-retain2image4ipu to: " + str(image2d4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'IZ-'
        else:
            pass    
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-retain2image4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'JPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step J/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step J1/33) passing" + "; task-passing-to-retain2image4jpu: " + str(task4retain2image['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['JPU'] = retain2image4jpu(task4retain2image['JPU'])                                                      # 
         
            message2print = "{(Step J2/33) retain" + "; jpu-image-retain-by-retain2image4jpu to: " + str(image2d4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'JZ-'
        else:
            pass    
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-retain2image4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'KPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step K/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step K1/33) passing" + "; task-passing-to-retain2image4kpu: " + str(task4retain2image['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['KPU'] = retain2image4kpu(task4retain2image['KPU'])                                                      # 
         
            message2print = "{(Step K2/33) retain" + "; kpu-image-retain-by-retain2image4kpu to: " + str(image2d4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'KZ-'
        else:
            pass    
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-retain2image4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'LPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step L/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step L1/33) passing" + "; task-passing-to-retain2image4lpu: " + str(task4retain2image['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['LPU'] = retain2image4lpu(task4retain2image['LPU'])                                                      # 
         
            message2print = "{(Step L2/33) retain" + "; lpu-image-retain-by-retain2image4lpu to: " + str(image2d4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'LZ-'
        else:
            pass    
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-retain2image4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'MPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step M/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step M1/33) passing" + "; task-passing-to-retain2image4mpu: " + str(task4retain2image['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['MPU'] = retain2image4mpu(task4retain2image['MPU'])                                                      # 
         
            message2print = "{(Step M2/33) retain" + "; mpu-image-retain-by-retain2image4mpu to: " + str(image2d4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'MZ-'
        else:
            pass    
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-retain2image4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'NPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step N/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step N1/33) passing" + "; task-passing-to-retain2image4npu: " + str(task4retain2image['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['NPU'] = retain2image4npu(task4retain2image['NPU'])                                                      # 
         
            message2print = "{(Step N2/33) retain" + "; npu-image-retain-by-retain2image4npu to: " + str(image2d4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'NZ-'
        else:
            pass    
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-retain2image4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'OPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step O/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step O1/33) passing" + "; task-passing-to-retain2image4opu: " + str(task4retain2image['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['OPU'] = retain2image4opu(task4retain2image['OPU'])                                                      # 
         
            message2print = "{(Step O2/33) retain" + "; opu-image-retain-by-retain2image4opu to: " + str(image2d4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'OZ-'
        else:
            pass    
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-retain2image4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'PPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step P/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step P1/33) passing" + "; task-passing-to-retain2image4ppu: " + str(task4retain2image['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['PPU'] = retain2image4ppu(task4retain2image['PPU'])                                                      # 
         
            message2print = "{(Step P2/33) retain" + "; ppu-image-retain-by-retain2image4ppu to: " + str(image2d4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'PZ-'
        else:
            pass    
    except:
        message2print = "{(Step PZ1/33) yielded" + "; pu-yielded-by-retain2image4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'QPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step Q/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step Q1/33) passing" + "; task-passing-to-retain2image4qpu: " + str(task4retain2image['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['QPU'] = retain2image4qpu(task4retain2image['QPU'])                                                      # 
         
            message2print = "{(Step Q2/33) retain" + "; qpu-image-retain-by-retain2image4qpu to: " + str(image2d4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'QZ-'
        else:
            pass    
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-retain2image4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'RPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step R/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step R1/33) passing" + "; task-passing-to-retain2image4rpu: " + str(task4retain2image['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['RPU'] = retain2image4rpu(task4retain2image['RPU'])                                                      # 
         
            message2print = "{(Step R2/33) retain" + "; rpu-image-retain-by-retain2image4rpu to: " + str(image2d4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'RZ-'
        else:
            pass    
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-retain2image4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'SPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step S/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step S1/33) passing" + "; task-passing-to-retain2image4spu: " + str(task4retain2image['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['SPU'] = retain2image4spu(task4retain2image['SPU'])                                                      # 
         
            message2print = "{(Step S2/33) retain" + "; spu-image-retain-by-retain2image4spu to: " + str(image2d4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'SZ-'
        else:
            pass    
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-retain2image4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'TPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step T/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step T1/33) passing" + "; task-passing-to-retain2image4tpu: " + str(task4retain2image['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['TPU'] = retain2image4tpu(task4retain2image['TPU'])                                                      # 
         
            message2print = "{(Step T2/33) retain" + "; tpu-image-retain-by-retain2image4tpu to: " + str(image2d4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'TZ-'
        else:
            pass    
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-retain2image4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'UPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step U/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step U1/33) passing" + "; task-passing-to-retain2image4upu: " + str(task4retain2image['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['UPU'] = retain2image4upu(task4retain2image['UPU'])                                                      # 
         
            message2print = "{(Step U2/33) retain" + "; upu-image-retain-by-retain2image4upu to: " + str(image2d4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'UZ-'
        else:
            pass    
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-retain2image4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'VPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step V/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step V1/33) passing" + "; task-passing-to-retain2image4vpu: " + str(task4retain2image['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['VPU'] = retain2image4vpu(task4retain2image['VPU'])                                                      # 
         
            message2print = "{(Step V2/33) retain" + "; vpu-image-retain-by-retain2image4vpu to: " + str(image2d4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'VZ-'
        else:
            pass    
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-retain2image4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'WPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step W/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step W1/33) passing" + "; task-passing-to-retain2image4wpu: " + str(task4retain2image['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['WPU'] = retain2image4wpu(task4retain2image['WPU'])                                                      # 
         
            message2print = "{(Step W2/33) retain" + "; wpu-image-retain-by-retain2image4wpu to: " + str(image2d4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'WZ-'
        else:
            pass    
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-retain2image4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'XPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step X/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step X1/33) passing" + "; task-passing-to-retain2image4xpu: " + str(task4retain2image['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['XPU'] = retain2image4xpu(task4retain2image['XPU'])                                                      # 
         
            message2print = "{(Step X2/33) retain" + "; xpu-image-retain-by-retain2image4xpu to: " + str(image2d4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'XZ-'
        else:
            pass    
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-retain2image4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'YPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step Y/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step Y1/33) passing" + "; task-passing-to-retain2image4ypu: " + str(task4retain2image['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['YPU'] = retain2image4ypu(task4retain2image['YPU'])                                                      # 
         
            message2print = "{(Step Y2/33) retain" + "; ypu-image-retain-by-retain2image4ypu to: " + str(image2d4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'YZ-'
        else:
            pass    
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-retain2image4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        if 'ZPU' in keys2retain:
            # -----------------------------------------------------------------------------
            # (Step Z/33) 
            # ----------------------------------------------------------------------------- 
            message2print = "{(Step Z1/33) passing" + "; task-passing-to-retain2image4zpu: " + str(task4retain2image['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
        
            image2d4xi ['ZPU'] = retain2image4zpu(task4retain2image['ZPU'])                                                      # 
         
            message2print = "{(Step Z2/33) retain" + "; zpu-image-retain-by-retain2image4zpu to: " + str(image2d4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
     
            code2ack  = code2ack + 'ZZ-'
        else:
            pass    
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-retain2image4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; image2d4xi-returning-by-retain2image4xi: " + str(image2d4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    if debug is True:
        print('(Step 33/33) of retain2image4xi - RETURNING IMAGE2D4XI:  ', image2d4xi) 
    
    return image2d4xi
    
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2imageinfo4xi" usage = "
#
#   print('(Step 14C/700) OF IMAGE2D4XI5TEST - TRYING TO VERIFY XI KNOWLEDGEBASE ', time4xi())  
#   try:                               
#       task4getinfo2image = {}
#       task4getinfo2image ['APU'] = {}
#       task4getinfo2image ['APU'] ['CALLBACK'] = 0
#       task4getinfo2image ['GPU'] = {}
#       task4getinfo2image ['GPU'] ['CALLBACK'] = 0
#       task4getinfo2image ['XPU'] = {}
#       task4getinfo2image ['XPU'] ['CALLBACK'] = 0          
#       task4getinfo2image ['ZPU'] = {}
#       task4getinfo2image ['ZPU'] ['CALLBACK'] = 0    
#                          
#       response4getinfo2Dimage = get2imageinfo4xi (task4getinfo2image)                                                                                             
#       keys2response = response4getinfo2Dimage.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4getinfo2Dimage[key2response])
#           # APU  :  {'CALLBACK': <function trace2image4apu at 0x0000000004484C48>}
#           # GPU  :  {'CALLBACK': <function trace2image4gpu at 0x00000000049F1D48>}
#           # XPU  :  {'CALLBACK': <function trace2image4xpu at 0x0000000005693948>}
#           # ZPU  :  {'CALLBACK': <function trace2image4zpu at 0x00000000059090C8>}
#   except:
#       print('(Step 14Z3/700) OF IMAGE2D4XI5TEST *** FAILED TO VERIFY XI KNOWLEDGEBASE ', time4xi()) 
#            
#">

# -------------------------------------------------------------------------------------------------   
def get2imageinfo4xi(task4supportedimageformats2xi=None):

    '''
    gets image2d4xi
    '''
    
    global image2d4xi
    global info2image4xi
    
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class2print = "get2imageinfo4xi"
    method2print = "get2imageinfo4xi"

    message2print = "{(Step 0A/33) started" + "; get2imageinfo4xi-started: " + str(get2imageinfo4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # <function get2imageinfo4xi at 0x0000000003A9E9C8>                                                              
    
    message2print = "{(Step 0A/33) passed" + "; task4supportedimageformats2xi-passed-to-get2imageinfo4xi: " + str(task4supportedimageformats2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    if task4supportedimageformats2xi is None:
        task4supportedimageformats2xi = {}
        
    keys2supportedimageformats = task4supportedimageformats2xi.keys()
    if debug is True:
        print('(Step 0A/33) of get2imageinfo4xi - keys2supportedimageformats:  ', keys2supportedimageformats)    
        # dict_keys(['GPU', 'ZPU', 'PPU', 'APU'])

        print('(step 0a/33) of get2imageinfo4xi - passed-to-get2imageinfo4xi task4supportedimageformats2xi:  ', task4supportedimageformats2xi)   
        # {'GPU': {'WIDTH': 0, 'DIMENSION': 2, 'HEIGHT': 0}, 
        #  'ZPU': {'WIDTH': 0, 'DIMENSION': 2, 'HEIGHT': 0}, 
        #  'PPU': {'WIDTH': 0, 'DIMENSION': 2, 'HEIGHT': 0}, 
        #  'APU': {'WIDTH': 0, 'DIMENSION': 2, 'HEIGHT': 0}}

    
    
    if image2d4xi is None:
        # -------------------------------------------------------------------------------------
        # TRY TO CREATE           
        # -------------------------------------------------------------------------------------           
        image2d4xi = create2image4xi()
        
        message2print = "{(Step 1B/33) initialized" + "; image2d4xi-initialized-by-get2imageinfo to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
    else:
        # -------------------------------------------------------------------------------------
        # USE           
        # -------------------------------------------------------------------------------------         
        info2return = {} 
        
          
        if 'APU' in keys2supportedimageformats:
            try:
                info2return['APU'] = get2imageinfo4apu(task4supportedimageformats2xi['APU'])
                message2print = "{(Step 1C1/33) got" + "; apuimage-got-by-get2imageinfo: " + str(info2return['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1A/33) of get2imageinfo4xi - info2return:  ', info2return) 
                    # {'APU': {'WIDTH': 800, 'HEIGHT': 800}}
            except:
                pass     
        if 'BPU' in keys2supportedimageformats:
            try:
                info2return['BPU'] = get2imageinfo4bpu(task4supportedimageformats2xi['BPU'])
                message2print = "{(Step 1C1/33) got" + "; bpuimage-got-by-get2imageinfo: " + str(info2return['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass     
            
        if 'CPU' in keys2supportedimageformats:
            try:
                info2return['CPU'] = get2imageinfo4cpu(task4supportedimageformats2xi['CPU'])
                message2print = "{(Step 1C1/33) got" + "; cpuimage-got-by-get2imageinfo: " + str(info2return['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass     
            
        if 'DPU' in keys2supportedimageformats:
            try:
                info2return['DPU'] = get2imageinfo4dpu(task4supportedimageformats2xi['DPU'])
                message2print = "{(Step 1C1/33) got" + "; dpuimage-got-by-get2imageinfo: " + str(info2return['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'EPU' in keys2supportedimageformats:
            try:
                info2return['EPU'] = get2imageinfo4epu(task4supportedimageformats2xi['EPU'])
                message2print = "{(Step 1C1/33) got" + "; epuimage-got-by-get2imageinfo: " + str(info2return['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'FPU' in keys2supportedimageformats:
            try:
                info2return['FPU'] = get2imageinfo4fpu(task4supportedimageformats2xi['FPU'])
                message2print = "{(Step 1C1/33) got" + "; fpuimage-got-by-get2imageinfo: " + str(info2return['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'GPU' in keys2supportedimageformats:
            try:
                info2return['GPU'] = get2imageinfo4gpu(task4supportedimageformats2xi['GPU'])
                message2print = "{(Step 1C1/33) got" + "; gpuimage-got-by-get2imageinfo: " + str(info2return['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'HPU' in keys2supportedimageformats:
            try:
                info2return['HPU'] = get2imageinfo4hpu(task4supportedimageformats2xi['HPU'])
                message2print = "{(Step 1C1/33) got" + "; hpuimage-got-by-get2imageinfo: " + str(info2return['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #             
            except:
                pass
        if 'IPU' in keys2supportedimageformats:    
            try:
                info2return['IPU'] = get2imageinfo4ipu(task4supportedimageformats2xi['IPU'])
                message2print = "{(Step 1C1/33) got" + "; ipuimage-got-by-get2imageinfo: " + str(info2return['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'JPU' in keys2supportedimageformats:                     
            try:
                info2return['JPU'] = get2imageinfo4jpu(task4supportedimageformats2xi['JPU'])
                message2print = "{(Step 1C1/33) got" + "; jpuimage-got-by-get2imageinfo: " + str(info2return['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'KPU' in keys2supportedimageformats:                     
            try:
                info2return['KPU'] = get2imageinfo4kpu(task4supportedimageformats2xi['KPU'])
                message2print = "{(Step 1C1/33) got" + "; kpuimage-got-by-get2imageinfo: " + str(info2return['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'LPU' in keys2supportedimageformats:                     
            try:
                info2return['LPU'] = get2imageinfo4lpu(task4supportedimageformats2xi['LPU'])
                message2print = "{(Step 1C1/33) got" + "; lpuimage-got-by-get2imageinfo: " + str(info2return['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'MPU' in keys2supportedimageformats:                     
            try:
                info2return['MPU'] = get2imageinfo4mpu(task4supportedimageformats2xi['MPU'])
                message2print = "{(Step 1C1/33) got" + "; mpuimage-got-by-get2imageinfo: " + str(info2return['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'NPU' in keys2supportedimageformats:                     
            try:
                info2return['NPU'] = get2imageinfo4npu(task4supportedimageformats2xi['NPU'])
                message2print = "{(Step 1C1/33) got" + "; npuimage-got-by-get2imageinfo: " + str(info2return['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'OPU' in keys2supportedimageformats:                    
            try:
                info2return['OPU'] = get2imageinfo4opu(task4supportedimageformats2xi['OPU'])
                message2print = "{(Step 1C1/33) got" + "; opuimage-got-by-get2imageinfo: " + str(info2return['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'PPU' in keys2supportedimageformats:                     
            try:
                info2return['PPU'] = get2imageinfo4ppu(task4supportedimageformats2xi['PPU'])
                message2print = "{(Step 1C1/33) got" + "; ppuimage-got-by-get2imageinfo: " + str(info2return['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'QPU' in keys2supportedimageformats:                     
            try:
                info2return['QPU'] = get2imageinfo4qpu(task4supportedimageformats2xi['QPU'])
                message2print = "{(Step 1C1/33) got" + "; qpuimage-got-by-get2imageinfo: " + str(info2return['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'RPU' in keys2supportedimageformats:                     
            try:
                info2return['RPU'] = get2imageinfo4rpu(task4supportedimageformats2xi['RPU'])
                message2print = "{(Step 1C1/33) got" + "; rpuimage-got-by-get2imageinfo: " + str(info2return['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'SPU' in keys2supportedimageformats:                     
            try:
                info2return['SPU'] = get2imageinfo4spu(task4supportedimageformats2xi['SPU'])
                message2print = "{(Step 1C1/33) got" + "; spuimage-got-by-get2imageinfo: " + str(info2return['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'TPU' in keys2supportedimageformats:                     
            try:
                info2return['TPU'] = get2imageinfo4tpu(task4supportedimageformats2xi['TPU'])
                message2print = "{(Step 1C1/33) got" + "; tpuimage-got-by-get2imageinfo: " + str(info2return['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'UPU' in keys2supportedimageformats:                     
            try:
                info2return['UPU'] = get2imageinfo4upu(task4supportedimageformats2xi['UPU'])
                message2print = "{(Step 1C1/33) got" + "; upuimage-got-by-get2imageinfo: " + str(info2return['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'VPU' in keys2supportedimageformats:                    
            try:
                info2return['VPU'] = get2imageinfo4vpu(task4supportedimageformats2xi['VPU'])
                message2print = "{(Step 1C1/33) got" + "; vpuimage-got-by-get2imageinfo: " + str(info2return['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'WPU' in keys2supportedimageformats:                     
            try:
                info2return['WPU'] = get2imageinfo4wpu(task4supportedimageformats2xi['WPU'])
                message2print = "{(Step 1C1/33) got" + "; wpuimage-got-by-get2imageinfo: " + str(info2return['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'XPU' in keys2supportedimageformats:                     
            try:
                info2return['XPU'] = get2imageinfo4xpu(task4supportedimageformats2xi['XPU'])
                message2print = "{(Step 1C1/33) got" + "; xpuimage-got-by-get2imageinfo: " + str(info2return['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'YPU' in keys2supportedimageformats:                     
            try:
                info2return['YPU'] = get2imageinfo4ypu(task4supportedimageformats2xi['YPU'])
                message2print = "{(Step 1C1/33) got" + "; ypuimage-got-by-get2imageinfo: " + str(info2return['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'ZPU' in keys2supportedimageformats:                     
            try:
                info2return['ZPU'] = get2imageinfo4zpu(task4supportedimageformats2xi['ZPU'])
                message2print = "{(Step 1C1/33) got" + "; zpuimage-got-by-get2imageinfo: " + str(info2return['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
                     
            
    message2print = "{(Step 33/33) returning" + "; info2return-returning-by-get2imageinfo: " + str(info2return) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 


    if debug is True:
        print('(Step 33/33) of get2imageinfo4xi - RETURNING INFO2RETURN:  ', info2return)  
        #1 
        # {'GPU': {'WIDTH': 800, 'HEIGHT': 800}, 
        #  'ZPU': {'WIDTH': 800, 'HEIGHT': 800}, 
        #  'PPU': {'WIDTH': 800, 'HEIGHT': 800}, 
        #  'APU': {'WIDTH': 800, 'HEIGHT': 800}}
        #2
        # {'GPU': {'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, ....

    return info2return
            
#</function4xi> 
 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2supportedimageformats4xi" usage = "
#
#   print('(Step 3A1/700) OF IMAGE2D4XI5TEST - TRYING TO GET SUPPORTED 2D IMAGE FORMATS FOR XI ', time4xi())    
#   task4getinfo2image = {}
#   kb2task = {}
#   kb2task ['APU'] = {}
#   kb2task ['GPU'] = {}
#   kb2task ['PPU'] = {}
#   kb2task ['ZPU'] = {}
#   keys2task = kb2task.keys()
#   for key2task in sorted(keys2task):
#       task4getinfo2image [key2task] = {}
#        
#   try:                
#       response = get2supportedimageformats4xi(task4getinfo2image)   
#       keys2response = response.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response[key2response])
#           # APU  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
#           # GPU  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
#           # PPU  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
#           # ZPU  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
#   except:
#       print('(Step 3Z3/700) OF IMAGE2D4XI5TEST *** FAILED TO GET SUPPORTED 2D IMAGE FORMATS FOR XI', time4xi())
#      
#">

# -------------------------------------------------------------------------------------------------   
def get2supportedimageformats4xi(task4supportedimageformats2xi=None):  

    '''
    gets supported image formats for xi
    '''
    global image2d4xi
    global info2image4xi    

    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    debug = True
    class2print = "get2supportedimageformats4xi"
    method2print = "get2supportedimageformats4xi"
    
    message2print = "{(Step 0A/33) started" + "; get2supportedimageformats4xi-started: " + str(get2supportedimageformats4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # <function get2supportedimageformats4xi at 0x0000000003A9E9C8>  
    
    message2print = "{(Step 0A/33) passed" + "; task4supportedimageformats2xi-passed-to-get2supportedimageformats4xi: " + str(task4supportedimageformats2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #
    if debug is True:
        print('(step 0a/33) of get2supportedimageformats4xi - passed-to-get2supportedimageformats4xi task4supportedimageformats2xi:  ', task4supportedimageformats2xi)   
        # {'GPU': {}, 'ZPU': {}, 'PPU': {}, 'APU': {}}
        
    if task4supportedimageformats2xi is None:
        task4supportedimageformats2xi = {}
        
    keys2supportedimageformats = task4supportedimageformats2xi.keys()     
        
    
    if image2d4xi is None:
        # -------------------------------------------------------------------------------------
        # TRY TO CREATE           
        # -------------------------------------------------------------------------------------           
        image2d4xi = create2image4xi()
        
        message2print = "{(Step 1B/33) initialized" + "; image2d4xi-initialized-by-get2supportedimageformats to: " + str(image2d4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
    else:
        # -------------------------------------------------------------------------------------
        # USE           
        # -------------------------------------------------------------------------------------         
        info2formats = {} 
        
        if debug is True:
            print('(Step 1/33) of get2supportedimageformats4xi - keys2supportedimageformats:  ', keys2supportedimageformats) 
            # dict_keys(['GPU', 'ZPU', 'PPU', 'APU'])
          
        if 'APU' in keys2supportedimageformats:
            try:
                info2formats['APU'] = get2supportedimageformats4apu(task4supportedimageformats2xi['APU'])
                message2print = "{(Step 1C1/33) got" + "; apuimage-got-by-get2supportedimageformats: " + str(info2formats['APU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                if debug is True:
                    print('(Step 1A/33) of get2supportedimageformats4xi - info2formats:  ', info2formats) 
                    # {'APU': {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}}
            except:
                pass     
        if 'BPU' in keys2supportedimageformats:
            try:
                info2formats['BPU'] = get2supportedimageformats4bpu(task4supportedimageformats2xi['BPU'])
                message2print = "{(Step 1C1/33) got" + "; bpuimage-got-by-get2supportedimageformats: " + str(info2formats['BPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass     
            
        if 'CPU' in keys2supportedimageformats:
            try:
                info2formats['CPU'] = get2supportedimageformats4cpu(task4supportedimageformats2xi['CPU'])
                message2print = "{(Step 1C1/33) got" + "; cpuimage-got-by-get2supportedimageformats: " + str(info2formats['CPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass     
            
        if 'DPU' in keys2supportedimageformats:
            try:
                info2formats['DPU'] = get2supportedimageformats4dpu(task4supportedimageformats2xi['DPU'])
                message2print = "{(Step 1C1/33) got" + "; dpuimage-got-by-get2supportedimageformats: " + str(info2formats['DPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'EPU' in keys2supportedimageformats:
            try:
                info2formats['EPU'] = get2supportedimageformats4epu(task4supportedimageformats2xi['EPU'])
                message2print = "{(Step 1C1/33) got" + "; epuimage-got-by-get2supportedimageformats: " + str(info2formats['EPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'FPU' in keys2supportedimageformats:
            try:
                info2formats['FPU'] = get2supportedimageformats4fpu(task4supportedimageformats2xi['FPU'])
                message2print = "{(Step 1C1/33) got" + "; fpuimage-got-by-get2supportedimageformats: " + str(info2formats['FPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'GPU' in keys2supportedimageformats:
            try:
                info2formats['GPU'] = get2supportedimageformats4gpu(task4supportedimageformats2xi['GPU'])
                message2print = "{(Step 1C1/33) got" + "; gpuimage-got-by-get2supportedimageformats: " + str(info2formats['GPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #      
            except:
                pass               
        if 'HPU' in keys2supportedimageformats:
            try:
                info2formats['HPU'] = get2supportedimageformats4hpu(task4supportedimageformats2xi['HPU'])
                message2print = "{(Step 1C1/33) got" + "; hpuimage-got-by-get2supportedimageformats: " + str(info2formats['HPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #             
            except:
                pass
        if 'IPU' in keys2supportedimageformats:    
            try:
                info2formats['IPU'] = get2supportedimageformats4ipu(task4supportedimageformats2xi['IPU'])
                message2print = "{(Step 1C1/33) got" + "; ipuimage-got-by-get2supportedimageformats: " + str(info2formats['IPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'JPU' in keys2supportedimageformats:                     
            try:
                info2formats['JPU'] = get2supportedimageformats4jpu(task4supportedimageformats2xi['JPU'])
                message2print = "{(Step 1C1/33) got" + "; jpuimage-got-by-get2supportedimageformats: " + str(info2formats['JPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'KPU' in keys2supportedimageformats:                     
            try:
                info2formats['KPU'] = get2supportedimageformats4kpu(task4supportedimageformats2xi['KPU'])
                message2print = "{(Step 1C1/33) got" + "; kpuimage-got-by-get2supportedimageformats: " + str(info2formats['KPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'LPU' in keys2supportedimageformats:                     
            try:
                info2formats['LPU'] = get2supportedimageformats4lpu(task4supportedimageformats2xi['LPU'])
                message2print = "{(Step 1C1/33) got" + "; lpuimage-got-by-get2supportedimageformats: " + str(info2formats['LPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'MPU' in keys2supportedimageformats:                     
            try:
                info2formats['MPU'] = get2supportedimageformats4mpu(task4supportedimageformats2xi['MPU'])
                message2print = "{(Step 1C1/33) got" + "; mpuimage-got-by-get2supportedimageformats: " + str(info2formats['MPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'NPU' in keys2supportedimageformats:                     
            try:
                info2formats['NPU'] = get2supportedimageformats4npu(task4supportedimageformats2xi['NPU'])
                message2print = "{(Step 1C1/33) got" + "; npuimage-got-by-get2supportedimageformats: " + str(info2formats['NPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'OPU' in keys2supportedimageformats:                    
            try:
                info2formats['OPU'] = get2supportedimageformats4opu(task4supportedimageformats2xi['OPU'])
                message2print = "{(Step 1C1/33) got" + "; opuimage-got-by-get2supportedimageformats: " + str(info2formats['OPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'PPU' in keys2supportedimageformats:                     
            try:
                info2formats['PPU'] = get2supportedimageformats4ppu(task4supportedimageformats2xi['PPU'])
                message2print = "{(Step 1C1/33) got" + "; ppuimage-got-by-get2supportedimageformats: " + str(info2formats['PPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'QPU' in keys2supportedimageformats:                     
            try:
                info2formats['QPU'] = get2supportedimageformats4qpu(task4supportedimageformats2xi['QPU'])
                message2print = "{(Step 1C1/33) got" + "; qpuimage-got-by-get2supportedimageformats: " + str(info2formats['QPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'RPU' in keys2supportedimageformats:                     
            try:
                info2formats['RPU'] = get2supportedimageformats4rpu(task4supportedimageformats2xi['RPU'])
                message2print = "{(Step 1C1/33) got" + "; rpuimage-got-by-get2supportedimageformats: " + str(info2formats['RPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'SPU' in keys2supportedimageformats:                     
            try:
                info2formats['SPU'] = get2supportedimageformats4spu(task4supportedimageformats2xi['SPU'])
                message2print = "{(Step 1C1/33) got" + "; spuimage-got-by-get2supportedimageformats: " + str(info2formats['SPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'TPU' in keys2supportedimageformats:                     
            try:
                info2formats['TPU'] = get2supportedimageformats4tpu(task4supportedimageformats2xi['TPU'])
                message2print = "{(Step 1C1/33) got" + "; tpuimage-got-by-get2supportedimageformats: " + str(info2formats['TPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'UPU' in keys2supportedimageformats:                     
            try:
                info2formats['UPU'] = get2supportedimageformats4upu(task4supportedimageformats2xi['UPU'])
                message2print = "{(Step 1C1/33) got" + "; upuimage-got-by-get2supportedimageformats: " + str(info2formats['UPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'VPU' in keys2supportedimageformats:                    
            try:
                info2formats['VPU'] = get2supportedimageformats4vpu(task4supportedimageformats2xi['VPU'])
                message2print = "{(Step 1C1/33) got" + "; vpuimage-got-by-get2supportedimageformats: " + str(info2formats['VPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'WPU' in keys2supportedimageformats:                     
            try:
                info2formats['WPU'] = get2supportedimageformats4wpu(task4supportedimageformats2xi['WPU'])
                message2print = "{(Step 1C1/33) got" + "; wpuimage-got-by-get2supportedimageformats: " + str(info2formats['WPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'XPU' in keys2supportedimageformats:                     
            try:
                info2formats['XPU'] = get2supportedimageformats4xpu(task4supportedimageformats2xi['XPU'])
                message2print = "{(Step 1C1/33) got" + "; xpuimage-got-by-get2supportedimageformats: " + str(info2formats['XPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'YPU' in keys2supportedimageformats:                     
            try:
                info2formats['YPU'] = get2supportedimageformats4ypu(task4supportedimageformats2xi['YPU'])
                message2print = "{(Step 1C1/33) got" + "; ypuimage-got-by-get2supportedimageformats: " + str(info2formats['YPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
        if 'ZPU' in keys2supportedimageformats:                     
            try:
                info2formats['ZPU'] = get2supportedimageformats4zpu(task4supportedimageformats2xi['ZPU'])
                message2print = "{(Step 1C1/33) got" + "; zpuimage-got-by-get2supportedimageformats: " + str(info2formats['ZPU'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
            except:
                pass
                     
            
    message2print = "{(Step 33/33) returning" + "; info2formats-returning-by-get2supportedimageformats: " + str(info2formats) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 

    if debug is True:
        print('(Step 33/33) of get2supportedimageformats4xi - RETURNING INFO2FORMATS:  ', info2formats)  
        #  {'GPU': {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}, 
        #   'ZPU': {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}, '
        #    PPU': {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}, 
        #   'APU': {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}}
 

    return info2formats
            
#</function4xi> 

 



# -------------------------------------------------------------------------------------------------
#<function4xi function = "wait2image4xi" usage = "        
#   print('(Step 16C/25) OF IMAGE2D4XI5TEST - TRYING TO WAIT PROCESSING UNIT(S) OF XI FOR JUST CREATED 2D IMAGE: ', time4xi())   
#   try:                               
#       task4wait2image  = {}
#       task4wait2image['APU']  = {}
#       task4wait2image['GPU']  = {}
#       task4wait2image['PPU']  = {}
#       task4wait2image['ZPU']  = {}
#       response4wait2image = wait2image4xi(task4wait2image) 
#       keys2waitresponse = response4wait2image.keys()
#       for key2waitresponse in sorted(keys2waitresponse):
#           print(key2waitresponse, ' : ', response4wait2image[key2waitresponse] )
#           # APU  :  <queue4xi.Queue4Xi object at 0x0000000005CCAEB8>
#           # PPU  :  <queue4xi.Queue4Xi object at 0x0000000005CE0EF0>
#           # ZPU  :  <queue4xi.Queue4Xi object at 0x0000000005CE6E80>                                                                                                 
#   except:
#       print('(Step 16Z3/25) OF IMAGE2D4XI5TEST *** FAILED TO WAIT PROCESSING UNIT(S) OF XI FOR JUST CREATED 2D IMAGE: ', time4xi()) 
#">

# -------------------------------------------------------------------------------------------------   
def wait2image4xi(task4wait2xi=None):

    '''
    waits 
    '''
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    debug = True
    class2print = "wait2image4xi" 
    method2print = "wait2image4xi"

    message2print = "{(Step 1A/33) started" + "; wait2image4xi-started: " + str(wait2image4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # <function wait2image4xi at 0x0000000003AF0348> 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4wait2xi-to-wait2image4xi: " + str(task4wait2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    #     
    if task4wait2xi is None:
        task4wait2xi  = {}  
    keys2wait = task4wait2xi.keys()
    if debug is True:
       print("(Step 1C/33) of wait2image4xi - keys2wait: ", sorted(keys2wait))
       # ['APU', 'GPU', 'PPU', 'ZPU']
    
    code2ack  = ' '
    code2nack = ' '    
         
    
    image2dwait4xi = {}
      
             
    # -----------------------------------------------------------------------------------------
    # (Step A/33) - APU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step A/33) 
        # ----------------------------------------------------------------------------- 
        if 'APU' in keys2wait:
            message2print = "{(Step A/33) passing" + "; task-passing-to-wait2image4apu: " + str(task4wait2xi['APU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4apu = wait2image4apu()
            image2dwait4xi ['APU'] = response2wait4apu ['QUEUE']                                                     
                         
            message2print = "{(Step A1/33) set" + "; apu-image-wait-set-by-wait2image4apu to: " + str(image2dwait4xi ['APU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step A2/33) of wait2image4xi - set wait4xi of APU image to: ", image2dwait4xi ['APU'])
                # <queue4xi.Queue4Xi object at 0x0000000005CD1518>
                
            code2ack  = code2ack + 'A1-'
        else:
            pass    
    except:
        message2print = "{(Step AZ1/33) yielded" + "; apu-yielded-by-wait2image4xi: " + 'APU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'AZ1-'

    # -----------------------------------------------------------------------------------------
    # (Step B/33) - BPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step B/33) 
        # ----------------------------------------------------------------------------- 
        if 'BPU' in keys2wait:
            message2print = "{(Step B/33) passing" + "; task-passing-to-wait2image4bpu: " + str(task4wait2xi['BPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4bpu = wait2image4bpu()
            image2dwait4xi ['BPU']  = response2wait4bpu ['QUEUE']                                                      # 
         
            message2print = "{(Step B1/33) set" + "; bpu-image-wait-set-by-wait2image4bpu to: " + str(image2dwait4xi ['BPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'B1-'
        else:
            pass    
    except:
        message2print = "{(Step BZ1/33) yielded" + "; bpu-yielded-by-wait2image4xi: " + 'BPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'BZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step C/33) - CPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step C/33) 
        # ----------------------------------------------------------------------------- 
        if 'CPU' in keys2wait:
            message2print = "{(Step C/33) passing" + "; task-passing-to-wait2image4cpu: " + str(task4wait2xi['CPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4cpu = wait2image4cpu()
            image2dwait4xi ['CPU']  = response2wait4cpu ['QUEUE']                                                      # 
         
            message2print = "{(Step C1/33) set" + "; cpu-image-wait-set-by-wait2image4cpu to: " + str(image2dwait4xi ['CPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'C1-'
        else:
            pass    
    except:
        message2print = "{(Step CZ1/33) yielded" + "; cpu-yielded-by-wait2image4xi: " + 'CPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'CZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step D/33) - DPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step D/33) 
        # ----------------------------------------------------------------------------- 
        if 'DPU' in keys2wait:
            message2print = "{(Step D/33) passing" + "; task-passing-to-wait2image4dpu: " + str(task4wait2xi['DPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4dpu = wait2image4dpu()
            image2dwait4xi ['DPU']  = response2wait4dpu ['QUEUE']                                                      # 
         
            message2print = "{(Step D1/33) set" + "; dpu-image-wait-set-by-wait2image4dpu to: " + str(image2dwait4xi ['DPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'D1-'
        else:
            pass    
    except:
        message2print = "{(Step DZ1/33) yielded" + "; dpu-yielded-by-wait2image4xi: " + 'DPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'DZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step E/33) - EPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step E/33) 
        # ----------------------------------------------------------------------------- 
        if 'EPU' in keys2wait:
            message2print = "{(Step E/33) passing" + "; task-passing-to-wait2image4epu: " + str(task4wait2xi['EPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4epu = wait2image4epu()
            image2dwait4xi ['EPU']  = response2wait4epu ['QUEUE']                                                      # 
         
            message2print = "{(Step E1/33) set" + "; epu-image-wait-set-by-wait2image4epu to: " + str(image2dwait4xi ['EPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'E1-'
        else:
            pass    
    except:
        message2print = "{(Step EZ1/33) yielded" + "; epu-yielded-by-wait2image4xi: " + 'EPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'EZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step F/33) - FPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step F/33) 
        # ----------------------------------------------------------------------------- 
        if 'FPU' in keys2wait:
            message2print = "{(Step F/33) passing" + "; task-passing-to-wait2image4fpu: " + str(task4wait2xi['FPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2waitfpu = wait2image4fpu()
            image2dwait4xi ['FPU']  = response2wait4fpu ['QUEUE']                                                      # 
         
            message2print = "{(Step F1/33) set" + "; fpu-image-wait-set-by-wait2image4fpu to: " + str(image2dwait4xi ['PU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'F1-'
        else:
            pass    
    except:
        message2print = "{(Step FZ1/33) yielded" + "; fpu-yielded-by-wait2image4xi: " + 'FPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'FZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step G/33) - GPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step G/33) 
        # ----------------------------------------------------------------------------- 
        if 'GPU' in keys2wait:
            message2print = "{(Step G/33) passing" + "; task-passing-to-wait2image4gpu: " + str(task4wait2xi['GPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            #
            response2waitgpu = wait2image4gpu() 
        
            image2dwait4xi ['GPU']  = response2wait4gpu ['QUEUE']                                                       # 
         
            message2print = "{(Step G1/33) set" + "; gpu-image-wait-set-by-wait2image4gpu to: " + str(image2dwait4xi ['GPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'G1-'
        else:
            pass    
    except:
        message2print = "{(Step GZ1/33) yielded" + "; gpu-yielded-by-wait2image4xi: " + 'GPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'GZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step H/33) - HPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step H/33) 
        # ----------------------------------------------------------------------------- 
        if 'HPU' in keys2wait:
            message2print = "{(Step H/33) passing" + "; task-passing-to-wait2image4hpu: " + str(task4wait2xi['HPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            #
            response2waithpu = wait2image4hpu() 
        
            image2dwait4xi ['HPU']  = response2wait4hpu ['QUEUE']                                                      # 
         
            message2print = "{(Step H1/33) set" + "; hpu-image-wait-set-by-wait2image4hpu to: " + str(image2dwait4xi ['HPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'H1-'
        else:
            pass    
    except:
        message2print = "{(Step HZ1/33) yielded" + "; hpu-yielded-by-wait2image4xi: " + 'HPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'HZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step I/33) - IPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step I/33) 
        # ----------------------------------------------------------------------------- 
        if 'IPU' in keys2wait:
            message2print = "{(Step I/33) passing" + "; task-passing-to-wait2image4ipu: " + str(task4wait2xi['IPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            #
            response2wait4ipu = wait2image4ipu() 
        
            image2dwait4xi ['IPU']  = response2wait4ipu ['QUEUE']                                                      # 
         
            message2print = "{(Step I1/33) set" + "; ipu-image-wait-set-by-wait2image4ipu to: " + str(image2dwait4xi ['IPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'I1-'
        else:
            pass    
    except:
        message2print = "{(Step IZ1/33) yielded" + "; ipu-yielded-by-wait2image4xi: " + 'IPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'IZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step J/33) - JPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step J/33) 
        # ----------------------------------------------------------------------------- 
        if 'JPU' in keys2wait:
            message2print = "{(Step J/33) passing" + "; task-passing-to-wait2image4jpu: " + str(task4wait2xi['JPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            #
            response2wait4jpu = wait2image4jpu() 
            image2dwait4xi ['JPU']  = response2wait4jpu ['QUEUE']                                                      # 
         
            message2print = "{(Step J1/33) set" + "; jpu-image-wait-set-by-wait2image4jpu to: " + str(image2dwait4xi ['JPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'J1-'
        else:
            pass    
    except:
        message2print = "{(Step JZ1/33) yielded" + "; jpu-yielded-by-wait2image4xi: " + 'JPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'JZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step K/33) - KPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step K/33) 
        # ----------------------------------------------------------------------------- 
        if 'KPU' in keys2wait:
            message2print = "{(Step K/33) passing" + "; task-passing-to-wait2image4kpu: " + str(task4wait2xi['KPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4kpu = wait2image4kpu()
            image2dwait4xi ['KPU']  = response2wait4kpu ['QUEUE']                                                      # 
         
            message2print = "{(Step K1/33) set" + "; kpu-image-wait-set-by-wait2image4kpu to: " + str(image2dwait4xi ['KPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'K1-'
        else:
            pass    
    except:
        message2print = "{(Step KZ1/33) yielded" + "; kpu-yielded-by-wait2image4xi: " + 'KPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'KZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step L/33) - LPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step L/33) 
        # ----------------------------------------------------------------------------- 
        if 'LPU' in keys2wait:
            message2print = "{(Step L/33) passing" + "; task-passing-to-wait2image4lpu: " + str(task4wait2xi['LPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4lpu = wait2image4lpu()
            image2dwait4xi ['LPU']  = response2wait4lpu ['QUEUE']                                                      # 
         
            message2print = "{(Step L1/33) set" + "; lpu-image-wait-set-by-wait2image4lpu to: " + str(image2dwait4xi ['LPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + '1-'
        else:
            pass    
    except:
        message2print = "{(Step LZ1/33) yielded" + "; lpu-yielded-by-wait2image4xi: " + 'LPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'LZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step M/33) - MPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step M/33) 
        # ----------------------------------------------------------------------------- 
        if 'MPU' in keys2wait:
            message2print = "{(Step M/33) passing" + "; task-passing-to-wait2image4mpu: " + str(task4wait2xi['MPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4mpu = wait2image4mpu()
            image2dwait4xi ['MPU']  = response2wait4mpu ['QUEUE']                                                      # 
         
            message2print = "{(Step M1/33) set" + "; mpu-image-wait-set-by-wait2image4mpu to: " + str(image2dwait4xi ['MPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'M1-'
        else:
            pass    
    except:
        message2print = "{(Step MZ1/33) yielded" + "; mpu-yielded-by-wait2image4xi: " + 'MPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'MZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step N/33) - NPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step N/33) 
        # ----------------------------------------------------------------------------- 
        if 'NPU' in keys2wait:
            message2print = "{(Step N/33) passing" + "; task-passing-to-wait2image4npu: " + str(task4wait2xi['NPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4npu = wait2image4npu()
            image2dwait4xi ['NPU']  = response2wait4npu ['QUEUE']                                                      # 
         
            message2print = "{(Step N1/33) set" + "; npu-image-wait-set-by-wait2image4npu to: " + str(image2dwait4xi ['NPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'N1-'
        else:
            pass    
    except:
        message2print = "{(Step NZ1/33) yielded" + "; npu-yielded-by-wait2image4xi: " + 'NPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'NZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step O/33) - OPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step O/33) 
        # ----------------------------------------------------------------------------- 
        if 'OPU' in keys2wait:
            message2print = "{(Step O/33) passing" + "; task-passing-to-wait2image4opu: " + str(task4wait2xi['OPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4opu = wait2image4opu()
            image2dwait4xi ['OPU']  = response2wait4opu ['QUEUE']                                                      # 
         
            message2print = "{(Step O1/33) set" + "; opu-image-wait-set-by-wait2image4opu to: " + str(image2dwait4xi ['OPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'O1-'
        else:
            pass    
    except:
        message2print = "{(Step OZ1/33) yielded" + "; opu-yielded-by-wait2image4xi: " + 'OPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'OZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step P/33) - PPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step P/33) 
        # ----------------------------------------------------------------------------- 
        if 'PPU' in keys2wait:
            message2print = "{(Step P/33) passing" + "; task-passing-to-wait2image4ppu: " + str(task4wait2xi['PPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4ppu = wait2image4ppu()
            image2dwait4xi ['PPU']  = response2wait4ppu ['QUEUE']                                                      # 
         
            message2print = "{(Step P1/33) set" + "; ppu-image-wait-set-by-wait2image4ppu to: " + str(image2dwait4xi ['PPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'P1-'
        else:
            pass    
    except:
        message2print = "{(Step PZ1/33) yielded" + "; ppu-yielded-by-wait2image4xi: " + 'PPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'PZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Q/33) - QPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Q/33) 
        # ----------------------------------------------------------------------------- 
        if 'QPU' in keys2wait:
            message2print = "{(Step Q/33) passing" + "; task-passing-to-wait2image4qpu: " + str(task4wait2xi['QPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4qpu = wait2image4qpu()
            image2dwait4xi ['QPU']  = response2wait4qpu ['QUEUE']                                                      # 
         
            message2print = "{(Step Q1/33) set" + "; qpu-image-wait-set-by-wait2image4qpu to: " + str(image2dwait4xi ['QPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Q1-'
        else:
            pass    
    except:
        message2print = "{(Step QZ1/33) yielded" + "; qpu-yielded-by-wait2image4xi: " + 'QPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'QZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step R/33) - RPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step R/33) 
        # ----------------------------------------------------------------------------- 
        if 'RPU' in keys2wait:
            message2print = "{(Step R/33) passing" + "; task-passing-to-wait2image4rpu: " + str(task4wait2xi['RPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4rpu = wait2image4rpu()
            image2dwait4xi ['RPU']  = response2wait4rpu ['QUEUE']                                                      # 
         
            message2print = "{(Step R1/33) set" + "; rpu-image-wait-set-by-wait2image4rpu to: " + str(image2dwait4xi ['RPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'R1-'
        else:
            pass    
    except:
        message2print = "{(Step RZ1/33) yielded" + "; rpu-yielded-by-wait2image4xi: " + 'RPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'RZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step S/33) - SPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step S/33) 
        # ----------------------------------------------------------------------------- 
        if 'SPU' in keys2wait:
            message2print = "{(Step S/33) passing" + "; task-passing-to-wait2image4spu: " + str(task4wait2xi['SPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4spu = wait2image4spu()
            image2dwait4xi ['SPU']  = response2wait4spu ['QUEUE']                                                      # 
         
            message2print = "{(Step S1/33) set" + "; spu-image-wait-set-by-wait2image4spu to: " + str(image2dwait4xi ['SPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'S1-'
        else:
            pass    
    except:
        message2print = "{(Step SZ1/33) yielded" + "; spu-yielded-by-wait2image4xi: " + 'SPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'SZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step T/33) - TPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step T/33) 
        # ----------------------------------------------------------------------------- 
        if 'TPU' in keys2wait:
            message2print = "{(Step T/33) passing" + "; task-passing-to-wait2image4tpu: " + str(task4wait2xi['TPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4tpu = wait2image4tpu()
            image2dwait4xi ['TPU']  = response2wait4tpu ['QUEUE']                                                      # 
         
            message2print = "{(Step T1/33) set" + "; tpu-image-wait-set-by-wait2image4tpu to: " + str(image2dwait4xi ['TPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'T1-'
        else:
            pass    
    except:
        message2print = "{(Step TZ1/33) yielded" + "; tpu-yielded-by-wait2image4xi: " + 'TPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'TZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step U/33) - UPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step U/33) 
        # ----------------------------------------------------------------------------- 
        if 'UPU' in keys2wait:
            message2print = "{(Step U/33) passing" + "; task-passing-to-wait2image4upu: " + str(task4wait2xi['UPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4upu = wait2image4upu()
            image2dwait4xi ['UPU']  = response2wait4upu ['QUEUE']                                                      # 
         
            message2print = "{(Step U1/33) set" + "; upu-image-wait-set-by-wait2image4upu to: " + str(image2dwait4xi ['UPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'U1-'
        else:
            pass    
    except:
        message2print = "{(Step UZ1/33) yielded" + "; upu-yielded-by-wait2image4xi: " + 'UPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'UZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step V/33) - VPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step V/33) 
        # ----------------------------------------------------------------------------- 
        if 'VPU' in keys2wait:
            message2print = "{(Step V/33) passing" + "; task-passing-to-wait2image4vpu: " + str(task4wait2xi['VPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4vpu = wait2image4vpu()
            image2dwait4xi ['VPU']  = response2wait4vpu ['QUEUE']                                                      # 
         
            message2print = "{(Step V1/33) set" + "; vpu-image-wait-set-by-wait2image4vpu to: " + str(image2dwait4xi ['VPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'V1-'
        else:
            pass    
    except:
        message2print = "{(Step VZ1/33) yielded" + "; vpu-yielded-by-wait2image4xi: " + 'VPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'VZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step W/33) - WPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step W/33) 
        # ----------------------------------------------------------------------------- 
        if 'WPU' in keys2wait:
            message2print = "{(Step W/33) passing" + "; task-passing-to-wait2image4wpu: " + str(task4wait2xi['WPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4wpu = wait2image4wpu()
            image2dwait4xi ['WPU']  = response2wait4wpu ['QUEUE']                                                      # 
         
            message2print = "{(Step W1/33) set" + "; wpu-image-wait-set-by-wait2image4wpu to: " + str(image2dwait4xi ['WPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'W1-'
        else:
            pass    
    except:
        message2print = "{(Step WZ1/33) yielded" + "; wpu-yielded-by-wait2image4xi: " + 'WPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'WZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step X/33) - XPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step X/33) 
        # ----------------------------------------------------------------------------- 
        if 'XPU' in keys2wait:
            message2print = "{(Step X/33) passing" + "; task-passing-to-wait2image4xpu: " + str(task4wait2xi['XPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4xpu = wait2image4xpu() 
            image2dwait4xi ['XPU']  = response2wait4xpu ['QUEUE']                                                      # 
         
            message2print = "{(Step X1/33) set" + "; xpu-image-wait-set-by-wait2image4xpu to: " + str(image2dwait4xi ['XPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step X2/33) of wait2image4xi - set wait4xi of XPU image to: ", image2dwait4xi ['XPU'])
            code2ack  = code2ack + 'X1-'
        else:
            pass    
    except:
        message2print = "{(Step XZ1/33) yielded" + "; xpu-yielded-by-wait2image4xi: " + 'XPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'XZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Y/33) - YPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Y/33) 
        # ----------------------------------------------------------------------------- 
        if 'YPU' in keys2wait:
            message2print = "{(Step Y/33) passing" + "; task-passing-to-wait2image4ypu: " + str(task4wait2xi['YPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4ypu = wait2image4ypu()
            image2dwait4xi ['YPU']  = response2wait4ypu ['QUEUE']                                                      # 
         
            message2print = "{(Step Y1/33) set" + "; ypu-image-wait-set-by-wait2image4ypu to: " + str(image2dwait4xi ['YPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
        
            code2ack  = code2ack + 'Y1-'
        else:
            pass    
    except:
        message2print = "{(Step YZ1/33) yielded" + "; ypu-yielded-by-wait2image4xi: " + 'YPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'YZ1-'
        
    # -----------------------------------------------------------------------------------------
    # (Step Z/33) - ZPU
    # -----------------------------------------------------------------------------------------               
    try:
        # -----------------------------------------------------------------------------
        # (Step Z/33) 
        # ----------------------------------------------------------------------------- 
        if 'ZPU' in keys2wait:
            message2print = "{(Step Z/33) passing" + "; task-passing-to-wait2image4zpu: " + str(task4wait2xi['ZPU'])  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                         
            # 
            response2wait4zpu = wait2image4zpu()
            image2dwait4xi ['ZPU']  = response2wait4zpu ['QUEUE']                                                      # 
         
            message2print = "{(Step Z1/33) set" + "; zpu-image-wait-set-by-wait2image4zpu to: " + str(image2dwait4xi ['ZPU'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                          
            # 
            if debug is True:
                print("{(Step Z2/33) of wait2image4xi - set wait4xi of ZPU image to: ", image2dwait4xi ['ZPU'])
            code2ack  = code2ack + 'Z1-'
        else:
            pass    
    except:
        message2print = "{(Step ZZ1/33) yielded" + "; zpu-yielded-by-wait2image4xi: " + 'ZPU' + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + 'ZZ1-'

                                                
    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    if debug is True:
        print("{(Step 33/33) of wait2image4xi - RETURNING IMAGE2DWAIT4XI : ", image2dwait4xi)
        # APU  :  <queue4xi.Queue4Xi object at 0x0000000005DDF630>
        # PPU  :  <queue4xi.Queue4Xi object at 0x0000000005DF3668>
        # ZPU  :  <queue4xi.Queue4Xi object at 0x0000000005DF95F8>
        
    message2print = "{(Step 33/33) returning" + "; image2dwait4xi-returning-by-wait2image4xi: " + str(image2dwait4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
    
    return image2dwait4xi
    
    

   
#</function4xi> 
                                               
# =================================================================================================
#<class4xi class = "Image2D4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for XI 2D image" usage = "OpenCL XI 2D image"
#>

# =================================================================================================
class Image2D4Xi(object): 
    ''' 
    Image2D4Xi offers  methods for XI 2D image
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2xi = cpu_corecount4xi()
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
            'create2image',                    # ACK 5.31   p76    
            'copy2image',                      # ACK 5.31   p88
            'copy2imagetobuffer',              # ACK 5.3.4  p90
            'copy2buffertoimage',              # ACK 5.3.4  p92
            'read2image',                      # ACK 5.3.3  p84
            'write2image',                     # ACK 5.3.3  p84            
            'map2image',                       # ACK 5.3.5  p94            
            'get2imageinfo',                   # ACK 5.3.6  p97
            'get2supportedimageformats',       # ACK 5.3.2  p82 
            'retain2image',                    # ACK 5.4.1  p99 
            'release2image',                   # ACK 5.4.1  p99
            'trace2image',                     # ACK 
            'set2imagecallback',               # ACK 
            'set2image',                       # ACK                
            'wait2image',                      # ACK 
            'sense',                           # ACK 
            'reason',                          # ACK 
            'ace')                             # ACK         
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Image2D4Xi" usage = "
    #   print('(Step 105A/700) OF IMAGE2D4XI5TEST - CREATING IMAGE4XI OBJECT ', time4xi())     
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                        
    #       # ---------------------------------------------------------------------------------------------        
    #       imageobject2xi = Image2D4Xi()
    #       print('(Step 105B/700) OF IMAGE2D4XI5TEST - CREATED IMAGE4XI OBJECT: ', imageobject2xi)                                  
    #       # <image2d4xi.Image2D4Xi object at 0x00000000048AAB38>
    #   except:
    #       print('(Step 105Z/700) OF IMAGE2D4XI5TEST *** FAILED TO CREATE IMAGE4XI OBJECT')
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4imagecreate2xi = None):
        '''
        _init__ method initializes Image2D4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "Image2D4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-Image2D4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 23:41:37 09/06/11 Pacific Daylight Time 

        message2print = "{(Step 1B/33) borning" + "; image2d4xi-of-Image2D4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-image2d4xi-of-Image2D4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2xi-sharing-by-image2d4xi-of-Image2D4Xi: " + str(Image2D4Xi.classvariable2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4             
                                
        message2print = "{(Step 1E/33) passed" + "; task4imagecreate2xi-passed-to-init-of-Image2D4Xi: " + str(task4imagecreate2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                            
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) passing" + "; task4imagecreate2xi-passing-to-create2image4xi-by-init-of-Image2D4Xi: " + str(task4imagecreate2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None  
        
        image2xi = create2image4xi(task4imagecreate2xi)
        
        message2print = "{(Step 2B/33) performed" + "; create2image4xi-performed-by-init-of-Image2D4Xi: " + str(create2image4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <function create2image4xi at 0x0000000003A9E7C8>
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; image2d4xi-of-Image2D4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # { Image2D4Xi : __init__ ; (Step 3A/33) activated; image2d4xi-of-Image2D4Xi-activated: ; time: 00:14:05 09/07/11 Pacific Daylight Time} 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-image2d4xi-of-Image2D4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'> 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2xi-shared-by-image2d4xi-of-Image2D4Xi: " + str(Image2D4Xi.classvariable2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4           
       
        message2print = "{(Step 3D/33) returning" + "; init-of-Image2D4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 00:14:05 09/07/11 Pacific Daylight Time
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2image-of-Image2D4Xi" usage = "
    #    print('(Step 123A/700) OF IMAGE2D4XI5TEST - TRYING TO CREATE 2D IMAGE for XI ', time4xi()) 
    # 
    #    try:
    #        xi2xi = Image2D4Xi()                            
    #        
    #        task4create2image = {} 
    #        for key2pu in keys2pu:
    #            task4create2image [key2pu]  = {}
    #                        
    #        response4create2Dimage = xi2xi.create2image(task4create2image)                                  
    #        
    #        keys2response = response4create2Dimage.keys()
    #        
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4create2Dimage[key2response])
    #            #
    #            
    #    except:
    #        print('(Step 123Z/700) OF IMAGE2D4XI5TEST *** FAILED TO CREATE 2D IMAGE for XI ', time4xi())               
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2image(self, task4image2create = None):
        '''
        create2image method creates 2D image objects of Image2D4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "create2image"
                     
        message2print = "{(Step 1A/33) started" + "; create2image-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 00:14:05 09/07/11 Pacific Daylight Time 
            
        message2print = "{(Step 1B/33) passed" + "; task4image2create-passed-to-create-of-Image2D4Xi: " + str(task4image2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4image2create-passing-to-create2image4xi-by-create2image-of-Image2D4Xi: " + str(task4image2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # None      
  
        image2xi = create2image4xi(task4image2create)

        message2print = "{(Step 2B/33) performed" + "; create2image4xi-performed-by-create2image-of-Image2D4Xi: " + str(create2image4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2image4xi at 0x00000000039DF7C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; image2xi-returning-by-create2image-of-Image2D4Xi: " + str(image2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return image2xi
                                
    #                        
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2image-of-Image2D4Xi" usage = "
    # 
    #    response4set2Dimage = {} 
    #    print('(Step 114A/700) OF IMAGE2D4XI5TEST - TRYING TO SET 2D IMAGE4XI ', time4xi())   
    #    try:                               
    #        response4set2Dimage = imageobject2xi.set2image(task4set2image)                                                                                                         
    #                                                                                      
    #        print('(Step 114B/700) OF IMAGE2D4XI5TEST - SET 2D IMAGE4XI ', time4xi())
    #        keys2response = response4set2Dimage.keys()
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4set2Dimage[key2response])
    #            # APU  :  {'CODE2ERROR': 0, ... 'ROWPITCH': 800, ...
    #            # ....
    #            # ZPU  :  {'CODE2ERROR': 0, ... 'ROWPITCH': 800, ...
    #            
    #        print('(Step 114B/700) OF IMAGE2D4XI5TEST - SET 2D IMAGE4XI ', time4xi())
    #        # 06:50:19 11/05/11 Pacific Daylight Time
    #             
    #    except:
    #        print('(Step 114Z/700) OF IMAGE2D4XI5TEST *** FAILED TO SET 2D IMAGE4XI *** ', time4xi()) 
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2image(self, task4set2image = None):
        '''
        sets 2D image XI objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "set2image"
                     
        message2print = "{(Step 1A/33) started" + "; set2image-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2image-passed-to-set2image-of-Image2D4Xi: " + str(task4set2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2image-passing-to-set2image4xi-by-set2image-of-Image2D4Xi: " + str(task4set2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 

        image2xi = set2image4xi(task4set2image)

        message2print = "{(Step 2B/33) performed" + "; set2image4xi-performed-by-set2image-of-Image2D4Xi: " + str(set2image4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function set2image4xi at 0x0000000003AB36C8> 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; image2xi-returning-by-set2image-of-Image2D4Xi: " + str(image2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                
        return image2xi
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2imageinfo-of-Image2D4Xi" usage = "
    #   
    #    print('(Step 106A1/700) OF IMAGE2D4XI5TEST - TRYING TO GET 2D IMAGE INFO WITH METHOD ', time4xi())    
    #    try: 
    #        task4getinfo2image = {}
    #        for key2pu in keys2pu:
    #            if KB2CC [key2pu] == 'ACK':
    #                task4getinfo2image [key2pu]  = {}
    #                task4getinfo2image [key2pu] ['WIDTH']  = 0
    #                task4getinfo2image [key2pu] ['HEIGHT']  = 0 
    #               
    #        response4get2imageinfo = imageobject2xi.get2imageinfo(task4getinfo2image)                                 
    #                                               
    #        keys2response = response4get2imageinfo.keys()
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4get2imageinfo[key2response])
    #            # APU  :  {'WIDTH': 800, 'HEIGHT': 800}
    #            # GPU  :  {'WIDTH': 800, 'HEIGHT': 800}
    #            # ZPU  :  {'WIDTH': 800, 'HEIGHT': 800}
    #    except:
    #        print('(Step 106Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO GET 2D IMAGE INFO WITH METHOD ', time4xi())    
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2imageinfo(self, task4imageinfo2xi=None):
        '''
        get2imageinfo method gets 2D objects of Image2D4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "get2imageinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2imageinfo-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        image2xi = get2imageinfo4xi(task4imageinfo2xi)
        
        message2print = "{(Step 2A/33) returning" + "; image2xi-returning-by-get2imageinfo-of-Image2D4Xi: " + str(image2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
        return image2xi
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2supportedimageformats-of-Image2D4Xi" usage = "
    # 
    #    print('(Step 106B1/700) OF IMAGE2D4XI5TEST - TRYING TO GET SUPPORTED IMAGE FORMATS FOR XI')
    #    try:
    #        task4supportedimageformats2image = {} 
    #        for key2pu in keys2pu:
    #            if KB2CC [key2pu] == 'ACK':
    #                task4supportedimageformats2image [key2pu]  = {}
    #        
    #        response4supportedimageformats = imageobject2xi.get2supportedimageformats(task4supportedimageformats2image)
    #           
    #        keys2response = response4supportedimageformats.keys()
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4supportedimageformats[key2response])
    #            # APU  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
    #            # GPU  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'}
    #            # ZPU  :  {'TYPE': 'CL_UNORM_INT8', 'ORDER': 'CL_RGBA'} 
    #    except:
    #        print('(Step 102Z/33) OF XI4XI5TEST *** FAILED TO GET SUPPORTED 2D IMAGE FORMATS FOR XI***')    
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2supportedimageformats(self, task4supportedimageformats2xi=None ):
        '''
        get2supportedimageformats method gets supported imageformats by objects of Image2D4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "get2supportedimageformats"
                     
        message2print = "{(Step 1A/33) started" + "; get2supportedimageformats-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        supportedimageformats2xi = get2supportedimageformats4xi(task4supportedimageformats2xi)
        
        message2print = "{(Step 2A/33) returning" + "; supportedimageformats2xi-returning-by-get2imageinfo-of-Image2D4Xi: " + str(supportedimageformats2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
        return supportedimageformats2xi
                            
    #</methodize4xi>    
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "read2image-of-Image2D4Xi" usage = "
    #
    #    print('(Step 127C/700) OF IMAGE2D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH READ2IMAGE4XI ', time4xi())        
    #    try: 
    #        task4read2image = {} 
    #        for key2pu in keys2pu:
    #            task4read2image[key2pu]  = {}    
    #        
    #        response4read2image = xi2xi.read2image(task4read2image)
    #        
    #        keys2readresponse = response4read2image.keys()
    #        for key2readresponse in sorted(keys2readresponse):
    #            kb2detail = response4read2image[key2readresponse]
    #            keys2detail = kb2detail.keys()
    #            for key2detail in keys2detail: 
    #                print(key2readresponse, key2detail, kb2detail[key2detail])
    #                #
    #    except:
    #        print('(Step 127Z4/700) OF IMAGE2D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH READ2IMAGE4XI ', time4xi()) 
    #      
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def read2image(self, task4read2image = None):
        '''
        reads Image2D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "read2image"
                     
        message2print = "{(Step 1A/33) started" + "; read2image-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 00:20:02 10/05/11 Pacific Daylight Time 
            
        message2print = "{(Step 1B/33) passed" + "; task4read2image-passed-to-read2image-of-Image2D4Xi: " + str(task4read2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4read2image-passing-to-read2image4xi-by-read2image-of-Image2D4Xi: " + str(task4read2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None
  
        response4readimage2xi = read2image4xi(task4read2image)

        message2print = "{(Step 2B/33) performed" + "; read2image4xi-performed-by-read2image-of-Image2D4Xi: " + str(read2image4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function read2image4xi at 0x000000000385DA48> 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4readimage2xi-returning-by-read2image-of-Image2D4Xi: " + str(response4readimage2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
  
        return response4readimage2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "map2image-of-Image2D4Xi" usage = "
    # 
    #    print('=' *33)          
    #    print('(Step 132A/700) OF IMAGE2D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH MAP2IMAGE4XI ', time4xi())        
    #    print('=' *33)      
    #    #                         
    #    response4map2image      = {} 
    #    task4map2image        = {}                                                                                    
    #    queue4map          = {} 
    #    channel4map2publish = {} 
    #    channel4map2consume = {} 
    #    try:
    #        task4map2image = {} 
    #        for key2pu in keys2pu:
    #            if KB2CC [key2pu] == 'ACK':
    #                task4map2image [key2pu]  = {}
    #                                                
    #        response4map2image = xi2xi.map2image(task4map2image)
    #        
    #        print('(Step 132B/700) OF IMAGE2D4XI5TEST - GOT RESPONSE4MAP2IMAGE ', response4map2image)
    #        # {'GPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E678D0>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7228>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7224>}, 
    #        #  'ZPU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E6E128>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7260>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7256>}, 
    #        #  'APU': {'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E67F28>, 'PUBLISHERCHANNEL': <read-write PipeConnection, handle 7196>, 'CONSUMERCHANNEL': <read-write PipeConnection, handle 7192>}}
    #        print('(Step 9CB/700) OF IMAGE2D4XI5TEST - CONTINUES AFTER GETTING RESPONSE4MAP2IMAGE ', time4xi())   
    #    except:
    #        print('(Step 132Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH MAP2IMAGE4XI ', time4xi())
    #                 
    #    print('(Step 132C/700) OF IMAGE2D4XI5TEST - TRYING TO INITIALIZE QUEUE FOR MAP ', time4xi())               
    #    try: 
    #        queue4map          = {}
    #    except:
    #        print('(Step 132Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO INITIALIZE QUEUES FOR MAP ', time4xi()) 
    #    try:            
    #        channel4map2publish = {}
    #    except:
    #        print('(Step 132Z2/700) OF IMAGE2D4XI5TEST *** FAILED TO INITIALIZE PUBLISHING CHANNELS FOR MAP ', time4xi()) 
    #    
    #    try:    
    #        channel4map2consume = {}
    #    except:    
    #        print('(Step 132Z5/700) OF IMAGE2D4XI5TEST *** FAILED TO INITIALIZE CONSUMING CHANNELS FOR MAP ', time4xi())
    #    try:         
    #        for key2pu in keys2pu:
    #            try:
    #                if KB2CC [key2pu] == 'ACK':
    #                    try:   
    #                        queue4map [key2pu] = response4map2image [key2pu] ['QUEUE']
    #                        print(key2pu, ' SET QUEUE TO : ', queue4map [key2pu])
    #                        # ZPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006046588>
    #                        # GPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006046400>
    #                        # APU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000006046390>
    #                    except:
    #                        print('(Step 132Z6/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi()) 
    #                    try:    
    #                        channel4map2publish [key2pu] = response4map2image [key2pu] ['PUBLISHERCHANNEL']
    #                        print(key2pu, ' SET CHANNEL TO PUBLISH4XI TO : ', channel4map2publish [key2pu])
    #                        # ZPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7256>
    #                        # GPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7224>
    #                        # APU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7192>
    #                                           
    #                    except:
    #                        print('(Step 132Z7/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi()) 
    #                    try:            
    #                        channel4map2consume [key2pu] = response4map2image [key2pu]['CONSUMERCHANNEL']
    #                        print(key2pu, ' SET CHANNEL TO CONSUME4XI TO : ', channel4map2consume [key2pu])
    #                        # ZPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7252>
    #                        # GPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7220>
    #                        # APU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7188>
    #                    except:
    #                        print('(Step 132Z8/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi())     
    #            except:
    #                print('(Step 132Z9/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi())             
    #    except:
    #        print('(Step 132Z10/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR MAP ', time4xi()) 
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def map2image(self, task4map2image = None):
        '''
        maps Image2D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "map2image"
                     
        message2print = "{(Step 1A/33) started" + "; map2image-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4map2image-passed-to-map2image-of-Image2D4Xi: " + str(task4map2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4map2image-passing-to-map2image4xi-by-map2image-of-Image2D4Xi: " + str(task4map2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None
  
        response4mapimage2xi = map2image4xi(task4map2image)

        message2print = "{(Step 2B/33) performed" + "; map2image4xi-performed-by-map2image-of-Image2D4Xi: " + str(map2image4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function map2image4xi at 0x000000000390BAC8> 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4mapimage2xi-returning-by-map2image-of-Image2D4Xi: " + str(response4mapimage2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        
        return response4mapimage2xi
                                                           
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2image-of-Image2D4Xi" usage = "
    #
    #    print('(Step 133A/700) OF IMAGE2D4XI5TEST - TRYING TO RELEASE 2D IMAGES OF XI DEVICE ', time4xi())    
    #    # 
    #    try: 
    #        task4release = {} 
    #        for key2pu in keys2pu:
    #            task4release [key2pu]  = {}
    #                
    #        response4release = xi2xi.release2image(task4release)
    #        
    #        key2response = response4release.keys()
    #        for key2response in keys2response:
    #            print(key2response, ' : ', response4release [key2response] )
    #            #    
    #    except:
    #        print('(Step 133Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO RELEASE IMAGES OF XI DEVICE ', time4xi()) 
    #     
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release2image(self, task4release2image = None):
        '''
        releases Image2D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "release2image"
                     
        message2print = "{(Step 1A/33) started" + "; release2image-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2image-passed-to-release2image-of-Image2D4Xi: " + str(task4release2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2image-passing-to-release2image4xi-by-release2image-of-Image2D4Xi: " + str(task4release2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        image2xi = release2image4xi(task4release2image)

        message2print = "{(Step 2B/33) performed" + "; release2image4xi-performed-by-release2image-of-Image2D4Xi: " + str(release2image4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; image2xi-returning-by-release2image-of-Image2D4Xi: " + str(image2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                          
                
        return image2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2image-of-Image2D4Xi" usage = "
    #
    #    print('(Step 134A/700) OF IMAGE2D4XI5TEST - TRYING TO RETAIN 2D IMAGE OF XI DEVICE ', time4xi())   
    #    try:
    #        task4retain2image = {} 
    #        for key2pu in keys2pu:
    #            task4retain2image [key2pu]  = {}
    #            task4retain2image [key2pu] ['COUNT2REFERENCE'] = 1 
    #    
    #            response4retain2Dimage = xi2xi.retain2image(task4retain2image)                                                                                                 
    #                                    
    #            keys2response = response4retain2Dimage.keys()
    #            for key2response in keys2response:
    #                print(key2response, ' : ', response4retain2Dimage[key2response])
    #                #
    #    except:
    #        print('(Step 134Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO RETAIN 2D IMAGE OF XI DEVICE ', time4xi())
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2image(self, task4retain2image = None):
        '''
        retains Image2D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "retain2image"
                     
        message2print = "{(Step 1A/33) started" + "; retain2image-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 00:14:05 09/07/11 Pacific Daylight Time 
            
        message2print = "{(Step 1B/33) passed" + "; task4retain-passed-to-retain2image-of-Image2D4Xi: " + str(task4retain2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain-passing-to-retain2image4xi-by-retain-of-Image2D4Xi: " + str(task4retain2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        image2xi = retain2image4xi(task4retain2image)

        message2print = "{(Step 2B/33) performed" + "; retain2image4xi-performed-by-retain2image-of-Image2D4Xi: " + str(retain2image4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function retain2image4xi at 0x00000000039DF948>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; image2xi-returning-by-retain2image-of-Image2D4Xi: " + str(image2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                         
                
        return image2xi
                                                           
    #</methodize4xi>   
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "wait2image-of-Image2D4Xi" usage = "
    # 
    #    print('(Step 126A/25) OF IMAGE2D4XI5TEST - TRYING TO WAIT XI 2D IMAGE: ', time4xi())  
    #    try:                               
    #        task4wait2image  = {}
    #        for key2pu in keys2pu:
    #            task4wait2image[key2pu]  = {}
    #            
    #        response4wait2image = xi2xi.wait2image(task4wait2image) 
    #        # {(Step 33/33) of wait2image4xi - RETURNING IMAGE2DWAIT4XI :  
    #        # {
    #        # 'DPU': <queue4xi.Queue4Xi object at 0x0000000005F82CF8>, 
    #        # 'EPU': <queue4xi.Queue4Xi object at 0x0000000005F829E8>, 
    #        # 'BPU': <queue4xi.Queue4Xi object at 0x0000000005F87080>, 
    #        # 'CPU': <queue4xi.Queue4Xi object at 0x0000000005F820B8>, 
    #        # 'VPU': <queue4xi.Queue4Xi object at 0x0000000005F79A90>, 
    #        # 'RPU': <queue4xi.Queue4Xi object at 0x0000000005F7CC18>, 
    #        # 'WPU': <queue4xi.Queue4Xi object at 0x0000000005F79F98>, 
    #        # 'SPU': <queue4xi.Queue4Xi object at 0x0000000005F7CA90>, 
    #        # 'PPU': <queue4xi.Queue4Xi object at 0x0000000005F7C2E8>, 
    #        # 'QPU': <queue4xi.Queue4Xi object at 0x0000000005F7C5F8>, 
    #        # 'KPU': <queue4xi.Queue4Xi object at 0x0000000005F82B70>, 
    #        # 'YPU': <queue4xi.Queue4Xi object at 0x0000000006199E10>, 
    #        # 'LPU': <queue4xi.Queue4Xi object at 0x0000000005F7CEF0>, 
    #        # 'ZPU': <queue4xi.Queue4Xi object at 0x0000000006199C88>, 
    #        # 'TPU': <queue4xi.Queue4Xi object at 0x0000000005F7C128>, 
    #        # 'UPU': <queue4xi.Queue4Xi object at 0x0000000005F79E10>, 
    #        # 'XPU': <queue4xi.Queue4Xi object at 0x0000000006199F98>, 
    #        # 'OPU': <queue4xi.Queue4Xi object at 0x0000000005F7CB00>, 
    #        # 'APU': <queue4xi.Queue4Xi object at 0x0000000005F870B8>, 
    #        # 'MPU': <queue4xi.Queue4Xi object at 0x0000000005F7C4E0>, 
    #        # 'IPU': <queue4xi.Queue4Xi object at 0x0000000005F82588>, 
    #        # 'NPU': <queue4xi.Queue4Xi object at 0x0000000005F7C8D0>, 
    #        # 'JPU': <queue4xi.Queue4Xi object at 0x0000000005F82550>}
    #                
    #        keys2response = response4wait2image.keys()
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4wait2image[key2response] )
    #            # 
    #                                                                                                          
    #    except:
    #        print('(Step 126Z/25) OF IMAGE2D4XI5TEST *** FAILED TO WAIT XI 2D IMAGE: ', time4xi())      
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def wait2image(self, task4wait2image = None):
        '''
        waits Image2D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "wait2image"
                     
        message2print = "{(Step 1A/33) started" + "; wait2image-of-Image2D4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 00:14:05 09/07/11 Pacific Daylight Time 
            
        message2print = "{(Step 1B/33) passed" + "; task4wait2image-passed-to-wait2image-of-Image2D4Xi: " + str(task4wait2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4wait-passing-to-wait2image4xi-by-wait2image-of-Image2D4Xi: " + str(task4wait2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None
  
        image2xi = wait2image4xi(task4wait2image)

        message2print = "{(Step 2B/33) performed" + "; wait2image4xi-performed-by-wait2image-of-Image2D4Xi: " + str(wait2image4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; image2xi-returning-by-wait2image-of-Image2D4Xi: " + str(image2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                
        return image2xi
                                                           
    #</methodize4xi> 
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "write2image-of-Image2D4Xi" usage = "
    #
    #    print('(Step 128C/700) OF IMAGE2D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH WRITE2IMAGE4XI ', time4xi())        
    #    try: 
    #        task4write2image = {} 
    #        for key2pu in keys2pu:
    #            task4write2image[key2pu]  = {}    
    #        
    #        response4write2image = xi2xi.write2image(task4write2image)
    #        
    #        keys2writeresponse = response4write2image.keys()
    #        for key2writeresponse in sorted(keys2writeresponse):
    #            kb2detail = response4write2image[key2writeresponse]
    #            keys2detail = kb2detail.keys()
    #            for key2detail in keys2detail: 
    #                print(key2writeresponse, key2detail, kb2detail[key2detail])
    #                #
    #    except:
    #        print('(Step 128Z4/700) OF IMAGE2D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH WRITE2IMAGE4XI ', time4xi()) 
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def write2image(self, task4write2image = None):
        '''
        writes Image2D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "write2image"
                     
        message2print = "{(Step 1A/33) started" + "; write2image-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4write2image-passed-to-write2image-of-Image2D4Xi: " + str(task4write2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4write2image-passing-to-write2image4xi-by-write2image-of-Image2D4Xi: " + str(task4write2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None
  
        response4writeimage2xi = write2image4xi(task4write2image)

        message2print = "{(Step 2B/33) performed" + "; write2image4xi-performed-by-write2image-of-Image2D4Xi: " + str(write2image4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function write2image4xi at 0x000000000380AEC8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4writeimage2xi-returning-by-write2image-of-Image2D4Xi: " + str(response4writeimage2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return response4writeimage2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "copy2image-of-Image2D4Xi" usage = "
    # 
    #    print('(Step 129C/700) OF IMAGE2D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY2IMAGE4XI ', time4xi())        
    #    try: 
    #        task4copy2image = {} 
    #        for key2pu in keys2pu:
    #            task4copy2image[key2pu]  = {}    
    #        
    #        response4copy2image = xi2xi.copy2image(task4copy2image)
    #        
    #        keys2copyresponse = response4copy2image.keys()
    #        for key2copyresponse in sorted(keys2copyresponse):
    #            kb2detail = response4copy2image[key2copyresponse]
    #            keys2detail = kb2detail.keys()
    #            for key2detail in keys2detail: 
    #                print(key2copyresponse, key2detail, kb2detail[key2detail])
    #                #
    #    except:
    #        print('(Step 129Z4/700) OF IMAGE2D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY2IMAGE4XI ', time4xi()) 
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def copy2image(self, task4copy2image = None):
        '''
        copies Image2D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "copy2image"
                     
        message2print = "{(Step 1A/33) started" + "; copy2image-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #  
            
        message2print = "{(Step 1B/33) passed" + "; task4copy2image-passed-to-copy2image-of-Image2D4Xi: " + str(task4copy2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4copy2image-passing-to-copy2image4xi-by-copy2image-of-Image2D4Xi: " + str(task4copy2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None 
  
        response4copyimage2xi = copy2image4xi(task4copy2image)

        message2print = "{(Step 2B/33) performed" + "; copy2image4xi-performed-by-copy2image-of-Image2D4Xi: " + str(copy2image4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function copy2image4xi at 0x000000000390B8C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4copyimage2xi-returning-by-copy2image-of-Image2D4Xi: " + str(response4copyimage2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
        return response4copyimage2xi
                                                           
    #</methodize4xi>
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "copy2imagetobuffer-of-Image2D4Xi" usage = "
    # 
    #    print('=' *33)          
    #    print('(Step 60A/700) OF IMAGE2D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY2IMAGETOBUFFER4XI ', time4xi())        
    #    print('=' *33)      
    #    #                         
    #    response4copy2imagetobuffer      = {} 
    #    task4copy2imagetobuffer        = {}                                                                                    
    #    queue4copyimagetobuffer          = {} 
    #    channel4copyimagetobuffer2publish = {} 
    #    channel4copyimagetobuffer2consume = {} 
    #    try:
    #        task4copy2imagetobuffer = {} 
    #        for key2pu in keys2pu:
    #            if KB2CC [key2pu] == 'ACK':
    #                task4copy2imagetobuffer [key2pu]  = {}
    #                                                
    #        response4copy2imagetobuffer = xi2xi.copy2imagetobuffer(task4copy2imagetobuffer)
    #        
    #        print('(Step 60B/700) OF IMAGE2D4XI5TEST - GOT RESPONSE4COPY2IMAGETOBUFFER4XI2IMAGE ', response4copy2imagetobuffer)
    #        # 
    #    except:
    #        print('(Step 60Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY2IMAGETOBUFFER4XI ', time4xi())
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def copy2imagetobuffer(self, task4copy2imagetobuffer = None):
        '''
        copies 2D images to buffer
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "copy2imagetobuffer"
                     
        message2print = "{(Step 1A/33) started" + "; copy2imagetobuffer-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4copy2imagetobuffer-passed-to-copy2imagetobuffer-of-Image2D4Xi: " + str(task4copy2imagetobuffer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4copy2imagetobuffer-passing-to-copy2imagetobuffer4xi-by-copy2imagetobuffer-of-Image2D4Xi: " + str(task4copy2imagetobuffer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None
  
        response4copyimage2xi = copy2imagetobuffer4xi(task4copy2imagetobuffer)

        message2print = "{(Step 2B/33) performed" + "; copy2imagetobuffer4xi-performed-by-copy2imagetobuffer-of-Image2D4Xi: " + str(copy2imagetobuffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function copy2imagetobuffer4xi at 0x000000000390B948>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4copyimage2xi-returning-by-copy2imagetobuffer-of-Image2D4Xi: " + str(response4copyimage2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
          
        return response4copyimage2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "copy2buffertoimage-of-Image2D4Xi" usage = "
    # 
    #    print('=' *33)          
    #    print('(Step 129A/700) OF IMAGE2D4XI5TEST - TRYING TO ESTABLISH CONTROL & COMMAND WITH COPY2BUFFERTOIMAGE4XI ', time4xi())        
    #    print('=' *33)      
    #    #                         
    #    response4copy2buffertoimage      = {} 
    #    task4copy2buffertoimage        = {}                                                                                    
    #    queue4copybuffertoimage          = {} 
    #    channel4copybuffertoimage2publish = {} 
    #    channel4copybuffertoimage2consume = {} 
    #    try:
    #        task4copy2buffertoimage = {} 
    #        for key2pu in keys2pu:
    #            if KB2CC [key2pu] == 'ACK':
    #                task4copy2buffertoimage [key2pu]  = {}
    #                                                
    #        response4copy2buffertoimage = xi2xi.copy2buffertoimage(task4copy2buffertoimage)
    #        
    #        print('(Step 129B/700) OF IMAGE2D4XI5TEST - GOT RESPONSE4COPY2BUFFERTOIMAGE4XI2IMAGE ', response4copy2buffertoimage)
    #        # 
    #    except:
    #        print('(Step 129Z1/700) OF IMAGE2D4XI5TEST *** FAILED TO ESTABLISH CONTROL & COMMAND WITH COPY2BUFFERTOIMAGE4XI ', time4xi())
    #                 
    #    print('(Step 129C/700) OF IMAGE2D4XI5TEST - TRYING TO SET QUEUE AND CHANNELS FOR COPY2BUFFERTOIMAGE4XI ', time4xi())               
    #    try: 
    #        queue4copybuffertoimage          = {}
    #        channel4copybuffertoimage2publish = {} 
    #        channel4copybuffertoimage2consume = {}
    #        for key2pu in keys2pu:
    #            if KB2CC [key2pu] == 'ACK':   
    #                queue4copybuffertoimage [key2pu] = response4copy2buffertoimage [key2pu] ['QUEUE']
    #                print(key2pu, ' SET QUEUE TO : ', queue4copybuffertoimage [key2pu])
    #    
    #                channel4copybuffertoimage2publish [key2pu] = response4copy2buffertoimage [key2pu] ['PUBLISHERCHANNEL']
    #                 print(key2pu, ' SET CHANNEL TO PUBLISH4XI TO : ', channel4copybuffertoimage2publish [key2pu])
    #         
    #                 channel4copybuffertoimage2consume [key2pu] = response4copy2buffertoimage [key2pu]['CONSUMERCHANNEL']
    #                 print(key2pu, ' SET CHANNEL TO CONSUME4XI TO : ', channel4copybuffertoimage2consume [key2pu])
    #                 # 
    #                 # ZPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000005FC4F98>
    #                 # ZPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7160>
    #                 # ZPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7156>
    #                 # GPU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000005FC4AC8>
    #                 # GPU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7128>
    #                 # GPU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7124>
    #                 # APU  SET QUEUE TO :  <queue4xi.Queue4Xi object at 0x0000000005FC4A58>
    #                 # APU  SET CHANNEL TO PUBLISH4XI TO :  <read-write PipeConnection, handle 7096>
    #                 # APU  SET CHANNEL TO CONSUME4XI TO :  <read-write PipeConnection, handle 7092> 
    #                         
    #    except:
    #        print('(Step 129Z2/700) OF IMAGE2D4XI5TEST *** FAILED TO SET QUEUE AND CHANNELS FOR COPY2BUFFERTOIMAGE4XI ', time4xi())       
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def copy2buffertoimage(self, task4copy2buffertoimage = None):
        '''
        copies 2D images to buffer
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "copy2buffertoimage"
                     
        message2print = "{(Step 1A/33) started" + "; copy2buffertoimage-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4copy2buffertoimage-passed-to-copy2buffertoimage-of-Image2D4Xi: " + str(task4copy2buffertoimage) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4copy2buffertoimage-passing-to-copy2buffertoimage4xi-by-copy2buffertoimage-of-Image2D4Xi: " + str(task4copy2buffertoimage) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None
  
        response4copyimage2xi = copy2buffertoimage4xi(task4copy2buffertoimage)

        message2print = "{(Step 2B/33) performed" + "; copy2buffertoimage4xi-performed-by-copy2buffertoimage-of-Image2D4Xi: " + str(copy2buffertoimage4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function copy2buffertoimage4xi at 0x000000000390B9C8> 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4copyimage2xi-returning-by-copy2buffertoimage-of-Image2D4Xi: " + str(response4copyimage2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                
        return response4copyimage2xi
                                                           
    #</methodize4xi>    
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2image-of-Image2D4Xi" usage = "
    #
    #    print('(Step 125A/25) OF IMAGE2D4XI5TEST - TRYING TO TRACE XI: ', time4xi()) 
    #    try:                               
    #        task4trace2image  = {}
    #        for key2pu in keys2pu:
    #            task4trace2image[key2pu]  = {}
    #            
    #        response4trace2image = xi2xi.trace2image(task4trace2image) 
    #        
    #        key2response = response4trace2image.keys()
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4trace2image[key2response] )
    #            # APU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4apu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4apu', 'METHOD': 'trace2image4apu'}
    #            # BPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4bpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4bpu', 'METHOD': 'trace2image4bpu'}
    #            # CPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4cpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4cpu', 'METHOD': 'trace2image4cpu'}
    #            # DPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4dpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4dpu', 'METHOD': 'trace2image4dpu'}
    #            # EPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4epu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4epu', 'METHOD': 'trace2image4epu'}
    #            # FPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4fpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4fpu', 'METHOD': 'trace2image4fpu'}
    #            # GPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4gpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4gpu', 'METHOD': 'trace2image4gpu'}
    #            # HPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4hpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4hpu', 'METHOD': 'trace2image4hpu'}
    #            # IPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4ipu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4ipu', 'METHOD': 'trace2image4ipu'}
    #            # JPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4jpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4jpu', 'METHOD': 'trace2image4jpu'}
    #            # KPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4kpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4kpu', 'METHOD': 'trace2image4kpu'}
    #            # LPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4lpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4lpu', 'METHOD': 'trace2image4lpu'}
    #            # MPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4mpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4mpu', 'METHOD': 'trace2image4mpu'}
    #            # NPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4npu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4npu', 'METHOD': 'trace2image4npu'}
    #            # OPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4opu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4opu', 'METHOD': 'trace2image4opu'}
    #            # PPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4ppu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4ppu', 'METHOD': 'trace2image4ppu'}
    #            # QPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4qpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4qpu', 'METHOD': 'trace2image4qpu'}
    #            # RPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4rpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4rpu', 'METHOD': 'trace2image4rpu'}
    #            # SPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4spu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4spu', 'METHOD': 'trace2image4spu'}
    #            # TPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4tpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4tpu', 'METHOD': 'trace2image4tpu'}
    #            # UPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4upu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4upu', 'METHOD': 'trace2image4upu'}
    #            # VPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4vpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4vpu', 'METHOD': 'trace2image4vpu'}
    #            # WPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4wpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4wpu', 'METHOD': 'trace2image4wpu'}
    #            # XPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4xpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4xpu', 'METHOD': 'trace2image4xpu'}
    #            # YPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4ypu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4ypu', 'METHOD': 'trace2image4ypu'}
    #            # ZPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2image4zpu-failed {}; time: 07:07:05 11/05/11 Pacific Daylight Time}', 'CLASS': 'trace2image4zpu', 'METHOD': 'trace2image4zpu'}
    #                                                                                                       
    #    except:
    #        print('(Step 125Z/25) OF IMAGE2D4XI5TEST *** FAILED TO TRACE XI: ', time4xi())       
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def trace2image(self, task4trace2image = None):
        '''
        traces Image2D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "trace2image"
                     
        message2print = "{(Step 1A/33) started" + "; trace2image-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2image-passed-to-trace-of-Image2D4Xi: " + str(task4trace2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None   
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2image-passing-to-trace2image4xi-by-trace2image-of-Image2D4Xi: " + str(task4trace2image) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None  
  
        trace2xi = trace2image4xi(task4trace2image)

        message2print = "{(Step 2B/33) performed" + "; trace2image4xi-performed-by-trace2image-of-Image2D4Xi: " + str(trace2image4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-trace2image-of-Image2D4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                 
                
        return trace2xi
                                                           
    #</methodize4xi>       


    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2imagecallback-of-Image2D4Xi" usage = "
    # 
    #    print('(Step 124A/700) OF IMAGE2D4XI5TEST - TRYING TO SET IMAGE CALLBACK WITH METHOD OF OBJECT XI2XI: ', xi2xi) 
    # 
    #    try:
    #        task4callback2image = {} 
    #        for key2pu in keys2pu:
    #            task4callback2image [key2pu]  = {}
    #                                         
    #        response4callback = xi2xi.set2imagecallback(task4callback2image)                                  
    #        
    #        key2response = response4callback.keys()
    #        for key2response in sorted(keys2response):
    #            print(key2response, ' : ', response4callback [key2response] )
    #            # APU  :  {'CALLBACK': <function trace2image4apu at 0x00000000043E2648>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # BPU  :  {'CALLBACK': <function trace2image4bpu at 0x00000000044C40C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # CPU  :  {'CALLBACK': <function trace2image4cpu at 0x0000000004581848>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # DPU  :  {'CALLBACK': <function trace2image4dpu at 0x00000000046AD048>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # EPU  :  {'CALLBACK': <function trace2image4epu at 0x00000000047667C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # FPU  :  {'CALLBACK': <function trace2image4fpu at 0x000000000483AF48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # GPU  :  {'CALLBACK': <function trace2image4gpu at 0x0000000004914748>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # HPU  :  {'CALLBACK': <function trace2image4hpu at 0x00000000049B0EC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # IPU  :  {'CALLBACK': <function trace2image4ipu at 0x0000000004A8F6C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # JPU  :  {'CALLBACK': <function trace2image4jpu at 0x0000000004B19E48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # KPU  :  {'CALLBACK': <function trace2image4kpu at 0x0000000004C00648>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # LPU  :  {'CALLBACK': <function trace2image4lpu at 0x0000000004CC4DC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # MPU  :  {'CALLBACK': <function trace2image4mpu at 0x0000000004DA55C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # NPU  :  {'CALLBACK': <function trace2image4npu at 0x0000000004E47D48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # OPU  :  {'CALLBACK': <function trace2image4opu at 0x0000000004F4B548>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # PPU  :  {'CALLBACK': <function trace2image4ppu at 0x0000000004FDDCC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # QPU  :  {'CALLBACK': <function trace2image4qpu at 0x00000000051034C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # RPU  :  {'CALLBACK': <function trace2image4rpu at 0x0000000005248C48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # SPU  :  {'CALLBACK': <function trace2image4spu at 0x0000000005337448>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # TPU  :  {'CALLBACK': <function trace2image4tpu at 0x00000000053F7BC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # UPU  :  {'CALLBACK': <function trace2image4upu at 0x00000000054A23C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # VPU  :  {'CALLBACK': <function trace2image4vpu at 0x0000000005537B48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # WPU  :  {'CALLBACK': <function trace2image4wpu at 0x00000000056AAAC8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # XPU  :  {'CALLBACK': <function trace2image4xpu at 0x0000000005628348>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # YPU  :  {'CALLBACK': <function trace2image4ypu at 0x00000000057572C8>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #            # ZPU  :  {'CALLBACK': <function trace2image4zpu at 0x0000000005854A48>, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 21Z1-22Z2-22Z3-23Z1-24Z1-25Z1-26Z1-27Z1-28Z1-29Z1-30Z1-31Z1-34Z1-35Z1-36Z1-37Z1-38Z1-39Z1-'}
    #                          
    #    except:
    #        print('(Step 124Z/700) OF IMAGE2D4XI5TEST *** FAILED TO SET IMAGE CALLBACK WITH METHOD ***', time4xi())    
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2imagecallback(self, task4set2imagecallback = None): 
        '''
        set2imagecallback of Image2D4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "Image2D4Xi"
        method2print = "set2imagecallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2imagecallback-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2imagecallback-passed-to-set2imagecallback-of-Image2D4Xi: " + str(task4set2imagecallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None    
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2imagecallback-passing-to-set2imagecallback -by-set2imagecallback-of-Image2D4Xi: " + str(task4set2imagecallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None
        
        callback2xi4image = {} 
        try:
            callback2xi4image = set2imagecallback4xi (task4set2imagecallback)

            message2print = "{(Step 2B/33) callback2xi4image" + "; callback2xi4image-set-by-set2imagecallback-of-Image2D4Xi to: " + str(callback2xi4image) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # 
        except:
            message2print = "{(Step 4A/33) failed" + "; callback2xi4image-failed-by-set2imagecallback-of-Image2D4Xi: " + str(callback2xi4image) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; callback2xi4image-returning-by-set2imagecallback-of-Image2D4Xi: " + str(callback2xi4image) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                                             
        return callback2xi4image
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Image2D4Xi" usage = "
    #
    #    print('(Step 170A/700) OF IMAGE2D4XI5TEST - SENSING ', time4xi())  
    #    # 
    #    try:
    # 
    #         response4sense = xi2xi.sense()
    #         
    #         print(response4sense)
    #         # {'classvariable2xi-of-Image2D4Xi': 4, 'object': <image2d4xi.Image2D4Xi object at 0x0000000006018278>}         
    # 
    #     except:
    #         print('(Step 170Z/700) OF IMAGE2D4XI5TEST *** FAILED TO SENSE ', time4xi())      
    #  
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Image2D4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Image2D4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; Image2D4Xi-sensing-by-sense-of-Image2D4Xi: " + str(Image2D4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'image2d4xi.Image2D4Xi'>         
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-Image2D4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object': <image2d4xi.Image2D4Xi object at 0x0000000004188400>}   
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2xi-of-Image2D4Xi'] = Image2D4Xi.classvariable2xi
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-Image2D4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; Image2D4Xi-sensed-by-sense-of-Image2D4Xi: " + str(Image2D4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # <class 'image2d4xi.Image2D4Xi'>
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-Image2D4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #             
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Image2D4Xi" usage = "
    # 
    #    print('(Step 171A/700) OF IMAGE2D4XI5TEST - REASONING ', time4xi())  
    #    # 
    #    try:
    #                
    #        response4reason = xi2xi.reason()
    #        
    #        print(response4reason)
    #        # {'object-reason-object4xi': <image2d4xi.Image2D4Xi object at 0x0000000006018278>, 'time-reason-of-Image2D4Xi': '09:46:11 11/05/11 Pacific Daylight Time'}         
    # 
    #     except:
    #         print('(Step 171Z/700) OF IMAGE2D4XI5TEST *** FAILED TO REASON ', time4xi())  
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Image2D4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'Image2D4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 01:02:22 09/07/11 Pacific Daylight Time 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; Image2D4Xi-reasoning-by-reason-of-Image2D4Xi: " + str(Image2D4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # <class 'image2d4xi.Image2D4Xi'>  
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-Image2D4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object-reason-object4xi': <image2d4xi.Image2D4Xi object at 0x0000000004188400>}      
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-Image2D4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-Image2D4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; Image2D4Xi-reasoned-by-reason-of-Image2D4Xi: " + str(Image2D4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # <class 'image2d4xi.Image2D4Xi'>
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-Image2D4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #            
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Image2D4Xi" usage = "
    # 
    #    print('(Step 172A/700) OF IMAGE2D4XI5TEST - ACING ', time4xi())  
    #    # 
    #    try:
    # 
    #         response4ace = xi2xi.ace()
    # 
    #         print(response4ace)
    #         # {'cores-of-Image2D4Xi': 4, 'object8xi': <image2d4xi.Image2D4Xi object at 0x0000000006018278>}         
    # 
    #     except:
    #         print('(Step 172Z/700) OF IMAGE2D4XI5TEST *** FAILED TO ACE ', time4xi())                                     
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Image2D4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'Image2D4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-Image2D4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; Image2D4Xi-acing-by-ace-of-Image2D4Xi: " + str(Image2D4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'image2d4xi.Image2D4Xi'>           
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-Image2D4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object8xi': <image2d4xi.Image2D4Xi object at 0x0000000004188400>}   


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-Image2D4Xi'] = Image2D4Xi.classvariable2xi
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-Image2D4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; Image2D4Xi-aced-by-ace-of-Image2D4Xi: " + str(Image2D4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'image2d4xi.Image2D4Xi'>  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-Image2D4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   image2d4xi5test.txt
#   sense-image2d4xi5test.xml
#   reason-image2d4xi5test.xml
#   ace-image2d4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# None
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of image2d4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
